#! /bin/sh

#GT4PORT=`grep "service.port" $GLOBUS_LOCATION/ogsa.properties | cut -d'=' -f 2 `
GT4PORT=8443
hostname=`hostname -f`

# Get host ip address
# First check /etc/hosts file
hostip=`grep ${hostname} /etc/hosts | grep -v "^#" | head -n 1 | awk '{print $1}'`
if [ -z "$hostip" ]; then
    # second use nslookup
    hostip=`host ${hostname} | cut -d' ' -f4`
fi

if [ -z "${hostip}" ]; then
    GT4HOST="${hostname}"
else
    GT4HOST="${hostip}"
fi

if [ -z "$GT4PORT" ]; then 
   GT4PORT="8443"
fi
if [ -z "$GT4HOST" ]; then 
   GT4HOST="localhost"
fi

JOB_SERVICE="https://${GT4HOST}:${GT4PORT}/wsrf/services/metascheduler/JobService"
RSV_SERVICE="https://${GT4HOST}:${GT4PORT}/wsrf/services/metascheduler/ReservationService"
QUEUING_SERVICE="https://${GT4HOST}:${GT4PORT}/wsrf/services/metascheduler/QueuingService"

JOB_CLIENT=com.platform.metascheduler.client.JobServiceClient
RSV_CLIENT=com.platform.metascheduler.client.ReservationServiceClient
QUEUING_CLIENT=com.platform.metascheduler.client.QueuingServiceClient

CSF_VERSION="4.0"

export GT4PORT
export GT4HOST
export JOB_SERVICE
export RSV_SERVICE
export JOB_CLIENT
export RSV_CLIENT
export CSF_VERSION

