my $gpath = $ENV{GPT_LOCATION};

if (!defined($gpath))
{
  $gpath = $ENV{GLOBUS_LOCATION};
}

if (!defined($gpath))
{
   die "GPT_LOCATION or GLOBUS_LOCATION needs to be set before running this script"
}

my $globusdir = $ENV{GLOBUS_LOCATION};

if (!defined($globusdir))
{
  die "GLOBUS_LOCATION needs to be set before running this script"
}	

@INC = (@INC, "$gpath/lib/perl");

require Grid::GPT::Setup;

my $metadata = new Grid::GPT::Setup(package_name => "csf");

my $setupdir = "$globusdir/setup/globus/";

print "Deploying Platform CSF (Community Scheduler Framework) ...\n";

#chdir "$globusdir" or die "Cannot chdir to $globusdir";

system "ant deployGar -f $globusdir/share/globus_wsrf_common/build-packages.xml -Dgar.name=$globusdir/tmp/csf/metascheduler.gar";

$metadata->finish();

setup("$globusdir/docs/metascheduler/examples", "GLOBUS_LOCATION",
	"$globusdir" );

#Subroutine to replace all the occurence of $search with $replace in $dir.

sub setup {

my ($dir, $search, $replace) = @_;

opendir(DIR,$dir) or die "$dir not found\n";

@directories = readdir DIR; 
foreach $file (@directories) {
        $found=0; 
        @filecontent=(); 
        if (substr($file,0,1) eq '.') {next;} 
        open(INF,"$dir//$file") or next; 
        @filecontent=<INF>; 
        close(INF); 
        foreach $line (@filecontent) {
           if ($line =~ s/$search/$replace/g) { $found = 1; }
        }
        
        if (!$found) { next; } #Next loop if search string not found

        if (open(OUTF,">$dir/$file")) { #Open file for output
                foreach $line (@filecontent) {
                        print OUTF $line; 
                }
                close(OUTF); #Close file
        } else { 
                print "Error opening $file for replacement";
        }
}

closedir DIR; 
}

