package com.platform.metascheduler.client;

import org.globus.axis.gsi.GSIConstants;
import org.globus.gsi.proxy.IgnoreProxyPolicyHandler;

import java.io.FileReader;
import java.io.File;
import java.io.BufferedReader;
import java.io.IOException;
import java.util.Vector;
import java.net.URL;

import com.platform.www.namespaces._2003._05.metascheduler.gsa.AgreementType;
import com.platform.www.namespaces._2003._05.metascheduler.gsa.NegotiabilityType;
import com.platform.www.namespaces._2003._05.metascheduler.gsa.TermType;
import com.platform.metascheduler.utils.ReservationHelper;
import com.platform.metascheduler.utils.GSARsvAttributes;
import com.platform.metascheduler.reservation.ReservationPortType;
import com.platform.metascheduler.reservation.ReservationFaultType;
import com.platform.metascheduler.reservation.service.ReservationServiceLocator;
import com.platform.metascheduler.utils.MetaSchedulerConstants;
import javax.xml.namespace.QName;
import javax.xml.rpc.Stub;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import org.apache.axis.utils.XMLUtils;
import org.apache.axis.MessageContext;
import org.apache.axis.message.MessageElement;
import org.apache.axis.message.addressing.ReferencePropertiesType;

import java.rmi.RemoteException;

import org.globus.ws.policy.Compositor;
import org.globus.ws.policy.OpenUsageType;

import metascheduler.platform.com._2003._05.rsl.metascheduler.HostsTermType;
import metascheduler.platform.com._2003._05.rsl.metascheduler.CpuTermType;
import metascheduler.platform.com._2003._05.rsl.metascheduler.TimeTermType;
import metascheduler.platform.com._2003._05.rsl.metascheduler.ResReqTermType;
import metascheduler.platform.com._2003._05.rsl.metascheduler.UserTermType;

import com.platform.metascheduler.reservation.service.ReservationServiceAddressingLocator;
import org.globus.wsrf.ResourceException;
import org.globus.wsrf.encoding.ObjectSerializer;
import org.globus.wsrf.encoding.ObjectDeserializer;
import org.globus.wsrf.encoding.DeserializationException;
import org.apache.axis.message.addressing.Address;
import org.apache.axis.message.addressing.EndpointReferenceType;

import org.globus.axis.gsi.GSIConstants;
import org.globus.wsrf.impl.security.authentication.Constants;
import org.globus.wsrf.impl.security.authorization.HostAuthorization;
import org.globus.wsrf.impl.security.authorization.NoAuthorization;
import org.globus.wsrf.impl.security.authorization.GridMapAuthorization;
import org.globus.wsrf.impl.security.authorization.SelfAuthorization;
import org.globus.gsi.proxy.IgnoreProxyPolicyHandler;

import com.platform.metascheduler.reservation.CreateResource;
import com.platform.metascheduler.reservation.CreateResourceResponse;
import com.platform.metascheduler.reservation.Submit;
import com.platform.metascheduler.reservation.SubmitResponse;
import com.platform.metascheduler.reservation.Cancel;
import com.platform.metascheduler.reservation.CancelResponse;
import com.platform.metascheduler.reservation.Start;
import com.platform.metascheduler.reservation.StartResponse;
import com.platform.metascheduler.reservation.Modify;
import com.platform.metascheduler.reservation.ModifyResponse;
import com.platform.metascheduler.reservation.GetStatus;
import com.platform.metascheduler.reservation.GetStatusResponse;
import com.platform.metascheduler.reservation.GetRsvData;
import com.platform.metascheduler.reservation.GetRsvDataResponse;
import org.oasis.wsrf.lifetime.Destroy;

import org.xml.sax.InputSource;
import java.io.FileOutputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;


public class ReservationServiceClient {
    static{
 	org.globus.axis.util.Util.registerTransport();
    }
    static String    userhome= System.getProperty("user.home") + "/";

    private static void printUsage() {
        System.err.println("Usage: ReservationServiceClient <ReservationService_handle> <ReservationService_operation>")
;
        System.err.println("Usage: ReservationServiceClient <reservation_name> <service_operation>");
        System.err.println("ReservationService Handle:  URI to ReservationService");
        System.err.println("ReservationService operation:");
        System.err.println("    createService rsl <rsl_file> [ reservation_name ]");
        System.err.println("    createService id <rsv_id> [ reservation_name ]");
        System.err.println("    createService agreement <agreement_file> [reservation_name ]");
        System.err.println("Service operation:");
        System.err.println("    submit");
        System.err.println("    modify <rsl_file>");
        System.err.println("    cancel");
        System.err.println("    getStatus");
        System.err.println("    getRsvData");
        return;
    }

    private static String readRsl(String rslFile) {
        BufferedReader rslReader = null;
        StringBuffer rsl = null;
        try {
            rslReader = new BufferedReader(new FileReader(rslFile));
            rsl = new StringBuffer();
            String rslLine = rslReader.readLine();
            while (rslLine != null) {
                rsl.append(rslLine);
                rslLine = rslReader.readLine();
            }
        } catch (IOException e) {
            System.err.println("Error reading rsl file: " + e.getMessage());
            System.exit(2);
        } finally {
            if (rslReader != null) {
                try {
                    rslReader.close();
                } catch (IOException ee) {
                    // ignore this error
                }
            }
        }
        return (rsl.toString());
    }

    public static void main (String[] args) {
	String handle = null;
	String rsvName = null;
	String op = null;
	String oparg[] = new String[3];
	ReservationServiceAddressingLocator locator = new ReservationServiceAddressingLocator();
 	EndpointReferenceType endpoint = null;
 	ReservationPortType rsv = null;

        if (args.length < 2) {
	    printUsage();
            return;
        }

	handle = args[0];
	rsvName= args[0];
	op = args[1];
	if (args.length > 2) {
            oparg[0] = args[2];
        }
	if (args.length > 3) {
	    oparg[1] = args[3];
	}
	if (args.length > 4) {
	    oparg[2] = args[4];
	}

	try {
	    if (op.equalsIgnoreCase("createService")) { 
		if (oparg[0] == null || oparg[1] == null) {
		    printUsage();
		    return;
		}
                endpoint = new EndpointReferenceType();
                endpoint.setAddress(new Address(handle));
		System.out.println(handle);
                rsv = locator.getReservationPortTypePort(endpoint);
	    
		/* We create a service handle. */
		((Stub)rsv)._setProperty(Constants.GSI_SEC_CONV,
				   Constants.SIGNATURE);
		((Stub)rsv)._setProperty(GSIConstants.GSI_MODE,
					   GSIConstants.GSI_MODE_LIMITED_DELEG);
		((Stub)rsv)._setProperty(Constants.AUTHORIZATION,
                                           HostAuthorization.getInstance());
                //((Stub)rsv)._setProperty(Constants.GRIM_POLICY_HANDLER,
	        //                                new IgnoreProxyPolicyHandler());
		((org.apache.axis.client.Stub)rsv).setTimeout(0);				
		String            instanceID = oparg[2];
		String		  rsv_type = null;
		String		  creationParameter = null;

		if (oparg[0].equalsIgnoreCase("rsl")) {
		    rsv_type = MetaSchedulerConstants.RSV_CREATE_BY_RSL;
		    creationParameter = readRsl(oparg[1]);
		} else if (oparg[0].equalsIgnoreCase("id")) {
		    rsv_type = MetaSchedulerConstants.RSV_CREATE_BY_ID;
		    creationParameter = oparg[1];
		} else if (oparg[0].equalsIgnoreCase("agreement")) {
		    rsv_type = MetaSchedulerConstants.RSV_CREATE_BY_AGREEMENT;
		    creationParameter = readRsl(oparg[1]);
		} else {
		    printUsage();
		    return;
		}
	
		CreateResourceResponse response = rsv.createResource(
			new CreateResource(instanceID,creationParameter,rsv_type));
		endpoint = response.getEndpointReference();
		String status   = response.getStatus();
 		if (status.startsWith(MetaSchedulerConstants.RESERVATION_SERVICE_ERR_EXIST)) {
 			System.out.println("Error :" + MetaSchedulerConstants.RESERVATION_SERVICE_ERR_EXIST);
 			return;
 		}

		// serialize epr
		// if user hasn't input instance name , take resourceKey as name
		if (instanceID == null) {
		        ReferencePropertiesType rp= endpoint.getProperties();
		        MessageElement [] key = rp.get_any();
		        instanceID = key[0].getValue();
		}
                FileOutputStream out = null;
                try {
                     out = new FileOutputStream(userhome + "Rsv_" + instanceID + ".epr");
                     out.write(ObjectSerializer.toString(endpoint,
                               new QName("", "RsvEPR")).getBytes());
                } catch (IOException e) {
                     System.err.println("Failed to write subscription epr: " + e.getMessage());
                } finally {
                     if (out != null) {
                          try { out.close(); } catch (Exception ee) {}
                     }
                }
		System.out.println("Created Resource is : " + instanceID);
		return;	
	    } // END of "createService"
	
            //Deserialize endpoint
            FileInputStream in = null;
            try {
                in = new FileInputStream(userhome + "Rsv_" + rsvName + ".epr");
                endpoint = (EndpointReferenceType)ObjectDeserializer.deserialize(
                    new InputSource(in),
                    EndpointReferenceType.class);
            }catch ( FileNotFoundException fe) {
                System.out.println("Reservation: " + rsvName + "hasn't been created !");
            } catch (DeserializationException e){
            }finally {
                if (in != null) {
                    try { in.close(); } catch (Exception e) {}
                }
            }

            if ( endpoint == null ) {
                System.out.println("Reservation: " + rsvName + "hasn't been created !");
                return ;
            }

	    ReservationPortType reservation = locator.getReservationPortTypePort(endpoint);

	    ((Stub)reservation)._setProperty(Constants.GSI_SEC_CONV,
				     Constants.SIGNATURE);
	    ((Stub)reservation)._setProperty(GSIConstants.GSI_MODE,
	    			     GSIConstants.GSI_MODE_LIMITED_DELEG);
	    ((Stub)reservation)._setProperty(Constants.AUTHORIZATION,
					       HostAuthorization.getInstance());
            //((Stub)reservation)._setProperty(Constants.GRIM_POLICY_HANDLER,
	    //                                new IgnoreProxyPolicyHandler());
	    ((org.apache.axis.client.Stub)reservation).setTimeout(300000);
	    
	    if (op.equalsIgnoreCase("submit")) {
		System.out.println(op + "() => " + (reservation.submit(new Submit()).isValue()? "Success!":"Fail!"));
	    } else if (op.equalsIgnoreCase("start")) {
		if (oparg[0] == null) {
		    System.err.println("Oprand need for " + op +"()");
		    return;
		}
		System.out.println(op + "(" + oparg[0] + ") => " 
			       + reservation.start(new Start(oparg[0])).getValue());
	    } else if (op.equalsIgnoreCase("modify")) {
		if (oparg[0] == null) {
		    System.err.println("Oprand need for " + op +"()");
		    return;
		}
		System.out.println(op + "(" + oparg[0] + ") => " 
				   + (reservation.modify(new Modify(readRsl(oparg[0]))).isValue()? "Success!":"Fail!"));
	    } else if (op.equalsIgnoreCase("cancel")) {
		System.out.println(op + "() => " + (reservation.cancel(new Cancel()).isValue()? "Success!":"Fail!"));
	    } else if (op.equalsIgnoreCase("getStatus")) {
		System.out.println(op + "() => " + reservation.getStatus(new GetStatus()).getValue());
	    } else if (op.equalsIgnoreCase("getRsvData")) {
		System.out.println(op + "() => " + reservation.getRsvData(new GetRsvData()).getValue());
	    } else if (op.equalsIgnoreCase("destroy")) {
		reservation.destroy(new Destroy());
                //delete epr file
                File test = new File(userhome + "Rsv_"+ rsvName +".epr");
                if (test.exists()) {
                        if(test.delete()){
                                System.out.println("deleted " + rsvName + "'s epr file");
                        } else{
                                System.out.println("Delete epr file failed!");
                        }
                }
		System.out.println("Reservation resource : " + rsvName +" destroyed");
	    } else {
		System.err.println("Operation <" + op +"> not supported");
	    }
        } catch (RemoteException e) {
            String msg = e.getMessage();
            if ( msg != null ) {
               System.err.println("Reservation fault type: " + msg);
            } else {
               e.printStackTrace();
            }
	} catch (Exception e) {
	    e.printStackTrace();
	}
    }

}
