package com.platform.metascheduler.impl;

import java.rmi.RemoteException;
import com.platform.metascheduler.job.JobPortType;
import com.platform.metascheduler.job.JobConfigParamsType;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import java.io.*;
import java.lang.Boolean;
import java.net.URL;
import java.net.InetAddress;
import java.math.BigDecimal;
import java.util.*;
import java.util.Hashtable;

import com.platform.metascheduler.job.GridJobStatus;
import com.platform.metascheduler.job.JobPortType;
import com.platform.metascheduler.job.JobFaultType;
import com.platform.metascheduler.job.JobDataType;
import com.platform.metascheduler.utils.MetaSchedulerRsl;
import com.platform.metascheduler.utils.JobAttributes;
import com.platform.metascheduler.utils.JobDataHelper;
import com.platform.metascheduler.utils.MetaSchedulerConstants;
import com.platform.metascheduler.queuing.QueuingPortType;
import com.platform.metascheduler.queuing.QueuingRequestType;
import com.platform.metascheduler.queuing.RmFactoryType;
import com.platform.metascheduler.queuing.service.QueuingServiceLocator;
import com.platform.metascheduler.resourcemanager.ResourceManagerFactoryPortType;
import com.platform.metascheduler.resourcemanager.ResourceManagerLsfPortType;
import com.platform.metascheduler.resourcemanager.ResourceManagerFaultType;
//import com.platform.metascheduler.impl.JobGramTask;

import org.apache.axis.message.MessageElement;
import org.globus.axis.gsi.GSIConstants;
import org.apache.commons.logging.*;
import javax.xml.soap.SOAPException;
import java.net.MalformedURLException;
import javax.xml.namespace.QName;

import java.util.Timer;
import java.util.TimerTask;
import com.platform.metascheduler.impl.JobInfoTask;

import org.globus.exec.utils.rsl.RSLParseException;

/*************** wsrf classes ******************/
import org.globus.wsrf.encoding.ObjectSerializer;
import org.globus.wsrf.config.ConfigException;
import org.globus.wsrf.container.ServiceHost;
import org.globus.wsrf.ResourceContext;
import org.globus.wsrf.ResourceKey;
import org.globus.wsrf.utils.AddressingUtils;
import org.globus.wsrf.ResourceException;

import org.apache.axis.message.addressing.EndpointReferenceType;
import org.apache.axis.message.addressing.Address;

/*************** GSI classes ******************/
import org.globus.axis.gsi.GSIConstants;
import org.globus.wsrf.impl.security.authentication.Constants;
import org.globus.wsrf.impl.security.authorization.HostAuthorization;
import org.globus.wsrf.impl.security.authorization.SelfAuthorization;
import org.globus.gsi.proxy.IgnoreProxyPolicyHandler;
import org.globus.wsrf.impl.security.authentication.secureconv.service.SecurityContext;
import org.globus.wsrf.impl.security.authentication.Constants;
import org.globus.wsrf.security.SecurityManager;
//import org.globus.ogsa.impl.security.authorization.Authorization;
/*************** stub classes ******************/
import org.oasis.wsrf.lifetime.SetTerminationTime;
import org.oasis.wsrf.lifetime.SetTerminationTimeResponse;
import com.platform.metascheduler.job.CreateResourceResponse;
import com.platform.metascheduler.job.CreateResource;
import com.platform.metascheduler.job.Start;
import com.platform.metascheduler.job.StartResponse;
import com.platform.metascheduler.job.Cancel;
import com.platform.metascheduler.job.CancelResponse;
import com.platform.metascheduler.job.GetStatus;
import com.platform.metascheduler.job.GetStatusResponse;
import com.platform.metascheduler.job.Stop;
import com.platform.metascheduler.job.StopResponse;
import com.platform.metascheduler.job.Resume;
import com.platform.metascheduler.job.ResumeResponse;
import com.platform.metascheduler.job.Submit;
import com.platform.metascheduler.job.SubmitResponse;
import com.platform.metascheduler.job.GetJobData;
import com.platform.metascheduler.job.GetJobDataResponse;
import com.platform.metascheduler.job.Signal;
import com.platform.metascheduler.job.SignalResponse;
import com.platform.metascheduler.job.Modify;
import com.platform.metascheduler.job.ModifyResponse;
import com.platform.metascheduler.job.GetJobDataType;
import com.platform.metascheduler.job.GetJobDataTypeResponse;
import com.platform.metascheduler.resourcemanager.service.ResourceManagerFactoryServiceAddressingLocator;
import com.platform.metascheduler.resourcemanager.service.ResourceManagerLsfServiceAddressingLocator;
import com.platform.metascheduler.resourcemanager.ResourceManagerFactoryPortType;
import com.platform.metascheduler.resourcemanager.ResourceManagerLsfPortType;
import com.platform.metascheduler.resourcemanager.CreateResourceManagerResponse;
import com.platform.metascheduler.resourcemanager.CreateResourceManager;
import com.platform.metascheduler.resourcemanager.JobSubmit;
import com.platform.metascheduler.resourcemanager.JobSubmitResponse;
import com.platform.metascheduler.resourcemanager.JobQuery;
import com.platform.metascheduler.resourcemanager.JobQueryResponse;
import com.platform.metascheduler.resourcemanager.JobControl;
import com.platform.metascheduler.resourcemanager.JobControlResponse;
import com.platform.metascheduler.resourcemanager.RsvSubmit;
import com.platform.metascheduler.resourcemanager.RsvSubmitResponse;
import com.platform.metascheduler.resourcemanager.RsvQuery;
import com.platform.metascheduler.resourcemanager.RsvQueryResponse;
import com.platform.metascheduler.resourcemanager.RsvCancel;
import com.platform.metascheduler.resourcemanager.RsvCancelResponse;
import com.platform.metascheduler.queuing.service.QueuingServiceAddressingLocator;

import org.ietf.jgss.GSSCredential;
import org.ietf.jgss.GSSContext;
import org.apache.axis.MessageContext;
import javax.xml.rpc.Stub;
//import com.platform.metascheduler.utils.AggregationHelper;
import java.util.Calendar;

import org.w3c.dom.Element;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.apache.axis.utils.XMLUtils;

import java.text.SimpleDateFormat;
import java.text.FieldPosition;

/**
 * Implement Job Service.
 * 
 */
public class JobImpl {

    static Log logger = LogFactory.getLog(JobImpl.class);

    private String m_rslFile = null;
    private MetaSchedulerRsl m_rslParser = null;
    private String m_clusterName = null;

    private static String m_rmFactoryUrl = null;
//  endpointmap is ResourceManagerFactory 's epr
//  usersubject+clusterName is key , epr is value
    private static Hashtable endpointmap = null;
    private static String subject = null;

    private String m_rmJobId = null;
    private static int m_pullingInterval = 120;
    private Timer m_timer = null;
    private JobAttributes m_attr = null;


    private static String m_localport = null;
    private boolean done = false;

    private static final String TYPE_MMJFS = "mmjfs";
    private static final String TYPE_FORK = "mmjfs";
    private static final String TYPE_PBS = "mmjfs";
    private static final String TYPE_RMADAPTER = "rmadapter";
    private static final int    TIME_OUT  = 300000;  // 300 seconds
    private String subscriptionID = null;
    private static final String INDEX_SERVICE_URL = 
                           "ogsa/services/base/index/IndexService";
    private Element m_message;
    private static String    m_admin  = null;

    // tmp var
    private JobDataType m_jobdata = null;
    private String m_rsl = null;


    // factory var
    // resourcekey is key , name is value
    static Hashtable m_jobs = null;

    private static final String DEFAULT_NAMESPACE 
	= "http://www.platform.com/namespaces/2003/05/metascheduler/job";
    private static final String PREFIX_RSL = "RSL:";
    private static final String PREFIX_ID = "ID:";

    private static final int    DEFAULT_MIN_ID = 1;
    private static final int    DEFAULT_MAX_ID = 999999;
    private static final int    DEFAULT_PULLING_INTERVAL = 20;
    //handle modify to m_handle
    private static String m_handle = null;

    private static final String DEFAULT_GIS_HANDLE =
        "https://localhost:8443/ogsa/services/base/index/IndexService";
    private static final String DEFAULT_REGISTRY_HANDLE =
        "https://localhost:8443/ogsa/services/core/registry/ContainerRegistryService";

    private static final int sequence_min = 1;
    private static final int sequence_max = 999999;
    private int pulling_interval = 20;
    private static int sequence_next;
    private Vector admins;
    private StringBuffer sequence_date = new StringBuffer(10);
    private final SimpleDateFormat dateFmt = new SimpleDateFormat("yyyyMMdd_");
    private JobConfigParamsType m_config = null;

    // new var
    private static boolean m_inited = false;

    /**
     *  this flag indicates whether the client should wait for the 
     *  job to finish, and then destroy it.
     */
    private boolean destroy;

    /*
     * Create a resource which hasn't been assign value
    */
       public CreateResourceResponse createResource(CreateResource request)
			throws RemoteException {

		if (!this.m_inited){
			this.init();
		}

		logger.debug("Begin createResource!");

		ResourceContext ctx = null;
		JobResourceHome home = null;
		ResourceKey key = null;
	    EndpointReferenceType epr = null;


 	    String extendMsg = request.getCreateOp();
	    String jobname = request.getName();
            SecurityManager manager = SecurityManager.getManager();
	    String m_userID    = manager.getCaller(); 

	    if(jobname != null) {
	    	if(m_jobs.contains(jobname)) {
			logger.debug(MetaSchedulerConstants.JOB_SERVICE_ERR_EXIST + ": " + jobname);
			return new CreateResourceResponse(epr,MetaSchedulerConstants.JOB_SERVICE_ERR_EXIST);
	    	}
	    }

            if (extendMsg.startsWith(PREFIX_RSL)){
            	// new job
            	String rsl = extendMsg.substring(PREFIX_RSL.length());
            	logger.debug("RSL: " + rsl.toString());
            	QName jobID = new QName(m_handle, this.getNextID());
	    	/* modify config and status RP*/

		this.m_jobdata = new JobDataType();
		this.m_jobdata.setJobId(jobID);
		this.m_rsl     = rsl;
        	try {
            		processRsl();
        	} catch (Exception e) {
            		logger.error("Error processing rsl file: " , e);
        	}
		logger.debug("Create user is :" + m_userID);
            	logger.debug("Create new job with ID:" + jobID.toString());
            } else if (extendMsg.startsWith(PREFIX_ID)) {
                //existing job, cannot create new service. User should bind to
                // the job instance directly
                logger.error("Try to create new instance for existing job" );
                throw new RemoteException("Cannot create new instance for existing job");
            } else {
                logger.error("createServiceObject(): require : Either \"RSL:...\" or \"ID:...\"");
                throw new RemoteException("No Create type specified");
            }

	    try {
	    		ctx = ResourceContext.getResourceContext();
			logger.debug("Get resourceHome!");
			home = (JobResourceHome) ctx.getResourceHome();
			logger.debug("Home.Create()!");
			key = home.create(this.m_jobdata,m_rsl,m_userID,m_config);
			
 	    } catch (Exception e) {
			throw new RemoteException("", e);
	    }

            if (jobname == null) {
                jobname = ((Integer)key.getValue()).toString();
                logger.debug("set jobname:" + jobname);
            }

	    logger.debug("add to m_jobs,key is :" + (Integer)key.getValue() + ",name is:" +jobname);
	    m_jobs.put(key,jobname);
	    logger.debug("m_jobs size is :" + m_jobs.size());

	    try {
		epr = AddressingUtils.createEndpointReference(ctx, key);
		logger.debug("key is:" + (Integer)key.getValue());
	    } catch (Exception e) {
		throw new RemoteException("", e);
	    }
	    return new CreateResourceResponse(epr,"Success!");


/*        try {
            ServiceData serviceData;
            serviceData = this.getServiceDataSet().create(m_jobData.getJobId());
            m_serviceData = serviceData;
            this.getServiceDataSet().add(serviceData);
        } catch (Exception e) {
            logger.error("Error setting service data", e);
        }

        // aggregation
        try {
            this.subscriptionID = AggregationHelper.subscribe(
                                                m_localport+INDEX_SERVICE_URL,
                                                m_jobData.getJobId(),
                                                this.service_handle,
                                                999999);
            this.getServiceDataSet().get(m_jobData.getJobId()).notifyChange();
        } catch (Exception e) {
            e.printStackTrace();
        }*/
    }

    public void init() throws RemoteException{
         try {
		this.m_localport = "https://" + ServiceHost.getBaseURL().getHost()
                         	+ ":" + ServiceHost.getBaseURL().getPort()
                         	+ "/";
		this.m_handle  = m_localport + MetaSchedulerConstants.JOB_URL;
         } catch ( Exception e ) { }

	 this.m_jobs=new Hashtable();

         m_config = new JobConfigParamsType();
         m_config.setMinID(DEFAULT_MIN_ID);
         m_config.setMaxID(DEFAULT_MAX_ID);
         m_config.setPullinginterval(DEFAULT_PULLING_INTERVAL);
         m_config.setAdmin(new String[0]);
         m_config.setGisHandle(DEFAULT_GIS_HANDLE);
         m_config.setRegistryHandle(DEFAULT_REGISTRY_HANDLE);

	 m_admin     = System.getProperty("user.name"); 

	 try {
             this.processConfig();
         } catch (ConfigException e) {
             throw new RemoteException(e.getMessage());
         }
         if ( m_config.getPullinginterval() > 0 ) {
             m_pullingInterval = m_config.getPullinginterval()*1000;
         }
         this.sequence_next = this.sequence_min;
         this.sequence_date = this.currentSequenceDate();

         this.m_inited=true;
	 this.endpointmap = new Hashtable();
    }

    private StringBuffer currentSequenceDate() {
	StringBuffer sequence_now = new StringBuffer(10);

	long now = System.currentTimeMillis();
	this.dateFmt.format(new Date(now), sequence_now, new FieldPosition(0));

	return sequence_now;
    }

    private String getNextID() {
	StringBuffer sequence_now = this.currentSequenceDate();

	if (! sequence_now.toString().equals(this.sequence_date.toString())) {
	    this.sequence_date = sequence_now;
	    this.sequence_next = this.sequence_min;
	}

	String id = "ID_" + this.sequence_date.toString() + this.sequence_next;
	this.sequence_next ++;
	return (id);
    }

    private void processConfig() throws ConfigException {
	// read configuration
	String fileName = "etc/metascheduler/metascheduler-config.xml";
        logger.debug("serviceConfig=" + fileName);

        InputStream input = null;
        Document doc = null;
        try {
            input = new FileInputStream(fileName);
            if (input == null) {
                throw new ConfigException("Could not load config file: "
                                          + fileName);
            }
            doc = XMLUtils.newDocument(input);
        } catch (FileNotFoundException e) {
            logger.debug("Configuration file (" + fileName
                         + ") not found, using default values");
            return;
        } catch (Exception e) {
            throw new ConfigException(e);
        } finally {
            if (input != null) {
                try {
                    input.close();
                } catch (Exception e) {
                    throw new ConfigException(e);
                }
            }
        }

        NodeList nodes = doc.getElementsByTagNameNS(this.DEFAULT_NAMESPACE,
                                            "jobFactoryConfig");
        if (nodes.getLength() == 0) {
            logger.debug("No <jobFactoryConfig> section");
            return;
        }

        Element configElement = (Element)nodes.item(0);
        NodeList children = configElement.getChildNodes();
        if (children == null) {
            return;
        }

        ArrayList adminList = new ArrayList();
        for (int i=0; i<children.getLength(); i++) {
            Node childNode = children.item(i);
            String ns_uri = childNode.getNamespaceURI();
            String localname = childNode.getLocalName();

            logger.debug("Processing node <" + ns_uri + ":" + localname + ">");

            switch(childNode.getNodeType()) {
            case Node.ELEMENT_NODE:
                logger.debug("Is ELEMENT_NODE");
                if ( !ns_uri.equals(DEFAULT_NAMESPACE) ){
                    break;
                }

                String value = ((Element)childNode).getAttribute("value");
                if (value == null) {
                    break;
                }

                if ( localname.equals("minID") ) {
                    logger.debug("minID=" + value);
                    m_config.setMinID(Integer.parseInt(value));
                } else if ( localname.equals("maxID") ) {
                    logger.debug("maxID=" + value);
                    m_config.setMaxID(Integer.parseInt(value));
                } else if ( localname.equals("admin") ) {
                    logger.debug("admin=" + value);
                    adminList.add(value);
                } else if ( localname.equals("pullingInterval") ) {
                    logger.debug("pullingInterval=" + value);
                    m_config.setPullinginterval(Integer.parseInt(value));
                } else if ( localname.equals("queueName") ) {
                    logger.debug("queueName=" + value);
                    m_config.setQueuingservicename(value);
                } else if ( localname.equals("GisHandle") ) {
                    logger.debug("GisHandle=" + value);
                    m_config.setGisHandle(value);
                } else if ( localname.equals("registryHandle") ) {
                    logger.debug("registryHandle=" + value);
                    m_config.setRegistryHandle(value);
                }
                break;
            default:
                logger.debug("Not ELEMENT_NODE");
                break;
            }
        }
        m_config.setAdmin((String[])adminList.toArray(new String[0]));
    }

   /* get Resource reference , invoked when access RPs*/
    public JobResource getResource() throws RemoteException {
                logger.debug("Enter getResrouce!");
                Object resource = null;
                try {
                        resource = ResourceContext.getResourceContext().getResource();
                } catch (Exception e) {
                        logger.info("getResource() error!");
                        throw new RemoteException("", e);
                }
                JobResource jResource = (JobResource) resource;
                return jResource;
    }


    /**
     * JobImpl: constructor
     *
     * Parsing the rsl string. If the rsl contains an existing 
     * job instance id, then try to bind to that job instance, 
     * if it already exists.
     * If the bind fails, the instance is gone, take over the job 
     * and mark the job instance to itself.
     * If the job does not have an job instance, assign one and mark itself as
     * the owner of the job.
     * The job id is assigned by JobFactoryService, it is up to the
     * job instance to deside whether to take the id or not.
     * @param rsl  The rsl string of the job
     *        id   New JobId passed from JobFactory.
     */
       
    /**
     *
     * processRsl internal initialization of the JobService instance.
     *
     */
    private void processRsl() throws RSLParseException, 
                                     RemoteException {

        logger.debug("Entering processRsl...");
        //logger.debug("Rsl String ="+m_rslFile);
	try {
            m_rslParser = new MetaSchedulerRsl(this.m_rsl);
	} catch (RSLParseException e) {
            logger.error("Found errors in rsl file.", e);
            throw e;
	}

        //logger.debug("Rsl Parser string ="+m_rslParser.writeRslString());

        m_attr = new JobAttributes(m_rslParser.getRootElement());

	if ( m_attr == null) { 
	    logger.error("m_attr is NULL"); 
	} 
        logger.debug("Job attributes="+m_attr.toString());
   
        /**
         * check 
         */
        String instanceId = null;
        try {
            instanceId = m_attr.getJobInstanceId();
        } catch (RSLParseException e) {
	    logger.debug("Instance ID not initialized yet, must be new job.");
        }

        if ( instanceId != null ) {
            // Existant job. 
            // 
            logger.debug("Instance ID is "+instanceId);
        } else {
            logger.debug("Creating new job instance");
            logger.debug("In processRsl, trying to acquire lock");
            Calendar nowCal = Calendar.getInstance();
            this.m_jobdata.setHandleId(m_handle);
	    try {
		this.m_jobdata.setClusterName(m_attr.getCluster());
		logger.debug("Rsl specifies: clusterName: " + m_attr.getCluster());
            } catch (RSLParseException attE) {
		logger.debug("Cluster name is not set");
	    }

            try {
                this.m_jobdata.setGridRsvId(m_attr.getGridReservationId());
                logger.debug("Rsl specifies: gridReservationId: " + m_attr.getGridReservationId());
            } catch (RSLParseException attE) {
                logger.debug("Grid reservation id not set");
            }

            if ( m_attr.isMetaSchedulerJob()) {
                this.m_jobdata.setRslRootName("metascheduler:job");
            } else {
                this.m_jobdata.setRslRootName("gram:job");
            }
            this.m_jobdata.setSubmissionTime(nowCal);
            this.m_jobdata.setRsl(m_rslParser.writeRslString());
            this.m_jobdata.setState(GridJobStatus.Created);

            String clname = null;
            try {
                clname = m_attr.getCluster();
            } catch (RSLParseException e) {
                logger.debug("Cluster Name not set, Job service will not dispatch job.");
            }

        }
        logger.debug("m_jobData = " + JobDataHelper.toXmlString(this.m_jobdata));
    }

    public static String getFactoryUri() {
        return m_rmFactoryUrl;
    }

/*    public synchronized JobDataHelper getJobDataHelper() throws RemoteException {
        return m_jobData;
    }*/

    public synchronized GetJobDataTypeResponse getJobDataType(GetJobDataType request) throws RemoteException { 
	return new GetJobDataTypeResponse(this.getResource().getJobdata());
    }

    public String getState() throws RemoteException {
        String tmp = null;
        logger.debug("In getState, trying to acquire lock");
	JobResource resource = this.getResource();
        resource.acquire();
        try {
        tmp = resource.getJobdata().getState().toString();
        } catch (Exception e) {
             logger.debug("Error get job state"+e);
        }
        logger.debug("In getState, the current state is " + tmp);
        resource.release();
        return tmp;
    }

    public GetStatusResponse getStatus(GetStatus request) throws RemoteException {
        return new GetStatusResponse(getState());
    }

    public GetJobDataResponse getJobData(GetJobData request) throws RemoteException {
        logger.debug("Entering getJobData, handle id : "+this.m_handle);
	JobResource resource = this.getResource();
        resource.acquire();
	String jobstr = JobDataHelper.toXmlString(resource.getJobdata());
        resource.release();
        return new GetJobDataResponse(jobstr);
    }

    /**
     * Update service state and sends notification.
     */
    /*public synchronized void setServiceData() {
        
        logger.trace("In setServiceData");
        
        ServiceDataAttributes attributes = null;
        try {
            m_jobData.acquire();
            attributes =
              new ServiceDataAttributes(ObjectSerializer.toElement(m_jobData));
            m_jobData.release();
        } catch (Exception e) {
            e.printStackTrace();
            return;
        }

        Calendar nowCal = Calendar.getInstance();
        Calendar hourLaterCal = Calendar.getInstance();
        hourLaterCal.add(Calendar.HOUR_OF_DAY, 1);

        attributes.setAvailableUntil(new ExtendedDateTimeType(hourLaterCal));
        attributes.setGoodFrom(new ExtendedDateTimeType(nowCal));
        attributes.setGoodUntil(new ExtendedDateTimeType(hourLaterCal));
        attributes.setOriginator(new HandleType(this.service_handle));
        m_serviceData.setValue(attributes);

        m_serviceData.notifyChange();
    }*/

/*    public void setGramJob(GramJob job) {
        m_job = job;
    }*/

    /**
     * Submit job to a queuing service.
     *
     * @params queueName submit job to the specified queue or default if null. Queue name
     *                   can be either a name, which the local QueuingFactory will be contacted,
     *                   or a handle, could be a remote handle.
     * @return The job instance handle string.
     * 
     */
    public SubmitResponse submit(Submit request) throws RemoteException {
	EndpointReferenceType jobepr = request.getJobEpr();
	String queueName = request.getQueueName();
	checkClientContext();
        JobResource resource = this.getResource();
        QueuingPortType queue = null;
        QueuingRequestType req = new QueuingRequestType( );
        req.setJobEpr(jobepr);

        GridJobStatus state = resource.getJobdata().getState();
        if ( state != GridJobStatus.Created &&
             state != GridJobStatus.Sched_susp) {
           // Wrong state, throw an exception
            logger.error("Job state is wrong for submit to queue: " + 
                         state.toString());
            throw new RemoteException("Wrong state to submit job:"
                                           +state.toString());
        }

        try {
            if ( queueName != null && queueName.length() != 0 ) {
                logger.debug("In submit to queue " + queueName);
                queue = getQueueService(queueName);
		resource.setQueueName(queueName);
                queue.submit(new com.platform.metascheduler.queuing.Submit(req));
            } else if (( resource.getQueueName() != null) && !(resource.getQueueName().startsWith("NONE"))) {
                // For resuming a sched_susp job
                logger.debug("submit to queue " + resource.getQueueName());
                queue = getQueueService(resource.getQueueName());
                queue.submit(new com.platform.metascheduler.queuing.Submit(req));
            } else if ( resource.getJobConfig().getQueuingservicename() != null ) {
		String nameFromConfig = resource.getJobConfig().getQueuingservicename();
                logger.debug("submit to default queue " + nameFromConfig);
                queue = getQueueService(nameFromConfig);
                resource.setQueueName(queueName);
                queue.submit(new com.platform.metascheduler.queuing.Submit(req));
            } else {
		throw new RemoteException("No queue is defined in queuing factory");
            }
            setState(GridJobStatus.Sched);
        } catch (RemoteException e) {
	    throw e;
        }
        return new SubmitResponse(resource.getJobdata().getHandleId());
    }

    /**
     * Send the job to a cluster.
     * The job service will try to look for the ResourceManager handle
     * which serves the clusterName. If not found, it will check the
     * mmjfs handle in the rsl file. If still not found, it will send
     * the job to local mmjfs by default.
     *
     * @param clusterName The name of the cluster to run job.
     * @return jobId returned by the resource manager.
     */

    public StartResponse start(Start request) 
	     throws RemoteException {
	String factoryUri = request.getFactoryUri();
	String clusterName = request.getClusterName();
	String rmTypeString = request.getRmType();
	String rmRsvId = request.getRmRsvId();
	checkClientContext();
	RmFactoryType rmType = null; 
	if ( rmTypeString != null) {
	    try { 
                if ( rmTypeString.equals(RmFactoryType._Fork)
		     || rmTypeString.equals(RmFactoryType._Fork )) {
		    rmType = RmFactoryType.Fork;
                } else if ( rmTypeString.equals(RmFactoryType._PBS )) {
		    rmType = RmFactoryType.PBS;
                } else if ( rmTypeString.equals(RmFactoryType._Multi )) {
		    rmType = RmFactoryType.Multi;
                } else if ( rmTypeString.equals(RmFactoryType._LSF )) {
		    rmType = RmFactoryType.LSF;
                } else {
		    rmType = RmFactoryType.RMFS;
                }

	    } catch ( IllegalStateException e) { 
		rmType = RmFactoryType.RMFS;
	    }
	} 
	return new StartResponse(start(factoryUri, clusterName, rmType, rmRsvId)); 
    }

    // Dispatch the job to the cluster with specified rsvId. 
    // rsvId could be null.
    //
    private String start(String factoryUri, String clusterName, 
			 RmFactoryType rmType, String rsvId) throws 
			     RemoteException {
        String tmpFactoryUri = null;
	String rmJobId = null;
	JobResource resource = this.getResource();
        GridJobStatus state = resource.getJobdata().getState();
        ResourceKey  jobkey = null;
        try{
               jobkey = ResourceContext.getResourceContext().getResourceKey();
        } catch (Exception e) {
               logger.error("get current ResourceKey error:" + e.getMessage());
               throw new RemoteException("get current ResourceKey error",e);
        }

	if ( rmType != null) { 
	    logger.debug("Job " + m_handle + 
                     " receives start request: " + rmType.toString() + 
                     ":" + factoryUri + ":" + clusterName); 
	} else { 
	    logger.debug("Job " + m_handle + 
                     " receives start request: rmType=null"  + 
                     ":" + factoryUri + ":" + clusterName); 

	}

	if ( state == null) { 
	    logger.error("Job state is unknown"); 
            throw new RemoteException("Wrong state to start job :");
	}

        if ( state != GridJobStatus.Created &&
             state != GridJobStatus.Sched_susp && 
             state != GridJobStatus.Pend && 
             state != GridJobStatus.Sched) {
           // Wrong state, throw an exception
            logger.error("Job state is wrong for start: " + state.toString());
            throw new RemoteException("Wrong state to start job :"+
                                            state.toString());
        }

        if ( rmType != null && ! rmType.equals(RmFactoryType.RMFS)) {
            if( resource.getJobdata().getRslRootName().equals("metascheduler:job")){
                // Reject the start request as the job file format 
                // is not compabitable with gram.
                logger.error("Wrong job file format for gram job");
                throw new RemoteException("Job file format incompabitable with gram");
            }
        }
        // TODO Do job file stagging first before submit job to resource maneger.
        setState(GridJobStatus.Pend);
        logger.debug("Entering start: cluster:" + 
                      clusterName+" URI:"+factoryUri+ "type:"+rmType);

        resource.setRmtype(rmType);
	// type is GRAM
        if ( rmType != null && ! rmType.equals(RmFactoryType.RMFS)) {
            logger.debug("Submitting job to gram " + factoryUri);
            try {
                String tmpType = null;
                if ( rmType.equals(RmFactoryType.Fork)) {
		    tmpType = "Fork";
                    resource.setDestType("Fork");
                } else if (rmType.equals(RmFactoryType.PBS)) {
		    tmpType = rmType.toString();
                    resource.setDestType(rmType.toString());
                } else if (rmType.equals(RmFactoryType.Multi)) {
		    tmpType = rmType.toString();
                    resource.setDestType(rmType.toString());
                } else {
		    tmpType = rmType.toString();
                    resource.setDestType(rmType.toString());
                }
                JobGramTask gramtask = new JobGramTask(jobkey, resource.getRsl(), factoryUri, tmpType, this.getGSSCredential());
		resource.setJobGramTask(gramtask);
                gramtask.start();
                setState(GridJobStatus.Run);
                m_rmFactoryUrl = factoryUri;
            } catch (Exception e) {
                logger.error("Error running job through mmjfs ", e); 
                throw new RemoteException("Error running job through mmjfs", e);
            }
            return new String("GramJob");
        }

        if ( factoryUri == null || factoryUri.length() == 0) {
            tmpFactoryUri = 
                m_localport+MetaSchedulerConstants.RESOURCE_MANAGER_FACTORY_URL;
        } else {
            tmpFactoryUri = factoryUri;
        }
        try {
            ResourceManagerLsfPortType adapter = getRMAdapter(tmpFactoryUri, clusterName,this.getGSSCredential());

	    // if havn't gotten LsfPortType , submit the job as a GramJob
            if ( adapter == null ) {
		if (tmpFactoryUri.indexOf(MetaSchedulerConstants.RESOURCE_MANAGER_FACTORY_URL) > 0) {
		    throw new RemoteException("Cannot access cluster: " + tmpFactoryUri + ";" + clusterName);
		}  
                // try mmjfs
                // Use default factoryUrl and Fork
                logger.debug("Sending job to Gram");
                String factory = m_localport+"wsrf/services/ManagedExecutableJobService";
                JobGramTask gramtask = new JobGramTask(jobkey, m_rslFile, factory, 
                                  RmFactoryType.Fork.toString(), this.getGSSCredential());
		resource.setJobGramTask(gramtask);
                gramtask.start();
                setState(GridJobStatus.Run);
                resource.setDestType(RmFactoryType.Fork.toString());
                m_rmFactoryUrl = factory;
            } else {
                m_clusterName = clusterName;
                m_rmFactoryUrl = tmpFactoryUri;

		// Modify m_rslFile to map Grid Reservation ID to RM rsvId
		String rslFile = resource.getRsl();
		String submitRslFile = mapGridRsvID(rslFile, rsvId);

		if ( submitRslFile != null) { 
                    rmJobId = adapter.jobSubmit(new JobSubmit(submitRslFile)).getJobId();
		} else { 
                    rmJobId = adapter.jobSubmit(new JobSubmit(rslFile)).getJobId();
		}

                logger.debug("Got job id from resource manager: " + rmJobId);
                if ( rmJobId != null ) {
                    resource.getJobdata().setRmJobId(rmJobId);
                    resource.getJobdata().setClusterName(clusterName);
                }
                resource.setDestType(TYPE_RMADAPTER);
                m_timer = new Timer();
                logger.debug("Set timer for pulling at interval " + m_pullingInterval);
                m_timer.schedule(new JobInfoTask(jobkey,this.getGSSCredential()), 
                                 m_pullingInterval, m_pullingInterval);
            }
            logger.debug("Job forwarded");
            setState(GridJobStatus.Forwarded);
        } catch (Exception e) {
            logger.error("Failed to submit job to Resource Manager", e);
            throw new RemoteException("Failed to submit job to Resource Manager", e);
        }
        return rmJobId;
    }

    /**
     * Kill the job.
     */
    public CancelResponse cancel(Cancel request) throws RemoteException {
	logger.debug("Enter cancel!");
	checkClientContext();
        int ret = 0;
	JobResource resource = this.getResource();
	String rmJobId = resource.getJobdata().getRmJobId();
        logger.debug("Enter cancel for job " + resource.getJobdata().getJobId());
        try {
            GridJobStatus state = resource.getJobdata().getState();

            if ( (state == GridJobStatus.Created) ||
                 (state == GridJobStatus.Pend) ||
                 (state == GridJobStatus.Sched_susp) ||
                 (state == GridJobStatus.Pend_susp)) {
                // Just change the state
                jobExit();
            } else if (state == GridJobStatus.Sched) {
                // Ask Queuing service to cancel the job or do nothing
                /*if ( m_queueName != null ) {
                    QueuingPortType queue = getQueueService(m_queueName);
                    QueuingRequestType req = new QueuingRequestType( );
                    req.setJobHandle(this.service_handle);
                    queue.remove(req);
                }
                jobExit();*/
            } else if ((state == GridJobStatus.Forwarded) ||
                    (state == GridJobStatus.Forw_susp) ||
                    (state == GridJobStatus.Run) ||
                    (state == GridJobStatus.Run_susp)) {
  
                if ( resource.getDestType() == TYPE_RMADAPTER ) {
                    ResourceManagerLsfPortType adapter = 
                              getRMAdapter(m_rmFactoryUrl, m_clusterName,this.getGSSCredential());

                    logger.debug("Calling RM adapter to kill job  "+ rmJobId);
		    ret = adapter.jobControl(new JobControl(rmJobId,
					MetaSchedulerConstants.job_control_kill)).getReply();

                    logger.debug("After call RM adapter to kill job  "+ rmJobId);
                    m_timer.cancel();
                    jobExit();
                } else {
                  /*  logger.debug("Calling GramTask to kill job  "+ rmJobId);
                    m_job.cancel();
                    jobExit();
                    setState(GridJobStatus.PExit);*/
                }
            } else { 
                // Too late, do nothing
                logger.debug("Trying to cancel an exited or done job");
                throw new RemoteException("Cannot cancel job since it is already finished");
            }
        } catch (Exception e) {
            logger.error("Error kill job", e);
            ret = -1;
        }
        if ( ret == 0 ) {
            logger.debug("Job killed "+ rmJobId);
            return new CancelResponse(true);
        } else {
            logger.debug("Error kill job "+ rmJobId);
            return new CancelResponse(false);
        }
    }

    /** 
     * Suspend the job.
     */
    public StopResponse stop(Stop request) throws RemoteException {
	checkClientContext();
	int ret = 0;
        boolean retval=true;
        JobResource resource = this.getResource();
        try {
            ResourceManagerLsfPortType adapter = null;

            if ( resource.getDestType() == TYPE_RMADAPTER) {
                adapter  = getRMAdapter(m_rmFactoryUrl, m_clusterName,this.getGSSCredential());
            }

            GridJobStatus state;

            logger.debug("In stop, trying to acquire lock");
            resource.acquire();
            state  = resource.getJobdata().getState();
	    String rmJobId = resource.getJobdata().getRmJobId();
            resource.release();
            if ( state == GridJobStatus.Sched ) { 
              /*  QueuingPortType queue = getQueueService(m_queueName);
                QueuingRequestType req = new QueuingRequestType();
                req.setJobHandle(this.service_handle);
                queue.remove(req);
                setState(GridJobStatus.Sched_susp); */
            } else if ( state == GridJobStatus.Forwarded ) {
                if ( resource.getDestType() == TYPE_RMADAPTER ) {
		    ret = adapter.jobControl(new JobControl(rmJobId,
					MetaSchedulerConstants.job_control_stop)).getReply();
                    if ( ret == 0) {
                        setState(GridJobStatus.Forw_susp);
                    } else {
                        retval = false;
                    }
                } else {
                    // should not go into this state
                    /*setState(GridJobStatus.Forw_susp);
                    m_job.cancel();*/
                }
            } else if ( state == GridJobStatus.Run ) {
                if ( resource.getDestType() == TYPE_RMADAPTER ) {
		    ret = adapter.jobControl(new JobControl(rmJobId,
					MetaSchedulerConstants.job_control_stop)).getReply();
                    if ( ret == 0) {
                        setState(GridJobStatus.Run_susp);
                    } else {
                        retval = false;
                    }
                } else {
                    /*setState(GridJobStatus.Run_susp);
                    m_job.cancel();*/
                }
            } else if ( state == GridJobStatus.Pend ) {
                setState(GridJobStatus.Pend_susp);
            } else {
                retval = false;
            }
        } catch (Exception e) {
            logger.error("Error stopping job", e);
        }
        return new StopResponse(retval);
    }

    public SignalResponse signal(Signal request) throws RemoteException {
	String sig = request.getSig();
	checkClientContext();
        int ret = 0;
        JobResource resource = this.getResource();
        try {
            ResourceManagerLsfPortType adapter;

            if ( resource.getDestType() == TYPE_RMADAPTER) {
                adapter  = getRMAdapter(m_rmFactoryUrl, m_clusterName,this.getGSSCredential());
	        String rmJobId = resource.getJobdata().getRmJobId();
		ret = adapter.jobControl(new JobControl(rmJobId,sig)).getReply();
            } else {
                //resource.getGramJob().signal( Integer.parseInt(sig));
            }
        } catch (Exception e) {
            logger.error("Failed to send signal to job ", e);
            ret = -1;
        }
        if ( ret == 0 ) {
            return new SignalResponse(true);
        } else {
            return new SignalResponse(false);
        }
    }

    /**
     * modify the job parameter, not implemented.
     *
     * Not implemented.
     */
    public ModifyResponse modify(Modify request) throws RemoteException {
	checkClientContext();
	logger.debug("PortType modify not implement yet!");
        return new ModifyResponse(true);
    }

    /**
     * Resume a suspended job.
     */
    public ResumeResponse resume(Resume request) throws RemoteException {
	checkClientContext();
        ResourceKey  jobkey = null;
        try{
               jobkey = ResourceContext.getResourceContext().getResourceKey();
        } catch (Exception e) {
               logger.error("get current ResourceKey error:" + e.getMessage());
               throw new RemoteException("get current ResourceKey error",e);
        }
        int ret = -1;
        JobResource resource = this.getResource();
        String tmpState = getState();
        logger.debug("In resume, current state is "+ tmpState);
        try {
            if ( tmpState.equals(GridJobStatus.Forw_susp.toString()) || 
                 tmpState.equals(GridJobStatus.Run_susp.toString())) {        

                if ( resource.getDestType() == TYPE_RMADAPTER) {
                    ResourceManagerLsfPortType adapter;
                    adapter  = getRMAdapter(m_rmFactoryUrl, m_clusterName,this.getGSSCredential());
	            String rmJobId = resource.getJobdata().getRmJobId();
		    ret = adapter.jobControl(new JobControl(rmJobId,MetaSchedulerConstants.job_control_resume)).getReply();
                } else {
                    JobGramTask gramtask = new JobGramTask(jobkey,
                                        m_rslFile, 
                                        m_rmFactoryUrl, 
                                        resource.getDestType(), 
					this.getGSSCredential());
		    resource.setJobGramTask(gramtask);
                    gramtask.start();
                    setState(GridJobStatus.Run);
                }
            } else if (tmpState.equals(GridJobStatus.Pend_susp.toString())) {
                // Change state to pending
		resource.acquire();
                start(m_rmFactoryUrl, resource.getJobdata().getClusterName(), resource.getRmtype(), null);
		resource.release();
                ret = 0;
            } else if (tmpState.equals(GridJobStatus.Sched_susp.toString())) {
                // Resubmit the job
                /*submit(m_queueName);
                ret = 0;*/
            } else {
                logger.error("Wrong job state to resume job");
            }
        } catch (Exception e) {
            logger.error("Cannot resume job", e);
        }
        if (ret== 0 ) {
            return new ResumeResponse(true);
        } else {
            return new ResumeResponse(false);
        }
    }

    /**
     * Job finished. Do post done cleanup
     *
     */
    public boolean jobDone() throws RemoteException {
/*        if ( m_state == GridJobStatus.Run_susp &&
             resource.getDestType() != TYPE_RMADAPTER) {
            // For GRAM job suspended means kill it 
            // and restart it later so we need to 
            // ignore the exit status update.
            return true;
        } else {
            setState(GridJobStatus.PDone);
        }
        return true;*/
        return true;
    }

    /**
     * Job exited. Do post exit cleanup
     *
     */
    public boolean jobExit() throws RemoteException {
	JobResource resource = this.getResource();
	GridJobStatus state = resource.getJobdata().getState();
        if ( state == GridJobStatus.Run_susp &&
             resource.getDestType() != TYPE_RMADAPTER) {
            // For GRAM job suspended means kill it 
            // and restart it later so we need to 
            // ignore the exit status update.
            return true;
        } else {
            setState(GridJobStatus.PExit);
        }
        return true;
    }

    private QueuingPortType getQueueService(String queueName) 
                     throws RemoteException{
	// for transport-level security
        org.globus.axis.util.Util.registerTransport();

	logger.debug("get " + queueName + " port");
        QueuingPortType queue= null;
        String tmpQueueName = null;
	EndpointReferenceType endpoint= null;
    
        try {
            //TODO talk to GIS for the queuename to handle mapping.
            String queueString = null;
            if ( queueName.startsWith("https://")) {
                // It's a handle
                queueString = queueName.substring(0, queueName.lastIndexOf('/')-1);
                tmpQueueName = queueName.substring(queueName.lastIndexOf('/')+1);
            } else {
                queueString = new String(m_localport+MetaSchedulerConstants.QUEUING_URL);
                tmpQueueName = queueName;
            }
		MessageContext ctx = MessageContext.getCurrentContext();
 		SecurityContext sec = (SecurityContext)ctx.getProperty(Constants.CONTEXT);
                GSSCredential tmp = null;
                try{
                        tmp = sec.getDelegatedCredential();
                }catch (Exception e) {
                        logger.debug(e.getMessage());
                }

	    logger.debug("queueString =" + queueString);
	    QueuingServiceAddressingLocator locator = new QueuingServiceAddressingLocator();
            endpoint = new EndpointReferenceType();
            endpoint.setAddress(new Address(queueString));
            queue = locator.getQueuingPortTypePort(endpoint);
	    String status = null;

            if ( tmp != null) {
                try {
                        logger.debug("Credential is for identity : " + tmp.getName().toString());
                        ((Stub)queue)._setProperty(GSIConstants.GSI_CREDENTIALS, tmp);
                } catch (org.ietf.jgss.GSSException e) { }
            } else{ 
		logger.debug("client dosen't have credential !");
	    }

            ((Stub)queue)._setProperty(GSIConstants.GSI_MODE,
                           GSIConstants.GSI_MODE_LIMITED_DELEG);
            ((Stub)queue)._setProperty(Constants.GSI_SEC_CONV,
                           Constants.SIGNATURE);
            ((Stub)queue)._setProperty(Constants.AUTHORIZATION,
                                        HostAuthorization.getInstance());
            //((Stub)queue)._setProperty(Constants.GRIM_POLICY_HANDLER,
            //                            new IgnoreProxyPolicyHandler());
            //((org.apache.axis.client.Stub)queue).setTimeout(0);

            com.platform.metascheduler.queuing.CreateResourceResponse createResponse = queue.createResource(
			new com.platform.metascheduler.queuing.CreateResource(tmpQueueName));
            status = createResponse.getStatus();
            endpoint = createResponse.getEndpointReference();
            if (status.startsWith(MetaSchedulerConstants.QUEUE_SERVICE_ERR_EXIST)) {
                   logger.debug("In JobImpl.getQueueService :" + 
				MetaSchedulerConstants.QUEUE_SERVICE_ERR_EXIST);
            }
            queue = locator.getQueuingPortTypePort(endpoint);
            if ( tmp != null) {
                try {
                        logger.debug("Credential is for identity : " + tmp.getName().toString());
                        ((Stub)queue)._setProperty(GSIConstants.GSI_CREDENTIALS, tmp);
                } catch (org.ietf.jgss.GSSException e) { }
            } else{ 
		logger.debug("client dosen't have credential !");
	    }
            ((Stub)queue)._setProperty(GSIConstants.GSI_MODE,
                           GSIConstants.GSI_MODE_LIMITED_DELEG);
            ((Stub)queue)._setProperty(Constants.GSI_SEC_CONV,
                           Constants.SIGNATURE);
            ((Stub)queue)._setProperty(Constants.AUTHORIZATION,
                                        HostAuthorization.getInstance());
            //((Stub)queue)._setProperty(Constants.GRIM_POLICY_HANDLER,
            //                            new IgnoreProxyPolicyHandler());
            //((org.apache.axis.client.Stub)queue).setTimeout(0);

        } catch (RemoteException e) {
            String msg = e.getMessage();
            logger.debug("QueueFactory throws exception, message:"+ msg);
            if (msg.indexOf(MetaSchedulerConstants.QUEUE_SERVICE_ERR_NOCONFIG) > 0) {
		msg = MetaSchedulerConstants.QUEUE_SERVICE_ERR_NOCONFIG;
		logger.error(msg);
		throw new RemoteException(msg);
	    } else if (msg.indexOf(MetaSchedulerConstants.QUEUE_SERVICE_ERR_INVALID_NAME) > 0) {
		msg = MetaSchedulerConstants.QUEUE_SERVICE_ERR_INVALID_NAME + 
                      ": " + queueName;
		logger.error(msg);
		throw new RemoteException(msg);
	    } else {
                logger.error("Error getting Queueing Service, unknown fault type: "+ msg);
            }
	} catch (Exception e) {
            logger.error("Error getting Queueing Service ", e);
        }
        return queue;
    }

/*    private IndexService getIndexServiceInstance() {
        IndexService index=null;
        try {
            URL indexportUrl = new URL(m_localport + INDEX_SERVICE_URL);
            IndexServiceGridLocator indexLocator = new IndexServiceGridLocator();
            index = indexLocator.getIndexServicePort(indexportUrl);
        } catch (MalformedURLException urlE) {
            logger.error("Error parsing target URL ", urlE);
        } catch (GridServiceException gridE) {
            logger.error("Error locating Index Service port", gridE);
        }
        return index;
    }*/

    public static ResourceManagerLsfPortType getRMAdapter(String clusterName,GSSCredential tmp) throws RemoteException {
        // TODO find the cluster name to factory URI mapping

        String factoryUri = m_localport+ 
                            MetaSchedulerConstants.RESOURCE_MANAGER_FACTORY_URL;
        if ( m_rmFactoryUrl != null ) {
            return getRMAdapter(m_rmFactoryUrl, clusterName,tmp);
        } else {
            return getRMAdapter(factoryUri, clusterName,tmp);
        }
    }

    public static ResourceManagerLsfPortType getRMAdapter(String factoryUri, 
							  String clusterName,
							  GSSCredential tmp) 
   		throws RemoteException {
	// for transport-level security
        org.globus.axis.util.Util.registerTransport();

        ResourceManagerLsfPortType rmport=null;

	logger.debug("In getRMAdapter factoryURL=" + factoryUri + " m_rmFactoryUrl="+
                      m_rmFactoryUrl+" clusterName="+clusterName);


	// If epr exists. Get LsfPortType from epr.
        if ( ((m_rmFactoryUrl != null ) && m_rmFactoryUrl.equals(factoryUri)) &&
              endpointmap.containsKey(subject+clusterName)) {
            try {
		EndpointReferenceType endpoint = (EndpointReferenceType)endpointmap.get(subject+clusterName);
	        logger.debug("Trying to reuse existing rmport");
                ResourceManagerLsfServiceAddressingLocator locator = new
                                ResourceManagerLsfServiceAddressingLocator();
                rmport = locator.getResourceManagerLsfPortTypePort(endpoint);
	 	if ( tmp != null ) { 
	            ((Stub)rmport)._setProperty(GSIConstants.GSI_CREDENTIALS, tmp);
	 	} 
                ((Stub)rmport)._setProperty(Constants.GSI_SEC_CONV,
                                            Constants.SIGNATURE);
                ((Stub)rmport)._setProperty(GSIConstants.GSI_MODE,
                                    GSIConstants.GSI_MODE_LIMITED_DELEG);
                ((Stub)rmport)._setProperty(Constants.AUTHORIZATION,
                                        HostAuthorization.getInstance());
	        //((Stub)rmport)._setProperty(Constants.GRIM_POLICY_HANDLER,
		//			new IgnoreProxyPolicyHandler());
		((org.apache.axis.client.Stub)rmport).setTimeout(TIME_OUT);
                Calendar timeout = Calendar.getInstance();
                timeout.add(Calendar.MINUTE, m_pullingInterval*2/60+5);

            	SetTerminationTimeResponse response = rmport.setTerminationTime(new SetTerminationTime(timeout));
	    	Calendar newTermTime = response.getNewTerminationTime();

            	logger.debug("requested: " + timeout.getTime());
            	logger.debug("scheduled: " + newTermTime.getTime());

            } catch (RemoteException e) {
		// the endpoint is overdue , remove it ,and try to create a new
		endpointmap.remove(subject+clusterName);
            } catch (Exception e) {
                e.printStackTrace();
            } 

	    if (endpointmap.containsKey(subject+clusterName)) {
            	return rmport;
	    }
        }

        try {
            // TODO talk to GIS for rm adapter factory to clustername mapping
	    logger.debug("enter getRMAdapter " + clusterName);
	    ResourceManagerLsfServiceAddressingLocator locator = new
                                ResourceManagerLsfServiceAddressingLocator();

            logger.debug("rmport : " +factoryUri);
            EndpointReferenceType endpoint = createRmService(factoryUri, clusterName);
	    logger.debug(endpoint.getAddress());
            rmport = locator.getResourceManagerLsfPortTypePort(endpoint);
	    if ( tmp != null ) { 
	        ((Stub)rmport)._setProperty(GSIConstants.GSI_CREDENTIALS, tmp);
	    } 
            ((Stub)rmport)._setProperty(Constants.GSI_SEC_CONV,
                                            Constants.SIGNATURE);
            ((Stub)rmport)._setProperty(GSIConstants.GSI_MODE,
                                    GSIConstants.GSI_MODE_LIMITED_DELEG);
            ((Stub)rmport)._setProperty(Constants.AUTHORIZATION,
                                        HostAuthorization.getInstance());
	    //((Stub)rmport)._setProperty(Constants.GRIM_POLICY_HANDLER,
	    //				new IgnoreProxyPolicyHandler());
	    ((org.apache.axis.client.Stub)rmport).setTimeout(TIME_OUT);

            Calendar timeout = Calendar.getInstance();
            timeout.add(Calendar.MINUTE, m_pullingInterval*2/60+5);

            SetTerminationTimeResponse response = rmport.setTerminationTime(new SetTerminationTime(timeout));
	    Calendar newTermTime = response.getNewTerminationTime();

            logger.debug("requested: " + timeout.getTime());
            logger.debug("scheduled: " + newTermTime.getTime());
	    logger.debug("save endpoint to map");
	    endpointmap.put(subject+clusterName,endpoint);

        } catch (Exception e) {
            logger.error("Error locating Resource Manager port", e);
        }
        return rmport;
    }

    private GSSCredential getGSSCredential() {
        MessageContext ctx = MessageContext.getCurrentContext();
	SecurityContext sec = (SecurityContext)ctx.getProperty(Constants.CONTEXT);
	GSSCredential tmp = null; 
	try{
		tmp = sec.getDelegatedCredential(); 
	}catch (Exception e) { 
		logger.debug(e.getMessage()); 
	}
	if ( tmp != null) {
	    try {
	        logger.debug("Credential is for identity : " + tmp.getName().toString());
	    } catch (org.ietf.jgss.GSSException e) { }
	}
	return tmp;
    }

    private static EndpointReferenceType createRmService(String factoryURI, String cluster) {

 	ResourceManagerFactoryServiceAddressingLocator locator =
 		new ResourceManagerFactoryServiceAddressingLocator();
 	ResourceManagerFactoryPortType rmf = null;
	EndpointReferenceType endpoint = null;

        logger.debug(": enter createRmService");
	try {
		logger.debug("factory=" +factoryURI);
		logger.debug("cluster=" +cluster);
              	endpoint = new EndpointReferenceType();
              	endpoint.setAddress(new Address(factoryURI));
	      	rmf = locator.getResourceManagerFactoryPortTypePort(endpoint);
		// Setup client delegation
		//GSSCredential tmp = SecureServicePropertiesHelper.getCredential(this);
		//if ( tmp != null) {
	 	//   try {
	 	//       logger.debug("Credential is for identity : " + tmp.getName().toString());
	 	//   } catch (org.ietf.jgss.GSSException e) {
	 	//   }
	 	//   gridFactory.getStub()._setProperty(GSIConstants.GSI_CREDENTIALS, tmp);
		//}
	        MessageContext ctx = MessageContext.getCurrentContext();
		SecurityContext sec = (SecurityContext)ctx.getProperty(Constants.CONTEXT);
		GSSCredential tmp = null; 
		try{
			tmp = sec.getDelegatedCredential(); 
		}catch (Exception e) { 
			logger.debug(e.getMessage()); 
		}
		if ( tmp != null) {
		    try {
		        logger.debug("Credential is for identity : " + tmp.getName().toString());
			((Stub)rmf)._setProperty(GSIConstants.GSI_CREDENTIALS, tmp);
		    } catch (org.ietf.jgss.GSSException e) { }
		}else{logger.debug("NULL!!!!!!!!!!!!!!!!!!");}

		((Stub)rmf)._setProperty(GSIConstants.GSI_MODE,
					   GSIConstants.GSI_MODE_LIMITED_DELEG);
		((Stub)rmf)._setProperty(Constants.GSI_SEC_CONV,
					   Constants.SIGNATURE);
		((Stub)rmf)._setProperty(Constants.AUTHORIZATION,
					   HostAuthorization.getInstance());
		//((Stub)rmf)._setProperty(Constants.GRIM_POLICY_HANDLER,
		//			   new IgnoreProxyPolicyHandler());
		CreateResourceManagerResponse response = rmf.createResourceManager(new CreateResourceManager(cluster,null));
                endpoint = response.getEndpointReference();

        } catch ( RemoteException e) {
            logger.error("Remote Exception: " + e);
	    //throw new RemoteException(e.getMessage());
        } catch ( Exception e) {
            logger.error("Exception: " + e);
	}

        logger.debug(": leaving createRmService");
	logger.debug(endpoint.getAddress());
        return endpoint;
    }

    public boolean setState(GridJobStatus state) throws RemoteException{
        logger.debug("In setState, new state = "+state);
	JobResource resource = this.getResource();
        resource.acquire();
        resource.getJobdata().setState(state);
        resource.release();
        // update ServiceData and notify change
        //setServiceData();
        return true;
    }

    private static String mapGridRsvID(
            String rslString,
	    String rsvID)
    {
	logger.debug("RSL=" + rslString);
	logger.debug("rsvID=" + rsvID);

	Document doc = null;
	try {
	    MetaSchedulerRsl rsl = new MetaSchedulerRsl(rslString);
	    doc = rsl.getDocument();
	} catch (Exception e) {
            logger.error("Found errors in rsl file.", e);
	    return null;
	}

	NodeList list = doc.getElementsByTagNameNS(
				   MetaSchedulerConstants.METASCHEDULER_RSL_NS,
				   "job");
	// there should only be one.
	if (list.getLength() != 1) {
	    return null;
	}

	Node jobNode = list.item(0);
	if (jobNode.getNodeType() != Node.ELEMENT_NODE) {
	    return null;
	}

	NodeList jobList = ((Element)jobNode).getElementsByTagNameNS(
				   MetaSchedulerConstants.METASCHEDULER_RSL_NS,
				   "gridReservationId");

	// should only be one
	if (jobList.getLength() != 1) {
	    return null;
	}

	Node gridRsvNode = jobList.item(0);
	if (gridRsvNode.getNodeType() != Node.ELEMENT_NODE) {
	    return null;
	}

	Element rsvElement = doc.createElementNS(
				 MetaSchedulerConstants.METASCHEDULER_RSL_NS,
				 "metascheduler:reservationId");
	Element rslElement = doc.createElementNS(
				 MetaSchedulerConstants.RSL_NS,
				 "rsl:string");
	Element stringElement = doc.createElementNS(
				 MetaSchedulerConstants.RSL_NS,
				 "rsl:stringElement");
	stringElement.setAttribute("value", rsvID);
	rslElement.appendChild(stringElement);
	rsvElement.appendChild(rslElement);

	jobNode.replaceChild(rsvElement, gridRsvNode);

	String outString = XMLUtils.DocumentToString(doc);
	
	logger.debug("outString:" + outString);
	return outString;
    }

   private void checkClientContext() throws RemoteException {
        MessageContext ctx = MessageContext.getCurrentContext();
	SecurityContext sec = (SecurityContext)ctx.getProperty(Constants.CONTEXT);
	//SecurityManager.getManager().setServiceOwnerFromContext();
        if (sec == null) {
            throw new RemoteException("Service requires secure access.");
	}
	GSSContext context = sec.getContext();
	try {
	    String clientID = context.getSrcName().toString();

	    SecurityManager securityManager = SecurityManager.getManager();
	    this.subject = securityManager.getCaller();
	    logger.debug("currentUserSubject= " + subject);
            String[] localUserIds = securityManager.getLocalUsernames();
            String username = localUserIds[0];
	    String createuser = this.getResource().getCreateuser();

	    logger.debug("The CreateUser: " + createuser);
	    if (clientID.equals(createuser) ) {
		logger.debug("The client ID matches original user: " + createuser);
	    } else {
		if ( m_admin != null && username.equals(m_admin)) { 
		    logger.debug("The client name is admin: " + clientID);
		} else {
		    logger.debug("The client ID is: " + clientID);
		    logger.debug("The owner of the instance is: " +  createuser);
		    throw new RemoteException("User has no permission to access the service instance."); 
		}
	    }
	} catch (Exception e){
	    throw new RemoteException("checkClientContext:" + e);
	}
    }

}

