package com.platform.metascheduler.impl;

import org.globus.wsrf.Resource;
import org.globus.wsrf.RemoveCallback;
import org.globus.wsrf.ResourceIdentifier;
import org.globus.wsrf.ResourceProperties;
import org.globus.wsrf.ResourceProperty;
import org.globus.wsrf.ResourcePropertySet;
import org.globus.wsrf.impl.SimpleResourcePropertySet;
import org.globus.wsrf.impl.SimpleResourceProperty;
import org.globus.wsrf.ResourceException;

import org.apache.axis.message.addressing.EndpointReferenceType;
import com.platform.metascheduler.queuing.QueueConfigParamsType;

import javax.xml.namespace.QName;
import java.util.Vector;
//import java.lang.Thread;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class QueuingResource
		implements
			Resource,
			ResourceIdentifier,
			ResourceProperties,
			RemoveCallback {

	private ResourcePropertySet propSet;
	private Object key;
	private ResourceProperty config;
	private ResourceProperty status;
	private ResourceProperty jobs;
	private ResourceProperty schedplugins;
	//private ResourceProperty schedthread;

        private Thread m_owner = null;
        private int m_lock_count = 0;
        private static Log logger = LogFactory.getLog(QueuingResource.class);

	// GET/SETTERS
	// config
	public QueueConfigParamsType getConfig() {
		return (QueueConfigParamsType) this.config.get(0);
	}
	public void setConfig(QueueConfigParamsType i_config) {
		this.config.set(0, i_config);
	}
	// status
	public String getStatus() {
		return ((String) this.status.get(0));
	}
	public void setStatus(String i_status) {
		this.status.set(0, i_status);
	}
	// jobs
	public Vector getJobs() {
		Vector o_jobs = new Vector();
		int jobsize = this.jobs.size();
		for(int i=0; i< jobsize ; i++ ){
			o_jobs.add( (EndpointReferenceType) this.jobs.get(i));
		}
		return o_jobs;
	}
	public void setJobs(Vector i_jobs) {
		int jobsize = i_jobs.size();
		this.jobs.clear();
		for(int i=0; i< jobsize ; i++ ){
			this.jobs.add( (EndpointReferenceType) i_jobs.get(i));
		}
	}
	public void addJob(EndpointReferenceType i_job) {
		this.jobs.add( (EndpointReferenceType) i_job );
	}
	public void removeJob(EndpointReferenceType i_job) {
		this.jobs.remove( (EndpointReferenceType) i_job );
	}
	// schedplugins
	public Vector getSchedplugins() {
		Vector o_schedplugins = new Vector();
		int pluginsize = this.schedplugins.size();
		for(int i=0; i< pluginsize ; i++ ){
			o_schedplugins.add( (schedPlugin) this.schedplugins.get(i));
		}
		return o_schedplugins;
	}
	public void addPlugin(schedPlugin i_plugin) {
		this.jobs.add( i_plugin );
	}
	public void removePlugin(schedPlugin i_plugin) {
		this.jobs.remove( i_plugin );
	}
	public void setSchedplugins(Vector i_schedplugins) {
		int pluginsize = i_schedplugins.size();
		this.schedplugins.clear();
		for(int i=0; i< pluginsize ; i++){
			this.schedplugins.add( (schedPlugin) i_schedplugins.get(i));
		}
	}
	// thread
	/*public Thread getSchedthread() {
		return (Thread) this.schedthread.get(0);
	}
	public void setSchedthread(Thread i_schedthread) {
		this.schedthread.set(0, i_schedthread);
	}*/


    	public synchronized void acquire()
   	{
       		boolean ret = false;
        
        	logger.debug("In acquire, lockcount="+m_lock_count);
        	while ( ret != true ) { 
            	if( m_owner == null )
            	{   
                	m_owner = Thread.currentThread();
                	m_lock_count = 1;
                	ret = true;
                	logger.debug("acquired lock, lockcount="+m_lock_count);
            	} else if( m_owner == Thread.currentThread() ) {   
                	++m_lock_count;
                	ret = true;
                	logger.debug("acquired lock, lockcount="+m_lock_count);
            	}
            	if ( !ret ) {
                	try {
                    		logger.debug("acquiring lock, waiting");
                    		this.wait(1000);
                	} catch (Exception e) {
                	}
            	}
        	} 
    	}

    	public synchronized void release()
    	{
        	logger.debug("Releasing lock");
        	if( m_owner == Thread.currentThread() && --m_lock_count <= 0 )
        	{   
            		m_owner = null;
            		logger.debug("Releasd lock, lockcount="+m_lock_count);
            		notify();
        	}
        	logger.debug("Lock released, lockcount="+m_lock_count);
    	}
	public Object create(QueueConfigParamsType i_qconfig,Vector i_plugins,String i_status) throws Exception {
		this.key = new Integer(hashCode());
		this.propSet = new SimpleResourcePropertySet(new QName(
			"http://www.platform.com/namespaces/2003/05/metascheduler/queuing",
			"QueuingResourceProperties"));

		try {
			this.config = new SimpleResourceProperty(new QName(
			"http://www.platform.com/namespaces/2003/05/metascheduler/queuing",
			"Config"));
			this.propSet.add(this.config);
			this.config.add(i_qconfig);

			this.status = new SimpleResourceProperty(new QName(
			"http://www.platform.com/namespaces/2003/05/metascheduler/queuing",
			"Status"));
			this.propSet.add(this.status);
			this.status.add(i_status);

			this.jobs = new SimpleResourceProperty(new QName(
			"http://www.platform.com/namespaces/2003/05/metascheduler/queuing",
			"Jobs"));
			this.propSet.add(this.jobs);

			this.schedplugins = new SimpleResourceProperty(new QName(
			"http://www.platform.com/namespaces/2003/05/metascheduler/queuing",
			"Schedplugins"));
			this.propSet.add(this.schedplugins);
			this.setSchedplugins(i_plugins);

		} catch (Exception e) {
			throw new RuntimeException(e.getMessage());
		}
		return key;
	}

	public ResourcePropertySet getResourcePropertySet() {
		return this.propSet;
	}

	public Object getID() {
		return this.key;
	}
    	public void remove() throws ResourceException {
       		System.out.println("Queuing service is being destroyed");
		/*Thread thrd = (Thread)this.schedthread.get(0);
		thrd.interrupt();   // Too aggressive?*/
    	}
}
