package com.platform.metascheduler.impl;

import org.globus.wsrf.Resource;
import org.globus.wsrf.RemoveCallback;
import org.globus.wsrf.ResourceIdentifier;
import org.globus.wsrf.ResourceProperties;
import org.globus.wsrf.ResourceProperty;
import org.globus.wsrf.ResourcePropertySet;
import org.globus.wsrf.impl.SimpleResourcePropertySet;
import org.globus.wsrf.impl.SimpleResourceProperty;
import org.globus.wsrf.ResourceException;
import org.globus.wsrf.ResourceLifetime;

import com.platform.www.namespaces._2003._05.metascheduler.gsa.AgreementType;
import com.platform.www.namespaces._2003._05.metascheduler.gsa.StatusType;
import com.platform.metascheduler.reservation.GridReservationType;

import javax.xml.namespace.QName;
import java.util.Hashtable;
import java.util.Calendar;

public class ReservationResource
		implements
			Resource,
			ResourceIdentifier,
			ResourceProperties,
			ResourceLifetime,
			RemoveCallback {

	private ResourcePropertySet propSet;
	private Object key;
	private ResourceProperty rsvName;
	private ResourceProperty status;
	private ResourceProperty createUser;
	private ResourceProperty createParameter;
	private ResourceProperty agreement;
	private ResourceProperty rsvData;
	private ResourceProperty clusterMap;
	//private ResourceProperty serviceGroupRule;
        protected Calendar terminationTime = null;

	// GET/SETTERS
	// rsvName
	public String getRsvName() {
		return ((String) this.rsvName.get(0));
	}
	public void setRsvName(String i_rsvName) {
		this.rsvName.set(0, i_rsvName);
	}
	// status
	public StatusType getStatus() {
		return ((StatusType) this.status.get(0));
	}
	public void setStatus(StatusType i_status) {
		this.status.set(0, i_status);
	}
	// createUser
	public String getCreateUser() {
		return ((String) this.createUser.get(0));
	}
	public void setCreateUser(String i_createUser) {
		this.createUser.set(0, i_createUser);
	}
	// createParameter
	public AgreementType getCreateParameter() {
		return ((AgreementType) this.createParameter.get(0));
	}
	public void setCreateParameter(AgreementType i_createParameter) {
		this.createParameter.set(0, i_createParameter);
	}
	// agreement
	public AgreementType getAgreement() {
		return (AgreementType) this.agreement.get(0);
	}
	public void setAgreement(AgreementType i_agreement) {
		this.agreement.set(0, i_agreement);
	}
	// rsvData
	public GridReservationType getRsvData() {
		return (GridReservationType) this.rsvData.get(0);
	}
	public void setRsvData(GridReservationType i_rsvData) {
		this.rsvData.set(0, i_rsvData);
	}
	// clusterMap
	public Hashtable getClusterMap() {
		return (Hashtable) this.clusterMap.get(0);
	}
	public void setClusterMap(Hashtable i_clusterMap) {
		this.clusterMap.set(0, i_clusterMap);
	}

	public Object create(String i_rsvName,
			     StatusType i_status,
			     String i_createUser,
			     AgreementType i_createParameter, 
			     AgreementType i_agreement, 
			     GridReservationType i_rsvData,
			     Hashtable i_clusterMap,
			     Calendar i_terminationTime) throws Exception {

		this.key = new Integer(hashCode());
		this.propSet = new SimpleResourcePropertySet(new QName(
			"http://www.platform.com/namespaces/2003/05/metascheduler/reservation",
			"ReservationResourceProperties"));

		try {
			this.rsvName = new SimpleResourceProperty(new QName(
			"http://www.platform.com/namespaces/2003/05/metascheduler/reservation",
			"RsvName"));
			this.propSet.add(this.rsvName);
			this.rsvName.add(i_rsvName);

			this.status = new SimpleResourceProperty(new QName(
			"http://www.platform.com/namespaces/2003/05/metascheduler/reservation",
			"Status"));
			this.propSet.add(this.status);
			this.status.add(i_status);

			this.createUser = new SimpleResourceProperty(new QName(
			"http://www.platform.com/namespaces/2003/05/metascheduler/reservation",
			"CreateUser"));
			this.propSet.add(this.createUser);
			this.createUser.add(i_createUser);

			this.createParameter = new SimpleResourceProperty(new QName(
			"http://www.platform.com/namespaces/2003/05/metascheduler/reservation",
			"CreateParameter"));
			this.propSet.add(this.createParameter);
			this.createParameter.add(i_createParameter);

			this.agreement = new SimpleResourceProperty(new QName(
			"http://www.platform.com/namespaces/2003/05/metascheduler/reservation",
			"Agreement"));
			this.propSet.add(this.agreement);
			this.agreement.add(i_agreement);

			this.rsvData= new SimpleResourceProperty(new QName(
			"http://www.platform.com/namespaces/2003/05/metascheduler/reservation",
			"RsvData"));
			this.propSet.add(this.rsvData);
			this.rsvData.add(i_rsvData);

			this.clusterMap = new SimpleResourceProperty(new QName(
			"http://www.platform.com/namespaces/2003/05/metascheduler/reservation",
			"ClusterMap"));
			this.propSet.add(this.clusterMap);
			this.clusterMap.add(i_clusterMap);

		} catch (Exception e) {
			throw new RuntimeException(e.getMessage());
		}
		this.setTerminationTime(i_terminationTime);
		return key;
	}

	public ResourcePropertySet getResourcePropertySet() {
		return this.propSet;
	}

	public Object getID() {
		return this.key;
	}
    	public void remove() throws ResourceException {
       		System.out.println("Reservation resource is being destroyed");
    	}

        //Implement ResourceLifetime Interface
        public void setTerminationTime(Calendar time) {
                this.terminationTime = time;
        }
        public Calendar getTerminationTime() {
                return this.terminationTime;
        }
        public Calendar getCurrentTime() {
                return Calendar.getInstance();
        }

}
