package com.platform.metascheduler.impl;

import com.platform.www.namespaces._2003._05.metascheduler.gsa.SupportedAgreementType;
import com.platform.www.namespaces._2003._05.metascheduler.gsa.SupportedTermType;
import com.platform.www.namespaces._2003._05.metascheduler.gsa.AgreementType;
import com.platform.www.namespaces._2003._05.metascheduler.gsa.StatusType;
import com.platform.www.namespaces._2003._05.metascheduler.gsa.ActivityType;
import com.platform.www.namespaces._2003._05.metascheduler.gsa.NegotiabilityType;
import com.platform.www.namespaces._2003._05.metascheduler.gsa.SatisfactionType;

//import org.xmlsoap.schemas.ws._2002._12.policy.UsageType;
import org.globus.ws.policy.UsageType;

//import com.platform.metascheduler.utils.AggregationHelper;
import com.platform.metascheduler.utils.GridReservationTypeHelper;
import com.platform.metascheduler.utils.ReservationHelper;
import com.platform.metascheduler.utils.MetaSchedulerHelper;
import com.platform.metascheduler.utils.MetaSchedulerConstants;
import com.platform.metascheduler.utils.GSARsvAttributes;

import com.platform.metascheduler.reservation.ReservationConfigParamsType;
import com.platform.metascheduler.reservation.ReservationPortType;
import com.platform.metascheduler.reservation.ReservationFaultType;
import com.platform.metascheduler.reservation.GridReservationStatus;
import com.platform.metascheduler.reservation.GridReservationType;
import com.platform.metascheduler.reservation.ReservationType;
import com.platform.metascheduler.resourcemanager.ResourceManagerLsfPortType;
import com.platform.metascheduler.resourcemanager.ResourceManagerFaultType;
import com.platform.metascheduler.resourcemanager.RsvInfoType;
import com.platform.metascheduler.resourcemanager.RsvsInfoType;
import com.platform.metascheduler.resourcemanager.RsvHostInfoType;
import com.platform.metascheduler.utils.MetaSchedulerRsl;

/********************* Stub Class *******************/
import com.platform.metascheduler.reservation.CreateResource;
import com.platform.metascheduler.reservation.CreateResourceResponse;
import com.platform.metascheduler.reservation.Submit;
import com.platform.metascheduler.reservation.SubmitResponse;
import com.platform.metascheduler.reservation.Start;
import com.platform.metascheduler.reservation.StartResponse;
import com.platform.metascheduler.reservation.Cancel;
import com.platform.metascheduler.reservation.CancelResponse;
import com.platform.metascheduler.reservation.Modify;
import com.platform.metascheduler.reservation.ModifyResponse;
import com.platform.metascheduler.reservation.GetStatus;
import com.platform.metascheduler.reservation.GetStatusResponse;
import com.platform.metascheduler.reservation.GetRsvData;
import com.platform.metascheduler.reservation.GetRsvDataResponse;
import com.platform.metascheduler.reservation.GetRsvById;
import com.platform.metascheduler.reservation.GetRsvByIdResponse;

/********************* wsrf Class *******************/
import org.globus.wsrf.container.ServiceHost;
import org.globus.wsrf.ResourceContext;
import org.globus.wsrf.ResourceKey;
import org.globus.wsrf.utils.AddressingUtils;
import org.globus.wsrf.ResourceException;
import org.globus.wsrf.ResourceHome;
import org.oasis.wsrf.lifetime.Destroy;
import org.globus.wsrf.config.ConfigException;

/*************** GSI classes ******************/
import org.globus.axis.gsi.GSIConstants;
import org.globus.wsrf.impl.security.authentication.Constants;
import org.globus.wsrf.impl.security.authorization.HostAuthorization;
import org.globus.wsrf.impl.security.authorization.SelfAuthorization;
import org.globus.gsi.proxy.IgnoreProxyPolicyHandler;
import org.globus.wsrf.impl.security.authentication.secureconv.service.SecurityContext;
import org.globus.wsrf.impl.security.authentication.Constants;
import org.globus.wsrf.security.SecurityManager;
import org.ietf.jgss.GSSCredential;
import org.ietf.jgss.GSSContext;
import org.apache.axis.MessageContext;

import org.ietf.jgss.GSSCredential;
import org.ietf.jgss.GSSContext;

import org.apache.axis.types.URI;
import org.apache.axis.MessageContext;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.axis.message.MessageElement;
import org.apache.axis.utils.XMLUtils;
import org.apache.axis.message.addressing.EndpointReferenceType;

import java.io.File;
import java.io.InputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.StringReader;
import java.rmi.RemoteException;
import java.text.SimpleDateFormat;
import java.text.FieldPosition;
import java.util.Vector;
import java.util.Calendar;
import java.util.Date;
import java.util.StringTokenizer;
import java.util.ArrayList;
import java.util.Hashtable;
import java.net.URL;
import java.text.ParseException;
import javax.xml.namespace.QName;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.rpc.Stub;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;

import org.xml.sax.InputSource;

import org.globus.exec.utils.rsl.RSLParseException;

/**
 * Implement reservation service.
 */
public class ReservationServiceImpl{
    private static Log logger
        = LogFactory.getLog(ReservationServiceImpl.class);
	
//    private String factory_handle = null;
    private static String service_handle = null;
//    private Hashtable clusterMap = null;
//    private GridReservationType rsv = null;
    private String[] admins = null;
    private String registryHandle = null;
    private String subscriptionID = null;
//    private AgreementType agreement = null;
//    private ServiceData rsvServiceData = null;
//    private ServiceData statusServiceData = null;
    private String   userID = null; 

// factory var
    static Hashtable m_rsvs = null;
    static Hashtable m_ids = null;

    private static final String DEFAULT_NAMESPACE =
    MetaSchedulerConstants.RESERVATION_NS;
    private static final int    DEFAULT_MIN_ID = 1;
    private static final int    DEFAULT_MAX_ID = 999999;
    private static final String DEFAULT_GIS_HANDLE =
 	"https://localhost:8080/ogsa/services/base/index/IndexService";
    private static final String DEFAULT_REGISTRY_HANDLE =
 	"https://localhost:8080/ogsa/services/core/registry/ContainerRegistryService";
    private static final String RESOURCE_MANAGER_FACTORY_NAME =
	"metascheduler/ResourceManagerFactoryService";
    private static final String PREFIX_RSL = "RSL:";
    private static final String PREFIX_ID = "ID:";
    private static final int    DEFAULT_CLEAN_PERIOD = 30;   // 30 minutes

    private static SupportedTermType[] SUPPORTED_TERM_TYPES = null;
    private static SupportedAgreementType SUPPORTED_AGREEMENT_TYPE = null;

    private static ReservationConfigParamsType config;
    private static int sequence_next;
    private static StringBuffer sequence_date = new StringBuffer(10);
    private static final SimpleDateFormat dateFmt = new SimpleDateFormat("yyyyMMdd_");
    private static Hashtable reservationMap;
    private static boolean m_init = false;

    /**
     * Constructor for reservation service object.
     * 
     * @param rsv       Underlying grid reservation object.
     * @param admins    List of administrator identities, or null.
     * @param gisHandle Handle to index service, used to aggregate reservation
     *                  status and update.
     * @param registryHandle Handle to registry, used to lookup services 
     *                       (such as ResourceManagerFactoryService).
     * @param agreement If the reservation is created using agreement, 
     *                  the agreement itself should be passed in, otherwise 
     *                  null should be used.
     */
   /* public ReservationServiceImpl(
        GridReservationType rsv, 
        String[] admins,
	String gisHandle,
	String registryHandle,
	int   cleanPeriod,
	AgreementType agreement
    ) {
	super("Reservation Service");
	this.rsv = rsv;
	this.admins = admins;	
	this.gis_handle = gisHandle;
	this.registryHandle = registryHandle;
	this.subscriptionID = null;
	this.cleanPeriod = cleanPeriod;
	this.agreement = agreement;
    }*/

    /**
     * Post create routine.  Responsible of initializing service with SDE, 
     * aggregate reservation info to Index Service, and lookup available RMFS.
     * In case reservation is created by agreement, reservation will be made;
     * exception is thrown if reservation attempt is not successful.
     *
     * @param context As per <code>GridServiceCallback</code> interface.
     */

    private Hashtable getClusterMap() throws RemoteException{

	Hashtable clusterMap = null;
	Hashtable local = null;
	Hashtable remote = null;

	 // Get local RMFS map
	String rmFactory = null;
        rmFactory = RESOURCE_MANAGER_FACTORY_NAME;
	
	if (rmFactory != null) {
	    logger.debug("Updating clusterMap from local factory: " 
			 + rmFactory);
	    local = MetaSchedulerHelper.getResourceManagerInfoMap(rmFactory);
	}

	if (this.config.getCommunityGisHandle() != null && 
	    !this.config.getCommunityGisHandle().equals("")) {
	    logger.debug("Updating clusterMap from Community GIS: " 
			 + this.config.getCommunityGisHandle());
	    remote = MetaSchedulerHelper.getRemoteRM(this.config.getCommunityGisHandle());
	}

	clusterMap = new Hashtable();
	if (local != null) {
	    clusterMap.putAll(local);
	}
	if (remote != null) {
	    clusterMap.putAll(remote);
	}
	return clusterMap;
    }

    /**
     * Submit the reservation request.
     *
     * Reservation request is send to RMFS.  Reservation must be in CREATED 
     * state, otherwise submission will fail.  Upon success, the state of 
     * reservation will transistion to RESERVED.  On failure, the state of
     * reservation will be EXIT.
     *
     * @return  true on success, false otherwise.
     * @throws RemoteException
     * @throws ReservationFaultType if reservation cannot be made
     */
    public SubmitResponse submit(Submit request) 
	throws RemoteException, ReservationFaultType {

	// check client context
	ReservationResource resource = getResource();
	checkClientContext();
        MessageContext messageCtx = MessageContext.getCurrentContext();
        SecurityContext sec = (SecurityContext)messageCtx.getProperty(Constants.CONTEXT);
        GSSCredential tmp = null;
        try{
                tmp = sec.getDelegatedCredential();
        }catch (Exception e) {
                logger.debug(e.getMessage());
        }
        if ( tmp != null) {
                try {
                        logger.debug("Credential is for identity : " + tmp.getName().toString());
                } catch (org.ietf.jgss.GSSException e) { }
        }

	try {
	    ReservationHelper.submitReservation(resource.getRsvData(), resource.getClusterMap(),tmp);
	} catch (ReservationFaultType e) {
	 //   GridReservationTypeHelper.updateGridReservationType(
	//		                 rsv,
	//				 this.rsvServiceData, 
	//				 new HandleType(this.service_handle));
	    return new SubmitResponse(false);
	} catch (RSLParseException e) { 
	 //   GridReservationTypeHelper.updateGridReservationType(
	//		                 rsv,
	//				 this.rsvServiceData, 
	//				 new HandleType(this.service_handle));
	    return new SubmitResponse(false);
	}


	//GridReservationTypeHelper.updateGridReservationType(rsv,
	//	    this.rsvServiceData, new HandleType(this.service_handle));
	return new SubmitResponse(true);

    } // END of submit()

    public StartResponse start(Start request)
	    throws RemoteException, ReservationFaultType {
	String clusterName = request.getClusterName();
	checkClientContext();

	// NOT IMPLEMENTED YET

	return new StartResponse(clusterName);
    } // END of start()

    public ModifyResponse modify(Modify request) 
	    throws RemoteException, ReservationFaultType {
	String rsl = request.getRsl();

	logger.debug("Entering... rsl=" + rsl);
	ReservationResource resource = getResource();

	if (resource.getAgreement() != null) {
	    throw ReservationHelper.makeReservationFault(
			    "Agreement based reservation cannot be modified");
	}

	checkClientContext();

	if ( ! resource.getRsvData().getStatus().equals(GridReservationStatus.CREATED) ) {
	    String msg = 
		"Modify can only apply to reservation in CREATED status";
	    logger.warn(msg);
	    throw ReservationHelper.makeReservationFault(msg);
	}

	MetaSchedulerRsl msRsl = null;
	try { 
	    msRsl = new MetaSchedulerRsl(rsl);
	} catch (Exception e) {
	    logger.warn("Content of RSL is not valid:" + e);
	    throw ReservationHelper.makeReservationFault(e.getMessage());
	} 

	if (msRsl == null || msRsl.getRootElement() == null) {
	    String msg = "Content of RSL is not valid";
	    logger.warn(msg);
	    throw ReservationHelper.makeReservationFault(msg);
	}
	GridReservationType rsv = resource.getRsvData();
	rsv.setRSL(rsl);
	resource.setRsvData(rsv);
	//GridReservationTypeHelper.updateGridReservationType(
	//				 rsv,
	//				 this.rsvServiceData,
	//				 new HandleType(this.service_handle));
	return new ModifyResponse(true);
    } // END of modify()

    public CancelResponse cancel(Cancel request) 
	    throws RemoteException, ReservationFaultType {
	
	checkClientContext();
        MessageContext messageCtx = MessageContext.getCurrentContext();
        SecurityContext sec = (SecurityContext)messageCtx.getProperty(Constants.CONTEXT);
        GSSCredential tmp = null;
        try{
                tmp = sec.getDelegatedCredential();
        }catch (Exception e) {
                logger.debug(e.getMessage());
        }
        if ( tmp != null) {
                try {
                        logger.debug("Credential is for identity : " + tmp.getName().toString());
                } catch (org.ietf.jgss.GSSException e) { }
        }

	try {
	    ReservationHelper.cancelReservation(getResource().getRsvData(), getResource().getClusterMap(), tmp);
	} catch (RemoteException e) {
	    //GridReservationTypeHelper.updateGridReservationType(rsv,
	    //	    this.rsvServiceData, new HandleType(this.service_handle));
	    return new CancelResponse(false);
	}

	//GridReservationTypeHelper.updateGridReservationType(rsv,
	//	    this.rsvServiceData, new HandleType(this.service_handle));

	// set termination time for service 1 hour from now
	try { 
	    Calendar cal = Calendar.getInstance();
	    cal.add(Calendar.MINUTE, this.config.getCleanPeriod());

	    getResource().setTerminationTime(cal);
	    Date date  = cal.getTime(); 
	    logger.debug("Instance termination time: " + date.toString());
	} catch (RemoteException e) { 
	    e.printStackTrace();
	}
	return new CancelResponse(true);

    } // END of cancel()

    public String get_Status() throws RemoteException, ReservationFaultType {
	if (getResource().getRsvData() == null) {
	    return ("null");
	}
	return (getResource().getRsvData().getStatus().toString());

    } // END of getStatus()

    public GetStatusResponse getStatus(GetStatus request) throws RemoteException, ReservationFaultType {
	return new GetStatusResponse(this.get_Status());
    } // END of getStatus()

    public String get_RsvData() throws RemoteException, ReservationFaultType {
	return (GridReservationTypeHelper.toXMLString(getResource().getRsvData()));
    } // END of getRsvData()

    public GetRsvDataResponse getRsvData(GetRsvData request) throws RemoteException, ReservationFaultType {
	return new GetRsvDataResponse(this.get_RsvData());
    } // END of getRsvData()

    public GetRsvByIdResponse getRsvById(GetRsvById request) throws RemoteException, ReservationFaultType {
	String rsvId = request.getRsvId();
	ResourceKey key = null;
	EndpointReferenceType epr = null;
 	ResourceContext ctx = null;
	ReservationHome home = null;
	GridReservationType rsv= null;
	ReservationResource resource = null;
	try {
 		ctx = ResourceContext.getResourceContext();
 	} catch (Exception e) {
 		throw new RemoteException("",e);
 	}
        if (rsvId != null) {
                if(m_ids.containsKey(rsvId)) {
                        logger.debug("rsvId" + rsvId + " exist in m_ids!");
			key = (ResourceKey)m_ids.get(rsvId);
 			logger.debug("get Reservation Key!: " + (Integer)key.getValue());
 			try {
 				epr = AddressingUtils.createEndpointReference(ctx, key);
 				logger.debug(epr);
	                        home = (ReservationHome) ctx.getResourceHome();
				resource = (ReservationResource)home.find(key);
 			} catch (Exception e) {
 				throw new RemoteException("", e);
			}
			if (resource==null) {
                        	logger.debug("rsvId" + rsvId + " resource isn't exist!");
				m_ids.remove(rsvId);
			} else {
				rsv = resource.getRsvData();
			}
                }
        }
	return new GetRsvByIdResponse(rsv);
    } // END of getRsvById()

/*    public ExtensibilityType findServiceData(ExtensibilityType queryExpression)
        throws RemoteException, FaultType, TargetInvalidFaultType,
	       ExtensibilityNotSupportedFaultType, ExtensibilityTypeFaultType {
	logger.debug("Reservation service findServiceData");
	this.updateStatus();
        return super.findServiceData(queryExpression);
    }*/

/*    private void updateStatus() {
	logger.debug("update status");

	StatusType gsaStatus = new StatusType();
	gsaStatus.setNegotiation(UsageType.fromString("{" + MetaSchedulerConstants.WS_POLICY_NS +"}Observed"));
	gsaStatus.setSatisfaction(SatisfactionType.fromString("{" + MetaSchedulerConstants.AGREEMENT_NS +"}Satisfied"));
	
	Calendar now = Calendar.getInstance();
	logger.debug("Now: " + now.toString());
	Calendar start = rsv.getStartTime().getDateTimeValue();
	logger.debug("Start: " + start.toString());
	Calendar end = start;
	end.add(Calendar.SECOND, (int)rsv.getDuration());
	logger.debug("End: " + end.toString());

	if (rsv.getStatus().equals(GridReservationStatus.RESERVED) &&
	    now.after(start) &&
	    now.before(end) ) {
	    gsaStatus.setActivity(ActivityType.fromString("{" + MetaSchedulerConstants.AGREEMENT_NS +"}Active"));
	} else {
	    gsaStatus.setActivity(ActivityType.fromString("{" + MetaSchedulerConstants.AGREEMENT_NS +"}Inactive"));
	}
	
	this.statusServiceData.setValue(gsaStatus);
	this.statusServiceData.notifyChange();

    }*/
 // END of updateStatus()

    private void checkClientContext() throws RemoteException {
        MessageContext ctx = MessageContext.getCurrentContext();
	SecurityContext sec = (SecurityContext)ctx.getProperty(Constants.CONTEXT);
        if (sec == null) {
            throw new RemoteException("Service requires secure access.");
	}
	GSSContext context = sec.getContext();
	try {
	    String clientID = context.getSrcName().toString();
	    if (clientID.equals(getResource().getCreateUser())) {
		logger.debug("the client ID is: " + clientID);
	    } else {
		logger.debug("the client ID is: " + clientID);
		logger.debug("the owner of the instance is: " + getResource().getCreateUser());
		throw new RemoteException("User has no permission to access the service instance."); 
	    }
	} catch (Exception e){
	    throw new RemoteException("checkClientContext:" + e);
	}
    }

    private void init() throws RemoteException{
        try {
         	this.service_handle = "https://" + ServiceHost.getBaseURL().getHost()
                         + ":" + ServiceHost.getBaseURL().getPort()
                         + "/" + MetaSchedulerConstants.RESERVATION_URL;
         	logger.debug("ReservationService handle: " + this.service_handle);
         } catch ( Exception e ) { }
	this.m_rsvs = new Hashtable();
	this.m_ids = new Hashtable();
	initializeDefaultConfig();
 	try {
 		processConfig();
 	} catch (ConfigException e) {
 		throw new RemoteException(e.getMessage());
 	}

	// Initialize reservation ID sequence
	this.sequence_next = this.config.getMinID();
	this.sequence_date = this.currentSequenceDate();
	this.reservationMap = new Hashtable();

	// Initialize SDEs
	//ServiceDataSet container = this.serviceBase.getServiceDataSet();
	//QName serviceDataName = null; 
	//ServiceData serviceData = null;

	// publish configuration as SDE with name "ConfigParams"
	//serviceDataName = new QName(this.handle, "ConfigParams");
	//serviceData = container.create(serviceDataName);
	//serviceData.addValue(this.config);
	//container.add(serviceData);

	// publish SDE for supported agreement
	//serviceDataName = new QName(MetaSchedulerConstants.OGSI_AGREEMENT_NS,
	//			    "supportedAgreement");
	//serviceData = container.create(serviceDataName);
	//serviceData.addValue(SUPPORTED_AGREEMENT_TYPE);
	//container.add(serviceData);

	// Service group membership content rule
	//serviceData = container.create(ServiceData.MEMBERSHIP_CONTENT_RULE);
	//MembershipContentRuleType rule = new MembershipContentRuleType();
	//QName gsaQName = new QName(MetaSchedulerConstants.OGSI_AGREEMENT_NS,
	//				   "Agreement");
	//QName relatedQName =new QName(MetaSchedulerConstants.OGSI_AGREEMENT_NS,
	//			      "RelatedAgreementType");
        //rule.setMemberInterface(gsaQName);
        //rule.setContent(new QName[] { relatedQName });
	//serviceData.addValue(rule);
	//container.add(serviceData);

    }

    private void initializeDefaultConfig() {
        this.config = new ReservationConfigParamsType();
        this.config.setMinID(DEFAULT_MIN_ID);
        this.config.setMaxID(DEFAULT_MAX_ID);
        this.config.setAdminList(new String[0]);
        this.config.setGisHandle(DEFAULT_GIS_HANDLE);
        this.config.setCommunityGisHandle(DEFAULT_GIS_HANDLE);
        this.config.setRegistryHandle(DEFAULT_REGISTRY_HANDLE);
        this.config.setCleanPeriod(DEFAULT_CLEAN_PERIOD);
    } // END of initializeDefaultConfig()


    private void processConfig() throws ConfigException
    {
	logger.debug("Enter processConfig!");
	String fileName = "etc/metascheduler/metascheduler-config.xml";

	InputStream input = null;
	Document doc = null;
        try {
            input = new FileInputStream(fileName);
	    if (input == null) {
		throw new ConfigException("Could not load config file: " 
					  + fileName);
	    }
	    doc = XMLUtils.newDocument(input);
	} catch (FileNotFoundException e) {
	    logger.debug("Configuration file (" + fileName 
			 + ") not found, using default values");
            return;
	} catch (Exception e) {
            throw new ConfigException(e);
        } finally {
            if (input != null) {
                try {
                    input.close();
                } catch (Exception e) {
                    throw new ConfigException(e);
                }
            }
        }

	NodeList nodes = doc.getElementsByTagNameNS(this.DEFAULT_NAMESPACE,
					    "reservationFactoryConfig");
	if (nodes.getLength() == 0) {
	    logger.debug("No <rsv:reservationFactoryConfig> section");
	    return;
	}

	Element configElement = (Element)nodes.item(0);
	NodeList children = configElement.getChildNodes();
	if (children == null) {
	    return;
	}

	ArrayList adminList = new ArrayList();
	for (int i=0; i<children.getLength(); i++) {
	    Node childNode = children.item(i);
	    String ns_uri = childNode.getNamespaceURI();
	    String localname = childNode.getLocalName();

	    logger.debug("Processing node <" + ns_uri + ":" + localname + ">");

	    switch(childNode.getNodeType()) {
	    case Node.ELEMENT_NODE:
		logger.debug("Is ELEMENT_NODE");
		if ( !ns_uri.equals(DEFAULT_NAMESPACE) ){
		    break;
		}

		String value = ((Element)childNode).getAttribute("value");
		if (value == null) {
		    break;
		}

		if ( localname.equals("minID") ) {
		    logger.debug("minID=" + value);
		    this.config.setMinID(Integer.parseInt(value));
		} else if ( localname.equals("maxID") ) {
		    logger.debug("maxID=" + value);
		    this.config.setMaxID(Integer.parseInt(value));
		} else if ( localname.equals("admin") ) {
		    logger.debug("admin=" + value);
		    adminList.add(value);
		} else if ( localname.equals("GISHandle") ) {
		    logger.debug("GISHandle=" + value);
		    this.config.setGisHandle(value);
		} else if ( localname.equals("CommunityGISHandle") ) {
		    logger.debug("CommunityGISHandle=" + value);
		    this.config.setCommunityGisHandle(value);
		} else if ( localname.equals("registryHandle") ) {
		    logger.debug("registryHandle=" + value);
		    this.config.setRegistryHandle(value);
                } else if ( localname.equals("cleanPeriod") ) {
                    logger.debug("cleanPeriod=" + value);
                    this.config.setCleanPeriod(Integer.parseInt(value));
                }
		break;
	    default:
		logger.debug("Not ELEMENT_NODE");
		break;
	    }
	}
	this.config.setAdminList((String[])adminList.toArray(new String[0]));
    } // END of processConfig()

    private StringBuffer currentSequenceDate() {
        StringBuffer sequence_now = new StringBuffer(10);

        long now = System.currentTimeMillis();
        this.dateFmt.format(new Date(now), sequence_now, new FieldPosition(0));

        return sequence_now;
    } // END of currentSequenceDate

    private String getNextID() {
        StringBuffer sequence_now = this.currentSequenceDate();

        if (! sequence_now.toString().equals(this.sequence_date.toString())) {
            this.sequence_date = sequence_now;
            this.sequence_next = this.config.getMinID();
        }

        String id = "ID_" + this.sequence_date.toString() + this.sequence_next;
        this.sequence_next ++;
        return (id);
    } // END of getNextID

    private ReservationResource getResource() throws RemoteException {
        logger.debug("Enter getResrouce!");
        Object resource = null;
        try {
            resource = ResourceContext.getResourceContext().getResource();
        } catch (Exception e) {
            logger.info("getResource() error!");
            throw new RemoteException("", e);
        }
            ReservationResource rResource = (ReservationResource) resource;
            return rResource;
    }

    public CreateResourceResponse createResource(CreateResource request) throws RemoteException {
	String rsvName = request.getRsvName();
	String creationType = request.getRsvType();
	String rsvPara = request.getRsvPara();

	logger.debug("Ready to create Reservation Resource!");
	if (!m_init) { 
		init();
		m_init = true;
	}

	if (rsvName != null) {
        	if(m_rsvs.contains(rsvName)) {
               		logger.debug(MetaSchedulerConstants.RESERVATION_SERVICE_ERR_EXIST + ": " + rsvName);
               		return new CreateResourceResponse(null,MetaSchedulerConstants.RESERVATION_SERVICE_ERR_EXIST);
        	}
	}

	GridReservationType rsv = null;
	AgreementType agreement = null;

	if (creationType.equals(
                MetaSchedulerConstants.RSV_CREATE_BY_RSL)) {
	    if (rsvPara == null) {
		String err = "Unable to get RSL string from CreationParameter";
		logger.error(err);
		throw new RemoteException(err);
	    }
	    logger.debug("RSL: " + rsvPara);
	    rsv = createReservationByRSL(rsvPara);
	} else if (creationType.equals(
	        MetaSchedulerConstants.RSV_CREATE_BY_ID)) {
	    // existing reservation
	    if (rsvPara == null ) {
		String err = "Unable to get rsvID from CreationParameter";
		logger.error(err);
		throw new RemoteException(err);
	    }
	    // use local namespace uri as default
	    QName rsvID = new QName(service_handle, rsvPara);
	    logger.debug("RsvID: " + rsvID.toString());
	    rsv = createReservationByID(rsvID);
	} else if (creationType.equals(
            MetaSchedulerConstants.RSV_CREATE_BY_AGREEMENT)) {
            GSARsvAttributes gsa = new GSARsvAttributes(rsvPara);
            agreement = ReservationHelper.createAgreementType(gsa);
            if (agreement == null) {
                String err ="Reservation agreement not submitted";
		logger.error(err);
		throw new RemoteException(err);
            }
	    rsv = createReservationByAgreement(agreement);
	    logger.debug(((rsv == null)?"NULL":"OK"));
	} else {
	    String errmsg = "Incompatible creation extensibility type: " + creationType;
	    logger.error(errmsg);
	    throw new RemoteException(errmsg);
	}

	//this.factory_handle 
	//    = (String)this.getProperty(ServiceProperties.FACTORY_HANDLE);
	//this.service_handle
	//    = (String)this.getProperty(ServiceProperties.HANDLE);

	SecurityManager manager = SecurityManager.getManager();
	this.userID = manager.getCaller(); 
	manager.setServiceOwnerFromContext();
	MessageContext messageCtx = MessageContext.getCurrentContext();
 	SecurityContext sec = (SecurityContext)messageCtx.getProperty(Constants.CONTEXT);
 	GSSCredential tmp = null;
 	try{
 		tmp = sec.getDelegatedCredential();
 	}catch (Exception e) {
 		logger.debug(e.getMessage());
 	}
 	if ( tmp != null) {
 		try {
 			logger.debug("Credential is for identity : " + tmp.getName().toString());
 		} catch (org.ietf.jgss.GSSException e) { }
 	}
	// Service group membership content rule
	//serviceData = container.create(ServiceData.MEMBERSHIP_CONTENT_RULE);
	//MembershipContentRuleType rule = new MembershipContentRuleType();
	//QName gsaQName = new QName(MetaSchedulerConstants.OGSI_AGREEMENT_NS,
	//			   "Agreement");
	//QName relatedQName =new QName(MetaSchedulerConstants.OGSI_AGREEMENT_NS,
	//			      "RelatedAgreementType");
        //rule.setMemberInterface(gsaQName);
        //rule.setContent(new QName[] { relatedQName });
	//serviceData.addValue(rule);
	//container.add(serviceData);

	StatusType gsaStatus = new StatusType();
	gsaStatus.setNegotiation(UsageType.fromString("{" + MetaSchedulerConstants.WS_POLICY_NS +"}Observed"));
	gsaStatus.setSatisfaction(SatisfactionType.fromString("{" + MetaSchedulerConstants.AGREEMENT_NS +"}Satisfied"));
	gsaStatus.setActivity(ActivityType.fromString("{" + MetaSchedulerConstants.AGREEMENT_NS +"}Inactive"));

	// add reservation data to ServiceData set
	//this.rsvServiceData = 
	//   GridReservationTypeHelper.putGridReservationType(rsv, this);

	// aggregation
	//try {
	//    this.subscriptionID = AggregationHelper.subscribe(this.gis_handle, 
	//						 rsv.getGridRsvID(),
	//						 this.service_handle,
	//						 999999);
	//} catch (Exception e) {
	 //   e.printStackTrace();
	//}

	//this.rsvServiceData.notifyChange();

	//Add specified Admin to gridmap file.
	//if (this.admins != null) {
	//   for (int i=0; i < this.admins.length; i++) {
	//	manager.addAuthorizedUser(this, admins[i]);
	//   }
	//}

	Hashtable clusterMap = getClusterMap();
        logger.debug("got clusterMap!");
	// set termination time for service 1 hour after reservation finish
	Calendar cal = rsv.getStartTime();
	logger.debug("startTime:" + ReservationHelper.calToString(cal));
	cal.add(Calendar.SECOND, (int)rsv.getDuration());
	cal.add(Calendar.MINUTE, this.config.getCleanPeriod());

        logger.debug("Begin Reservation createResource!");

	ResourceContext ctx = null;
	ReservationHome home= null;
	ResourceKey     key = null;
	EndpointReferenceType epr = null;
        try {
		ctx = ResourceContext.getResourceContext();
		home = (ReservationHome) ctx.getResourceHome();
		key = home.create(rsvName,
				  gsaStatus,
				  this.userID,
				  agreement,
				  agreement,
				  rsv,
			 	  clusterMap,
				  cal);
	} catch (Exception e) {
		throw new RemoteException("", e);
	}
	if (rsvName == null) {
		rsvName = ((Integer)key.getValue()).toString();
		logger.debug("set rsvName:" + rsvName);
		try{
			ReservationResource resource = (ReservationResource)home.find(key);
			resource.setRsvName(rsvName);
		} catch (Exception e) {
			throw new RemoteException("", e);
		}
	}

        logger.debug("add to m_rsvs ,key is :" + (Integer)key.getValue() + ",name is:" +rsvName);
        m_rsvs.put(key,rsvName);
	logger.debug(rsv.getGridRsvID());
        m_ids.put(rsv.getGridRsvID().getLocalPart(),key);
        logger.debug("m_rsvs size is :" + m_rsvs.size());

	try {
		epr = AddressingUtils.createEndpointReference(ctx, key);
	} catch (Exception e) {
		throw new RemoteException("", e);
	}

	if (agreement != null) {
	    try {
		ReservationHelper.submitReservation(rsv, clusterMap, tmp);
	    } catch (RemoteException f) {
	//  here is notify Index Service to update rsvData , implement here next week
	//	GridReservationTypeHelper.updateGridReservationType(
	//				 rsv,
	//				 this.rsvServiceData, 
	//				 new HandleType(this.service_handle));
		logger.debug("rsv by agreement error:" + f.getMessage());
		throw f;
	    } catch (RSLParseException e) { 
	//	GridReservationTypeHelper.updateGridReservationType(
	//		                 rsv,
	//				 this.rsvServiceData, 
	//				 new HandleType(this.service_handle));
		throw new RemoteException(e.getMessage());
	    }
	//   GridReservationTypeHelper.updateGridReservationType(rsv,
	//	        this.rsvServiceData, new HandleType(this.service_handle));
	}
	return new CreateResourceResponse(epr,"Success!");

    }

    private GridReservationType createReservationByRSL( String rsl) throws RemoteException{

	QName rsvID = new QName(service_handle, this.getNextID());
	GridReservationType rsv = null;
	try {
	    logger.debug("rsvID:" + rsvID.getLocalPart());
	    rsv = GridReservationTypeHelper.getGridReservationType(rsvID, rsl);
	} catch (ParseException e) {
	    throw new RemoteException("RSL parse error:" + e.getMessage());
	} catch (RSLParseException e) { 
	    throw new RemoteException("RSL parse error:" + e.getMessage());
	} 

	if (rsv.getDuration() <= 0) {
	    throw new RemoteException("Begin time is after end time");
	}
	logger.debug("Create new reservation with ID:" + rsvID.toString());

	return rsv;
    } // END of createReservationByRSL

    private GridReservationType createReservationByID(
        QName rsvID
    ) throws RemoteException{

	GridReservationType rsv = null;

	/*implement by ID next week*/

	/*try {
	    logger.debug("GIS handle=" + this.config.getGisHandle());
	    rsv = GridReservationTypeHelper.getGridReservationType(
					   this.config.getGisHandle(), rsvID);
	} catch (RemoteException e) {
	    throw e;
	}*/

	if (rsv == null) {
	    throw new RemoteException("Reservation ID not found: " +
					   rsvID.toString());
	}
	logger.debug("Create previous reservation with ID:" +
		     rsvID.toString());
	return rsv;
    } // END of createServiceObjectByID

    private GridReservationType createReservationByAgreement(
        AgreementType agreement
    ) throws RemoteException{

	GridReservationType rsv = null;
	try {

	    // Additional policy for agreement negotiation can be added here
	    // In the mean time, agreement is directly map to rsl file.
	    String rsl = ReservationHelper.getRSLByAgreement(agreement);
	    logger.debug("Converted RSL = " + rsl);
	    rsv = createReservationByRSL(rsl);
	} catch (RemoteException e) {
	    logger.error(e.getMessage());
	    throw e;
	}
	return rsv;
    } // END of createReservationByAgreement
}
