package com.platform.metascheduler.resourcemanager.impl;

public class ClusterContact { 
    String  name = null;        // cluster name
    String  host = "localhost"; // contact host name
    int     port = 1966;        // contact port number
    String  type = "lsf";       // cluster resource manager type
    String  version="6.0";      // version of the resource manager

    public ClusterContact(String cluster) { 
	name = cluster;
    } 
    
    public ClusterContact(String cn,  String hn) { 
	name = cn;
	host = hn;
    } 

    public ClusterContact(String cn,  String hn, int pn) { 
	name = cn;
	host = hn;
	port = pn;
    } 

    public ClusterContact(String cn, String tn,  String hn, int pn) { 
	name = cn;
	if ( type != null) { 
	    type = tn;
	}
	if ( host != null) { 
	    host = hn;
	}
	if ( port > 0 ) { 
	    port = pn;
	}
    } 

    public ClusterContact(String cn, String tn,  String hn, int pn, String vn) { 
	name = cn; 
	if (tn != null) {
	    type = tn;
	}
	if (hn != null) {
	    host = hn;
	}
	if (pn > 0) {
	    port = pn;
	}
	if (vn != null) {
	    version = vn;
	}
    } 

    public String getHost( ) { 
	return (host);
    }

    public String getName( ) { 
	return (name);
    } 

    public String getType( ) { 
	return (type);
    } 

    public int getPort() { 
	return (port); 
    } 

    public String getVersion() {
	return (version);
    }

    public String toString() { 
	return (new String(name + ":" + type + ":" + host + ":" + port));
    } 

    public String getContactInfo() { 
	return (new String(name + ":" + host + ":" + port));
    }
} 

