package com.platform.metascheduler.resourcemanager.impl;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.platform.metascheduler.resourcemanager.JobInfoType;
import com.platform.metascheduler.resourcemanager.JobsInfoType;

import java.io.BufferedReader;
import java.io.Reader;
import java.io.StringReader;
import java.io.IOException;

import org.globus.wsrf.encoding.ObjectDeserializer;
import org.xml.sax.InputSource;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.apache.axis.utils.XMLUtils;

public class JobInfoTypeHelper {
    static Log logger = LogFactory.getLog(JobInfoTypeHelper.class);

    private Element      m_element = null;
    private Document     m_document = null;
    private JobsInfoType m_jobsInfo = null;
    private boolean      m_reparse = true;

    public JobInfoTypeHelper(String xmlString) {

	try {
            m_element = parse(new StringReader(xmlString));
	    m_jobsInfo = (JobsInfoType)ObjectDeserializer.toObject(m_element,
								 JobsInfoType.class);
        } catch (Exception e) {
            logger.error("Exception:" + e.getMessage());
            e.printStackTrace();
        }
    }


    public JobInfoType[] getJobs() {
	if (m_jobsInfo == null) {
	    return null;
	}

	return (m_jobsInfo.getJobsInfo());
    }

    public JobInfoType getJob(String jobId) {

	if (m_jobsInfo == null) {
	    return null;
	}

	JobInfoType [] jobInfo = m_jobsInfo.getJobsInfo();

	for (int i = 0; i < jobInfo.length; i ++) {
	    if (jobInfo[i].getJobId().equals(jobId)) {
		return jobInfo[i];
	    }
	}

	return null;
    }

    public Element parse(Reader rslReader)
            throws  Exception {

        if ( m_document != null &&
             m_element != null && !m_reparse) {
            return m_element;
        }

        DocumentBuilderFactory parserFactory = null;
        DocumentBuilder xmlParser = null;

        try {

            parserFactory = DocumentBuilderFactory.newInstance();
	    /*
            parserFactory.setNamespaceAware(true);
            parserFactory.setValidating(true);
            parserFactory.setAttribute(
                "http://java.sun.com/xml/jaxp/properties/schemaLanguage",
                "http://www.w3.org/2001/XMLSchema");
	    */
	    xmlParser = parserFactory.newDocumentBuilder();

            BufferedReader bufferedReader = new BufferedReader(rslReader);
            m_document = xmlParser.parse(new InputSource(bufferedReader));

        } catch (Exception e) {
            logger.debug("Exception: " + e);
	    return null;
        }

        m_element = m_document.getDocumentElement();
        m_reparse = false;
        return m_element;
    }
}


