package com.platform.metascheduler.resourcemanager.impl;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.CharacterData;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;
import org.w3c.dom.NamedNodeMap;
import org.apache.xerces.parsers.DOMParser;
import org.xml.sax.InputSource;
import org.apache.axis.message.MessageElement;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import javax.xml.namespace.QName;
import java.rmi.RemoteException;
import java.util.Vector;
import java.util.Enumeration;
import java.util.Calendar;

import com.platform.metascheduler.resourcemanager.lsf.ResourceManagerLsf;
//import com.platform.metascheduler.resourcemanager.gram.ResourceManagerGram;
import com.platform.metascheduler.resourcemanager.ResourceManagerAccessType;
import com.platform.metascheduler.resourcemanager.ResourceManagerInfoType;
//import com.platform.metascheduler.utils.AggregationHelper;
import com.platform.metascheduler.utils.JNDIHelper;
import com.platform.metascheduler.utils.MetaSchedulerConstants;

import org.globus.wsrf.ResourceContext;
import org.globus.wsrf.WSRFConstants;
import org.globus.wsrf.impl.ResourceHomeImpl;
import org.globus.wsrf.impl.SimpleResourceKey;
import org.globus.wsrf.ResourceKey;
import org.globus.wsrf.utils.AddressingUtils;
import org.globus.wsrf.container.ServiceHost;

import java.net.InetAddress;

import org.globus.mds.servicegroup.client.ServiceGroupRegistrationParameters;
import org.globus.wsrf.impl.servicegroup.client.ServiceGroupRegistrationClient;
import org.globus.wsrf.ResourceContextException;
import org.globus.wsrf.ResourceException;
import org.globus.wsrf.Resource;
import org.apache.axis.message.addressing.EndpointReferenceType;
import org.globus.wsrf.impl.ResourceHomeImpl;
import org.globus.wsrf.config.ContainerConfig;


public class ResourceManagerFactoryHome extends ResourceHomeImpl {

    private static Log logger =
        LogFactory.getLog(ResourceManagerFactoryHome.class.getName());
    private final String RM_NAMESPACE_URI =
	"http://www.platform.com/namespaces/2003/05/metascheduler/resourcemanager";
    private Vector clusters = new Vector();
    private ResourceManagerAccessType rmAccess = null;
    public static String m_handle = null;
    public static String gis_handle = null;
    public static ResourceKey frkey = null;
    public static RMFHomeConfig CONFIG = null;
    public static String DEFAULT_PORT ="8443";

    public void ManagedJobFactoryHome() {
        // Do nothing.
	logger.debug("ResourceManagerHome construction!");
    }
    public synchronized void initialize() throws Exception {
	super.initialize();
	logger.debug("Create ResourceManagerHome!");
	try{
        	CONFIG = (RMFHomeConfig)JNDIHelper.getResourceHomeConfiguration(
			 "metascheduler/ResourceManagerFactoryService");
		
		InetAddress addr=InetAddress.getLocalHost();
		String ip = addr.getHostAddress().toString();
		String address = addr.getHostName().toString();
		logger.debug("test:" + CONFIG.getGlobusLocation());
		logger.debug("test:" + CONFIG.getStagingHost());
		logger.debug("test:" + CONFIG.getStagingPort());
		this.m_handle = "https://" + ip
                         + ":" + DEFAULT_PORT
                         + "/" + MetaSchedulerConstants.RESOURCE_MANAGER_FACTORY_URL;
        	this.gis_handle = "https://" + ip
                         + ":" + DEFAULT_PORT
                         + "/" + MetaSchedulerConstants.INDEX_SERVICE_URL;
	}catch ( Exception e ) {
		logger.debug("get m_handle error!!!" + e.getMessage());
	}

	//Do process config file, read all clusters.
	this.processConfig();
	logger.debug("processConfig ok !");
	//create all clusters.
	// Temporary used format.
	// Set service data to the factory as a string
 	Enumeration e = clusters.elements();

	String data;
	StringBuffer strbuf = new StringBuffer();

 	while ( e.hasMoreElements() ) {
 	ClusterContact cluster = (ClusterContact) e.nextElement();
 	strbuf.append(cluster.toString() + " ");
 	}

 	data = strbuf.toString();
	logger.debug("data = " + data );
 	// add ResourceManager Access to ServiceData
        this.rmAccess = getResourceManagerAccessType();
        //this.serviceDataName = new QName(this.m_handle, "ResourceManagerAccess");
        //this.serviceData = putResourceManagerAccessType(rmAccess, this.base);

	// create ResourceManagerFactory Resource
	logger.debug("ready to create factory resource!");
	logger.debug("m_handle is " + m_handle);
	logger.debug(rmAccess.getURI());
	this.create(data,this.rmAccess);

        // aggregation ResourceManager Access SDE to IS
        //try {
       	//	this.subscriptionID = AggregationHelper.subscribe(this.gis_handle,
        //                                                  this.serviceDataName,
        //                                                  this.m_handle,
        //                                                  99999);
        //} catch (Exception exception) {
        //                exception.printStackTrace();
        //}
        //this.serviceData.notifyChange();
    }

    /**
     * Read cluster information from configuration file 
     * etc/metascheduler/resourcemanager-config.xml
     * and store them in cluster list clusters
     */

    private void processConfig( ) {

		BufferedReader xmlReader = null; 
		DOMParser      xmlParser = new DOMParser(); 
		
		// Find the path for the container 
		String rmFile  = null;
		String cfgPath = null; 
		String RM_CONFIG = "etc/metascheduler/resourcemanager-config.xml";
		
		rmFile  = "." +  File.separator + RM_CONFIG; 
		File  file = new File(rmFile); 
		if ( file.exists() == false) { 
				logger.error("RMFS: cannot find configuration file" + rmFile);
				return;
		}
		
		logger.debug("Process manager configuration file: " + rmFile); 
		try { 
			xmlReader = new BufferedReader(new FileReader(rmFile));
		} catch ( FileNotFoundException fnf) { 
			logger.error("Resource manager doesn't have any cluster configured");
			return;
		}
		
		try { 
			xmlParser.setFeature("http://xml.org/sax/features/namespaces", true); 
		} catch (org.xml.sax.SAXNotRecognizedException saxnre) { 
			logger.error(saxnre); 
		} catch (org.xml.sax.SAXNotSupportedException saxnre) { 
			logger.error(saxnre);
		}
		
		try { 
			xmlParser.parse(new InputSource(xmlReader));
		} catch (org.xml.sax.SAXException saxe) { 
			logger.error(saxe); 
		} catch (java.io.IOException ioe) { 
			logger.error(ioe);
		}
		
		Document rmDoc  = xmlParser.getDocument(); 
		Element  rmRoot = rmDoc.getDocumentElement(); 
		
		logger.debug("parse all clusters!");
		NodeList rmList = rmRoot.getElementsByTagNameNS(RM_NAMESPACE_URI, "cluster");
        	for(int i=0; i < rmList.getLength(); i++) { 
			NodeList      nodeList = null;
			CharacterData cdata = null; 
			String        name =null, host=null, type=null, version=null; 
			Element       element = (Element) rmList.item(i);
			int           port = 0; 
			
			nodeList = element.getElementsByTagNameNS(RM_NAMESPACE_URI, "name");
			if ( nodeList.getLength() != 0) { 
				cdata    = (CharacterData) nodeList.item(0).getFirstChild();
				name      = cdata.getData().trim();
			}
			
			nodeList = element.getElementsByTagNameNS(RM_NAMESPACE_URI, "type");
			if ( nodeList.getLength() != 0) { 
				cdata    = (CharacterData) nodeList.item(0).getFirstChild();
				type      = cdata.getData().trim();
			} 
			
			nodeList = element.getElementsByTagNameNS(RM_NAMESPACE_URI, "version");
			if ( nodeList.getLength() != 0) { 
				cdata    = (CharacterData) nodeList.item(0).getFirstChild();
				version      = cdata.getData().trim();
			} 
			
			nodeList = element.getElementsByTagNameNS(RM_NAMESPACE_URI, "host");
			if ( nodeList.getLength() != 0) { 
				cdata    = (CharacterData) nodeList.item(0).getFirstChild();
				host     = cdata.getData().trim();
			}
			
			nodeList = element.getElementsByTagNameNS(RM_NAMESPACE_URI, "port");
			if ( nodeList.getLength() != 0) { 
				cdata    = (CharacterData) nodeList.item(0).getFirstChild();
				port     = Integer.parseInt(cdata.getData().trim());
			}
			
			ClusterContact cluster = new ClusterContact(name, type, host, port, version);
			
			if ( cluster != null) { 
				logger.debug("Cluster contact: " + cluster.toString());
				clusters.add(cluster);
			}
		}
		
		try {
			xmlReader.close(); 
		} catch (IOException ee) {
			// ignore this error
		}
		
		return;
    }
    private void create(String clusters, ResourceManagerAccessType rmaccess) 
			throws Exception
    {
	logger.debug("create invoked!");
        ResourceManagerFactoryResource factoryResource = 	
		(ResourceManagerFactoryResource)createNewInstance();
	logger.debug("createInstance ok!");
	factoryResource.create(clusters,rmaccess);
	ResourceKey key = new SimpleResourceKey(keyTypeName, factoryResource.getID());
	this.add(key,factoryResource);
	this.frkey = key;
    }
    private ResourceManagerAccessType getResourceManagerAccessType() {
        if (this.rmAccess != null) {
                        return (this.rmAccess);
        }
        this.rmAccess = new ResourceManagerAccessType();
        this.rmAccess.setURI(this.m_handle);
        int size = clusters.size();
        if (size <= 0) {
		return (this.rmAccess);
        }
        ResourceManagerInfoType [] infoArray = new ResourceManagerInfoType[size];
        Enumeration e = clusters.elements();
        int idx = 0;
        while ( e.hasMoreElements() ) {
                ClusterContact cluster = (ClusterContact) e.nextElement();
                ResourceManagerInfoType info = new ResourceManagerInfoType();
                info.setName(cluster.getName());
                info.setType(cluster.getType());
                info.setVersion(cluster.getVersion());
                infoArray[idx] = info;
                idx ++;
        }
        this.rmAccess.setResourceManager(infoArray);
        return (this.rmAccess);
    }

    protected void add(ResourceKey key, Resource resource)
    {
        // pass the call to the superclass
        super.add(key,resource);

        //   TODO  form the EPR

        ResourceContext ctx;
        try {
            ctx = ResourceContext.getResourceContext();
        } catch(ResourceContextException e) {
            logger.error("Could not get ResourceContext: "+e);
            return;
        }

        EndpointReferenceType epr;
        try {
            epr = AddressingUtils.createEndpointReference(ctx, key);
        } catch(Exception e) {
            logger.error("Could not form EPR: "+e);
            return;
        }

        String regPath = ContainerConfig.getGlobusLocation()+
            "/etc/metascheduler/ResourceManagerFactory_Registration.xml";

        try {
            ServiceGroupRegistrationParameters params = 
                ServiceGroupRegistrationClient.readParams(regPath);

            params.setRegistrantEPR(epr);

            ServiceGroupRegistrationClient client = 
                ServiceGroupRegistrationClient.getContainerClient();

            client.register(params);
            //   TODO  cache reg id for use in remove later?
        } catch(Exception e) {
            logger.error("Exception when trying to register this rmAccess: " +e);
        }
    }
    public void remove(ResourceKey key) throws ResourceException
    {
        // TODO unregister
        // remove from home
	logger.debug("ResourceManagerFactoryResource removed!");
        super.remove(key);
    }

}
