package com.platform.metascheduler.resourcemanager.impl;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import org.globus.wsrf.Resource;
import org.globus.wsrf.ResourceIdentifier;
import org.globus.wsrf.ResourceProperties;
import org.globus.wsrf.ResourceProperty;
import org.globus.wsrf.ResourcePropertySet;
import org.globus.wsrf.impl.SimpleResourcePropertySet;
import org.globus.wsrf.impl.SimpleResourceProperty;

import com.platform.metascheduler.resourcemanager.ResourceManagerAccessType;
import javax.xml.namespace.QName;

import com.platform.metascheduler.utils.MetaSchedulerConstants;

public class ResourceManagerFactoryResource implements
			Resource,
			ResourceIdentifier,
			ResourceProperties {

	private static Log logger =
        	LogFactory.getLog(ResourceManagerFactoryResource.class.getName());
	private ResourcePropertySet propSet;
	private Object key;
	private ResourceProperty clusters;
	private ResourceProperty rmAccess;

	// GET/SETTERS
	// clusters
	public String getClusters() {
		return ((String) this.clusters.get(0));
	}

	public void setClusters(String i_clusters) {
		this.clusters.set(0, i_clusters);
	}

	// rmAccess
	public ResourceManagerAccessType getRmAccess() {
		return ((ResourceManagerAccessType) this.rmAccess.get(0));
	}

	public void setRmAccess(ResourceManagerAccessType i_rmAccess) {
		this.rmAccess.set(0,i_rmAccess);
	}

	public Object create(String i_clusters, ResourceManagerAccessType i_rmAccess) throws Exception {
		logger.debug("create is invoked!");
		this.key = new Integer(hashCode());
		this.propSet = new SimpleResourcePropertySet(new QName(
			MetaSchedulerConstants.RESOURCE_MANAGER_NS,
			"ResourceManagerFactoryResourceProperties"));

		try {
			logger.debug("set clusters");
			this.clusters = new SimpleResourceProperty(new QName(
				MetaSchedulerConstants.RESOURCE_MANAGER_NS,"Clusters"));
			this.propSet.add(this.clusters);
			this.clusters.add(i_clusters);

			logger.debug("set rmaccess");
			this.rmAccess = new SimpleResourceProperty(new QName(
				MetaSchedulerConstants.RESOURCE_MANAGER_NS,"RmAccess"));
			this.propSet.add(this.rmAccess);
			this.rmAccess.add(i_rmAccess);
		} catch (Exception e) {
			throw new RuntimeException(e.getMessage());
		}

		return key;
	}

	public ResourcePropertySet getResourcePropertySet() {
		return this.propSet;
	}

	public Object getID() {
		return this.key;
	}

}
