package com.platform.metascheduler.utils;

import java.util.Hashtable;
import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Vector;
import java.io.StringReader;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import org.w3c.dom.Attr;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;
import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;

import javax.xml.namespace.QName;
import org.globus.exec.utils.rsl.RSLParseException;

public class GSARsvAttributes extends MetaSchedulerRsl{
    
    static Log logger = LogFactory.getLog(GSARsvAttributes.class);
    
    private static Element  m_element = null;
    private static String gsaString = null;
    
    public GSARsvAttributes() {
    }

    public GSARsvAttributes(String aslString) {
    	try {
    	    m_element = parse(new StringReader(aslString));
	} catch (Exception e) {
	      logger.error("RslFile:RslFile parsing error:" , e);
	}	    
	gsaString = aslString;
    }

    public Element getRootElement(){
    	return m_element;
    }	

    public String getTermAttribute(String gsaTerm,String attr){

	String attribute = null;
	NodeList nlist =
	  m_element.getElementsByTagNameNS(MetaSchedulerConstants.METASCHEDULER_RSL_NS,gsaTerm);
	  
	if (nlist.getLength()>=1){
		Element term = (Element) nlist.item(0);
		attribute = term.getAttribute(attr);
	}

	return attribute;
    
    }
    
    public Vector getHosts(){
	
	Vector hostVector = new Vector();

	NodeList nlist =
	  m_element.getElementsByTagNameNS(MetaSchedulerConstants.METASCHEDULER_RSL_NS,"hostTerm");

	if (nlist.getLength() < 1) {
	    return null;
	}
	
        Element hostTerm = (Element) nlist.item(0);
	
        //Get host list.
	
	NodeList nlist1 = hostTerm.getChildNodes();
	
        for (int i=0;i<nlist1.getLength();i++){

                Node e = nlist1.item(i);
                if (e.getNodeType()==Node.ELEMENT_NODE){
		     hostVector.add(getText((Element)e));
                 }
         }

	 return hostVector;
    }

    public String getResReq(){
	return getElementValue("ResReq");
    }

    public String getUser(){

	return getElementValue("userTerm");
    }

    public String getBeginTime(){

	return getElementValue("startTime");
    }

    public String getEndTime(){
	return getElementValue("endTime");
    }

    public String getNumber(){

	return getElementValue("cpuTerm");

    }

    public String toString() {
	return "";
    }

    protected static String getText(Element element) {
        //node has only text data
        NodeList textNodes = element.getChildNodes();
        int textNodeCount = textNodes.getLength();

        StringBuffer textData = new StringBuffer();
        for (int index=0; index<textNodeCount; index++) {
            Node textNode = textNodes.item(index);
            if (textNode instanceof Text) {
                textData.append(((Text) textNode).getData());
            }
        }

        return textData.toString();
    }


    private static String getElementValue(String term){

	String retString = null;
	
	NodeList nlist = m_element.getElementsByTagNameNS(
			  MetaSchedulerConstants.METASCHEDULER_RSL_NS, term);

	if (nlist.getLength() < 1) {
	    return null;
	}

	Element gsaTerm = (Element) nlist.item(0);
	
	nlist = gsaTerm.getChildNodes();
	for (int i=0;i<nlist.getLength();i++){
	    Node e = nlist.item(i);
	    if (e.getNodeType()==Node.ELEMENT_NODE){
		retString =  getText((Element)e);
	    }
	}
	return retString;
	
    }
}
