/** 
 * MetaSchedulerConstants.java
 * 
 * Lists constant values in this class.
 */
package com.platform.metascheduler.utils;

import javax.xml.namespace.QName;

public class MetaSchedulerConstants {

    public static String JobState_NS =
        "http://www.platform.com/namespaces/2003/05/metascheduler/jobstate";
    public static String METASCHEDULER_RSL_NS =
        "http://com.platform.metascheduler/2003/05/rsl/metascheduler";
    public static final String RESERVATION_NS = 
        "http://www.platform.com/namespaces/2003/05/metascheduler/reservation";
    public static final String RESOURCE_MANAGER_NS =
	"http://com.platform.metascheduler/2003/05/resourcemanager";
    public static final String QUEUING_NS =
	"http://www.platform.com/namespaces/2003/05/metascheduler/queuing";
    public static final String OGSI_NS =
	"http://www.gridforum.org/namespaces/2003/03/OGSI";
    public static final String GIS_NS =
	"http://www.platform.com/namespaces/2003/05/metascheduler/GIS";

    // This is temporary until OGSI Agreement document finalize its namespace
    public static final String OGSI_AGREEMENT_NS = 
	"http://www.platform.com/namespaces/2003/05/metascheduler/gsa";
    public static final String AGREEMENT_NS = 
	"http://www.platform.com/namespaces/2003/05/metascheduler/gsa";
    public static final String WS_POLICY_NS = 
	"http://schemas.xmlsoap.org/ws/2002/12/policy";

    public static String GRAM_RSL_NS =
	"http://www.globus.org/namespaces/2004/02/rsl/gram";

    public static String RSL_NS =
	"http://www.globus.org/namespaces/2004/02/rsl";

    // Factory URL 
    public static final String INDEX_SERVICE_URL = "wsrf/services/DefaultIndexService";
    public static final String CONTAINER_REGISTRY_SERVICE_URL = "ogsa/services/core/registry/ContainerRegistryService";
    public static final String GRAM_FORK_URL = "wsrf/services/ManagedJobFactoryService";
    public static final String GRAM_PBS_URL = "wsrf/services/ManagedJobFactoryService";
    public static final String GRAM_LSF_URL = "wsrf/services/ManagedJobFactoryService";

//    public static final String RESOURCE_MANAGER_FACTORY_URL = "ogsa/services/metascheduler/ResourceManagerFactoryService";
//    public static final String QUEUING_FACTORY_URL = "ogsa/services/metascheduler/QueuingFactoryService";
//    public static final String RESERVATION_FACTORY_URL = "ogsa/services/metascheduler/ReservationFactoryService";

    public static final String QUEUING_URL = "wsrf/services/metascheduler/QueuingService";
    public static final String JOB_URL = "wsrf/services/metascheduler/JobService";
    public static final String RESERVATION_URL = "wsrf/services/metascheduler/ReservationService";
    public static final String RESOURCE_MANAGER_FACTORY_URL = "wsrf/services/metascheduler/ResourceManagerFactoryService";
    public static final String RESOURCE_MANAGER_LSF_URL = "wsrf/services/metascheduler/ResourceManagerLsfService";
    public static final String RESOURCE_MANAGER_GRAM_URL = "wsrf/services/metascheduler/ResourceManagerGramService";

    public static final String state_created = "Created";
    public static final String state_sched = "Sched";
    public static final String state_pending = "Pending";
    public static final String state_forwarded = "Forwarded";
    public static final String state_running = "Running";
    public static final String state_done = "Done";
    public static final String state_pdone = "PDone";
    public static final String state_exit = "Exit";
    public static final String state_pexit = "PExit";
    public static final String state_sched_susp = "Sched_Susp";
    public static final String state_forw_susp = "Forw_Susp";
    public static final String state_pend_susp = "Pend_Susp";
    public static final String state_run_susp = "Run_Susp";

    public static final String job_control_stop = "STOP";
    public static final String job_control_resume = "RESUME";
    public static final String job_control_kill = "KILL";

    /* job related */
    public static final String  JOB               = "job";
    public static final String  JOB_EXECUTABLE    = "executable";
    public static final String  JOB_DIRECTORY     = "directory";
    public static final String  JOB_ARGUMENTS     = "arguments";
    public static final String  JOB_ENVIRONMENT   = "environment";
    public static final String  JOB_STDIN         = "stdin";
    public static final String  JOB_STDOUT        = "stdout";
    public static final String  JOB_STDERR        = "stderr";
    public static final String  JOB_COUNT         = "count";
    public static final String  JOB_PROJECT       = "project";
    public static final String  JOB_QUEUE         = "queue";
    public static final String  JOB_MAXTIME       = "maxTime";
    public static final String  JOB_MAXWALLTIME   = "maxWallTime";
    public static final String  JOB_MAXCPUTIME    = "maxCpuTime";
    public static final String  JOB_MAXMEMORY     = "maxMemory";
    public static final String  JOB_CLUSTER       = "clusterName";
    public static final String  JOB_RESERVATIONID = "reservationId";
    public static final String  JOB_GRIDRESERVATIONID = "gridReservationId";
    public static final String  JOB_INSTANCEID    = "jobInstanceId";
    public static final String  JOB_FACTORY       = "factory";
    public static final String  JOB_FACTORY_TYPE  = "factoryType";

    /* reservation related */
    public static final String  RESERVATION   = "reservation";
    public static final String  RSV_HOSTS     = "hosts";
    public static final String  RSV_NUMBER    = "number";
    public static final String  RSV_RSRC      = "rsrc";
    public static final String  RSV_USER      = "user";
    public static final String  RSV_BEGINTIME = "beginTime";
    public static final String  RSV_ENDTIME   = "endTime";
/*    public static final QName   RSV_CREATE_BY_RSL =
            new QName(RESERVATION_NS, "createByRSL");
    public static final QName   RSV_CREATE_BY_ID =
            new QName(RESERVATION_NS, "createByID");
    public static final QName   RSV_CREATE_BY_AGREEMENT =
            new QName(RESERVATION_NS, "createByAgreement");*/
    public static final String RSV_CREATE_BY_RSL ="Create_Reservation_By_RSL";
    public static final String RSV_CREATE_BY_ID ="Create_Reservation_By_ID";
    public static final String RSV_CREATE_BY_AGREEMENT ="Create_Reservation_By_Agreement";


    /* Queuing service */
    public static final String  SCHED_PLUGIN_INTERFACE  = "com.platform.metascheduler.impl.schedPlugin";
    public static final String  SCHED_PLUGIN_DEFAULT    = "com.platform.metascheduler.impl.schedPluginDefault";

    public static final QName   HOSTS_TERM = 
	    new QName(METASCHEDULER_RSL_NS, "hostsTerm");
    public static final QName   CPU_TERM = 
	    new QName(METASCHEDULER_RSL_NS, "cpuTerm");
    public static final QName   USER_TERM = 
	    new QName(METASCHEDULER_RSL_NS, "userTerm");
    public static final QName   START_TIME_TERM = 
	    new QName(METASCHEDULER_RSL_NS, "startTime");
    public static final QName   END_TIME_TERM = 
	    new QName(METASCHEDULER_RSL_NS, "endTime");
    public static final QName   RES_REQ_TERM = 
	    new QName(METASCHEDULER_RSL_NS, "reqReq");

    public static final String  JOB_SERVICE_ERR_EXIST    = "Job Resource is created before";
    public static final String  RESERVATION_SERVICE_ERR_EXIST    = "Reservation Resource is created before";

    public static final String  QUEUE_SERVICE_ERR_NOCONFIG = "Queuing service disabled: no queue configuration in configuration file ";
    public static final String  QUEUE_SERVICE_ERR_EXIST    = "Queuing Resource is created before";
    public static final String  QUEUE_CREATE_SUCCESS    = "Queuing Resource is created successfully";
    public static final String  QUEUE_SERVICE_ERR_INVALID_NAME = "Queuing service name is invalid";

}

