package com.platform.metascheduler.utils;

import java.io.File;
import java.util.Hashtable;
import java.util.Iterator;

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import javax.xml.soap.SOAPElement;
import javax.xml.namespace.QName;

import org.globus.exec.utils.rsl.RSLParseException;
//import org.globus.ogsa.impl.base.gram.utils.rsl.UnresolvedSubstitutionReferencesException;
//import org.globus.ogsa.impl.base.gram.utils.rsl.AttributeNotFoundException;

public interface MsAttributes {

    //DOM tree related methods
    public void setRslRootElement(Element msElement);
    public Element getRslRootElement();

    //Substitution methods
    public Iterator substitutionDefinitionNames();
    public boolean isSubstitutionDefined(String substitutionName);
    public boolean isMetaSchedulerJob();
    public Iterator substitutionReferences();
    public boolean isSubstitutionReferenced(String substitutionName);
    public void setSubstitutionDefinition(  String substitutionName,
                                            String substitutionValue);
    public NodeList getSubstitutionDefinition(String substitutionName)
            throws RSLParseException;
    public void resolveAllSubstitutions()
            throws RSLParseException;

    //RSL schema type methods
    public String getMsNamespaceURI();

    //*** Attribute retrieval methods ***
    //Generic
    public Object getAttribute(QName name)
        throws  RSLParseException;
    //Primitives
    public Integer getIntegerAttribute(QName name)
        throws  RSLParseException;
    public Long getLongAttribute(QName name)
        throws  RSLParseException;
    public Float getFloatAttribute(QName name)
        throws RSLParseException;  
    public Double getDoubleAttribute(QName name)
        throws RSLParseException; 
    public Boolean getBooleanAttribute(QName name)
        throws RSLParseException;  
    public String getStringAttribute(QName name)
        throws RSLParseException;  
    //Complex
    public String getPathAttribute(QName name)
        throws RSLParseException;  
    public String getUrlAttribute(QName name)
        throws RSLParseException;  
    public Hashtable getHashtableAttribute(QName name)
        throws RSLParseException;  
    public String[] getFileInputAttribute(QName name)
        throws RSLParseException; 
    public String[] getFileOutputAttribute(QName name)
        throws RSLParseException;  
    public String getEnumerationAttribute(QName name)
        throws RSLParseException; 
    //Arrays
    public String[] getStringArrayAttribute(QName name)
        throws RSLParseException;  
    public String[][] getTwoDimensionalStringArrayAttribute(QName name)
        throws RSLParseException;  
    public String[] getPathArrayAttribute(QName name)
        throws RSLParseException;  
    public String[][] getFileInputArrayAttribute(QName name)
        throws RSLParseException;  
    public String[][] getFileOutputArrayAttribute(QName name)
        throws RSLParseException;  
}
