package com.platform.metascheduler.utils;
import com.platform.www.namespaces._2003._05.metascheduler.gsa.AgreementType;
import com.platform.www.namespaces._2003._05.metascheduler.gsa.NegotiabilityType;
import metascheduler.platform.com._2003._05.rsl.metascheduler.HostsTermType;
import metascheduler.platform.com._2003._05.rsl.metascheduler.CpuTermType;
import metascheduler.platform.com._2003._05.rsl.metascheduler.UserTermType;
import metascheduler.platform.com._2003._05.rsl.metascheduler.TimeTermType;
import metascheduler.platform.com._2003._05.rsl.metascheduler.ResReqTermType;
import org.globus.ws.policy.Compositor;
import org.globus.ws.policy.CompositorContent;
import org.globus.ws.policy.PolicyReferenceType;
import org.globus.ws.policy.PolicyExpression;
import org.globus.ws.policy.OpenUsageType;
//import org.xmlsoap.schemas.ws._2002._12.policy.Compositor;

import com.platform.metascheduler.utils.MetaSchedulerConstants;

import com.platform.metascheduler.reservation.GridReservationType;
import com.platform.metascheduler.reservation.GridReservationStatus;
import com.platform.metascheduler.reservation.ReservationType;
import com.platform.metascheduler.reservation.ReservationFaultType;
import com.platform.metascheduler.resourcemanager.ResourceManagerLsfPortType;
import com.platform.metascheduler.resourcemanager.ResourceManagerFaultType;
import com.platform.metascheduler.resourcemanager.RsvInfoType;
import com.platform.metascheduler.resourcemanager.RsvsInfoType;
import com.platform.metascheduler.resourcemanager.RsvHostInfoType;
import com.platform.metascheduler.resourcemanager.ResourceManagerInfoType;

import com.platform.metascheduler.resourcemanager.RsvCancel;
import com.platform.metascheduler.resourcemanager.RsvCancelResponse;
import com.platform.metascheduler.resourcemanager.RsvSubmit;
import com.platform.metascheduler.resourcemanager.RsvSubmitResponse;
import com.platform.metascheduler.resourcemanager.RsvQuery;
import com.platform.metascheduler.resourcemanager.RsvQueryResponse;

import org.apache.axis.message.MessageElement;
import org.apache.axis.utils.XMLUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.xerces.dom.DOMImplementationImpl;

import java.io.StringReader;
import java.util.StringTokenizer;
import java.util.Hashtable;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Vector;
import java.text.SimpleDateFormat;
import javax.xml.namespace.QName;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import java.net.URL;
import java.rmi.RemoteException;

import org.w3c.dom.Element;
import org.w3c.dom.Document;
import org.w3c.dom.DOMImplementation;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import org.xml.sax.InputSource;
import org.globus.exec.utils.rsl.RSLParseException;
import org.ietf.jgss.GSSCredential;

import org.globus.wsrf.encoding.ObjectDeserializer;
import org.globus.wsrf.encoding.ObjectSerializer;
import org.globus.wsrf.encoding.DeserializationException;
import org.globus.wsrf.utils.AnyHelper;

public class ReservationHelper {
    static Log logger = LogFactory.getLog(ReservationHelper.class.getName());

/*    public static QName getCreationType(
        ExtensibilityType extensibility
    ) throws GridServiceException {

	MessageElement message = getFirstMessageElement(extensibility);
	QName creationType = message.getQName();

	return creationType;
    }*/

    /*
    public static Object getCreationObject(
        ExtensibilityType extensibility
    ) throws GridServiceException {

	Object obj = AnyHelper.getAsObject(extensibility);
	
	return obj;
    }
    */

/*    private static MessageElement getFirstMessageElement(
        ExtensibilityType extensibility
    ) throws GridServiceException {

	MessageElement[] messageArray = extensibility.get_any();
	if (messageArray == null ||
	    messageArray.length == 0 ||
	    messageArray[0]== null ) {

	    String errmsg = "Creation message object not persent";
	    logger.error(errmsg);
	    throw new GridServiceException(errmsg);
	}
	return messageArray[0];

    }*/

    public static void cancelReservation(
        GridReservationType rsv,
	Hashtable clusterMap, 
	GSSCredential credential
    ) throws RemoteException{

 	//fortransport-levelsecurity
 	org.globus.axis.util.Util.registerTransport();

	ReservationType[] rm_rsvArray = rsv.getRmRsvs();
	if (rm_rsvArray == null) {
	    rsv.setStatus(GridReservationStatus.CANCELLED);
	    return;
	}

	for (int i=0; i<rm_rsvArray.length; i++) {
	    ResourceManagerLsfPortType rmPort = null;

	    QName rm_rsvQName = rm_rsvArray[i].getRsvID();
	    if (rm_rsvQName == null) {
		throw makeReservationFault("RM reservation ID not present");
	    }
	    String rmFactoryHandle = rm_rsvQName.getNamespaceURI();
	    String globalRsvID = rm_rsvQName.getLocalPart();
	    
	    int atIdx = globalRsvID.indexOf('@');
	    if (atIdx <= 0) {
		throw makeReservationFault(
				   "Incorrect RM reservation ID format");
	    }
		
	    String rsvID = globalRsvID.substring(0, atIdx);
	    String cluster = globalRsvID.substring(atIdx + 1);

	    if (rmFactoryHandle == null) {
		// RM Factory handle not specified, try to look it up using
		// cluster name
		rmFactoryHandle = 
		    MetaSchedulerHelper.getFactoryByClusterName(clusterMap, cluster);
	    }

	    try { 
		rmPort = MetaSchedulerHelper.getResourceManagerLsfPortToCluster(rmFactoryHandle, 
									 cluster,credential);
	    } catch ( ResourceManagerFaultType e) { 
		throw makeReservationFault(e.getMessage());
	    }

	    try {
		rmPort.rsvCancel(new RsvCancel(rsvID));
	    } catch (java.rmi.RemoteException e) {
	        logger.error("Remote Exception error");
		throw makeReservationFault(e.getMessage());
            } catch (Exception e) {
		logger.error(e.getMessage());
		throw makeReservationFault(e.getMessage());
	    }
	} // END of for-loop

	rsv.setStatus(GridReservationStatus.CANCELLED);
	return;	
    }

    private static String getClusterNameInHostsElement(GridReservationType rsv)
    { 
	String clusterName = null;

	// The function extracts clusterName specified in hosts element
 	// in format of hostname@clustername ... The resvation will be
	// submited to the first cluster defined. Co-allocation is not
	// handled at this version.

	try { 
	    MetaSchedulerRsl msRsl = new MetaSchedulerRsl(rsv.getRSL());
            Element          msRslRootElement = msRsl.getRootElement();
            RsvAttributes    rsvAttr = new RsvAttributes(msRslRootElement);
	    String 	     hosts = rsvAttr.getHosts();	
	    if (hosts.indexOf("@") > 0) {
		StringTokenizer st = new StringTokenizer(hosts);
        	while (st.hasMoreTokens()) {
		    String host = st.nextToken();

            	    if (host != null) {
                	int index = host.indexOf("@");
                	if (index > 0) { 
                    	    String cl = host.substring(index + 1);
                    	    if (cl != null){
				clusterName = cl;
				break;
			    }
			}
                    }
                } 
            }
	} catch (Exception e) {
	    logger.error(e);
	  
   	} 
	return clusterName;
    }
	

    public static void submitReservation(GridReservationType rsv, 
					 Hashtable clusterMap, 
					 GSSCredential credential
    ) throws RemoteException, 
	     RSLParseException {

	if ( ! rsv.getStatus().equals(GridReservationStatus.CREATED) ) {
	    throw makeReservationFault("Reservation not in CREATED state");
	}

        String clusterName = getClusterNameInHostsElement(rsv);

	rsv.setStatus(GridReservationStatus.SCHED);

	QName[] clusterQNames = findCandidateClusters(rsv, clusterMap);
	if (clusterQNames == null || clusterQNames.length == 0) {
	    // no candidate cluster found
	    throw makeReservationFault("No Candidate cluster found");
	}
	
	ReservationType[] rm_rsvArray = null;
	boolean satified = false;
        ArrayList failReasonList = new ArrayList();
        failReasonList.add ("Reservation failed");

	for (int i=0; i<clusterQNames.length; i++) {

	    String rmFactoryHandle = clusterQNames[i].getNamespaceURI();
	    String cluster = clusterQNames[i].getLocalPart();

	    if (clusterName != null && !cluster.equals(clusterName)) {
		continue;
	    }

	    logger.debug("Trying to reserve on cluster <" + cluster + ">");
	    logger.debug("Invoke reserveInCluster(cluster=" + cluster +
			 ", rmFactoryHandle=" + rmFactoryHandle +
			 ", rsl=" + rsv.getRSL() + ")");
	    ReservationType rm_rsv = null;
	    try { 
		rm_rsv = reserveInCluster(cluster, 
					  rmFactoryHandle, rsv.getRSL(), credential);
	    } catch (RemoteException e) {
                failReasonList.add (cluster+ ":");
                failReasonList.add(e.getMessage());
		continue;
	    }
	    logger.debug("Reservation made on cluster <" + cluster +
			     "> with ID <" + rm_rsv.getRsvID() + ">");
	    if (rm_rsvArray == null) {
		rm_rsvArray = new ReservationType[1];
		rm_rsvArray[0] = rm_rsv;
	    } else {
		ReservationType[] tmp_rsvArray = 
		    new ReservationType[rm_rsvArray.length + 1];
		System.arraycopy(rm_rsvArray, 0, tmp_rsvArray, 0,
				 rm_rsvArray.length);
		tmp_rsvArray[rm_rsvArray.length] = rm_rsv;
		rm_rsvArray = tmp_rsvArray;
	    }
	    rsv.setRmRsvs(rm_rsvArray);
	    if (satisfied(rsv)) {
		logger.debug("Reservation request satisfied");
		satified = true;
		break;
	    }
	}

	if (satified == false) {
	    cancelReservation(rsv, clusterMap, credential);
	    rsv.setStatus(GridReservationStatus.EXIT);
	    logger.warn("Reservation failed");
	    throw makeReservationFault( (String[])failReasonList.toArray(new String[0]) );
	}
	rsv.setStatus(GridReservationStatus.RESERVED);
    }

    public static ReservationType reserveInCluster(
        String cluster,
	String rmFactoryHandle,
	String rsl,
	GSSCredential credential
    ) throws RemoteException{
 	//fortransport-levelsecurity
 	org.globus.axis.util.Util.registerTransport();

	logger.debug("Entering... reserveInCluster!");

	ReservationType rm_rsv = null;
	ResourceManagerLsfPortType rmPort = null; 

	try { 
	    rmPort = MetaSchedulerHelper.getResourceManagerLsfPortToCluster(rmFactoryHandle, cluster, credential);
	} catch ( RemoteException e) { 
	    throw makeReservationFault(e.getMessage());
	}
	
	try {
	    String rm_rsvID = rmPort.rsvSubmit(new RsvSubmit(rsl)).getRsvId();
	    logger.debug("rm_rsvID=<" + rm_rsvID + ">");

	    rm_rsv = new ReservationType();

	    QName rm_rsvQName = new QName(rmFactoryHandle,
					  rm_rsvID + "@" + cluster);
	    String rm_rsvInfoString = rmPort.rsvQuery(new RsvQuery(rm_rsvID)).getRsvInfo();
	    logger.debug("rm_rsvInfoString=<" + rm_rsvInfoString + ">");
	    String[] locations = parseLocations(rm_rsvInfoString);
	    for (int i=0; i<locations.length; i++) {
		logger.debug("locations: " + locations[i]);
	    }
	    rm_rsv.setRsvID(rm_rsvQName);
	    rm_rsv.setLocations(locations);
	} catch (java.rmi.RemoteException e) {
	    logger.error("Remote Exception from RM service");
	    throw makeReservationFault("Remote Exception from RM service" + e.getMessage());
	}
	return (rm_rsv);
    }


    private static String[] parseLocations(String rsvInfoString) {
	ArrayList hostList = new ArrayList();

	DocumentBuilderFactory parserFactory = 
	    DocumentBuilderFactory.newInstance();
	//parserFactory.setNamespaceAware(true);
	//parserFactory.setValidating(true);
	//parserFactory.setAttribute(
        //        "http://java.sun.com/xml/jaxp/properties/schemaLanguage",
        //        "http://www.w3.org/2001/XMLSchema");
	Document doc = null;
	try {
	    DocumentBuilder xmlParser =
		parserFactory.newDocumentBuilder();
	    StringReader reader = new StringReader(rsvInfoString);
	    doc = xmlParser.parse(new InputSource(reader));
	} catch (Exception e) {
	    logger.error("Parse error: " + e.getMessage());
	    return null;
	}

	Element rsvElement = doc.getDocumentElement();
	RsvsInfoType rsvsInfo = null;
	try {
	    rsvsInfo = (RsvsInfoType)ObjectDeserializer.toObject(
					     rsvElement, RsvsInfoType.class);
	} catch (DeserializationException e) {
	    logger.error("Deserialization error: " + e.getMessage());
	    return null;
	}

	RsvInfoType[] rsvInfoArray = rsvsInfo.getRsvsInfo();
	if (rsvInfoArray == null || rsvInfoArray.length == 0) {
	    logger.error("Empty RsvsInfoType");
	}
	RsvInfoType rsvInfo = rsvInfoArray[0];
	RsvHostInfoType[] rsvHostInfo = rsvInfo.getHostInfo();
	for (int i=0; i<rsvHostInfo.length; i++) {
	    String hostname = rsvHostInfo[i].getName();
	    Integer intObj = rsvHostInfo[i].getNumber();
	    for (int k=0; k<intObj.intValue(); k++) {
		hostList.add(hostname);
	    }
	}

	return (String[])hostList.toArray(new String[0]);
    } // END of parseLocations()

    public static boolean satisfied( GridReservationType rsv) 
	throws  RSLParseException {
	long required = GridReservationTypeHelper.getRSLNumber(rsv);
	ReservationType[] rm_rsvArray = rsv.getRmRsvs();

	if (rm_rsvArray == null || required < 0) {
	    return false;
	}

	int rsvCpu = 0;

	for (int i=0; i<rm_rsvArray.length; i++) {
	    String[] locations = rm_rsvArray[i].getLocations();
	    if (locations != null) {
		rsvCpu += locations.length;
	    }
	}
	
	if (rsvCpu < required) {
	    return false;
	}
	return true;
    }

    public static QName[] findCandidateClusters(
	GridReservationType rsv,
	Hashtable clusterMap
    ) {
	ArrayList list = new ArrayList();

	// Can call index service to do some cluster selection.  For now, it 
	// returns all LSF cluster(s)

	for (java.util.Enumeration e = clusterMap.keys();
	     e.hasMoreElements() ;) {
	    QName key = (QName)e.nextElement();
	    ResourceManagerInfoType info =
		(ResourceManagerInfoType)clusterMap.get(key);

	    logger.debug("key=" + key.toString());
	    logger.debug("info=" + info.toString());

	    if (info.getType().equals("LSF")) {
		list.add(key);
	    }
	}

	return (QName[])list.toArray(new QName[0]);
    }

    private static String rslDocument(
        String[] hostsValue,
	int cpuValue,
	String userValue,
	Calendar startValue,
	Calendar endValue,
	String resReqValue
    ) {
	StringBuffer rslBuffer = new StringBuffer();

	String cfgPath = ".";

	rslBuffer.append("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
	rslBuffer.append("<rsl:rsl xmlns:rsl=\"" + MetaSchedulerConstants.RSL_NS + "\"\n");
	rslBuffer.append("         xmlns:metascheduler=\"" + MetaSchedulerConstants.METASCHEDULER_RSL_NS + "\"\n");
	rslBuffer.append("         xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n");
	rslBuffer.append("         xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\"\n");
	rslBuffer.append("         xsi:schemaLocation=\"\n");
	rslBuffer.append("           " + MetaSchedulerConstants.METASCHEDULER_RSL_NS + "\n");
	rslBuffer.append("           " + cfgPath + "/etc/metascheduler/metascheduler.xsd\">\n");
	rslBuffer.append("  <metascheduler:request>\n");
	rslBuffer.append("    <metascheduler:reservation>\n");

	if (resReqValue.length() > 0) {
	    rslBuffer.append("      <metascheduler:rsrc>\n");
	    rslBuffer.append("        <rsl:string>\n");
	    rslBuffer.append("		<![CDATA[" + resReqValue + "]]>\n");
	    rslBuffer.append("        </rsl:string>\n");
	    rslBuffer.append("      </metascheduler:rsrc>\n");
	}

	if (hostsValue.length >= 1) {
	    StringBuffer hostsValueStr = new StringBuffer();
	    for (int i=0; i<hostsValue.length; i++) {
		if (i != 0) {
		    hostsValueStr.append(" ");
		}
		hostsValueStr.append(hostsValue[i]);
	    }
	    rslBuffer.append("      <metascheduler:hosts>\n");
	    rslBuffer.append("        <rsl:string>\n");
	    rslBuffer.append("          <rsl:stringElement value=\"" + 
			     hostsValueStr.toString() +
			     "\"/>\n");
	    rslBuffer.append("        </rsl:string>\n");
	    rslBuffer.append("      </metascheduler:hosts>\n");
	}

	rslBuffer.append("      <metascheduler:user>\n");
	rslBuffer.append("        <rsl:string>\n");
	rslBuffer.append("          <rsl:stringElement value=\"" + 
			 userValue +
			 "\"/>\n");
	rslBuffer.append("        </rsl:string>\n");
	rslBuffer.append("      </metascheduler:user>\n");

	rslBuffer.append("      <metascheduler:number>\n");
	rslBuffer.append("        <rsl:long value=\"" + 
			 String.valueOf(cpuValue) + 
			 "\"/>\n");
	rslBuffer.append("      </metascheduler:number>\n");

	rslBuffer.append("      <metascheduler:beginTime>\n");
	rslBuffer.append("	  <xsd:dateTime value=\"" + 
			 		calToString(startValue) + "\"/>\n");
	rslBuffer.append("      </metascheduler:beginTime>\n");

	rslBuffer.append("      <metascheduler:endTime>\n");
	rslBuffer.append("	  <xsd:dateTime value=\"" + 
			 		calToString(endValue) + "\"/>\n");
	rslBuffer.append("      </metascheduler:endTime>\n");

	rslBuffer.append("    </metascheduler:reservation>\n");
	rslBuffer.append("  </metascheduler:request>\n");
	rslBuffer.append("</rsl:rsl>\n");

	return rslBuffer.toString();
    }

    private static String processAll(
        PolicyReferenceType all
    ) throws RemoteException {

	logger.debug("processAll(): Entering...");
		
	MessageElement[] msgElement = all.get_any();
	Element[]	element = null;
	try {
		element = AnyHelper.toElement(msgElement);
	}catch (Exception e) {
		logger.error("msgElement to Element error:" + e.getMessage());
		throw new RemoteException(e.getMessage());
	}

	if(msgElement.length == element.length) {
		logger.debug("SOAP element to DOM element ok!");
	}else {
		logger.debug("SOAP element to DOM element fail!");
	}

	String[] hosts = new String[0];
	int cpu = 0;
	String user = "";
	Calendar startTime = Calendar.getInstance();
	Calendar endTime =   Calendar.getInstance();
	String resReq = "";
	
	HostsTermType hostsTerm = null;	
	CpuTermType cpuTerm = null;
	UserTermType userTerm = null;
	TimeTermType startTimeTerm = null;
	TimeTermType endTimeTerm = null;
	ResReqTermType resReqTerm = null;

	for (int i=0; i<msgElement.length; i++) {
	    QName termQName = msgElement[i].getQName();

	    if (termQName.equals(MetaSchedulerConstants.HOSTS_TERM)) {

		try{
			hostsTerm = (HostsTermType)
		    		ObjectDeserializer.toObject(element[i], HostsTermType.class);
		} catch(DeserializationException e) {
			logger.error("hosts Deserialization Error!");
		}
		hosts = hostsTerm.getHost();
		/*
		NegotiabilityType negotiability = hostsTerm.getNegotiability();
		logger.debug("Negotiability: " + 
			     negotiability.getValue().toString());
		*/
		for (int h=0; h<hosts.length; h++) {
		    logger.debug("HOST: " + hosts[h]);
		}

	    } else if (termQName.equals(MetaSchedulerConstants.CPU_TERM)) {

		try{
			cpuTerm = (CpuTermType)
		    		ObjectDeserializer.toObject(element[i], CpuTermType.class);
		} catch(DeserializationException e) {
			logger.error("cpu Deserialization Error!");
		}
		cpu = cpuTerm.getNumber();
		/*
		NegotiabilityType negotiability = cpuTerm.getNegotiability();
		logger.debug("Negotiability: " + 
			     negotiability.getValue().toString());
		*/
		logger.debug("NUMBER: " + cpu);

	    } else if (termQName.equals(MetaSchedulerConstants.USER_TERM)) {

		try{
			userTerm = (UserTermType)
		    		ObjectDeserializer.toObject(element[i], UserTermType.class);
		} catch(DeserializationException e) {
			logger.error("user Deserialization Error!");
		}
		user = userTerm.getUser();
		/*
		NegotiabilityType negotiability = userTerm.getNegotiability();
		logger.debug("Negotiability: " + 
			     negotiability.getValue().toString());
		*/
		logger.debug("USER: " + user);

	    } else if (termQName.equals(
			      MetaSchedulerConstants.START_TIME_TERM)) {

		try{
			startTimeTerm = (TimeTermType)
		    		ObjectDeserializer.toObject(element[i], TimeTermType.class);
		} catch(DeserializationException e) {
			logger.error("startTime Deserialization Error!");
		}
		startTime = startTimeTerm.getTime();
		/*
		NegotiabilityType negotiability = startTimeTerm.getNegotiability();
		logger.debug("Negotiability: " + 
			     negotiability.getValue().toString());
		*/
		logger.debug("START_TIME: " + startTime.toString());

	    } else if (termQName.equals(
			      MetaSchedulerConstants.END_TIME_TERM)) {

		try{
			endTimeTerm = (TimeTermType)
		    		ObjectDeserializer.toObject(element[i],TimeTermType.class);
		} catch(DeserializationException e) {
			logger.error("endTime Deserialization Error!");
		}
		endTime = endTimeTerm.getTime();
		/*
		NegotiabilityType negotiability = endTimeTerm.getNegotiability();
		*/
		logger.debug("END_TIME: " + endTime.toString());

	    } else if (termQName.equals(MetaSchedulerConstants.RES_REQ_TERM)) {
		    
		try{
			resReqTerm = (ResReqTermType)
		    		ObjectDeserializer.toObject(element[i], ResReqTermType.class);
		} catch(DeserializationException e) {
			logger.error("resReq Deserialization Error!");
		}
		resReq = resReqTerm.getResReq();
		/*
		NegotiabilityType negotiability = resReqTerm.getNegotiability();
		logger.debug("Negotiability: " + 
			     negotiability.getValue().toString());
		*/
		logger.debug("RES_REQ: " + resReq);

	    }
	} // END of for

	/*
	Document rslDoc = rslDocument(hosts, cpu, user, 
				      startTime, endTime, resReq);
	String rsl = XMLUtils.DocumentToString(rslDoc);
	*/
	String rsl = rslDocument(hosts, cpu, user, 
				      startTime, endTime, resReq);

	return rsl;
    }

    public static String getRSLByAgreement(
        AgreementType agreement
    ) throws RemoteException {

	String rsl = null;
	CompositorContent allContent[] = agreement.getCompositorContent();
	/*
	Compositor exactlyOneArray[] = agreement.getExactlyOne();
	Compositor oneOrMoreArray[] = agreement.getOneOrMore();
	*/
	Compositor exactlyOneArray[] = null;
	Compositor oneOrMoreArray[] = null;

	logger.debug("getRSLByAgreement(): Entering ...");

	if (allContent != null && allContent.length > 0) {

	    if (allContent.length > 1) {
		throw makeReservationFault("Only one <wsp:All> is supported");
	    }
	    try {
		rsl = processAll(allContent[0].getPolicyReference());
	    } catch (RemoteException e) {
		throw makeReservationFault(e.getMessage());
	    }
	}

	if (exactlyOneArray != null && exactlyOneArray.length > 0) {
	    throw makeReservationFault("Support for <wsp:ExactlyOne> is not yet implmented");
	}

	if (oneOrMoreArray != null && oneOrMoreArray.length > 0) {
	    throw makeReservationFault("Support for <wsp:OneOrMore> is not yet implmented");
	}

	return rsl;
    }

/*    public static String lookupHandleByName(
        String registry,
        String needle
    ) throws RemoteException {
	
	logger.debug("Entering... registry=" + registry + 
		     " needle=" + needle);
	
	QName entry = new QName(GridConstants.OGSI_NS, "entry");
	QName[] qnames = { entry };

	OGSIServiceGridLocator locator = new OGSIServiceGridLocator();
	GridService service =
	    locator.getGridServicePort(new HandleType(registry));

	ExtensibilityType queryResult =
	    service.findServiceData(QueryHelper.getNamesQuery(qnames));

	if (queryResult.get_any() == null) {
	    return null;
	}

	//logger.debug(AnyHelper.getAsString(queryResult));

	ServiceDataValuesType serviceData 
	    = AnyHelper.getAsServiceDataValues(queryResult);

	MessageElement[] entries = serviceData.get_any();

	logger.debug("Number of entries=" + entries.length);
 
	for (int i=0; i<entries.length; i++) {
	    //logger.debug("ENTRY: " + entries[i].toString());
	    Object obj = AnyHelper.toObject(entries[i], EntryType.class);
	    if ( ! (obj instanceof EntryType) ) {
		continue;
	    }
	    EntryType entryType = (EntryType)obj;

	    EntryContentType content = entryType.getContent();
	    MessageElement[] contentAny = content.get_any();
	    if (contentAny == null || contentAny.length == 0) {
		continue;
	    }
	    PropertiesDetailType detail = (PropertiesDetailType)
		AnyHelper.toObject(contentAny[0], PropertiesDetailType.class);

	    String name = detail.getName();
	    String handle = detail.getHandle();
	    Boolean activeOnStartUp = detail.getActivateOnStartup();
	    StateType state = detail.getState();

	    logger.debug("service name=<" + name + ">");

	    if (handle.endsWith(needle)) {
		return handle;
	    }
	}
	
	logger.debug("service name not found");

	return null;
    }
*/
    // improve here in the future , return a WS-BaseFault type --2005/03/06
    public static RemoteException makeReservationFault( String desc) {
	return new RemoteException(desc);
    } // END of makeReservationFault

    public static RemoteException makeReservationFault(
        String[] descs
    ) {
	String msg = "";
	for(int i=0; i<descs.length; i++) {
		msg = msg + descs[i];
	}
	logger.debug("in make fault:"+msg);
	return  new RemoteException(msg);
    } // END of makeReservationFault

    public static AgreementType createAgreementType(GSARsvAttributes gsaAttr){
	
	logger.debug("Entering...");
	int           numTerms  = 0;
	AgreementType agreement = new AgreementType();
	HostsTermType hosts     = null;
        CpuTermType   cpu       = null;
        UserTermType  users     = null;
        TimeTermType  startTime = null;
        TimeTermType  endTime   = null;
        ResReqTermType resReq   = null;
	
	Element root = gsaAttr.getRootElement();
	Compositor comp = new Compositor();
	String attribute = null;
	
	NodeList nlist = root.getElementsByTagName("wsp:All");

	if (nlist.getLength()>=1){
	    Element term = (Element) nlist.item(0);
	    attribute = term.getAttribute("wsp:Usage");
	} else {
	    logger.debug("We only support All tag");
	}
	
	OpenUsageType usage = new OpenUsageType(attribute);
	
	comp.setUsage(usage);
	
	logger.debug("ready to process hosts");
	Vector hostsVector = gsaAttr.getHosts();
	if (hostsVector != null) {
	    numTerms ++;
	    String[] hostsString = new String[hostsVector.size()];
	
	    for (int i=0;i<hostsVector.size();i++){
		hostsString[i] = ((String)hostsVector.get(i)).trim();
	    }

	    hosts  = new HostsTermType();
	    hosts.setHost(hostsString);
	    String hostNegotiability = 
		gsaAttr.getTermAttribute("hostTerm","gsa:Negotiability");
	    if (hostNegotiability.equals("gsa:Fixed")) {
		hosts.setNegotiability(
			       NegotiabilityType.fromString("{" + MetaSchedulerConstants.AGREEMENT_NS + "}Fixed"));
	    } else if (hostNegotiability.equals("gsa:Negotiable")) {
		hosts.setNegotiability(
			       NegotiabilityType.fromString("{" + MetaSchedulerConstants.AGREEMENT_NS + "}Negotiable"));
	    }
	}

	logger.debug("ready to process user");
	String usersAttr = gsaAttr.getUser();
	if (usersAttr != null) {
	    numTerms ++;
	    users = new UserTermType();
	    users.setUser(usersAttr.trim());
	    String userNegotiability = 
		gsaAttr.getTermAttribute("userTerm", "gsa:Negotiability");
	    if (userNegotiability.equals("gsa:Fixed")) {
		users.setNegotiability(
			       NegotiabilityType.fromString("{" + MetaSchedulerConstants.AGREEMENT_NS + "}Fixed"));
	    } else if (userNegotiability.equals("gsa:Negotiable")) {
		users.setNegotiability(
			       NegotiabilityType.fromString("{" + MetaSchedulerConstants.AGREEMENT_NS + "}Negotiable"));
	    }
	}
	
	logger.debug("ready to process begintime");
	String beginTimeAttr = gsaAttr.getBeginTime();
	logger.debug("beginTime is:"+ beginTimeAttr);
	if (beginTimeAttr != null) {
	    numTerms ++;
	    startTime = new TimeTermType();
	    startTime.setTime(stringToCalendar(beginTimeAttr.trim()));
	    String startTimeNegotiability = 
		gsaAttr.getTermAttribute("startTime", "gsa:Negotiability");
	    if (startTimeNegotiability.equals("gsa:Fixed")) {
		startTime.setNegotiability(
			       NegotiabilityType.fromString("{" + MetaSchedulerConstants.AGREEMENT_NS + "}Fixed"));
	    } else if (startTimeNegotiability.equals("gsa:Negotiable")) {
		startTime.setNegotiability(
			       NegotiabilityType.fromString("{" + MetaSchedulerConstants.AGREEMENT_NS + "}Negotiable"));
	    }
	}

	logger.debug("ready to process endtime");
	String endTimeAttr = gsaAttr.getEndTime();
	if (endTimeAttr != null) {
	    numTerms ++;
	    endTime = new TimeTermType();
	    endTime.setTime(stringToCalendar(endTimeAttr.trim()));
	    String endTimeNegotiability = 
		gsaAttr.getTermAttribute("endTime", "gsa:Negotiability");
	    if (endTimeNegotiability.equals("gsa:Fixed")) {
		endTime.setNegotiability(
			       NegotiabilityType.fromString("{" + MetaSchedulerConstants.AGREEMENT_NS + "}Fixed"));
	    } else if (endTimeNegotiability.equals("gsa:Negotiable")) {
		endTime.setNegotiability(
			       NegotiabilityType.fromString("{" + MetaSchedulerConstants.AGREEMENT_NS + "}Negotiable"));
	    }
	}
	
	logger.debug("ready to process resreq");
	String resReqAttr = gsaAttr.getResReq();
	if (resReqAttr != null) {
	    numTerms ++;
	    resReq = new ResReqTermType();
	    resReq.setResReq(resReqAttr.trim());
	    String resReqNegotiability = 
		gsaAttr.getTermAttribute("ResReq", "gsa:Negotiability");
	    if (resReqNegotiability.equals("gsa:Fixed")) {
		resReq.setNegotiability(
			       NegotiabilityType.fromString("{" + MetaSchedulerConstants.AGREEMENT_NS + "}Fixed"));
	    } else if (resReqNegotiability.equals("gsa:Negotiable")) {
		resReq.setNegotiability(
			       NegotiabilityType.fromString("{" + MetaSchedulerConstants.AGREEMENT_NS + "}Negotiable"));
	    }
	}

	logger.debug("ready to process cpu");
	String cpuAttr = gsaAttr.getNumber();
	if (cpuAttr != null) {
	    numTerms ++;
	    Integer intCpu = new Integer(cpuAttr.trim());
	    cpu = new CpuTermType();
	    cpu.setNumber(intCpu.intValue());
	    String cpuNegotiability = 
		gsaAttr.getTermAttribute("cpuTerm", "gsa:Negotiability");
	    if (cpuNegotiability.equals("gsa:Fixed")) {
		cpu.setNegotiability(
			       NegotiabilityType.fromString("{" + MetaSchedulerConstants.AGREEMENT_NS + "}Fixed"));
	    } else if (cpuNegotiability.equals("gsa:Negotiable")) {
		cpu.setNegotiability(
			       NegotiabilityType.fromString("{" + MetaSchedulerConstants.AGREEMENT_NS + "}Negotiable"));
	    }
	}
	
	if (cpu == null || users == null ||
	    startTime == null || endTime == null) {
	    System.err.println("Missing required attribute(s) from agreement file");
	    return null;
	}

	if (hosts == null && resReq == null) {
	    System.err.println("Either hosts or resReq must be specified");
	    return null;
	}

	try {
	    int termsIdx = 0;
	    MessageElement[] any = new MessageElement[numTerms];

	    if (hosts != null) {
		any[termsIdx++] = 
		    AnyHelper.toAny(ObjectSerializer.toElement(hosts, MetaSchedulerConstants.HOSTS_TERM));
	    }

	    any[termsIdx++] = 
		AnyHelper.toAny(ObjectSerializer.toElement(cpu, MetaSchedulerConstants.CPU_TERM));
	    any[termsIdx++] = 
		AnyHelper.toAny(ObjectSerializer.toElement(users, MetaSchedulerConstants.USER_TERM));
	    any[termsIdx++] = AnyHelper.toAny(ObjectSerializer.toElement(startTime,
				      MetaSchedulerConstants.START_TIME_TERM));
	    any[termsIdx++] = 
		AnyHelper.toAny(ObjectSerializer.toElement(endTime, MetaSchedulerConstants.END_TIME_TERM));
	    if (resReq != null) {
		any[termsIdx++] = AnyHelper.toAny(ObjectSerializer.toElement(resReq,
				  MetaSchedulerConstants.RES_REQ_TERM));
	    }
	    PolicyReferenceType pRef = new PolicyReferenceType();
	    pRef.set_any(any);
	    CompositorContent compC[] = new CompositorContent[1];
	    compC[0] = new CompositorContent();
	    compC[0].setPolicyReference(pRef);
	    compC[0].setAll(comp);
	    agreement.setCompositorContent(compC);
	    
	} catch (Exception e) {
	    e.printStackTrace(); 
	    return null;
	}

       	return agreement;
	
    }

/**
 * stringToCalendar : Parse String type to Calendar type 
 * Because ExtendDateTimeType is unavailable on wsrf
 * @dateTime str (for example:"2004-12-29T20:00:00.000Z") 
 */
    public static Calendar stringToCalendar(String dateTimestr) {

         	StringTokenizer st = new StringTokenizer(dateTimestr,"T");

                String t= st.nextToken();
                StringTokenizer st1= new StringTokenizer(t,"-");
                int year = Integer.valueOf(st1.nextToken()).intValue();
                int month = Integer.valueOf(st1.nextToken()).intValue();
                int day = Integer.valueOf(st1.nextToken()).intValue();

                t= st.nextToken();
                StringTokenizer st2= new StringTokenizer(t,".");

                String t2= st2.nextToken();

                StringTokenizer st3= new StringTokenizer(t2,":");
                int hour = Integer.valueOf(st3.nextToken()).intValue();
                int minute = Integer.valueOf(st3.nextToken()).intValue();
                int second = Integer.valueOf(st3.nextToken()).intValue();
		
		Calendar cal = Calendar.getInstance();
		cal.set(year,month,day,hour,minute,second);
		return cal;
    }
/**
 * calToString : Parse Calendar type to a more simple string
 * because Calendar.toString() ruturn a very complex string
 * return is a string (for example:"2004-12-29T20:00:00.000Z")
 */
    public static String calToString(Calendar cal){
		String calstring= "";
		calstring = String.valueOf(cal.get(Calendar.YEAR)) + "-" + 
			    ((cal.get(Calendar.MONTH) < 10) ? "0":"") +
			    String.valueOf(cal.get(Calendar.MONTH)) + "-" +
			    ((cal.get(Calendar.DAY_OF_MONTH) < 10) ? "0":"") +
			    String.valueOf(cal.get(Calendar.DAY_OF_MONTH)) + "T" + 
			    ((cal.get(Calendar.HOUR_OF_DAY) < 10) ? "0":"") +
			    String.valueOf(cal.get(Calendar.HOUR_OF_DAY)) +":" +
			    ((cal.get(Calendar.MINUTE) < 10) ? "0":"") +
			    String.valueOf(cal.get(Calendar.MINUTE)) + ":" + 
			    ((cal.get(Calendar.SECOND) < 10) ? "0":"") +
			    String.valueOf(cal.get(Calendar.SECOND)) + ".000Z";
		logger.debug("calString is :" + calstring);
		return calstring;
    }
}
