package com.platform.metascheduler.utils;

import java.util.Hashtable;
import java.util.List;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Iterator;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import org.w3c.dom.Attr;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;
import org.w3c.dom.Document;

import javax.xml.namespace.QName;
import org.globus.exec.utils.rsl.RSLParseException;
//import org.globus.ogsa.impl.base.gram.utils.rsl.UnresolvedSubstitutionReferencesException;
//import org.globus.ogsa.impl.base.gram.utils.rsl.AttributeNotFoundException;

public class RsvAttributes extends MsAttributesImpl {
    static Log logger = LogFactory.getLog(RsvAttributes.class);

    static String RSV_NAMESPACE_URI = MetaSchedulerConstants.METASCHEDULER_RSL_NS;

    public RsvAttributes() {
    }

    public RsvAttributes(Element rslRootElement) {
        setRslRootElement(rslRootElement, MetaSchedulerConstants.RESERVATION);
    }

    public String getHosts()
            throws RSLParseException { 
        return (String) getAttribute(new QName(MetaSchedulerConstants.METASCHEDULER_RSL_NS,
                                               MetaSchedulerConstants.RSV_HOSTS));
    }

    public String getRsrc()
            throws  RSLParseException {
        return (String) getAttribute(new QName(MetaSchedulerConstants.METASCHEDULER_RSL_NS,
                                               MetaSchedulerConstants.RSV_RSRC));
    }

    public String getUser()
            throws  RSLParseException {
        return (String) getAttribute(new QName(MetaSchedulerConstants.METASCHEDULER_RSL_NS,
                                               MetaSchedulerConstants.RSV_USER));
    }

    public Calendar getBeginTime()
            throws  RSLParseException {
        return (Calendar) getAttribute(new QName(MetaSchedulerConstants.METASCHEDULER_RSL_NS,
                                               MetaSchedulerConstants.RSV_BEGINTIME));
    }

    public Calendar getEndTime()
            throws  RSLParseException {
        return (Calendar) getAttribute(new QName(MetaSchedulerConstants.METASCHEDULER_RSL_NS,
                                               MetaSchedulerConstants.RSV_ENDTIME));
    }

    public long getNumber()
            throws  RSLParseException {
        return ((Long) getAttribute(new QName(MetaSchedulerConstants.METASCHEDULER_RSL_NS,
                                              MetaSchedulerConstants.RSV_NUMBER))).longValue();
    }

    public String toString() {
        String rsv = null;
        try {
            rsv = "<hosts: " + this.getHosts() + "> <rsrc: " + this.getRsrc() + "> <number: "
                + this.getNumber()
                + "><user: " + this.getUser() + "> <beginTime: " + this.getBeginTime()
                + "><endTime: " + this.getEndTime() + ">";
        } catch ( RSLParseException e) {
            logger.debug("Cannot get reservation information");
        }

        return (rsv);
    }
}
