/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */

/*
 * put_get_user.c
 *
 * nexus_direct_put_*() and nexus_direct_get_*() code
 */

static char *rcsid = "$Header: /home/globdev/CVS/globus-packages/nexus/source/nexus/put_get_user.c,v 1.3 2005/04/18 21:43:21 smartin Exp $";

#include "internal.h"


/*********************************************************************
 * nexus_user_put_DATATYPE()
 *********************************************************************/

#undef nexus_user_put_float
void nexus_user_put_float(nexus_byte_t **user_buffer,
			  float *data,
			  unsigned long count)
{
    nexus_macro_user_put_float(user_buffer, data, count);
}

#undef nexus_user_put_double
void nexus_user_put_double(nexus_byte_t **user_buffer,
			   double *data,
			   unsigned long count)
{
    nexus_macro_user_put_double(user_buffer, data, count);
}

#undef nexus_user_put_short
void nexus_user_put_short(nexus_byte_t **user_buffer,
			  short *data,
			  unsigned long count)
{
    nexus_macro_user_put_short(user_buffer, data, count);
}

#undef nexus_user_put_u_short
void nexus_user_put_u_short(nexus_byte_t **user_buffer,
			    unsigned short *data,
			    unsigned long count)
{
    nexus_macro_user_put_u_short(user_buffer, data, count);
}

#undef nexus_user_put_int
void nexus_user_put_int(nexus_byte_t **user_buffer,
			int *data,
			unsigned long count)
{
    nexus_macro_user_put_int(user_buffer, data, count);
}

#undef nexus_user_put_u_int
void nexus_user_put_u_int(nexus_byte_t **user_buffer,
			  unsigned int *data,
			  unsigned long count)
{
    nexus_macro_user_put_u_int(user_buffer, data, count);
}

#undef nexus_user_put_long
void nexus_user_put_long(nexus_byte_t **user_buffer,
			 long *data,
			 unsigned long count)
{
    nexus_macro_user_put_long(user_buffer, data, count);
}

#undef nexus_user_put_u_long
void nexus_user_put_u_long(nexus_byte_t **user_buffer,
			   unsigned long *data,
			   unsigned long count)
{
    nexus_macro_user_put_u_long(user_buffer, data, count);
}

#undef nexus_user_put_char
void nexus_user_put_char(nexus_byte_t **user_buffer,
			 char *data,
			 unsigned long count)
{
    nexus_macro_user_put_char(user_buffer, data, count);
}

#undef nexus_user_put_u_char
void nexus_user_put_u_char(nexus_byte_t **user_buffer,
			   unsigned char *data,
			   unsigned long count)
{
    nexus_macro_user_put_u_char(user_buffer, data, count);
}

#undef nexus_user_put_byte
void nexus_user_put_byte(nexus_byte_t **user_buffer,
			 nexus_byte_t *data,
			 unsigned long count)
{
    nexus_macro_user_put_byte(user_buffer, data, count);
}



/*********************************************************************
 * nexus_user_get_DATATYPE()
 *********************************************************************/

#undef nexus_user_get_float
void nexus_user_get_float(nexus_byte_t **user_buffer,
			  float *data,
			  unsigned long count,
			  int format)
{
    nexus_macro_user_get_float(user_buffer, data, count, format);
}

#undef nexus_user_get_double
void nexus_user_get_double(nexus_byte_t **user_buffer,
			   double *data,
			   unsigned long count,
			   int format)
{
    nexus_macro_user_get_double(user_buffer, data, count, format);
}

#undef nexus_user_get_short
void nexus_user_get_short(nexus_byte_t **user_buffer,
			  short *data,
			  unsigned long count,
			  int format)
{
    nexus_macro_user_get_short(user_buffer, data, count, format);
}

#undef nexus_user_get_u_short
void nexus_user_get_u_short(nexus_byte_t **user_buffer,
			    unsigned short *data,
			    unsigned long count,
			    int format)
{
    nexus_macro_user_get_u_short(user_buffer, data, count, format);
}

#undef nexus_user_get_int
void nexus_user_get_int(nexus_byte_t **user_buffer,
			int *data,
			unsigned long count,
			int format)
{
    nexus_macro_user_get_int(user_buffer, data, count, format);
}

#undef nexus_user_get_u_int
void nexus_user_get_u_int(nexus_byte_t **user_buffer,
			  unsigned int *data,
			  unsigned long count,
			  int format)
{
    nexus_macro_user_get_u_int(user_buffer, data, count, format);
}

#undef nexus_user_get_long
void nexus_user_get_long(nexus_byte_t **user_buffer,
			 long *data,
			 unsigned long count,
			 int format)
{
    nexus_macro_user_get_long(user_buffer, data, count, format);
}

#undef nexus_user_get_u_long
void nexus_user_get_u_long(nexus_byte_t **user_buffer,
			   unsigned long *data,
			   unsigned long count,
			   int format)
{
    nexus_macro_user_get_u_long(user_buffer, data, count, format);
}

#undef nexus_user_get_char
void nexus_user_get_char(nexus_byte_t **user_buffer,
			 char *data,
			 unsigned long count,
			 int format)
{
    nexus_macro_user_get_char(user_buffer, data, count, format);
}

#undef nexus_user_get_u_char
void nexus_user_get_u_char(nexus_byte_t **user_buffer,
			   unsigned char *data,
			   unsigned long count,
			   int format)
{
    nexus_macro_user_get_u_char(user_buffer, data, count, format);
}

#undef nexus_user_get_byte
void nexus_user_get_byte(nexus_byte_t **user_buffer,
			 nexus_byte_t *data,
			 unsigned long count,
			 int format)
{
    nexus_macro_user_get_byte(user_buffer, data, count, format);
}



