/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */

#ifndef _globus_rls_server_auth_h_
#define _globus_rls_server_auth_h_

#include <sys/types.h>
#include <regex.h>

#define P_LRCREAD	0x01
#define P_LRCUPDATE	0x02
#define P_RLIREAD	0x04
#define P_RLIUPDATE	0x08
#define P_ADMIN		0x10
#define P_STATS		0x20

typedef struct acl_ {
  char		*dn;
  regex_t	re;
  int		perms;
  struct acl_	*nxt;
} ACL;

extern int	auth_getperms(ACL *acllist, char *dn);
extern ACL	*auth_freeacl(ACL *acllist);
extern ACL	*auth_newacl(ACL *acllist, char *val);
extern char	*auth_perms2s(int p);

#endif
