/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */

typedef enum { readlock, writelock }	LOCKTYPE;

typedef struct {
  globus_mutex_t	mtx;
  globus_cond_t		cond;
  int			readers;
  int			writer;
} LOCK;

extern int	lock_init(LOCK *lock);
extern void	lock_destroy(LOCK *lock);
extern void	lock_get(LOCK *lock, LOCKTYPE type);
extern void	lock_release(LOCK *lock, LOCKTYPE type);
