/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.cas.impl.databaseAccess;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * Sets the database configuration options
 */
public class CasDBOptions {
    
    static Log logger = LogFactory.getLog(CasDBOptions.class.getName());
    
    String driver;
    String connectionURL;
    String userName;
    String password;
    // Pool object defualt options 
    // no of connections, when pool is exhausted 1==block till max wait, 
    // max wait is in milliseconds
    int activeConnections = 32;
    byte onExhaustAction = 1;
    long maxWait = 100;
    int idleConnections = 2;

    public CasDBOptions() {
    }

    public CasDBOptions(String driver, String connectionURL,
                        String userName, String password) {
        logger.debug("constructor called with " + driver + " " + connectionURL 
                     + " " + userName + " " + password);
        this.driver = driver;
        this.connectionURL = connectionURL;
        this.userName = userName;
        this.password = password;
    }

    public void setDriver(String driver) {
        this.driver = driver;
    }

    public String getDriver() {

        return this.driver;
    }

    public String getConnectionURL() {

        return this.connectionURL;
    }

    public void setConnectionURL(String connectionURL) {
        this.connectionURL = connectionURL;
    }

    public String getUserName() {

        return this.userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    public String getPassword() {

        return this.password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public int getActiveConnections() {
        return this.activeConnections;
    }

    public void setActiveConnections(int conn) {
        this.activeConnections = conn;
    }

    public byte getOnExhaustAction() {
        return this.onExhaustAction;
    }

    public void setOnExhaustAction(byte action) {
        this.onExhaustAction = action;
    }

    public long getMaxWait() {
        return this.maxWait;
    }

    public void setMaxWait(long maxWait_) {
        this.maxWait = maxWait_;
    }

    public int getIdleConnections() {
        return this.idleConnections;
    }

    public void setIdleConnections(int conn) {
        this.idleConnections = conn;
    }
}
