/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.cas.impl.service;

import org.globus.wsrf.Resource;

import org.globus.wsrf.impl.SingletonResourceHome;

public class CasResourceHome extends SingletonResourceHome {

    protected Class resourceClass;

    int maxAssertionLifetime = -1;
    String voDescription = null;
    
    protected Resource findSingleton() {
        return new CasResource(this.maxAssertionLifetime, voDescription);
    }

    public void setResourceClass(String clazz)
        throws ClassNotFoundException {
        this.resourceClass = Class.forName(clazz);
    }

    public String getResourceClass() {
        return this.resourceClass.getName();
    }

    public void setMaxAssertionLifetime(int lifetime) {
        this.maxAssertionLifetime = lifetime;
    }

    public int getMaxAssertionLifetime() {
        return this.maxAssertionLifetime;
    }

    public void setVoDescription(String description) {
        this.voDescription = description;
    }

    public String getVoDescription() {
        return this.voDescription;
    }

}
