/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.cas.impl.databaseAccess;

import junit.framework.Test;
import junit.framework.TestSuite;
import junit.framework.TestResult;

import java.io.FileInputStream;

import java.util.Properties;

/**
 * Tests for databseAccess package
 */
public class PackageTests extends TestSuite {

    public PackageTests(String name) {
        super(name);
    }

    public void run(TestResult result) {
       try {
           String propFileName = System.getProperty("casTestProperties");
           Properties prop = new Properties();
           prop.load(new FileInputStream(propFileName));
           CasDBOptions casDbOption = 
               new CasDBOptions(prop.getProperty("dbDriver"), 
                                prop.getProperty("dbConnectionURL"),
                                prop.getProperty("dbUsername"), 
                                prop.getProperty("dbPassword"));
           CasDBStorage.setupDBConnection(casDbOption);
           super.run(result);
       } catch (Exception e) {
           e.printStackTrace();
           result.addError(this, e);
       }
    }

    public static Test suite() throws Exception {
        TestSuite suite = new PackageTests("CAS Database Access Tests");
        suite.addTestSuite(TestTrustAnchorData.class);
        suite.addTestSuite(TestUserData.class);
        suite.addTestSuite(TestNamespaceData.class);
        suite.addTestSuite(TestObjectComparison.class);
        suite.addTestSuite(TestObjectData.class);
        suite.addTestSuite(TestServiceTypeData.class);
        suite.addTestSuite(TestServiceTypeAction.class);
        suite.addTestSuite(TestPolicyData.class);
        return suite;
    }
}
