/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.cas.impl.databaseAccess;

import org.globus.cas.types.ServiceTypeData;

import org.globus.cas.impl.databaseAccess.ServiceTypeDataHandler;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class TestServiceTypeData extends TestCase {

    static Log logger =
              LogFactory.getLog(TestServiceTypeData.class.getName());

    public TestServiceTypeData(String name){
        super(name);
    }

    public static Test suite() {
        return new TestSuite(TestServiceTypeData.class);
    }

    public void testServiceTypeData() throws Exception {

        String serviceTypeName = "serviceTypeName"; 
        ServiceTypeData serviceTypeData = new ServiceTypeData();
        serviceTypeData.setName(serviceTypeName);
        String serviceId = ServiceTypeDataHandler.storeObject(serviceTypeData);
        assertTrue(serviceId!=null);
        logger.debug("Store  sercice type data went through");

        String[] list = ServiceTypeDataHandler.list();
        assertTrue(list.length==1);
        logger.debug("List objects went through " + list.length);
        
        ServiceTypeData retrievedData = (ServiceTypeData)ServiceTypeDataHandler.retrieveObject(serviceTypeName);
        assertTrue(retrievedData!=null);
        logger.debug("the retrieved service type " + retrievedData.toString());

        ServiceTypeDataHandler.deleteObject(serviceTypeName);
        ServiceTypeData deletedData = (ServiceTypeData)ServiceTypeDataHandler.retrieveObject(serviceTypeName);
        assertTrue(deletedData==null);
        logger.debug("delete service type data went through ");

    }
}
