/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.delegation.service;

import org.globus.wsrf.ResourceKey;

import org.globus.wsrf.impl.ResourceHomeImpl;
import org.globus.wsrf.impl.SimpleResourceKey;

import org.apache.axis.message.addressing.EndpointReferenceType;

import org.apache.axis.components.uuid.UUIDGen;
import org.apache.axis.components.uuid.UUIDGenFactory;

public class TestHome extends ResourceHomeImpl {

    int counter = 0;
    
    private static UUIDGen uuidGen = UUIDGenFactory.getUUIDGen();

    public ResourceKey create(EndpointReferenceType epr) throws Exception {

        if (counter == 4) {
            counter = 0;
        }
        counter++;
        TestResource resource = new TestResource(uuidGen.nextUUID());
        ResourceKey key = 
            new SimpleResourceKey(keyTypeName, resource.getID());
        this.add(key, resource);        
        resource.initialize(epr, counter, key);
        System.out.println("Counter in home " + counter);
        return key;
    }
}
