/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.delegation.service;

import org.globus.delegation.DelegationListener;

import org.globus.gsi.GlobusCredential;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import org.globus.wsrf.Resource;
import org.globus.wsrf.ResourceKey;
import org.globus.wsrf.ResourceHome;
import org.globus.wsrf.ResourceException;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class TestListener implements DelegationListener {

    static Log logger = 
        LogFactory.getLog(TestListener.class.getName());    
    String listenerId;
    String home = null;
    ResourceKey key = null;

    TestListener(String home, ResourceKey key) {
        this.home = home;
        this.key = key;
    }

    public void setId(String id) {
        this.listenerId = id;
    }

    public String getId() {
        return this.listenerId;
    }

    public void setCredential(GlobusCredential _credential) {
        System.out.println("Refresh callback");
        try {
            Context initialContext = new InitialContext();
            ResourceHome resHome = (ResourceHome)initialContext.lookup(home);
            logger.debug("Key " + key);
            Resource resource = resHome.find(key);
            if (resource == null) {
                throw new RuntimeException("Resource is null");
            }
            ((TestResource)resource).setCredential(_credential);
        } catch (ResourceException exp) {
            logger.error(exp);
            throw new RuntimeException("Error retrieving resource" 
                                       + exp.getMessage());
        } catch (NamingException exp) {
            logger.error(exp);
            throw new RuntimeException("Error retrieving resource" 
                                       + exp.getMessage());
        }
    }

    public void credentialDeleted() {
        System.out.println("Credential delegated notification");
    }
}
