/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.exec.service.test;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import junit.framework.TestResult;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import org.globus.wsrf.test.GSITestContainer;
import org.globus.wsrf.test.GridTestCase;
import org.globus.wsrf.test.GridTestSuite;
import org.globus.wsrf.test.TestContainer;

public class PackageTests extends TestSuite
{
    private static Log logger = LogFactory.getLog(PackageTests.class.getName());

    protected TestContainer testContainer;

    public PackageTests(String name) {
        super(name);
    }

    public void run(TestResult result)
    {
        this.testContainer = new GSITestContainer();
        if (logger.isDebugEnabled())
        {
            logger.debug("creating a new GSITestContainer");
        }

        try
        {
            this.testContainer.start();
            GridTestCase.setTestServer(this.testContainer);
            if (logger.isDebugEnabled())
            {
                logger.debug("assigning the new GSITestContainer to GridTestCase");
            }
            super.run(result);
        }
        catch (Exception e)
        {
            e.printStackTrace();
            result.addError(this, e);
        }
        finally
        {
            try
            {
                this.testContainer.stop();
            }
            catch(Exception e)
            {
                e.printStackTrace();
            }
        }
    }

    public static Test suite() throws Exception
    {
        TestSuite suite = new PackageTests("GRAM Stubs Testing");
        suite.addTest(new TestSuite(RSLTest.class));
        suite.addTest(new TestSuite(ManagedJobFactoryTest.class));
        suite.addTest(new TestSuite(ManagedJobTest.class));
        suite.addTest(new TestSuite(HoldReleaseTest.class));
        suite.addTest(new TestSuite(FileMappingTest.class));

        return suite;
    }
}
