/*
* Portions of this file Copyright 1999-2005 University of Chicago
* Portions of this file Copyright 1999-2005 The University of Southern California.
*
* This file or a portion of this file is licensed under the
* terms of the Globus Toolkit Public License, found at
* http://www.globus.org/toolkit/download/license.html.
* If you redistribute this file, with or without
* modifications, you must include this notice in the file.
*/

package org.globus.mds.aggregator.impl;

import org.globus.wsrf.Resource;
import org.globus.wsrf.ResourceException;
import org.globus.wsrf.impl.SingletonResourceHome;

/** This home provides a singleton home that creates a single 
    resource based on JNDI parameter, configured in the same way
    as ResourceHomeImpl:
    <br>
    resourceClass - configures the name of the resource class. For example:
    <pre>
    &lt;parameter&gt;
     &lt;name&gt;resourceClass&lt;/name&gt;
     &lt;value&gt;org.globus.wsrf.samples.counter.PersistentCounter&lt;/value&gt;
    &lt;/parameter&gt;
    </pre>

    <br>


    TODO is this another core-like home or option for the 
    core Singleton home? */


public class SingletonAggregatorHome extends SingletonResourceHome {

    protected Class resourceClass;

    public void setResourceClass(String clazz)
        throws ClassNotFoundException {
        this.resourceClass = Class.forName(clazz);
    }

    protected Resource findSingleton() throws ResourceException {

        try {
            return (Resource)this.resourceClass.newInstance();
        } catch (Exception e) {
            throw new ResourceException("When creating singleton", e);
        }
 


    }
}

