/*
* Portions of this file Copyright 1999-2005 University of Chicago
* Portions of this file Copyright 1999-2005 The University of Southern California.
*
* This file or a portion of this file is licensed under the
* terms of the Globus Toolkit Public License, found at
* http://www.globus.org/toolkit/download/license.html.
* If you redistribute this file, with or without
* modifications, you must include this notice in the file.
*/
package org.globus.wsrf.impl.servicegroup;

import javax.xml.namespace.QName;
import org.globus.wsrf.TopicListener;

import org.globus.wsrf.impl.SimpleTopic;
import org.globus.wsrf.impl.SimpleSubscriptionTopicListener;

/**
 *
 */
public class EntryTopic extends SimpleTopic 
{
    protected int subscriptions = 0;
    
    /** Creates a new instance of EntryTopic */
    public EntryTopic(QName name) {
        super(name);        
    }

    public boolean hasActiveSubscriptions() {
        return (subscriptions > 0);
    }
    
    public synchronized void addTopicListener(TopicListener listener)
    {
        this.listeners.add(listener);
        if (listener instanceof SimpleSubscriptionTopicListener) {
            subscriptions++;
        }        
    }
    
    public synchronized void removeTopicListener(TopicListener listener)
    {
        this.listeners.remove(listener);
        if (listener instanceof SimpleSubscriptionTopicListener) {
            subscriptions--;
        }         
    }
    
}
