/*
* Portions of this file Copyright 1999-2005 University of Chicago
* Portions of this file Copyright 1999-2005 The University of Southern California.
*
* This file or a portion of this file is licensed under the
* terms of the Globus Toolkit Public License, found at
* http://www.globus.org/toolkit/download/license.html.
* If you redistribute this file, with or without
* modifications, you must include this notice in the file.
*/
package org.globus.wsrf.impl.servicegroup; 

import org.apache.axis.message.addressing.EndpointReferenceType;

import org.apache.axis.utils.XMLUtils;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;





import java.io.InputStream;
import java.io.FileInputStream;
import java.rmi.RemoteException;

import org.globus.wsrf.ResourceContext;
import org.globus.wsrf.encoding.ObjectDeserializer;

import org.oasis.wsrf.servicegroup.Add;
import org.oasis.wsrf.servicegroup.AddRefusedFaultType;
import org.oasis.wsrf.servicegroup.ContentCreationFailedFaultType;
import org.oasis.wsrf.servicegroup.ServiceGroupRegistration;
import org.oasis.wsrf.servicegroup.UnsupportedMemberInterfaceFaultType;

import org.w3c.dom.Document;

/** This OperationProvider provides servicegroupregistration functionality.
*/

public class ServiceGroupRegistrationProvider {

/** Add operation. 
    <br>
    TODO: Perform validation on registrant:
    <ul>
        <li>check member satisfies MembershipContentRules semantics.</li>

        <li>Check that content satisfies membershipcontentrules.</li>
    </ul>

*/

    private static Log logger =
            LogFactory.getLog(ServiceGroupRegistrationProvider.class.getName());


    public EndpointReferenceType add(Add addRequest) 
        throws RemoteException, ContentCreationFailedFaultType, 
        AddRefusedFaultType, UnsupportedMemberInterfaceFaultType {

        logger.debug("ServiceGroupRegistrationProvider add called");

        // get the servicegroupregistration resource

        ServiceGroupRegistrationResource resource = null;
        try {
            resource = (ServiceGroupRegistrationResource)ResourceContext.getResourceContext().getResource();
        } catch (RemoteException e) {
            throw e;
        } catch (Exception e) {
            throw new RemoteException("", e);
        }
        
        // TODO: should we perform validity checking here against 
        // membership content rule?  We may need to this further downstream in 
        // the ServiceGroupRegistrationResource.

        return resource.serviceGroupAdd(addRequest);

    }

}

