/*
* Portions of this file Copyright 1999-2005 University of Chicago
* Portions of this file Copyright 1999-2005 The University of Southern California.
*
* This file or a portion of this file is licensed under the
* terms of the Globus Toolkit Public License, found at
* http://www.globus.org/toolkit/download/license.html.
* If you redistribute this file, with or without
* modifications, you must include this notice in the file.
*/
package org.globus.wsrf.impl.servicegroup;

import java.util.Iterator;
import org.globus.wsrf.Resource;

/** A resource which will act as a service group should implement this
    interface.
*/

public interface ServiceGroupResource extends Resource
{
    /** Provide an iterator that will return ResourceKeys that are valid
        in the context of the entry home */
    public Iterator iterateEntryKeys();
    
    /** Provide an iterator to a java.util.Set for getting the runtime entry 
        Resource instances directly. The element returned by the iterator is
        of the type Map.Entry */
    public Iterator iterateEntryValues();

}

