/*
* Portions of this file Copyright 1999-2005 University of Chicago
* Portions of this file Copyright 1999-2005 The University of Southern California.
*
* This file or a portion of this file is licensed under the
* terms of the Globus Toolkit Public License, found at
* http://www.globus.org/toolkit/download/license.html.
* If you redistribute this file, with or without
* modifications, you must include this notice in the file.
*/
package org.globus.wsrf.impl.servicegroup.inmemory;

import java.rmi.RemoteException;
import java.util.LinkedList;
import java.util.List;


import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import javax.xml.namespace.QName;

import org.apache.axis.message.addressing.Address;
import org.apache.axis.message.addressing.EndpointReferenceType;
import org.apache.axis.message.addressing.ReferencePropertiesType;
import org.apache.axis.MessageContext;
import org.apache.axis.utils.XMLUtils;




import org.globus.wsrf.ResourceProperty;
import org.globus.wsrf.Topic;
import org.globus.wsrf.TopicList;
import org.globus.wsrf.TopicListAccessor;
import org.globus.wsrf.Constants;

import org.globus.wsrf.impl.ReflectionResourceProperty;
import org.globus.wsrf.impl.SimpleResourcePropertySet;
import org.globus.wsrf.impl.lifetime.DestroyProvider;
import org.globus.wsrf.impl.lifetime.SetTerminationTimeProvider;
import org.globus.wsrf.impl.notification.GetCurrentMessageProvider;
import org.globus.wsrf.impl.notification.SubscribeProvider;
import org.globus.wsrf.impl.properties.GetMultipleResourcePropertiesProvider;
import org.globus.wsrf.impl.properties.GetResourcePropertyProvider;
import org.globus.wsrf.impl.properties.QueryResourcePropertiesProvider;
import org.globus.wsrf.impl.properties.SetResourcePropertiesProvider;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import org.oasis.wsrf.lifetime.ResourceNotDestroyedFaultType;
import org.oasis.wsrf.lifetime.TerminationTimeChangeRejectedFaultType;
import org.oasis.wsrf.lifetime.UnableToSetTerminationTimeFaultType;

import org.oasis.wsn.InvalidTopicExpressionFaultType;
import org.oasis.wsn.NoCurrentMessageOnTopicFaultType;
import org.oasis.wsn.ResourceUnknownFaultType;
import org.oasis.wsn.SubscribeCreationFailedFaultType;
import org.oasis.wsn.TopicNotSupportedFaultType;
import org.oasis.wsn.TopicPathDialectUnknownFaultType;
import org.oasis.wsrf.properties.InvalidQueryExpressionFaultType;
import org.oasis.wsrf.properties.InvalidResourcePropertyQNameFaultType;
import org.oasis.wsrf.properties.InvalidSetResourcePropertiesRequestContentFaultType;
import org.oasis.wsrf.properties.QueryEvaluationErrorFaultType;
import org.oasis.wsrf.properties.SetResourcePropertyRequestFailedFaultType;
import org.oasis.wsrf.properties.UnableToModifyResourcePropertyFaultType;
import org.oasis.wsrf.properties.UnknownQueryExpressionDialectFaultType;
import org.oasis.wsrf.properties.GetResourcePropertyResponse;

import org.globus.wsrf.ResourceHome;
import org.globus.wsrf.ResourceContext;
import org.globus.wsrf.ResourceProperties;
import org.globus.wsrf.ResourcePropertySet;

import org.oasis.wsrf.servicegroup.ServiceGroup;

import org.globus.wsrf.impl.servicegroup.ServiceGroupRegistrationProvider;


import org.oasis.wsrf.servicegroup.Add;
import org.oasis.wsrf.servicegroup.AddRefusedFaultType;
import org.oasis.wsrf.servicegroup.ContentCreationFailedFaultType;
import org.oasis.wsrf.servicegroup.ServiceGroupRegistration;
import org.oasis.wsrf.servicegroup.UnsupportedMemberInterfaceFaultType;


/**
 *  Service group implementation. <br>
 *  
 *  The ServiceSroup API has no exposed operations; just 
 *  read-only ResourceProperties; this service at the moment doesn't
 *  therefore do much. TODO However it may be desirable to
 *  make the standard implementation expose additional WSRF stuff
 *  such as lifetime management? Very likely, for example, that this 
 *  should expose the ServiceGroup add/remove topics. <br>
 *
 */

public class InMemoryServiceGroupService implements ServiceGroup
{

    /** TODO: hmm, can't get op providers to work properly so do it this way
        for now. */
    ServiceGroupRegistrationProvider sgrp = new ServiceGroupRegistrationProvider();
 

    private GetResourcePropertyProvider getResourcePropertyProvider =
        new GetResourcePropertyProvider();


    // WS-ServiceGroup
   

    public EndpointReferenceType add(Add addRequest)
        throws RemoteException, ContentCreationFailedFaultType,
        AddRefusedFaultType, UnsupportedMemberInterfaceFaultType { 
        
        return sgrp.add(addRequest);
    }

    // WS-Properties 

    public GetResourcePropertyResponse getResourceProperty(QName name) 
        throws RemoteException, 
               InvalidResourcePropertyQNameFaultType, 
               org.oasis.wsrf.properties.ResourceUnknownFaultType {
        return getResourcePropertyProvider.getResourceProperty(name);
    }

}

