<?xml version="1.0"?>
<!-- 
  Portions of this file Copyright 1999-2005 University of Chicago
  Portions of this file Copyright 1999-2005 The University of Southern California.
  
  This file or a portion of this file is licensed under the
  terms of the Globus Toolkit Public License, found at
  http://www.globus.org/toolkit/download/license.html.
  If you redistribute this file, with or without
  modifications, you must include this notice in the file.
-->
<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"

  xmlns:ag="http://mds.globus.org/aggregator/types"
  xmlns:wssg="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ServiceGroup-1.2-draft-01.xsd"
  xmlns:wsa="http://schemas.xmlsoap.org/ws/2004/03/addressing"
  xmlns:ns4="http://mds.globus.org/inmemoryservicegroup"
  xmlns:reg="http://www.globus.org/namespaces/2004/06/registry"
  xmlns:glue="http://mds.globus.org/glue/ce/1.1"
  xmlns:cc="http://mds.globus.org/2005/09/cluster-config"
  version="1.0">
<xsl:import href="local/style.xsl" />
<xsl:import href="local/footer.xsl" />
<xsl:import href="xslfooter.xsl" />
<xsl:import href="glue/tg_subclusterhosts.xsl" />
<xsl:import href="glue/hostbase.xsl" />
<xsl:import href="glue/clusterbase.xsl" />
<xsl:import href="glue/queuebase.xsl" />
<xsl:import href="glue/tgextensions.xsl" />
<xsl:param name="requestInfo" select="''"/>
<xsl:param name="baseURI" select="''"/>
<xsl:variable name="baseID" select="translate('$Id: tg_gluehosts.xsl,v 1.2.4.3 2006/03/29 00:30:56 pearlman Exp $', ':', '|')" />

<xsl:template match="/*">
<html>
<head>
<title>Queue, Cluster, Subcluster, and Host Overview with TeraGrid Extensions</title>
<style>
<xsl:call-template name="style" />
</style>
</head>
<body>
<h1>Queue Overview</h1>
<table>
<tr>
<xsl:call-template name="QueueBaseHeadings1"/>
</tr>
<tr>
<xsl:call-template name="QueueBaseHeadings2"/>
</tr>
<xsl:apply-templates select="//glue:ComputingElement" mode="rows" />
</table>
<h1>Cluster / Subcluster Overview</h1>
<table>
<tr>
<xsl:call-template name="ClusterBaseHeadings1"/>
<xsl:call-template name="TGClusterHeadings1"/>
</tr>
<tr>
<xsl:call-template name="ClusterBaseHeadings2"/>
<xsl:call-template name="TGClusterHeadings2"/>
</tr>
<xsl:apply-templates select="//glue:Cluster" mode="rows" />
</table>
<xsl:apply-templates select="//glue:SubCluster" mode="hosts"/>
<xsl:apply-templates select="//glue:ComputingElement[cc:TGHostExtType]" mode="TGQueueHack" />
</body>
</html>
</xsl:template>

<xsl:template match="//glue:Cluster"
              mode="rows"
	      priority="100">
<tr>
<xsl:apply-templates select="." mode="ClusterBase" />
<xsl:apply-templates select="." mode="TGClusterExtensions" />
</tr>
<tr>
<xsl:apply-templates select="./glue:SubCluster" mode="rows" />
</tr>
</xsl:template>

<xsl:template match="//glue:SubCluster"
              mode="rows"
	      priority="100">
<tr>
<xsl:apply-templates select="." mode="ClusterBase" />
<xsl:apply-templates select="." mode="TGClusterExtensions" />
</tr>
</xsl:template>

<!-- match a GLUE computing element -->
<xsl:template match="//glue:GLUECE/glue:ComputingElement" 
              mode="rows"
	      priority="100">
<tr>
<xsl:apply-templates select="." mode="QueueBase"/>
</tr>
</xsl:template>

<!-- match a GLUE host -->
<xsl:template match="//glue:Host" 
              mode="rows"
	      priority="100">
<tr>
<xsl:apply-templates select="." mode="HostBase"/>
<xsl:apply-templates select="." mode="TGHostExtensions"/>
</tr>
</xsl:template>
</xsl:stylesheet>

