/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.replica.replicator;

import java.util.List;

public interface ReplicationFactory {

    public Replication createReplication(
            ReplicationCredentials credentials,
            List items,
            ReplicationOptions options)
        throws CreateException;

    public ReplicationOptions createReplicationOptions(
            String indexUrl,
            String reliableTransferUrl,
            String registrationUrl,
            TransferOptions transferOptions)
        throws CreateException;

    public TransferOptions createTransferOptions(
            Integer transferConcurrency,
            Boolean binary,
            Integer blockSize,
            Integer tcpBufferSize,
            Integer parallelStreams,
            Boolean noTPT,
            Boolean dcau,
            String subjectName,
            String destinationSubjectName,
            String sourceSubjectName,
            String username)
        throws CreateException;

    public ReplicationItem createReplicationItem(
            String uri,
            Integer priority,
            String[] destinationUris)
        throws CreateException;

    public void destroy(Object key) throws NotFoundException;

    public Replication find(Object key) throws NotFoundException;
}
