/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.replica.replicator.impl;

import org.globus.replica.replicator.TransferOptions;

/**
 * INTERNAL USE ONLY.
 */
class TransferOptionsImpl implements TransferOptions {

    Integer transferConcurrency = null;
    Boolean binary = null;
    Integer blockSize = null;
    Integer tcpBufferSize = null;
    Integer parallelStreams = null;
    Boolean noTPT = null;
    Boolean dcau = null;
    String subjectName = null;
    String destinationSubjectName = null;
    String sourceSubjectName = null;
    String username = null;

    TransferOptionsImpl(
            Integer transferConcurrency,
            Boolean binary,
            Integer blockSize,
            Integer tcpBufferSize,
            Integer parallelStreams,
            Boolean noTPT,
            Boolean dcau,
            String subjectName,
            String destinationSubjectName,
            String sourceSubjectName,
            String username)
    {
        this.transferConcurrency = transferConcurrency;
        this.binary = binary;
        this.blockSize = blockSize;
        this.tcpBufferSize = tcpBufferSize;
        this.parallelStreams = parallelStreams;
        this.noTPT = noTPT;
        this.dcau = dcau;
        this.subjectName = subjectName;
        this.destinationSubjectName = destinationSubjectName;
        this.sourceSubjectName = sourceSubjectName;
        this.username = username;
    }

    TransferOptionsImpl(
            Integer transferConcurrency,
            Integer tcpBufferSize,
            Integer parallelStreams)
    {
        this.transferConcurrency = transferConcurrency;
        this.tcpBufferSize = tcpBufferSize;
        this.parallelStreams = parallelStreams;
    }

    TransferOptionsImpl()
    {
    }

    /*
     * 
    public int getTransferConcurrency() {
        if (this.transferConcurrency != null)
            return this.transferConcurrency.intValue();
        else
            return 0;
    }

    public boolean getBinary() {
        if (this.binary != null)
            return this.binary;
        else
            return false;
    }

    public int getBlockSize() {
        return this.blockSize;
    }

    public int getTcpBufferSize() {
        return this.tcpBufferSize;
    }

    public int getParallelStreams() {
        return this.parallelStreams;
    }

    public boolean getNoTPT() {
        return this.noTPT;
    }

    public boolean getDcau() {
        return this.dcau;
    }

    public String getDestinationSubjectName() {
        return this.destinationSubjectName;
    }

    public String getSourceSubjectName() {
        return this.sourceSubjectName;
    }

    public String getUsername() {
        return this.username;
    }
     *
     */
}

