/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.replica.replicator.service;

import javax.xml.namespace.QName;

import org.globus.wsrf.Constants;

/**
 * Constants for reuse
 */
public class ReplicatorConstants {

    /** Performance Log: Create Replicator Operation */
    public static final String PERFLOG_CREATEREPLICATOR = "perf:createreplicator_operation";

    /** Performance Log: Start Operation */
    public static final String PERFLOG_START = "perf:start_operation";

    /** Performance Log: Stop Operation */
    public static final String PERFLOG_STOP = "perf:stop_operation";

    /** Performance Log: Suspend Operation */
    public static final String PERFLOG_SUSPEND = "perf:suspend_operation";

    /** Performance Log: Resume Operation */
    public static final String PERFLOG_RESUME = "perf:resume_operation";


    /**
     *  <code>SERVICE_NAME</code>
     */
    public static final String SERVICE_NAME = "ReplicationService";

    /**
     * Jndi look up for container's work manager
     */
    public static final String WORKMANAGER = 
        "java:comp/env/wm/ContainerWorkManager";

    /**
     * Jndi look up for the service configuration
     */
    public static final String CONFIGURATION = 
        Constants.JNDI_SERVICES_BASE_NAME + SERVICE_NAME + "/Configuration";

    public static final String MESSAGE_RESOURCE_BUNDLE =
        "org.globus.replica.replicator.errors";

    public static final String REPLICATIONMANAGER =
        "java:comp/env/services/ReplicationService/ReplicationManager";
}
