/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.transfer.reliable.service;

/**
 * Configuration Class for RFT service populated from JNDI-config
 */
public class RFTConfiguration {
    private String maxActiveAllowed;
    private String backOff;
    
    /**
     * Default Constructor
     */
    public RFTConfiguration() {
        // Default constructor
    }
    
    /**
     * @param maxActiveAllowed
     * @param backOff
     */
    public RFTConfiguration(String maxActiveAllowed, String backOff) {
        this.maxActiveAllowed = maxActiveAllowed;
        this.backOff = backOff;
    }
    
    /**
     * @return Returns the backOff.
     */
    public String getBackOff() {
        return this.backOff;
    }
    /**
     * @param backOff The backOff to set.
     */
    public void setBackOff(String backOff) {
        this.backOff = backOff;
    }
    /**
     * @return Returns the maxActiveAllowed.
     */
    public String getMaxActiveAllowed() {
        return this.maxActiveAllowed;
    }
    /**
     * @param maxActiveAllowed The maxActiveAllowed to set.
     */
    public void setMaxActiveAllowed(String maxActiveAllowed) {
        this.maxActiveAllowed = maxActiveAllowed;
    }
}
