/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.transfer.reliable.service;

import org.globus.rft.generated.TransferStatusTypeEnumeration;


/**
 * RFTUtil
 */
public class RFTUtil {

    /**
     * Util method to map status from int to TransferStatusType
     * 
     * @param transferStatus
     * @return  <code> TransferStatusTypeEnumeration </code>
     */
    public synchronized static TransferStatusTypeEnumeration 
        mapStatus(int transferStatus) {
        if (transferStatus == 0) {
            return TransferStatusTypeEnumeration.Finished;
        }

        if (transferStatus == 1) {
            return TransferStatusTypeEnumeration.Retrying;
        }

        if (transferStatus == 2) {
            return TransferStatusTypeEnumeration.Failed;
        }

        if (transferStatus == 3) {
            return TransferStatusTypeEnumeration.Active;
        }

        if (transferStatus == 4) {
            return TransferStatusTypeEnumeration.Pending;
        }

        if (transferStatus == 5) {
            return TransferStatusTypeEnumeration.Cancelled;
        }

        if (transferStatus == 6) {
            return TransferStatusTypeEnumeration.Expanding;
        }

        if (transferStatus == 7) {
            return TransferStatusTypeEnumeration.Expanding_Done;
        }
        if (transferStatus == 8) {
            return TransferStatusTypeEnumeration.Dirty;
        }
        return null;
    }
    /**
     * Util method to map statuses
     * 
     * @param statusType
     * @return transferStatus
     */
    public static synchronized 
        int reverseMap(TransferStatusTypeEnumeration statusType) {
        int returnValue = -1;
        String status = statusType.getValue();
        if (status.equals("Finished")) {
            return RFTConstants.STATUS_FINISHED;
        }
        if (status.equals("Retrying")) {
            return RFTConstants.STATUS_RETRYING;
        }
        if (status.equals("Failed")) {
            return RFTConstants.STATUS_FAILED;
        }
        if (status.equals("Active")) {
            return RFTConstants.STATUS_ACTIVE;
        }
        if (status.equals("Pending")) {
            return RFTConstants.STATUS_PENDING;
        }
        if (status.equals("Cancelled")) {
            return RFTConstants.STATUS_CANCELLED;
        }
        if (status.equals("Expanding")) {
            return RFTConstants.STATUS_EXPANDING;
        }
        if (status.equals("Expanding_Done")) {
            return RFTConstants.STATUS_EXPANDING_DONE;
        }
        if (status.equals("Dirty")) {
            return RFTConstants.STATUS_DIRTY;
        }
        return returnValue;
    }


}
