/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.transfer.reliable.service.test;

import junit.framework.Test;
import junit.framework.TestResult;
import junit.framework.TestSuite;

/**
 * RFT Unit Tests
 */
public class PackageTests extends TestSuite {

    /**
     *  Constructor for the PackageTests object
     *
     *@param  name  Description of the Parameter
     */
    public PackageTests( String name ) {
        super( name );
    }


    /**
     *  Main processing method for the PackageTests object
     *
     *@param  result  Description of the Parameter
     */
    public void run( TestResult result ) {
        try {
            super.run( result );
        } catch ( Exception e ) {
            e.printStackTrace();
            result.addError( this, e );
        }
    }


    /**
     *  A unit test suite for JUnit
     *
     *@return                The test suite
     *@exception  Exception  Description of the Exception
     */
    public static Test suite() throws Exception {
        TestSuite suite = new PackageTests( "RFT Testing" );

        suite.addTest( new TestSuite( RFTTest.class ) );
        suite.addTest( new TestSuite( RFTOptionsTest.class ) );
        return suite;
    }
}

