/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */

#ifndef WSRP_I_FAULTS_H
#define WSRP_I_FAULTS_H 1

#if WSRP_GET_RESOURCE_PROPERTY
#   ifndef NEED_RESOURCE_UNKNOWN_FAULT
#       define NEED_RESOURCE_UNKNOWN_FAULT 1
#   endif /* NEED_RESOURCE_UNKNOWN_FAULT */
#   ifndef NEED_INVALID_RESOURCE_PROPERTY_QNAME_FAULT
#       define NEED_INVALID_RESOURCE_PROPERTY_QNAME_FAULT 1
#   endif /* NEED_INVALID_RESOURCE_PROPERTY_QNAME_FAULT */
#endif /* WSRP_GET_RESOURCE_PROPERTY */

#if WSRP_GET_MULTIPLE_RESOURCE_PROPERTIES
#   ifndef NEED_RESOURCE_UNKNOWN_FAULT
#       define NEED_RESOURCE_UNKNOWN_FAULT 1
#   endif /* NEED_RESOURCE_UNKNOWN_FAULT */
#   ifndef NEED_INVALID_RESOURCE_PROPERTY_QNAME_FAULT
#       define NEED_INVALID_RESOURCE_PROPERTY_QNAME_FAULT 1
#   endif /* NEED_INVALID_RESOURCE_PROPERTY_QNAME_FAULT */
#endif /* WSRP_GET_MULTIPLE_RESOURCE_PROPERTIES */

#if WSRP_SET_RESOURCE_PROPERTIES
#   ifndef NEED_RESOURCE_UNKNOWN_FAULT
#       define NEED_RESOURCE_UNKNOWN_FAULT 1
#   endif /* NEED_RESOURCE_UNKNOWN_FAULT */
#   ifndef NEED_INVALID_SET_RESOURCE_PROPERTIES_REQUEST_CONTENT_FAULT
#       define NEED_INVALID_SET_RESOURCE_PROPERTIES_REQUEST_CONTENT_FAULT 1
#   endif /* NEED_INVALID_SET_RESOURCE_PROPERTIES_REQUEST_CONTENT_FAULT */
#   ifndef NEED_UNABLE_TO_MODIFY_RESOURCE_PROPERTY_FAULT
#       define NEED_UNABLE_TO_MODIFY_RESOURCE_PROPERTY_FAULT 1
#   endif /* NEED_UNABLE_TO_MODIFY_RESOURCE_PROPERTY_FAULT */
#   ifndef NEED_INVALID_RESOURCE_PROPERTY_QNAME_FAULT
#       define NEED_INVALID_RESOURCE_PROPERTY_QNAME_FAULT 1
#   endif /* NEED_INVALID_RESOURCE_PROPERTY_QNAME_FAULT */
#   ifndef NEED_SET_RESOURCE_PROPERTY_REQUEST_FAILED_FAULT
#       define NEED_SET_RESOURCE_PROPERTY_REQUEST_FAILED_FAULT 1
#   endif /* NEED_SET_RESOURCE_PROPERTY_REQUEST_FAILED_FAULT */
#endif /* WSRP_SET_RESOURCE_PROPERTIES */

#if WSRP_QUERY_RESOURCE_PROPERTIES
#   ifndef NEED_RESOURCE_UNKNOWN_FAULT
#       define NEED_RESOURCE_UNKNOWN_FAULT 1
#   endif /* NEED_RESOURCE_UNKNOWN_FAULT */
#   ifndef NEED_UNKNOWN_QUERY_EXPRESSION_DIALECT_FAULT
#       define NEED_UNKNOWN_QUERY_EXPRESSION_DIALECT_FAULT 1
#   endif /* NEED_UNKNOWN_QUERY_EXPRESSION_DIALECT_FAULT */
#   ifndef NEED_INVALID_QUERY_EXPRESSION_FAULT
#       define NEED_INVALID_QUERY_EXPRESSION_FAULT 1
#   endif /* NEED_INVALID_QUERY_EXPRESSION_FAULT */
#   ifndef NEED_QUERY_EVALUATION_ERROR_FAULT
#       define NEED_QUERY_EVALUATION_ERROR_FAULT 1
#   endif /* NEED_QUERY_EVALUATION_ERROR_FAULT */
#endif /* WSRP_QUERY_RESOURCE_PROPERTIES */


#if NEED_RESOURCE_UNKNOWN_FAULT
#include "wsrp_ResourceUnknownFaultType.h"

#define RESOURCE_UNKNOWN(fault_name, fault) \
        wsrp_l_ResourceUnknownFaultType_create( \
                fault_name,\
                (wsrp_ResourceUnknownFaultType **) fault)

static
globus_result_t
wsrp_l_ResourceUnknownFaultType_create(
    char **                             fault_name,
    wsrp_ResourceUnknownFaultType **    fault)
{
    globus_result_t                     result;
    time_t                              timestamp = time(NULL);
    struct tm *                         tp;

    result = wsrp_ResourceUnknownFaultType_init(fault);

    if (result != GLOBUS_SUCCESS)
    {
        return result;
    }

    tp = globus_libc_gmtime_r(&timestamp, &(*fault)->Timestamp);
    globus_assert(tp != NULL);

    *fault_name = "ResourceUnknownFault";

    return result;
}
/* wsrp_l_ResourceUnknownFaultType_create() */
#endif /* NEED_RESOURCE_UNKNOWN_FAULT */

#if NEED_INVALID_RESOURCE_PROPERTY_QNAME_FAULT
#include "wsrp_InvalidResourcePropertyQNameFaultType.h"

#define INVALID_RESOURCE_PROPERTY_QNAME(fault_name, fault) \
        wsrp_l_InvalidResourcePropertyQNameFaultType_create( \
                fault_name,\
                (wsrp_InvalidResourcePropertyQNameFaultType **) fault)

static
globus_result_t
wsrp_l_InvalidResourcePropertyQNameFaultType_create(
    char **                             fault_name,
    wsrp_InvalidResourcePropertyQNameFaultType **
                                        fault)
{
    globus_result_t                     result;
    time_t                              timestamp = time(NULL);
    struct tm *                         tp;

    result = wsrp_InvalidResourcePropertyQNameFaultType_init(fault);

    if (result != GLOBUS_SUCCESS)
    {
        return result;
    }

    tp = globus_libc_gmtime_r(&timestamp, &(*fault)->Timestamp);
    globus_assert(tp != NULL);

    *fault_name = "InvalidResourcePropertyQNameFault";

    return result;
}
/* wsrp_l_InvalidResourcePropertyQNameFaultType_create() */
#endif /* NEED_INVALID_RESOURCE_PROPERTY_QNAME_FAULT */

#if NEED_INVALID_SET_RESOURCE_PROPERTIES_REQUEST_CONTENT_FAULT
#include "wsrp_InvalidSetResourcePropertiesRequestContentFaultType.h"

#define INVALID_SET_RESOURCE_PROPERTIES_REQUEST_CONTENT(fault_name, fault) \
        wsrp_l_InvalidSetResourcePropertiesRequestContentFaultType_create( \
                fault_name,\
                (wsrp_InvalidSetResourcePropertiesRequestContentFaultType **) fault)
static
globus_result_t
wsrp_l_InvalidSetResourcePropertiesRequestContentFaultType_create(
    char **                             fault_name,
    wsrp_InvalidSetResourcePropertiesRequestContentFaultType **
                                        fault)
{
    globus_result_t                     result;
    time_t                              timestamp = time(NULL);
    struct tm *                         tp;

    result = wsrp_InvalidSetResourcePropertiesRequestContentFaultType_init(
            fault);

    if (result != GLOBUS_SUCCESS)
    {
        return result;
    }

    tp = globus_libc_gmtime_r(&timestamp, &(*fault)->Timestamp);
    globus_assert(tp != NULL);

    *fault_name = "InvalidSetResourcePropertiesRequestContentFault";

    return result;
}
/* wsrp_l_InvalidResourcePropertyFaultType_create() */
#endif /* NEED_INVALID_SET_RESOURCE_PROPERTIES_REQUEST_CONTENT_FAULT */

#if NEED_UNABLE_TO_MODIFY_RESOURCE_PROPERTY_FAULT
#include "wsrp_UnableToModifyResourcePropertyFaultType.h"

#define UNABLE_TO_MODIFY_RESOURCE_PROPERTY(fault_name, fault) \
        wsrp_l_UnableToModifyResourcePropertyFaultType_create(\
                fault_name, \
                ()wsrp_UnableToModifyResourcePropertyFaultType **) fault)
static
globus_result_t
wsrp_l_UnableToModifyResourcePropertyFaultType_create(
    char **                             fault_name,
    wsrp_UnableToModifyResourcePropertyFaultType **
                                        fault)
{
    globus_result_t                     result;
    time_t                              timestamp = time(NULL);
    struct tm *                         tp;

    result = wsrp_UnableToModifyResourcePropertyFaultType_init(
            fault);

    if (result != GLOBUS_SUCCESS)
    {
        return result;
    }

    tp = globus_libc_gmtime_r(&timestamp, &(*fault)->Timestamp);
    globus_assert(tp != NULL);

    *fault_name = "UnableToModifyResourcePropertyFault";

    return result;
}
/* wsrp_l_InvalidResourcePropertyFaultType_create() */
#endif /* NEED_UNABLE_TO_MODIFY_RESOURCE_PROPERTY_FAULT */

#if NEED_SET_RESOURCE_PROPERTY_REQUEST_FAILED_FAULT
#include "wsrp_SetResourcePropertyRequestFailedFaultType.h"

#define SET_RESOURCE_PROPERTY_REQUEST_FAILED(fault_name, fault_type) \
    wsrp_l_SetResourcePropertyRequestFailedFaultType_create( \
        fault_name,\
        (wsrp_SetResourcePropertyRequestFailedFaultType **) fault)

static
globus_result_t
wsrp_l_SetResourcePropertyRequestFailedFaultType_create(
    char **                             fault_name,
    wsrp_SetResourcePropertyRequestFailedFaultType **
                                        fault)
{
    globus_result_t                     result;
    time_t                              timestamp = time(NULL);
    struct tm *                         tp;

    result = wsrp_SetResourcePropertyRequestFailedFaultType_init(
            fault);

    if (result != GLOBUS_SUCCESS)
    {
        return result;
    }

    tp = globus_libc_gmtime_r(&timestamp, &(*fault)->Timestamp);
    globus_assert(tp != NULL);

    *fault_name = "SetResourcePropertyRequestFailedFault";

    return result;
}
/* wsrp_l_SetResourcePropertyRequestFailedFaultType_create() */
#endif

#if NEED_UNKNOWN_QUERY_EXPRESSION_DIALECT_FAULT
#include "wsrp_UnknownQueryExpressionDialectFaultType.h"

#define UNKNOWN_QUERY_EXPRESSION_DIALECT(fault_name, fault) \
    wsrp_l_UnknownQueryExpressionDialectFaultType_create( \
        fault_name, \
        (wsrp_UnknownQueryExpressionDialectFaultType **) fault)

static
globus_result_t
wsrp_l_UnknownQueryExpressionDialectFaultType_create(
    char **                             fault_name,
    wsrp_UnknownQueryExpressionDialectFaultType **
                                        fault)
{
    globus_result_t                     result;
    time_t                              timestamp = time(NULL);
    struct tm *                         tp;

    result = wsrp_UnknownQueryExpressionDialectFaultType_init(
            fault);

    if (result != GLOBUS_SUCCESS)
    {
        return result;
    }

    tp = globus_libc_gmtime_r(&timestamp, &(*fault)->Timestamp);
    globus_assert(tp != NULL);

    *fault_name = "UnknownQueryExpressionDialectFault";

    return result;
}
/* wsrp_l_UnknownQueryExpressionDialectFaultType_create() */
#endif /* NEED_UNKNOWN_QUERY_EXPRESSION_DIALECT_FAULT */

#if NEED_INVALID_QUERY_EXPRESSION_FAULT
#include "wsrp_InvalidQueryExpressionFaultType.h"

#define INVALID_QUERY_EXPRESSION(fault_name, fault) \
    wsrp_l_InvalidQueryExpressionFaultType_create( \
            fault_name, \
            (wsrp_InvalidQueryExpressionFaultType **) fault)
static
globus_result_t
wsrp_l_InvalidQueryExpressionFaultType_create(
    char **                             fault_name,
    wsrp_InvalidQueryExpressionFaultType **
                                        fault)
{
    globus_result_t                     result;
    time_t                              timestamp = time(NULL);
    struct tm *                         tp;

    result = wsrp_InvalidQueryExpressionFaultType_init(
            fault);

    if (result != GLOBUS_SUCCESS)
    {
        return result;
    }

    tp = globus_libc_gmtime_r(&timestamp, &(*fault)->Timestamp);
    globus_assert(tp != NULL);

    *fault_name = "InvalidQueryExpressionFault";

    return result;
}
/* wsrp_l_InvalidQueryExpressionFaultType_create() */
#endif /* NEED_INVALID_QUERY_EXPRESSION_FAULT */

#if NEED_QUERY_EVALUATION_ERROR_FAULT
#include "wsrp_QueryEvaluationErrorFaultType.h"

#define QUERY_EVAULATION_ERROR(fault_name, fault) \
        wsrp_l_QueryEvaluationErrorFaultType_create( \
                fault_name, \
                (wsrp_QueryEvaluationErrorFaultType **) fault)
static
globus_result_t
wsrp_l_QueryEvaluationErrorFaultType_create(
    char **                             fault_name,
    wsrp_QueryEvaluationErrorFaultType **
                                        fault)
{
    globus_result_t                     result;
    time_t                              timestamp = time(NULL);
    struct tm *                         tp;

    result = wsrp_QueryEvaluationErrorFaultType_init(
            fault);

    if (result != GLOBUS_SUCCESS)
    {
        return result;
    }

    tp = globus_libc_gmtime_r(&timestamp, &(*fault)->Timestamp);
    globus_assert(tp != NULL);

    *fault_name = "QueryEvaluationErrorFault";

    return result;
}
/* wsrp_l_QueryEvaluationErrorFaultType_create() */
#endif /* NEED_QUERY_EVALUATION_ERROR_FAULT */

#endif /* WSRP_I_FAULTS_H */
