/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */

#include "ResourcePropertiesTestService_skeleton.h"
#include "ResourcePropertiesTestService_internal_skeleton.h"
#include "rptest_ResourcePropertyDefinitionType.h"

#include "globus_wsrf_resource.h"
#include "globus_soap_message_handle.h"
#include "globus_wsrf_core_tools.h"

#define ResourcePropertiesTestService_NS \
    "http://www.globus.org/namespaces/2004/10/ResourcePropertiesTest"

extern globus_service_descriptor_t ResourcePropertiesTestService_descriptor;

globus_result_t
ResourcePropertiesTestService_init(
    globus_service_descriptor_t *       service_desc)
{
    int                                 rc;
    GlobusFuncName(ResourcePropertiesTestService_init);

    rc = globus_module_activate(GLOBUS_WSRF_RESOURCE_MODULE);

    return (rc == GLOBUS_SUCCESS) ? GLOBUS_SUCCESS : GLOBUS_FAILURE;
}
/* ResourcePropertiesTestService_init() */

globus_result_t
ResourcePropertiesTestService_finalize(
    globus_service_descriptor_t *       service_desc)
{
    int                                 rc;
    GlobusFuncName(ResourcePropertiesService_finalize);

    rc = globus_module_deactivate(GLOBUS_WSRF_RESOURCE_MODULE);

    return (rc == GLOBUS_SUCCESS) ? GLOBUS_SUCCESS : GLOBUS_FAILURE;
}
/* ResourcePropertiesTestService_finalize() */

/* these functions are the service implementation and
 * must be implemented by the service implementer
 */

globus_result_t
ResourcePropertiesTestPortType_SetTerminationTime_init(
    globus_service_engine_t             engine,
    globus_soap_message_handle_t        message,
    wsrl_SetTerminationTimeType * SetTerminationTime)
{
    return GLOBUS_FAILURE;
}

globus_result_t
ResourcePropertiesTestPortType_SetTerminationTime_impl(
    globus_service_engine_t             engine,
    globus_soap_message_handle_t        message,
    globus_service_descriptor_t *       descriptor,
    wsrl_SetTerminationTimeType * SetTerminationTime,
    wsrl_SetTerminationTimeResponseType * SetTerminationTimeResponse,
    const char **                       fault_name,
    void ** fault)
{
    return GLOBUS_FAILURE;
}

globus_result_t
ResourcePropertiesTestPortType_Destroy_init(
    globus_service_engine_t             engine,
    globus_soap_message_handle_t        message,
    wsrl_DestroyType * Destroy)
{
    return GLOBUS_FAILURE;
}

globus_result_t
ResourcePropertiesTestPortType_Destroy_impl(
    globus_service_engine_t             engine,
    globus_soap_message_handle_t        message,
    globus_service_descriptor_t *       descriptor,
    wsrl_DestroyType * Destroy,
    wsrl_DestroyResponseType * DestroyResponse,
    const char **                       fault_name,
    void ** fault)
{
    return GLOBUS_FAILURE;
}

globus_result_t
ResourcePropertiesTestPortType_QueryResourceProperties_init(
    globus_service_engine_t             engine,
    globus_soap_message_handle_t        message,
    wsrp_QueryResourcePropertiesType * QueryResourceProperties)
{
    return GLOBUS_FAILURE;
}

globus_result_t
ResourcePropertiesTestPortType_QueryResourceProperties_impl(
    globus_service_engine_t             engine,
    globus_soap_message_handle_t        message,
    globus_service_descriptor_t *       descriptor,
    wsrp_QueryResourcePropertiesType * QueryResourceProperties,
    wsrp_QueryResourcePropertiesResponseType * QueryResourcePropertiesResponse,
    const char **                       fault_name,
    void ** fault)
{
    return GLOBUS_FAILURE;
}

globus_result_t
ResourcePropertiesTestPortType_SetResourceProperties_init(
    globus_service_engine_t             engine,
    globus_soap_message_handle_t        message,
    wsrp_SetResourcePropertiesType * SetResourceProperties)
{
    return GLOBUS_FAILURE;
}

globus_result_t
ResourcePropertiesTestPortType_SetResourceProperties_impl(
    globus_service_engine_t             engine,
    globus_soap_message_handle_t        message,
    globus_service_descriptor_t *       descriptor,
    wsrp_SetResourcePropertiesType * SetResourceProperties,
    wsrp_SetResourcePropertiesResponseType * SetResourcePropertiesResponse,
    const char **                       fault_name,
    void ** fault)
{
    return GLOBUS_FAILURE;
}

globus_result_t
ResourcePropertiesTestPortType_GetMultipleResourceProperties_init(
    globus_service_engine_t             engine,
    globus_soap_message_handle_t        message,
    wsrp_GetMultipleResourcePropertiesType * GetMultipleResourceProperties)
{
    return GLOBUS_FAILURE;
}

globus_result_t
ResourcePropertiesTestPortType_GetMultipleResourceProperties_impl(
    globus_service_engine_t             engine,
    globus_soap_message_handle_t        message,
    globus_service_descriptor_t *       descriptor,
    wsrp_GetMultipleResourcePropertiesType * GetMultipleResourceProperties,
    wsrp_GetMultipleResourcePropertiesResponseType * GetMultipleResourcePropertiesResponse,
    const char **                       fault_name,
    void ** fault)
{
    return GLOBUS_FAILURE;
}

globus_result_t
ResourcePropertiesTestPortType_GetResourceProperty_init(
    globus_service_engine_t             engine,
    globus_soap_message_handle_t        message,
    xsd_QName * GetResourceProperty)
{
    return GLOBUS_FAILURE;
}

globus_result_t
ResourcePropertiesTestPortType_GetResourceProperty_impl(
    globus_service_engine_t             engine,
    globus_soap_message_handle_t        message,
    globus_service_descriptor_t *       descriptor,
    xsd_QName * GetResourceProperty,
    wsrp_GetResourcePropertyResponseType * GetResourcePropertyResponse,
    const char **                       fault_name,
    void ** fault)
{
    return GLOBUS_FAILURE;
}

globus_result_t
ResourcePropertiesTestPortType_CreateResourcePropertiesTest_init(
    globus_service_engine_t             engine,
    globus_soap_message_handle_t        message,
    rptest_CreateResourcePropertiesTestType * CreateResourcePropertiesTest)
{
    return GLOBUS_SUCCESS;
}

globus_result_t
ResourcePropertiesTestPortType_CreateResourcePropertiesTest_impl(
    globus_service_engine_t             engine,
    globus_soap_message_handle_t        message,
    globus_service_descriptor_t *       descriptor,
    rptest_CreateResourcePropertiesTestType * CreateResourcePropertiesTest,
    rptest_CreateResourcePropertiesTestResponseType * CreateResourcePropertiesTestResponse,
    const char **                       fault_name,
    void ** fault)
{
    globus_result_t                     result;
    globus_uuid_t                       uuid;
    int                                 rc;
    int                                 i;
    xsd_QName *                         rp_qname;
    xsd_QName *                         type_qname;
    globus_xsd_type_registry_t          registry;
    globus_xsd_type_info_t              type_info;
    xsd_any *                           ref_prop;
    xsd_string *                        ref_prop_string;
    xsd_boolean *                       boolean_type;
    globus_resource_t                   resource;

    *fault_name = NULL;
    *fault = NULL;

    rc = globus_uuid_create(&uuid);

    if (rc != GLOBUS_SUCCESS)
    {
        result = GLOBUS_FAILURE;

        goto out;
    }
    result = globus_resource_create(uuid.text, &resource);
    if (result != GLOBUS_SUCCESS)
    {
        goto out;
    }
    globus_soap_message_handle_get_registry(message, &registry);
    if (registry == NULL)
    {
        registry = GLOBUS_GLOBAL_TYPE_REGISTRY;
    }

    for (i = 0; i < CreateResourcePropertiesTest->ResourcePropertyDefinition.length; i++)
    {
        rp_qname = &CreateResourcePropertiesTest->ResourcePropertyDefinition.elements[i].QName;
        type_qname = &CreateResourcePropertiesTest->ResourcePropertyDefinition.elements[i].TypeQName;
        boolean_type = CreateResourcePropertiesTest->ResourcePropertyDefinition.elements[i]._array;

        result = globus_xsd_type_registry_get(
            registry,
            type_qname,
            &type_info);
        if (result != GLOBUS_SUCCESS || type_info == NULL)
        {
            result = globus_xsd_type_registry_get(
                GLOBUS_GLOBAL_TYPE_REGISTRY,
                type_qname,
                &type_info);
        }
        if (result != GLOBUS_SUCCESS)
        {
            goto destroy_resource_out;
        }
        else if (type_info == NULL)
        {
            if (xsd_QName_keyeq(
                    globus_resource_properties_any_qname,
                    rp_qname))
            {
                type_info = &xsd_any_info;
            }
            else
            {
                result = GLOBUS_FAILURE;
            }
        }

        result = globus_resource_create_property(
            resource,
            rp_qname,
            (boolean_type && *boolean_type)
                ? type_info->array_info
                : type_info,
            NULL);

        if (result != GLOBUS_SUCCESS)
        {
            goto destroy_resource_out;
        }
    }

    xsd_string_init_cstr(&ref_prop_string,
            globus_libc_strdup(uuid.text));

    if (ref_prop_string == NULL)
    {
        result = GLOBUS_FAILURE;
        goto destroy_resource_out;
    }
    xsd_any_init(&ref_prop);
    if (ref_prop == NULL)
    {
        result = GLOBUS_FAILURE;
        goto destroy_ref_prop_string_out;
    }
    ref_prop->any_info = &xsd_string_info;
    xsd_QName_init(&ref_prop->element);
    if (ref_prop->element == NULL)
    {
        result = GLOBUS_FAILURE;
        goto destroy_ref_prop_out;
    }
    ref_prop->element->Namespace = globus_libc_strdup(
            ResourcePropertiesTestService_NS);
    if (ref_prop->element->Namespace == NULL)
    {
        result = GLOBUS_FAILURE;
        goto destroy_ref_prop_element;
    }
    ref_prop->element->local = globus_libc_strdup("ResourceID");
    if (ref_prop->element->local == NULL)
    {
        result = GLOBUS_FAILURE;
        goto destroy_ref_prop_element_ns;
    }
    ref_prop->value = ref_prop_string;

    result = globus_wsrf_core_create_endpoint_reference(
        engine,
        RESOURCEPROPERTIESTESTSERVICE_BASE_PATH,
        &ref_prop,
        &CreateResourcePropertiesTestResponse->EndpointReference);
    if (result != GLOBUS_SUCCESS)
    {
        goto destroy_ref_prop_element_local;
    }
    return result;

destroy_ref_prop_element_local:
    free(ref_prop->element->local);
destroy_ref_prop_element_ns:
    free(ref_prop->element->Namespace);
destroy_ref_prop_element:
    free(ref_prop->element);
destroy_ref_prop_out:
    free(ref_prop);
destroy_ref_prop_string_out:
    free(ref_prop_string);
destroy_resource_out:
    globus_resource_destroy(resource);
out:
    return result;
}
