/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


#include "globus_i_ws_security.h"
#include "globus_openssl.h"
#include "version.h"

GlobusDebugDefine(GLOBUS_WS_SECURITY);

static
int
globus_l_ws_security_activate();

static
int
globus_l_ws_security_deactivate();

globus_module_descriptor_t
globus_i_ws_security_module =
{
    "globus_ws_security_module",
    globus_l_ws_security_activate,
    globus_l_ws_security_deactivate,
    NULL,
    NULL,
    &local_version
};

static
int
globus_l_ws_security_activate()
{
    int                                 rc = 0;
    GlobusFuncName(globus_l_ws_security_activate);

    rc = globus_module_activate(GLOBUS_COMMON_MODULE);
    if(rc != GLOBUS_SUCCESS)
    {
        return rc;
    }

    GlobusDebugInit(GLOBUS_WS_SECURITY,
                    PKIPATH INFO DEBUG TRACE WARN);
    GlobusWSSecurityDebugEnter();

    rc = globus_module_activate(GLOBUS_OPENSSL_MODULE);

    return rc;
}

static
int
globus_l_ws_security_deactivate()
{
    int                                 rc = 0;
    GlobusFuncName(globus_l_ws_security_deactivate);
    GlobusWSSecurityDebugEnter();

    rc = globus_module_deactivate(GLOBUS_COMMON_MODULE);
    if(rc != GLOBUS_SUCCESS)
    {
        return rc;
    }

    return GLOBUS_SUCCESS;
}
