/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


#include "xsd_integer.h"
#include "globus_soap_message.h"

#include "globus_i_xsd.h"

GLOBUS_I_XSD_DEFINE_QNAME(xsd, integer);
GLOBUS_I_XSD_DEFINE_TYPE_INFO(xsd_integer);
GLOBUS_I_XSD_DEFINE_TYPE_FUNCTIONS(xsd_integer);
GLOBUS_I_XSD_DEFINE_ATTR_FUNCTIONS(xsd_integer, integer);

globus_result_t
xsd_integer_init_contents(
    xsd_integer *                       instance)
{
    GlobusFuncName(xsd_integer_init_contents);
    GlobusSoapMessageDebugEnter();
    
    *instance = NULL;

    GlobusSoapMessageDebugExit();
    return GLOBUS_SUCCESS;
}

void
xsd_integer_destroy_contents(
    xsd_integer *                       instance)
{
    GlobusFuncName(xsd_integer_destroy_contents);
    GlobusSoapMessageDebugEnter();

    if (*instance)
    {
        BN_free(*instance);
        *instance = NULL;
    }

    GlobusSoapMessageDebugExit();
}

globus_result_t
xsd_integer_copy_contents(
    xsd_integer *                       dest,
    const xsd_integer *                 src)
{
    globus_result_t                     result = GLOBUS_SUCCESS;
    GlobusFuncName(xsd_integer_copy_contents);
    GlobusSoapMessageDebugEnter();

    if(dest)
    {
        if(!src || !*src)
        {
            *dest = NULL;
        }
        else
        {
            *dest = BN_new();
            if(!*dest || !BN_copy(*dest, *src))
            {
                result = GlobusSoapMessageErrorOutOfMemory;
            }
        }
    }

    GlobusSoapMessageDebugExit();
    return result;
}

globus_result_t
xsd_integer_serialize_contents(
    xsd_QName *                         element,
    xsd_integer *                       instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options)
{
    globus_result_t                     result = GLOBUS_SUCCESS;
    GlobusFuncName(xsd_integer_serialize_contents);
    GlobusSoapMessageDebugEnter();

    /* serialize contents of type */
    result = globus_soap_message_serialize_integer(
        message_handle, instance);

    GlobusSoapMessageDebugExit();
    return result;
}

globus_result_t
xsd_integer_deserialize_contents(
    xsd_QName *                         eqn,
    xsd_integer *                       instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options)
{
    globus_result_t                     result = GLOBUS_SUCCESS;
    GlobusFuncName(xsd_integer_deserialize_contents);
    GlobusSoapMessageDebugEnter();
    
    result = globus_soap_message_deserialize_integer(
        message_handle, instance);

    GlobusSoapMessageDebugExit();
    return result;
}
