/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


#include "xsd_nonPositiveInteger.h"
#include "globus_soap_message.h"

#include "globus_i_xsd.h"

GLOBUS_I_XSD_DEFINE_QNAME(xsd, nonPositiveInteger);
GLOBUS_I_XSD_DEFINE_TYPE_INFO(xsd_nonPositiveInteger);
GLOBUS_I_XSD_DEFINE_TYPE_FUNCTIONS(xsd_nonPositiveInteger);
GLOBUS_I_XSD_DEFINE_ATTR_FUNCTIONS(xsd_nonPositiveInteger, integer);

globus_result_t
xsd_nonPositiveInteger_init_contents(
    xsd_nonPositiveInteger *            instance)
{
    GlobusFuncName(xsd_nonPositiveInteger_init_contents);
    GlobusSoapMessageDebugEnter();
    
    *instance = NULL;

    GlobusSoapMessageDebugExit();
    return GLOBUS_SUCCESS;
}

void
xsd_nonPositiveInteger_destroy_contents(
    xsd_nonPositiveInteger *            instance)
{
    GlobusFuncName(xsd_nonPositiveInteger_destroy_contents);
    GlobusSoapMessageDebugEnter();

    if (*instance)
    {
        BN_free(*instance);
        *instance = NULL;
    }

    GlobusSoapMessageDebugExit();
}

globus_result_t
xsd_nonPositiveInteger_copy_contents(
    xsd_nonPositiveInteger *            dest,
    const xsd_nonPositiveInteger *      src)
{
    globus_result_t                     result = GLOBUS_SUCCESS;
    GlobusFuncName(xsd_nonPositiveInteger_copy_contents);
    GlobusSoapMessageDebugEnter();

    if(dest)
    {
        if(!src || !*src)
        {
            *dest = NULL;
        }
        else
        {
            *dest = BN_new();
            if(!*dest || !BN_copy(*dest, *src))
            {
                result = GlobusSoapMessageErrorOutOfMemory;
            }
        }
    }

    GlobusSoapMessageDebugExit();
    return result;
}

globus_result_t
xsd_nonPositiveInteger_serialize_contents(
    xsd_QName *                         element,
    xsd_nonPositiveInteger *            instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options)
{
    globus_result_t                     result = GLOBUS_SUCCESS;
    GlobusFuncName(xsd_nonPositiveInteger_serialize_contents);
    GlobusSoapMessageDebugEnter();

    /* serialize contents of type */
    result = globus_soap_message_serialize_positiveInteger(
        message_handle, instance);

    GlobusSoapMessageDebugExit();
    return result;
}

globus_result_t
xsd_nonPositiveInteger_deserialize_contents(
    xsd_QName *                         eqn,
    xsd_nonPositiveInteger *            instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options)
{
    globus_result_t                     result = GLOBUS_SUCCESS;
    GlobusFuncName(xsd_nonPositiveInteger_deserialize_contents);
    GlobusSoapMessageDebugEnter();
    
    result = globus_soap_message_deserialize_positiveInteger(
        message_handle, instance);

    GlobusSoapMessageDebugExit();
    return result;
}
