/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */

/*
$Header: /home/globdev/CVS/globus-packages/mds/openldap/giis-ldapmodules/external.h,v 1.2 2005/04/18 22:00:16 neillm Exp $
$Log: external.h,v $
Revision 1.2  2005/04/18 22:00:16  neillm
- add copyright information to all applicable MDS2 files with the
  following exceptions (due to existing non-blobus copyright):

Hewlett Packard
./gris/source/grid_info_cpu_hpux_helper.c
./gris/source/grid_info_mem_hpux_helper.c
./gris/source/cpuinfo_tru64_helper.c
./gris/source/grid_info_daemon.c

OpenLDAP Foundation
./openldap/giis-ldapmodules/add.c
./openldap/giis-ldapmodules/delete.c
./openldap/giis-ldapmodules/modify.c
./openldap/giis-ldapmodules/bind.c
./openldap/giis-ldapmodules/acconfig.h
./openldap/giis-ldapmodules/modrdn.c
./openldap/giis-ldapmodules/abandon.c
./openldap/giis-ldapmodules/version.c
./openldap/giis-ldapmodules/slapd_giis.h
./openldap/giis-ldapmodules/fork.c
./openldap/ldapmodules/slapd_ldif.h
./openldap/ldapmodules/add.c
./openldap/ldapmodules/delete.c
./openldap/ldapmodules/modify.c
./openldap/ldapmodules/bind.c
./openldap/ldapmodules/modrdn.c
./openldap/ldapmodules/abandon.c
./openldap/ldapmodules/version.c
./openldap/ldapmodules/fork.c
./openldap/ldapmodules/external.h

Revision 1.1.1.1  2002/01/10 02:10:09  jslee
importing globus-beta-branch to the main trunk

Revision 1.1  2001/08/24 21:19:21  bletzing
New Package.

Revision 1.1.1.1  2001/07/21 02:18:06  june
Import giis backend

Revision 1.1.1.1  2001/07/21 01:53:49  june
Import giis backend

Revision 1.1.1.1  2001/07/06 21:11:15  mei
1) splitting out back-giis from the openldap 2.0.8-patched into a standalone
   directory that can generate 'dynamic modules' that can be used by the
   openldap's slapd (checked against 2.0.11 already)

Revision 1.2  2001/05/24 01:05:06  june
gridmap checking & timelimit debugging

Revision 1.1  2001/03/24 00:08:37  june
adding giis backend

Revision 1.1  2001/03/22 03:01:25  june
add giis backend

Revision 1.3  2000/09/13 02:11:50  june
resolve changes between 2.0 & 2.0.1

Revision 1.2  2000/09/12 22:41:39  june
Add giis backend
*/

#ifndef _GIIS_EXTERNAL_H
#define _GIIS_EXTERNAL_H

LDAP_BEGIN_DECL

extern int	giis_back_initialize LDAP_P(( BackendInfo *bi ));

extern int giis_back_bind LDAP_P(( BackendDB *bd,
        Connection *conn, Operation *op,
        const char *dn, const char *ndn, int method,
        struct berval *cred, char** edn ));

extern int	giis_back_search LDAP_P(( BackendDB *be,
	Connection *c, Operation *o,
	const char *base, const char *nbase,
	int scope, int deref, int slimit, int tlimit,
	Filter *f, const char *filterstr,
	char **attrs, int attrsonly));

extern int 	giis_back_db_config LDAP_P((BackendDB *bd,
	const char *fname, int lineno, int argc, char **argv ));

extern int	giis_back_modify LDAP_P(( BackendDB *bd,
	Connection *conn, Operation *op,
	const char *dn, const char *ndn,
	Modifications *ml ));

extern int	giis_back_modrdn LDAP_P(( BackendDB *bd,
	Connection *conn, Operation *op,
	const char *dn, const char *ndn,
	const char *newrdn, int deleteoldrdn,
	const char *newSuperior ));

extern int	giis_back_add LDAP_P(( BackendDB *bd,
	Connection *conn, Operation *op, Entry *e ));

extern int	giis_back_delete LDAP_P(( BackendDB *bd,
	Connection *conn, Operation *op,
	const char *dn, const char *ndn ));

extern int	giis_back_abandon LDAP_P(( BackendDB *bd,
	Connection *conn, Operation *op, int msgid ));

LDAP_END_DECL

#endif /* _GIIS_EXTERNAL_H */

