/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.replica.rls;

import java.util.*;

public class RLSStats {

  // Following constants must match defines in globus_rls_client.h.
  public static final int	RLS_LRCSERVER = 0x1;
  public static final int	RLS_RLISERVER = 0x2;
  public static final int	RLS_RCVLFNLIST = 0x4;
  public static final int	RLS_RCVBLOOMFILTER = 0x8;
  public static final int	RLS_SNDLFNLIST = 0x10;
  public static final int	RLS_SNDBLOOMFILTER = 0x20;

  public String Version;
  public int Uptime;
  public int Flags;
  public int LRCBloomFilterUI;
  public int LRCLFNListUI;
  public int LRCNumLFN;
  public int LRCNumPFN;
  public int LRCNumMAP;
  public int RLINumLFN;
  public int RLINumLRC;
  public int RLINumSender;
  public int RLINumMAP;

  public RLSStats(String version, int uptime, int flags, int lrcbloomfilterui,
		  int lrclfnlistui, int lrcnumlfn,
		  int lrcnumpfn, int lrcnummap, int rlinumlfn, int rlinumlrc,
		  int rlinumsender, int rlinummap) {
    Version = version;
    Uptime = uptime;
    Flags = flags;
    LRCBloomFilterUI = lrcbloomfilterui;
    LRCLFNListUI = lrclfnlistui;
    LRCNumLFN = lrcnumlfn;
    LRCNumPFN = lrcnumpfn;
    LRCNumMAP = lrcnummap;
    RLINumLFN = rlinumlfn;
    RLINumLRC = rlinumlrc;
    RLINumSender = rlinumsender;
    RLINumMAP = rlinummap;
  }

}
