/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */

#ifndef _bloom_h
#define _bloom_h

typedef struct {
  int			bfsize;
  int			numhash;
  globus_mutex_t	mtx;	/* Sync updates to bits,count,flags fields */
  u_char		*bits;
  short			*count;
  int			startlfns;	/* Num lfns when BF created	*/
  int			flags;
#define BF_NEEDUPDATE	0x1
} bloomfilter_t;

#define BITS2BYTES(bits)	((bits) / 8 + 1)

void		bf_addlfn(bloomfilter_t *bf, char *lfn);
void		bf_deletelfn(bloomfilter_t *bf, char *lfn);
extern void	bf_free(bloomfilter_t *bf);
extern int	bf_init(bloomfilter_t *bf, int bfsize, int numhash,
			int countbits);
extern void	bf_save(char *lrc_url, bloomfilter_t *bf);
extern int	bf_testlfn(bloomfilter_t *bf, char *lfn);
extern void	bf_unsave(char *lrc_url);
#endif
