/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.cas.impl.bootstrap;

import org.globus.cas.impl.CasConstants;

import org.globus.cas.types.ObjectData;
import org.globus.cas.types.NamespaceData;
import org.globus.cas.types.ServiceTypeData;

import org.globus.cas.impl.databaseAccess.ObjectDataHandler;
import org.globus.cas.impl.databaseAccess.NamespaceDataHandler;
import org.globus.cas.impl.databaseAccess.ServiceTypeDataHandler;
import org.globus.cas.impl.databaseAccess.ServiceTypeActionHandler;

public class PopulateImplicitObjectData  {

    public static void populateDb() throws Exception {
        
        // CAS Namespace
        NamespaceData nsData = new NamespaceData();
        nsData.setNickname(CasConstants.NAMESPACE_SELF);
        nsData.setBasename("baseName");
        nsData.setComparisonAlg(CasConstants.EXACT_ALG_CLASSNAME);
        NamespaceDataHandler.storeObject(nsData);

        // casServer as object
        ObjectData objData = new ObjectData();
        objData.setObjectName(CasConstants.OBJECT_SELF);
        objData.setObjectNamespace(CasConstants.NAMESPACE_SELF);
        ObjectDataHandler.storeObject(objData);

        // cas as service type
        ServiceTypeData serviceType = new ServiceTypeData();
        serviceType.setName(CasConstants.SERVICETYPE_CAS);
        ServiceTypeDataHandler.storeObject(serviceType);

        // cas/enroll_anchor
        ServiceTypeActionHandler.addServiceActionMapping(
                                 CasConstants.SERVICETYPE_CAS, 
                                 CasConstants.ACTION_ENROLL_ANCHOR);

        // cas/enroll_user
        ServiceTypeActionHandler.addServiceActionMapping(
                                 CasConstants.SERVICETYPE_CAS, 
                                 CasConstants.ACTION_ENROLL_USER);

        //cas/enroll_namespace
        ServiceTypeActionHandler.addServiceActionMapping(
                                 CasConstants.SERVICETYPE_CAS, 
                                 CasConstants.ACTION_ENROLL_NAMESPACE);
        
        //cas/enroll_object
        ServiceTypeActionHandler.addServiceActionMapping(
                                 CasConstants.SERVICETYPE_CAS, 
                                 CasConstants.ACTION_ENROLL_OBJECT);

        // cas/enroll_ServiceType
        ServiceTypeActionHandler.addServiceActionMapping(
                                 CasConstants.SERVICETYPE_CAS, 
                                 CasConstants.ACTION_CREATE_SERVICE_TYPE);
        
        // cas/create_object_group
        ServiceTypeActionHandler.addServiceActionMapping(
                                 CasConstants.SERVICETYPE_CAS, 
                                 CasConstants.ACTION_CREATE_OBJECT_GROUP);

        // cas/create_user_group
        ServiceTypeActionHandler.addServiceActionMapping(
                                 CasConstants.SERVICETYPE_CAS, 
                                 CasConstants.ACTION_CREATE_USER_GROUP);

        // cas/create_serviceAction_group
        ServiceTypeActionHandler.addServiceActionMapping(
                               CasConstants.SERVICETYPE_CAS, 
                               CasConstants.ACTION_CREATE_SERVICEACTION_GROUP);
        
        //cas/unenroll
        ServiceTypeActionHandler.addServiceActionMapping(
                                 CasConstants.SERVICETYPE_CAS, 
                                 CasConstants.ACTION_UNENROLL);
        
        //cas/delete_group
        ServiceTypeActionHandler.addServiceActionMapping(
                                 CasConstants.SERVICETYPE_CAS, 
                                 CasConstants.ACTION_DELETE_GROUP);

        //cas/add_group_entry
        ServiceTypeActionHandler.addServiceActionMapping(
                                 CasConstants.SERVICETYPE_CAS, 
                                 CasConstants.ACTION_ADD_GROUP_ENTRY);

        //cas/delete_group_entry
        ServiceTypeActionHandler.addServiceActionMapping(
                                 CasConstants.SERVICETYPE_CAS, 
                                 CasConstants.ACTION_REMOVE_GROUP_ENTRY);
        
        //cas/grant
        ServiceTypeActionHandler.addServiceActionMapping(
                                 CasConstants.SERVICETYPE_CAS, 
                                 CasConstants.ACTION_GRANT);

        //cas/grantAll
        ServiceTypeActionHandler.addServiceActionMapping(
                                 CasConstants.SERVICETYPE_CAS, 
                                 CasConstants.ACTION_GRANTALL);

        //cas/revoke
        ServiceTypeActionHandler.addServiceActionMapping(
                                 CasConstants.SERVICETYPE_CAS, 
                                 CasConstants.ACTION_REVOKE);

        //cas/superuser
        ServiceTypeActionHandler.addServiceActionMapping(
                                 CasConstants.SERVICETYPE_CAS, 
                                 CasConstants.ACTION_SU);

        //cas/query
        ServiceTypeActionHandler.addServiceActionMapping(
                                 CasConstants.SERVICETYPE_CAS, 
                                 CasConstants.ACTION_QUERY);
    }
}
