/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.cas.impl.databaseAccess;

/**
 * Constants used by CAS database access package
 */
public class CasDBConstants {
    
    // Tables 
    final public static String TABLE_TRUSTANCHOR = " trust_anchor_table";
    final public static String TABLE_USER = " user_table";
    final public static String TABLE_OBJECT = " object_table";
    final public static String TABLE_NAMESPACE = " namespace_table";
    final public static String TABLE_OBJECTGP = " object_group_table";
    final public static String TABLE_OBJECTGP_ENTRY = " object_group_entry";
    final public static String TABLE_USERGP = " user_group_table";
    final public static String TABLE_USERGP_ENTRY = " user_group_entry";
    final public static String TABLE_SERVICETYPE_ACTION 
        = " service_type_action";
    final public static String TABLE_SERVICEACTIONGP = " service_action_group";
    final public static String TABLE_SERVICEACTIONGP_ENTRY 
        = " service_action_group_entry";
    final public static String TABLE_SERVICETYPE = " service_type";
    final public static String TABLE_POLICY = " policy_table";


    // Columns
    final public static String COL_TRUST_NICKNAME = " trust_anchor_nickname";
    final public static String COL_AUTHMETHOD = " authentication_method";
    final public static String COL_AUTHDATA = " authentication_data";

    final public static String COL_USER_NICKNAME = " user_nickname";
    final public static String COL_SUBJECTNAME = " subject_name";

    final public static String COL_USERGP_NAME = " user_group_name";

    final public static String COL_SERVICETYPE_NAME = " service_type_name";

    final public static String COL_SERVICEACTION_ID = " service_action_id";
    final public static String COL_ACTION_NAME = " action_name";

    final public static String COL_SERVICEACTIONGP_NAME 
        = " service_action_group_name";

    final public static String COL_OBJECT_ID = " object_id";
    final public static String COL_OBJECT_NAME = " object_name";
    final public static String COL_NS_NICKNAME = " namespace_nickname";
    
    final public static String COL_BASENAME = " basename";
    final public static String COL_COMPARISON_ALG = " comparisonAlg";

    final public static String COL_OBJECTGP_NAME = " object_group_name";
    final public static String COL_OBJECT_SPEC = " object_specification";
    final public static String COL_OBJECT_SPEC_DESC = " object_spec_desc";

    final public static String COL_POLICY_ID = " policy_id";
    final public static String COL_USER_SPEC = " user_specification";
    final public static String COL_USER_SPEC_DESC = " user_spec_desc";
    final public static String COL_ACTION_SPEC = " action_specification";
    final public static String COL_ACTION_SPEC_DESC = " action_spec_desc";
}
