/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.cas.impl.service;

import org.globus.cas.types.ObjectData;

import org.globus.cas.impl.databaseAccess.ObjectDataHandler;
import org.globus.cas.impl.databaseAccess.CasDBException;

/**
 * Base class for all CAS Object comparison classes
 */
public abstract class ObjectComparison {

    public abstract boolean objectMatches(ObjectData objData1, 
					  ObjectData objData2) 
	throws CasDBException;

    public abstract boolean objectExists(ObjectData objData1) 
	throws CasDBException;

    public abstract ObjectData[] matchingSubset(ObjectData objData)
	throws CasDBException;

    public abstract ObjectData[] matchingSuperset(ObjectData objData)
	throws CasDBException;

    public boolean exactMatchExists(ObjectData objData) throws CasDBException {
	int objId = ObjectDataHandler.getObjectId(objData.getObjectName(),
						  objData.getObjectNamespace());
	if (objId == -1)
	    return false;
	else 
	    return true;
    }
}
