/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.cas.impl.databaseAccess;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.globus.cas.types.NamespaceData;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class TestNamespaceData extends TestCase {

    static Log logger =
              LogFactory.getLog(TestNamespaceData.class.getName());

    public TestNamespaceData(String name){
        super(name);
    }

    public static Test suite() {
        return new TestSuite(TestNamespaceData.class);
    }

    public void testNamespaceData() throws Exception {

        String nickname = "nickname";
        String basename = "basename";
        String compAlg = "compAlg";

        // Store name space data
        NamespaceData nsData = new NamespaceData();
        nsData.setNickname(nickname);
        nsData.setBasename(basename);
        nsData.setComparisonAlg(compAlg);
        NamespaceDataHandler.storeObject(nsData);
        logger.debug("Store object went through " + nsData.toString());

        // List of all namespaces
        String[] namespaceList = NamespaceDataHandler.list();
        assertTrue(namespaceList!=null);
        logger.debug("Name space list is " + namespaceList);

        // Ensure that the stored and retrieved objects are the same
        NamespaceData retrieveNSData = (NamespaceData)NamespaceDataHandler.retrieveObject(nickname);
        assertTrue(retrieveNSData!=null);
        logger.debug("Retrieved trust anchor " + retrieveNSData.toString());
        assertTrue(retrieveNSData.equals(nsData));
        
        // Delete name space data
        NamespaceDataHandler.deleteObject(nickname);
        NamespaceData deletedData = (NamespaceData)NamespaceDataHandler.retrieveObject(nickname);
        assertTrue(deletedData == null);
    }
}
