<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns="http://www.w3.
org/TR/REC-html40">
   <xsl:output method="html"/>
   <xsl:template match="/">
      <HTML>
         <HEAD>
            <TITLE>GRAM Scheduler Test Detail</TITLE>
         </HEAD>
         <BODY>
            <xsl:apply-templates/>
         </BODY>
      </HTML>
   </xsl:template>

   <xsl:template match="TestRun">
      <P>
         <font color="blue" size="+1"><xsl:value-of select="DateTime"/></font>
      </P>
      <P>
         <font size="+1">
            <xsl:value-of select="PassCount"/> of <xsl:value-of select="TestCount"/> Tests Passed.
          </font>
      </P>
      <xsl:for-each select="Test">
         <table border="1" cellpadding="2">
            <TR>
               <TD>
                  Pass/Fail
               </TD>
               <TD>
                  Test Name
               </TD>
               <TD>
                  Test Description
               </TD>
               <TD>
                  Service Container
               </TD>
               <TD>
                  Scheduler
               </TD>
               <TD>
                  Test Directory
               </TD>
               <TD>
                  RSL
               </TD>
               <TD>
                  RSL stdout
               </TD>
               <TD>
                  RSL stderr
               </TD>
               <TD>
                  stdout reference
               </TD>
            </TR>
            <TR>
               <xsl:if test="Result = 1">
                  <TD bgcolor="red">
                     FAIL
                  </TD>
               </xsl:if>
               <xsl:if test="Result = 0">
                  <TD bgcolor="green">
                     PASS
                  </TD>
               </xsl:if>
               <TD>
                  <xsl:value-of select="TestName"/>
               </TD>
               <TD>
                  <xsl:value-of select="TestDescription"/>
               </TD>
               <TD>
                  <xsl:value-of select="ServiceHostPort"/>
               </TD>
               <TD>
                  <xsl:value-of select="Scheduler"/>
               </TD>
               <TD>
                  <xsl:value-of select="TempDirectory"/>
               </TD>
               <TD>
                  <A>
                     <xsl:attribute name="href">
                        <xsl:value-of select="TestName"/>.xml
                     </xsl:attribute>
                     <xsl:value-of select="TestName"/>.xml
                  </A>
               </TD>
               <TD>
                  <A>
                     <xsl:attribute name="href">
                        <xsl:value-of select="TestName"/>.out
                     </xsl:attribute>
                     <xsl:value-of select="TestName"/>.out
                  </A>
               </TD>
               <TD>
                  <A>
                     <xsl:attribute name="href">
                        <xsl:value-of select="TestName"/>.err
                     </xsl:attribute>
                     <xsl:value-of select="TestName"/>.err
                  </A>
               </TD>
               <TD>
                  <A>
                     <xsl:attribute name="href">
                        <xsl:value-of select="TestName"/>.rout
                     </xsl:attribute>
                     <xsl:value-of select="TestName"/>.rout
                  </A>
               </TD>
            </TR>
         </table>
         <table border="1" cellpadding="2">
            <TR>
               <TD>
                  Run String
               </TD>
               <TD>
                  globusrun stdout
               </TD>
               <TD>
                  globusrun stderr
               </TD>
            </TR>
            <TR>
               <TD>
                  <xsl:value-of select="RunString"/>
               </TD>
               <TD>
                  <A>
                     <xsl:attribute name="href">
                        <xsl:value-of select="TestName"/>.cout
                     </xsl:attribute>
                     <xsl:value-of select="TestName"/>.cout
                  </A>
               </TD>
               <TD>
                  <A>
                     <xsl:attribute name="href">
                        <xsl:value-of select="TestName"/>.cerr
                     </xsl:attribute>
                     <xsl:value-of select="TestName"/>.cerr
                  </A>
               </TD>
            </TR>
         </table>
         <br></br>
         <br></br>
      </xsl:for-each>
   </xsl:template>
</xsl:stylesheet>

