<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns="http://www.w3.
org/TR/REC-html40">
   <xsl:output method="html"/>
   <xsl:template match="/">
      <HTML>
         <HEAD>
            <TITLE>GRAM Scheduler Tests</TITLE>
         </HEAD>
         <BODY>
            <xsl:apply-templates/>
         </BODY>
      </HTML>
   </xsl:template>

   <xsl:template match="TestRun">
      <P>
         <font color="blue" size="+1"><xsl:value-of select="DateTime"/></font>
      </P>
      <table border="1" cellpadding="2">
            <TR>
               <TD>
                  Pass/Fail
               </TD>
               <TD>
                  Test Description
               </TD>
               <TD>
                  Results
               </TD>
               <TD>
                  Execution Script
               </TD>
               <TD>
                  Test Group Detail
               </TD>
            </TR>
         <xsl:for-each select="ScriptExecution">
            <TR>
               <xsl:if test="Result = 1">
                  <TD bgcolor="red">
                     FAIL
                  </TD>
               </xsl:if>
               <xsl:if test="Result = 0">
                  <TD bgcolor="green">
                     PASS
                  </TD>
               </xsl:if>
               <TD>
                  <xsl:value-of select="TestName"/>
               </TD>
               <TD>
                  <xsl:value-of select="ResultString"/>
               </TD>
               <TD>
                  ./<xsl:value-of select="TestDirectory"/>/<xsl:value-of select="ExecutionScript"/>
               </TD>
               <TD>
                  <A>
                     <xsl:attribute name="href">
                        <xsl:value-of select="TempDirectory"/>/index.html
                     </xsl:attribute>
                     <xsl:value-of select="TempDirectory"/>
                  </A>
               </TD>
            </TR>
         </xsl:for-each>
      </table>
   </xsl:template>

   <xsl:template match="DateTime">
      <P><xsl:apply-templates/></P>
   </xsl:template>

   <!-- This Keeps Unused Things From Printing -->
   <xsl:template match="TestDirectory"></xsl:template>
   <xsl:template match="ExecutionScript"></xsl:template>
   <xsl:template match="Result"></xsl:template>
   <xsl:template match="TestName"></xsl:template>
   <xsl:template match="TempDirectory"></xsl:template>
   <xsl:template match="ResultString"></xsl:template>

</xsl:stylesheet>
