#for finding the schema:
#cp -r test*.xml $GLOBUS_LOCATION
#todo: use C shell and create function to build file path
#cd $GLOBUS_LOCATION

protocol=http
host=$HOSTNAME
port=8080
baseURL=wsrf/services
service=$baseURL/ManagedJobFactoryService
factory="$protocol://$host:$port/$service"

cmd_base="$GLOBUS_LOCATION/bin/managed-job-globusrun -factory $factory"
tool="$cmd_base -file"
line=------------------------------------

echo "A) test simple job execution, no stdout"
$tool test01.xml
echo $line

echo "B) test output to remote file"
$tool test05.xml
#test output to file
echo $line

echo "C.1) test stage-in of GASS-relative path"
$tool test03.xml -server
echo $line

echo "C.2) test stage-out to GASS-relative path"
$tool test04.xml -write-allow
echo $line

echo "C.3) test redirecting output to m-j-g"
$tool test01.xml -output
echo $line

echo "C.4.1) test writing stdout to remote file and staging out to GASS-relative path"
$tool test02.xml -write-allow
echo $line

echo "C.4.2) test writing stdout to remote file and redirecting output"
$tool test05.xml -output
echo $line

echo "C.4.3) test staging out to GASS path and redirecting output"
$tool test04.xml -write-allow -output
echo $line

echo "C.4.4) test staging out to GASS path, writing stdout to remote file and redirecting output"
$tool test02.xml -write-allow -output
echo $line

echo "C.4.5) test staging in to remote path and redirecting output"
$tool test03.xml -server -output
echo $line


echo "test batch: please do manual tests D.1) to D.3)"
echo $line

echo "test listing the submitted jobs"
$tool test01.xml -batch
$tool test05.xml -batch
$cmd_base -list
echo $line

echo "test -duration and -terminate-at: please do manual tests E)"
echo $line

#cleanup
#rm test*.xml
