my $gpath = $ENV{GPT_LOCATION};

if (!defined($gpath))
{
    $gpath = $ENV{GLOBUS_LOCATION};
}

if (!defined($gpath))
{
    die "GPT_LOCATION or GLOBUS_LOCATION needs to be set before running this script";
}

@INC = (@INC, "$gpath/lib/perl");

require Grid::GPT::Setup;
use Getopt::Long;

my $help		= 0;
my $condor_os           = '';
my $condor_arch         = '';
my $c_opts              = '';

GetOptions('help|h' => \$help,
           'condor-os=s' => \$condor_os,
           'condor-arch=s' => \$condor_arch);

&usage if $help;

my $metadata =
    new Grid::GPT::Setup(package_name => "globus_scheduler_provider_setup_condor");

my $globusdir	= $ENV{GLOBUS_LOCATION};
my $libexecdir	= "$globusdir/libexec";
my $pgm_file	= "$globusdir/libexec/globus-scheduler-provider-condor";

# create dir for program
# mkdir $libexecdir . "/gram_providers", 0777;

# Do script relocation
if($condor_os ne '')
{
    $c_opts = " --with-condor-os=$condor_os";
}
if($condor_arch ne '')
{
    $c_opts .= " --with-condor-arch=$condor_arch";
}

print `./find-condor-provider-tools $c_opts --cache-file=/dev/null`;

if($? != 0)
{
    print STDERR "Error locating Condor commands, aborting!\n";
    exit 2;
}

# Set executable permissions for script
chmod(0755, $pgm_file) || die "Can't set permissions on $pgm_file\n";

$metadata->finish();

sub usage
{
    print "Usage: $0 [options]\n".
          "Options: [--help|-h]\n".
          "          [-condor-os=CONDOR OS]\n".
          "          [-condor-arch=CONDOR ARCH]\n";
    exit 1;
}
