/*
* Portions of this file Copyright 1999-2005 University of Chicago
* Portions of this file Copyright 1999-2005 The University of Southern California.
*
* This file or a portion of this file is licensed under the
* terms of the Globus Toolkit Public License, found at
* http://www.globus.org/toolkit/download/license.html.
* If you redistribute this file, with or without
* modifications, you must include this notice in the file.
*/
package org.globus.mds.index.test.junit;

import org.apache.axis.utils.XMLUtils;

import org.globus.interop.widget.Widget;

import org.globus.mds.aggregator.impl.AggregatorServiceGroupResource;

import org.globus.wsrf.Constants;

import org.oasis.wsn.TopicExpressionType;

import com.widgets.WidgetPortType;
import com.widgets.service.WidgetServiceAddressingLocator;

import java.util.Calendar;
import java.util.Random;
import java.net.URL;

import java.rmi.RemoteException;

import javax.xml.namespace.QName;
import javax.xml.soap.SOAPElement;

import org.apache.axis.message.MessageElement;
import org.apache.axis.message.Text;
import org.apache.axis.message.addressing.Address;
import org.apache.axis.message.addressing.EndpointReferenceType;
import org.apache.axis.message.addressing.ReferencePropertiesType;
import org.apache.axis.types.URI;
import org.globus.interop.widget.Widget;
import org.globus.wsrf.Constants;
import org.globus.wsrf.encoding.ObjectDeserializer;
import org.globus.wsrf.encoding.ObjectSerializer;
import org.globus.wsrf.utils.AddressingUtils;
import org.globus.wsrf.utils.AnyHelper;

import org.globus.wsrf.impl.SimpleResourceKey;
import org.globus.wsrf.impl.servicegroup.ServiceGroupConstants;

import org.globus.mds.servicegroup.stubs.ServiceGroupFactoryPortType;
import org.globus.mds.servicegroup.stubs.ServiceGroupFactoryServiceAddressingLocator;

import org.oasis.wsrf.servicegroup.ServiceGroupServiceAddressingLocator;
import org.oasis.wsrf.servicegroup.ServiceGroupRegistration;

import org.globus.mds.aggregator.impl.AggregatorConstants;
import org.globus.mds.aggregator.test.junit.AggregatorTestCase;
import org.globus.mds.aggregator.types.AggregatorContent;
import org.globus.mds.aggregator.types.AggregatorConfig;
import org.globus.mds.aggregator.types.AggregatorData;
import org.globus.mds.aggregator.types.ExecutionPollType;

import org.globus.mds.servicegroup.client.ServiceGroupRegistrationParameters;
import org.globus.wsrf.impl.servicegroup.client.ServiceGroupRegistrationClient;

import junit.textui.TestRunner;

import javax.xml.namespace.QName;
import javax.xml.soap.SOAPElement;
import org.globus.wsrf.encoding.ObjectSerializer;
import org.globus.wsrf.encoding.SerializationException;



public class ExecutionIndexTest extends AggregatorTestCase {

    private String indexServiceAddress =
        "https://127.0.0.1:8443/wsrf/services/mds/test/execsource/IndexService";
    private String indexServiceAddressNoSecurity =
        "http://127.0.0.1:8080/wsrf/services/mds/test/execsource/IndexService";    

    public static void main(String args[]) throws Exception
    {
        TestRunner.run(ExecutionIndexTest.class);
    }

    public void decorateRegistrationParams(ServiceGroupRegistrationParameters params) throws SerializationException
    {
        ExecutionPollType rpPoll =
            new ExecutionPollType();
        rpPoll.setPollIntervalMillis(40000);
        rpPoll.setProbeName(new QName("","aggr-test"));
        AggregatorContent content =
            new AggregatorContent(new AggregatorConfig(),
                                  new AggregatorData(),
                                  null);
        SOAPElement rpPollElement = ObjectSerializer.toSOAPElement(rpPoll,
            AggregatorConstants.EXECUTION_RP_QNAME);
        content.getAggregatorConfig().set_any(
            new MessageElement[] { AnyHelper.toAny(rpPollElement) });

        params.setContent(content);

    }

    public EndpointReferenceType getAggregator()
    {
      try {
        EndpointReferenceType epr = new EndpointReferenceType();
        
        String serviceAddr = 
            (this.isSecure) ? 
            this.indexServiceAddress : 
            this.indexServiceAddressNoSecurity;
            
        epr.setAddress(new Address(serviceAddr));

        return epr;
      } catch(Exception e) {
        System.err.println("Exception when forming default EPR");
        e.printStackTrace();
        fail("Couldn't form default EPR");
        return null;
      }
   }
    
}
