/*
* Portions of this file Copyright 1999-2005 University of Chicago
* Portions of this file Copyright 1999-2005 The University of Southern California.
*
* This file or a portion of this file is licensed under the
* terms of the Globus Toolkit Public License, found at
* http://www.globus.org/toolkit/download/license.html.
* If you redistribute this file, with or without
* modifications, you must include this notice in the file.
*/
package org.globus.wsrf.impl.servicegroup.inmemory;

import java.util.Hashtable;

import javax.xml.namespace.QName;

import org.globus.wsrf.ResourceHome;
import org.globus.wsrf.ResourceKey;
import org.globus.wsrf.Resource;

import org.globus.wsrf.impl.SimpleResourceKey;

import org.globus.wsrf.impl.servicegroup.ServiceGroupConstants;

public class InMemoryServiceGroupHome 
    implements ResourceHome {
 
    Hashtable resources;
 
    public InMemoryServiceGroupHome() {
        this.resources = new Hashtable();
    }
   
    public Resource find(ResourceKey key) {
        return (Resource)this.resources.get(key);
    }

    public void remove(ResourceKey key) {
        this.resources.remove(key);
    }

    public Class getKeyTypeClass() {
        return String.class;
    }
    
    public QName getKeyTypeName() {
        return ServiceGroupConstants.KEY;
    }
  

    /** creates a new InMemoryServiceGroup resource. 

    <br>
    TODO: should there be a standard API for this? or are the factories
    for servicegroups almost always going to be non-general? */

    public InMemoryServiceGroupResource create() {

        InMemoryServiceGroupResource newServiceGroup = 
            new InMemoryServiceGroupResource();

        resources.put(newServiceGroup.getKey(),newServiceGroup);

        return newServiceGroup;
    } 
 
}
