/*
* Portions of this file Copyright 1999-2005 University of Chicago
* Portions of this file Copyright 1999-2005 The University of Southern California.
*
* This file or a portion of this file is licensed under the
* terms of the Globus Toolkit Public License, found at
* http://www.globus.org/toolkit/download/license.html.
* If you redistribute this file, with or without
* modifications, you must include this notice in the file.
*/

package org.globus.mds.trigger.impl;

/**
This is a bean used to pass in configuration for the TriggerService 
through JNDI.
*/
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.StringTokenizer;

public class TriggerConfiguration
{   
    public TriggerConfiguration() { }

    private String executableMappings;
    private Hashtable executables = new Hashtable();
    
    public String getExecutableMappings() {
        return executableMappings;
    }
    
    
    public Hashtable getExecutableMappingTable() {
        return executables;
    }
    
   
    public void setExecutableMappings(String s) 
    {
        String entry;
        String name; 
        String value;
            
        StringTokenizer toker = new StringTokenizer(s);
        while (toker.hasMoreTokens()) 
        {
            entry = toker.nextToken(",");            
            entry.trim();
            name = entry.substring(0,entry.lastIndexOf("="));
            value = entry.substring(entry.lastIndexOf("=")+1);
            executables.put(name.trim(), value.trim());
        }
    }
}
