/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.mds.webmds;

import java.io.IOException;
import java.io.FileReader;
import java.io.File;

/**
 * WebMDS utility class, passed to webmds source objects when they're
 * initialized.
 */

public class WebmdsUtil {
    private String directoryName = null;

    public WebmdsUtil() {
    }

    protected void setDirectoryName(String directoryName) {
	this.directoryName = directoryName;
    }

    /**
     * newFile -- create a new File object, with relative pathnames interpreted
     * relative to the application root directory.
     * @param fileName the name of the new file.
     * @return a newly-created File object.
     */
    public File newFile(String fileName) {
	File file = new File(fileName);
	if (! file.isAbsolute()) {
	    file = new File(this.directoryName, fileName);
	}
	return(file);
    }
}
