<?xml version="1.0"?>
<!-- 
  Portions of this file Copyright 1999-2005 University of Chicago
  Portions of this file Copyright 1999-2005 The University of Southern California.
  
  This file or a portion of this file is licensed under the
  terms of the Globus Toolkit Public License, found at
  http://www.globus.org/toolkit/download/license.html.
  If you redistribute this file, with or without
  modifications, you must include this notice in the file.
-->
<!-- $Id: clusterbase.xsl,v 1.2.2.2 2005/12/16 21:15:57 pearlman Exp $ -->
<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"

  xmlns:ag="http://mds.globus.org/aggregator/types"
  xmlns:wssg="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ServiceGroup-1.2-draft-01.xsd"
  xmlns:wsa="http://schemas.xmlsoap.org/ws/2004/03/addressing"
  xmlns:glue="http://mds.globus.org/glue/ce/1.1"
  version="1.0">

<xsl:template match="*"
              mode="ClusterBase"
	      priority="100">
<td><xsl:value-of select="local-name()"/></td>
<td><xsl:value-of select="./@glue:Name"/><xsl:text disable-output-escaping="yes">&amp;</xsl:text>nbsp;</td>
<td><xsl:value-of select="./@glue:UniqueID"/><xsl:text disable-output-escaping="yes">&amp;</xsl:text>nbsp;</td>
<!--
  Benchmark info doesn't seem to be reported by anything.
<td><xsl:value-of select="./glue:Benchmark/@glue:SI00"/>/<xsl:value-of select="./glue:Benchmark/@glue:SF00"/><xsl:text disable-output-escaping="yes">&amp;</xsl:text>nbsp;</td>
-->
<td><xsl:value-of select="./glue:Processor/@glue:InstructionSet"/></td>
<td><xsl:value-of select="./glue:Processor/@glue:ClockSpeed"/></td>
<td><xsl:value-of select="./glue:MainMemory/@glue:RAMSize"/></td>
<td><xsl:value-of select="./glue:OperatingSystem/@glue:Name"/> <xsl:value-of select="./glue:OperatingSystem/@glue:Release"/> <xsl:value-of select="./glue:OperatingSystem/@glue:Version"/><xsl:text disable-output-escaping="yes">&amp;</xsl:text>nbsp;</td>
<!--
  The only architecture info we seem to report is SMPSize.
-->
<td><xsl:value-of select="./glue:Architecture/@glue:SMPSize"/><xsl:text disable-output-escaping="yes">&amp;</xsl:text>nbsp;</td>
<!--
   The current CluMon implementation misspells TeraGridExtensions.  I'm
   not going to bother working around that, since they don't fill it in with
   meaningful info anyway.
-->
<td><xsl:value-of select="./glue:StorageDevice/@glue:Name"/></td>
<td><xsl:value-of select="./glue:StorageDevice/@glue:Size"/></td>
<td><xsl:value-of select="./glue:StorageDevice/@glue:AvailableSpace"/></td>
</xsl:template>

<xsl:template name="ClusterBaseHeadings1">
<th rowspan="2">Type</th>
<th rowspan="2">Name</th>
<th rowspan="2">UniqueID</th>
<!-- Benchmark info doesn't seem to be reported by anything.
<th>Benchmark (SI00/SF00)</th>
-->
<th colspan="2">Processor</th>
<th rowspan="2">Total Memory</th>
<th rowspan="2">Operating System</th>
<!--
  The only architecture info we seem to report is SMPSize.
-->
<th rowspan="2">SMP Size</th>
<th colspan="3">Storage Device</th>
</xsl:template>

<xsl:template name="ClusterBaseHeadings2">
<th>Type</th>
<th>Clock Speed</th>
<th>Name</th>
<th>Size</th>
<th>Available Space</th>
</xsl:template>

</xsl:stylesheet>
