<?xml version="1.0"?>
<!-- 
  Portions of this file Copyright 1999-2005 University of Chicago
  Portions of this file Copyright 1999-2005 The University of Southern California.
  
  This file or a portion of this file is licensed under the
  terms of the Globus Toolkit Public License, found at
  http://www.globus.org/toolkit/download/license.html.
  If you redistribute this file, with or without
  modifications, you must include this notice in the file.
-->
<!-- $Id: tgextensions.xsl,v 1.1.4.2 2006/03/29 00:01:21 pearlman Exp $ -->
<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"

  xmlns:ag="http://mds.globus.org/aggregator/types"
  xmlns:wssg="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ServiceGroup-1.2-draft-01.xsd"
  xmlns:wsa="http://schemas.xmlsoap.org/ws/2004/03/addressing"
  xmlns:glue="http://mds.globus.org/glue/ce/1.1"
  xmlns:cc="http://mds.globus.org/2005/09/cluster-config"
  version="1.0">

<xsl:template match="*"
              mode="TGClusterExtensions"
	      priority="100">
<td><xsl:value-of select="./cc:TeraGridExtensions/@cc:TotalNodes"/><xsl:text disable-output-escaping="yes">&amp;</xsl:text>nbsp;</td>
</xsl:template>

<xsl:template name="TGClusterHeadings1">
<th>TeraGrid Extensions</th>
</xsl:template>

<xsl:template name="TGClusterHeadings2">
<th>Total Nodes</th>
</xsl:template>


<xsl:template match="//glue:Host"
	      mode="TGHostExtensions"
	      priority="100">
<td><xsl:value-of select="./glue:TeraGridHostExtensions/@glue:NodeProperties"/></td>
</xsl:template>

<xsl:template name="TGHostHeadings1">
<th>TeraGrid Extensions</th>
</xsl:template>

<xsl:template name="TGHostHeadings2">
<th>Node Properties</th>
</xsl:template>

<!-- The PBS info provider currently puts all the host-specific
     teragrid extensions into the ComputingElement, so we display
     them here.  Note that this means the information will be
     duplicated if it's also provided by the ganglia/clumon/nagios
     provider.  Hopefully this will eventually move out of the
     ComputingElement altogether and back into the individual hosts.
-->

<xsl:template match="*" mode="TGQueueHack">
<h1>TeraGrid Host Extensions reported for Queue <xsl:value-of select="./@glue:Name"/></h1>
<table>
<tr>
<th>Name</th>
<th>Node Properties</th>
</tr>
<xsl:apply-templates select="./cc:TGHostExtType" mode="TGExtensionsHack"/>
</table>
</xsl:template>

<xsl:template match="*" mode="TGExtensionsHack">
<tr>
<td><xsl:value-of select="./@cc:Name"/></td>
<td><xsl:value-of select="./@cc:NodeProperties"/></td>
</tr>
</xsl:template>
</xsl:stylesheet>
