/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.replica.replicator.client;

import javax.xml.rpc.Stub;

import org.apache.commons.cli.ParseException;

import org.globus.wsrf.utils.FaultHelper;

import org.globus.replica.replicator.generated.service.ReplicationServiceAddressingLocator;
import org.globus.replica.replicator.generated.ReplicatorPortType;

public class Suspend extends org.globus.wsrf.client.BaseClient {

    public static void main(String[] args) {
        Suspend client = new Suspend();
        try {
            client.parse(args);
        } catch (ParseException e) {
            System.err.println("Error: " + e.getMessage());
            System.exit(COMMAND_LINE_ERROR);
        } catch (Exception e) {
            System.err.println("Error: " + e.getMessage());
            System.exit(COMMAND_LINE_ERROR);
        }

        ReplicationServiceAddressingLocator locator =
            new ReplicationServiceAddressingLocator();

        try {
            ReplicatorPortType port =
                locator.getReplicatorPortTypePort(client.getEPR());
            client.setOptions((Stub)port);
            port.suspend(new org.globus.replica.replicator.generated.Suspend());
            if (client.isDebugMode()) {
                System.out.println("Suspend operation was successful");
            }
        } catch (Exception e) {
            if (client.isDebugMode()) {
                FaultHelper helper = new FaultHelper(FaultHelper.toBaseFault(e));
                helper.printStackTrace(System.err);
            } else {
                System.err.println("Error: " + FaultHelper.getMessage(e));
            }
            System.exit(APPLICATION_ERROR);
        }
    }
}
