/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.replica.replicator;

public interface ReplicationStatus {
    public static final int PENDING = 1;
    public static final int ACTIVE = 2;
    public static final int SUSPENDING = 4;
    public static final int SUSPENDED = 8;
    public static final int TERMINATING = 16;
    public static final int TERMINATED = 32;
    public static final int DESTROYED = 64;
    public int getStatus();
    public static final int NONE = 1;
    public static final int DISCOVER = 2;
    public static final int TRANSFER = 4;
    public static final int REGISTER = 8;
    public int getStage();
    public static final int FINISHED = 2;
    public static final int FAILED = 4;
    public static final int EXCEPTION = 8;
    public int getResult();
    public String getErrorMsg();
    public void addObserver(ReplicationStatusObserver o);
    public void removeObserver(ReplicationStatusObserver o);
}
