/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.replica.replicator.impl;

import org.globus.replica.replicator.ReplicationItem;
import org.globus.replica.replicator.Source;
import org.globus.replica.replicator.Destination;

/**
 * INTERNAL USE ONLY.
 * Used to represent Source and Destination objects since their
 * contents are essentially equivalent.
 */
abstract class SrcDestImpl implements Source, Destination {
    String uri;
    int status;
    protected String errmsg;
    SrcDestImpl(String uri) {
        this.uri = uri;
        this.status = Source.PENDING; // TODO: value of Source or Dest PENDING must be same
        this.errmsg = null;
    }
    public String getUri() { return uri; }
    public String getErrorMsg() {
        synchronized (this) {
            return errmsg;
        }
    }
    public int getStatus() { 
        synchronized (this) {
            return status;
        }
    }
    void changeStatus(int n, String s) {
        synchronized (this) {
            this.status = n;
            this.errmsg = s;
        }
    }
}
