/*
 * Portions of this file Copyright 1999-2005 University of Chicago 
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the 
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without 
 * modifications, you must include this notice in the file.
 */
package org.globus.transfer.reliable.service;

import java.util.Collection;

import org.apache.axis.message.addressing.EndpointReferenceType;
import org.globus.rft.generated.OverallStatus;


public class RFTRecoveryData {
    private EndpointReferenceType delegationEPR;
    private String userName;
    private String userSubject;
    private Collection recoveredTransfers;
    private OverallStatus overallStatus;
    
    public RFTRecoveryData() {
    }
    /**
     * @param userName
     * @param userSubject
     * @param delegationEPR
     */
    public RFTRecoveryData(String userName, 
            String userSubject, EndpointReferenceType delegationEPR) {
        this.userName = userName;
        this.userSubject = userSubject;
        this.delegationEPR = delegationEPR;
    }
    /**
     * @return Returns the delegationEPR.
     */
    public EndpointReferenceType getDelegationEPR() {
        return this.delegationEPR;
    }
    /**
     * @param delegationEPR The delegationEPR to set.
     */
    public void setDelegationEPR(EndpointReferenceType delegationEPR) {
        this.delegationEPR = delegationEPR;
    }
    /**
     * @return Returns the userName.
     */
    public String getUserName() {
        return this.userName;
    }
    /**
     * @param userName The userName to set.
     */
    public void setUserName(String userName) {
        this.userName = userName;
    }
    /**
     * @return Returns the userSubject.
     */
    public String getUserSubject() {
        return this.userSubject;
    }
    /**
     * @param userSubject The userSubject to set.
     */
    public void setUserSubject(String userSubject) {
        this.userSubject = userSubject;
    }
    /**
     * @return Returns the recoveredTransfers.
     */
    public Collection getRecoveredTransfers() {
        return this.recoveredTransfers;
    }
    /**
     * @param recoveredTransfers The recoveredTransfers to set.
     */
    public void setRecoveredTransfers(Collection recoveredTransfers) {
        this.recoveredTransfers = recoveredTransfers;
    }

    public OverallStatus getOverallStatus() {
        return this.overallStatus;
    }

    public void setOverallStatus(OverallStatus overallStatus) {
        this.overallStatus = overallStatus;
    }
}
