/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.transfer.reliable.service.factory;

import java.util.Calendar;

import javax.xml.namespace.QName;

import org.globus.wsrf.impl.ReflectionResourceProperty;
import org.globus.wsrf.impl.SimpleResourcePropertyMetaData;

/**
 * RFT Factory uptime
 */
public class RFTFactoryStartTime extends ReflectionResourceProperty {
    
    private Calendar startTime = null;
    
    /**
     * Uptime of the RFT Factory
     * @param qname
     * @throws Exception
     */
    public RFTFactoryStartTime(QName qname) throws Exception {
        super(new SimpleResourcePropertyMetaData(qname));
        setObject(this);
        setPropertyName("RFTFactoryStartTime");
        initialize();    
        this.startTime = Calendar.getInstance();
    }
    /**
     * @return Returns the upTime.
     */
    public Calendar getRFTFactoryStartTime() {
        return this.startTime;
    }
    /**
     * @param startTime
     */
    public void setRFTFactoryStartTime(Calendar startTime) {
        this.startTime = startTime;
    }
}
