/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */

#include "interop_test.h"

#include "xsd_dateTime.h"
#include "xsd_string.h"

#define WSRL_NS "http://docs.oasis-open.org" \
                "/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd"

xsd_QName
termination_time_rp_qname =
{
    WSRL_NS,
    "TerminationTime"
};
xsd_QName
current_time_rp_qname =
{
    WSRL_NS,
    "CurrentTime"
};

xsd_QName
foo_rp_qname =
{
    "http://widgets.com",
    "foo"
};

static
globus_xsd_type_info_t termination_time_element_info;

static
globus_xsd_type_info_t current_time_element_info;

static
globus_xsd_type_info_t foo_element_info;

globus_result_t
interop_test_init_registry(
    globus_xsd_type_registry_t          registry)
{
    globus_result_t                     result;

    result = globus_xsd_type_info_init_from_template(
        &termination_time_element_info,
        &termination_time_rp_qname,
        &xsd_dateTime_info);

    if (result != GLOBUS_SUCCESS)
    {
        goto out;
    }
    result = globus_xsd_type_info_init_from_template(
        &current_time_element_info,
        &current_time_rp_qname,
        &xsd_dateTime_info);

    if (result != GLOBUS_SUCCESS)
    {
        goto destroy_termination_time_element_info;
    }

    result = globus_xsd_type_info_init_from_template(
        &foo_element_info,
        &foo_rp_qname,
        &xsd_string_info);

    if (result != GLOBUS_SUCCESS)
    {
        goto destroy_current_time_element_info;
    }

    result = globus_xsd_type_registry_insert(
        registry,
        foo_element_info,
        NULL);

    if (result != GLOBUS_SUCCESS)
    {
        goto destroy_foo_element_info;
    }
    result = globus_xsd_type_registry_insert(
        registry,
        current_time_element_info,
        NULL);

    if (result != GLOBUS_SUCCESS)
    {
        goto destroy_current_time_element_info;
    }
    result = globus_xsd_type_registry_insert(
        registry,
        termination_time_element_info,
        NULL);
    if (result != GLOBUS_SUCCESS)
    {
        goto destroy_termination_time_element_info;
    }

    return result;

destroy_foo_element_info:
    globus_xsd_type_info_destroy(foo_element_info);
destroy_current_time_element_info:
    globus_xsd_type_info_destroy(current_time_element_info);
destroy_termination_time_element_info:
    globus_xsd_type_info_destroy(termination_time_element_info);

out:
    return result;
}
/* interop_test_init_registry() */
