/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


#ifndef _GLOBUS_I_HANDLER_CHAIN_H_
#define _GLOBUS_I_HANDLER_CHAIN_H_

#include "globus_handler.h"

EXTERN_C_BEGIN

typedef struct globus_handler_chain_s
{
    globus_list_t *                     request_init_handlers;
    globus_list_t *                     request_handlers;
    globus_list_t *                     request_destroy_handlers;
    globus_list_t *                     response_init_handlers;
    globus_list_t *                     response_handlers;
    globus_list_t *                     response_destroy_handlers;
    globus_hashtable_t                  triggers;
    globus_handler_invoke_func_t        default_trigger;
    globus_list_t *                     extensions;
} globus_i_handler_chain_t;

typedef struct globus_handler_session_descriptor_s
{
    globus_list_t *                     remaining_handlers;
    globus_handler_invoke_func_t        trigger;
    globus_soap_message_handle_t        message;
    globus_handler_callback_func_t      callback_func;
    void *                              callback_args;
    globus_result_t                     result;
} globus_i_handler_session_descriptor_t;

EXTERN_C_END

#endif
