/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */

#include "globus_i_xsd.h"
#include "globus_i_xsd_type_info.h"
#include "globus_soap_message.h"

GLOBUS_I_XSD_DEFINE_QNAME(xsd, dateTime);
GLOBUS_I_XSD_DEFINE_TYPE_INFO(xsd_dateTime);
GLOBUS_I_XSD_DEFINE_TYPE_FUNCTIONS(xsd_dateTime);
GLOBUS_I_XSD_DEFINE_ATTR_FUNCTIONS(xsd_dateTime, dateTime);
GLOBUS_I_XSD_DEFINE_INIT_CONTENTS_GENERIC(xsd_dateTime);
GLOBUS_I_XSD_DEFINE_DESTROY_CONTENTS_GENERIC(xsd_dateTime);
GLOBUS_I_XSD_DEFINE_COPY_CONTENTS_GENERIC(xsd_dateTime);

globus_result_t
xsd_dateTime_serialize_contents(
    xsd_QName *                         element,
    xsd_dateTime *                      instance,
    globus_soap_message_handle_t        soap_message_handle,
    globus_xsd_element_options_t        options)
{
    globus_result_t                     result = GLOBUS_SUCCESS;
    GlobusFuncName(xsd_dateTime_serialize_contents);
    GlobusSoapMessageDebugEnter();

    /* serialize contents of type */
    result = globus_soap_message_serialize_dateTime(
        soap_message_handle, instance);

    GlobusSoapMessageDebugExit();
    return result;
}

globus_result_t
xsd_dateTime_deserialize_contents(
    xsd_QName *                         eqn,
    xsd_dateTime *                      instance,
    globus_soap_message_handle_t        soap_message_handle,
    globus_xsd_element_options_t        options)
{
    globus_result_t                     result = GLOBUS_SUCCESS;
    GlobusFuncName(xsd_dateTime_deserialize_contents);
    GlobusSoapMessageDebugEnter();
    
    result = globus_soap_message_deserialize_dateTime(
        soap_message_handle, instance);

    GlobusSoapMessageDebugExit();
    return result;
}
