/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


#include "xsd_double.h"
#include "globus_soap_message.h"

#include "globus_i_xsd.h"

GLOBUS_I_XSD_DEFINE_QNAME(xsd, double);
GLOBUS_I_XSD_DEFINE_TYPE_INFO(xsd_double);
GLOBUS_I_XSD_DEFINE_TYPE_FUNCTIONS(xsd_double);

GLOBUS_I_XSD_DEFINE_INIT_CONTENTS_GENERIC(xsd_double);
GLOBUS_I_XSD_DEFINE_DESTROY_CONTENTS_GENERIC(xsd_double);
GLOBUS_I_XSD_DEFINE_COPY_CONTENTS_GENERIC(xsd_double);

globus_result_t
xsd_double_serialize_contents(
    xsd_QName *                         element,
    xsd_double *                        instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options)
{
    globus_result_t                     result = GLOBUS_SUCCESS;
    GlobusFuncName(xsd_double_serialize_contents);
    GlobusSoapMessageDebugEnter();

    /* serialize contents of type */
    result = globus_soap_message_serialize_double(
        message_handle, instance);

    GlobusSoapMessageDebugExit();
    return result;
}

globus_result_t
xsd_double_deserialize_contents(
    xsd_QName *                         eqn,
    xsd_double *                        instance,
    globus_soap_message_handle_t        message_handle,
    globus_xsd_element_options_t        options)
{
    globus_result_t                     result = GLOBUS_SUCCESS;
    GlobusFuncName(xsd_double_deserialize_contents);
    GlobusSoapMessageDebugEnter();
    
    result = globus_soap_message_deserialize_double(
        message_handle, instance);

    GlobusSoapMessageDebugExit();
    return result;
}
