/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


#ifndef _GLOBUS_WSDL_CONFIG_H_
#define _GLOBUS_WSDL_CONFIG_H_

#include "globus_common.h"

EXTERN_C_BEGIN

typedef enum
{
    GLOBUS_WSDL_CONFIG_ERROR_FILE,
    GLOBUS_WSDL_CONFIG_ERROR_NO_EQUALS,
    GLOBUS_WSDL_CONFIG_ERROR_NO_ENDQUOTE,
    GLOBUS_WSDL_CONFIG_ERROR_HASH_INSERT,
    GLOBUS_WSDL_CONFIG_ERROR_NO_CURLY,
    GLOBUS_WSDL_CONFIG_ERROR_NO_ENV,
    GLOBUS_WSDL_CONFIG_ERROR_EXPANDING_REFS,
    GLOBUS_WSDL_CONFIG_ERROR_OUT_OF_MEMORY
} globus_wsdl_config_error_t;

typedef enum
{
    GLOBUS_WSDL_CONFIG_DEBUG_ERROR = 1,
    GLOBUS_WSDL_CONFIG_DEBUG_INFO = 2,
    GLOBUS_WSDL_CONFIG_DEBUG_TRACE = 4
} globus_wsdl_config_debug_level_t;

extern globus_module_descriptor_t       globus_i_wsdl_config_module;
#define GLOBUS_WSDL_CONFIG_MODULE       (&globus_i_wsdl_config_module)

char *
globus_wsdl_config_get_property(
    globus_hashtable_t                  props,
    const char *                        key);

globus_result_t
globus_wsdl_config_set_property(
    globus_hashtable_t *                props,
    const char *                        prop_string);

void
globus_wsdl_config_properties_destroy(
    globus_hashtable_t                  props);

globus_result_t
globus_wsdl_config_properties_init(
    globus_hashtable_t *                props);

globus_result_t
globus_wsdl_config_load_properties(
    const char *                        filename,
    globus_hashtable_t *                properties);

globus_result_t
globus_wsdl_config_expand_refs(
    globus_hashtable_t                  hash,
    char *                              value,
    size_t                              value_length,
    char **                             new_value,
    size_t *                            new_length);

EXTERN_C_END

#endif
