/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */


#ifndef _GLOBUS_WSDL_PARSER_H_
#define _GLOBUS_WSDL_PARSER_H_

#include "globus_common.h"

typedef enum 
{
    GLOBUS_WSDL_ERROR_JSRUNTIME,
    GLOBUS_WSDL_ERROR_JSCONTEXT,
    GLOBUS_WSDL_ERROR_JSLOAD,
    GLOBUS_WSDL_ERROR_TEMPLATE_LOAD,
    GLOBUS_WSDL_ERROR_SCANNING_IMPORTS,
    GLOBUS_WSDL_ERROR_SCANNING_ELEMENTS,
    GLOBUS_WSDL_ERROR_SCANNING_ATTRIBUTES,
    GLOBUS_WSDL_ERROR_SCANNING_MESSAGES,
    GLOBUS_WSDL_ERROR_SCANNING_PORTTYPES,
    GLOBUS_WSDL_ERROR_SCANNING_BINDINGS,
    GLOBUS_WSDL_ERROR_SCANNING_SERVICES,
    GLOBUS_WSDL_ERROR_SCANNING_TYPES,
    GLOBUS_WSDL_ERROR_PARSING_SCHEMA,
    GLOBUS_WSDL_ERROR_JAVASCRIPT,
    GLOBUS_WSDL_ERROR_JSDEBUG_FAILED,
    GLOBUS_WSDL_ERROR_JSDEBUG_COMPILE,
    GLOBUS_WSDL_ERROR_DIR_CREATE,
    GLOBUS_WSDL_ERROR_ACCESSING_TEMPLATE,
    GLOBUS_WSDL_ERROR_OUT_OF_MEMORY
} globus_wsdl_error_t;

#define GLOBUS_WSDL_DEBUG_ERROR     1
#define GLOBUS_WSDL_DEBUG_WARN      2
#define GLOBUS_WSDL_DEBUG_TRACE     4
#define GLOBUS_WSDL_DEBUG_INFO      8
#define GLOBUS_WSDL_DEBUG_TEMPLATE  16
#define GLOBUS_WSDL_DEBUG_XSD_DUMP  32
#define GLOBUS_WSDL_DEBUG_JSDEBUG   64

extern globus_module_descriptor_t       globus_i_wsdl_parser_module;
#define GLOBUS_WSDL_PARSER_MODULE       (&globus_i_wsdl_parser_module)

globus_result_t
globus_wsdl_execute(
    globus_list_t *                     schema_files,
    const char *                        tmpl_filename,
    const char *                        out_filename,
    const char *                        out_dir,
    globus_hashtable_t                  nsmap,
    globus_hashtable_t                  vars,
    globus_list_t *                     template_paths,
    globus_hashtable_t                  ignorable_namespaces,
    globus_hashtable_t                  include_namespaces,
    const int                           rt_size);

#endif
