//(c) International Business Machines Corporation, 2002 - 2005.
//(c) University of Edinburgh, 2002 - 2005.
//See OGSA-DAI-Licence.txt for licencing information.

package uk.org.ogsadai.examples.clienttoolkit;

import uk.org.ogsadai.client.toolkit.GenericServiceFetcher;
import uk.org.ogsadai.client.toolkit.Response;
import uk.org.ogsadai.client.toolkit.activity.ActivityRequest;
import uk.org.ogsadai.client.toolkit.activity.sql.SQLQuery;
import uk.org.ogsadai.client.toolkit.activity.sql.WebRowSet;
import uk.org.ogsadai.client.toolkit.service.DataService;

/**
 * This example shows how to use parameterised SQL queries.
 */
public class ParameterisedSQLQuery {

    // Copyright statement
    private static final String COPYRIGHT_NOTICE =
        "(c) IBM Corp. 2002 - 2005. (c) The University of Edinburgh 2002 - 2005.";
    public static void main(String[] args) throws Exception {

                // set up service URL and resource ID
        String handle = "http://localhost:8080/wsrf/services/ogsadai/DataService";
        String id = "MySQLResource";
        // service handle may be provided as an argument
        if (args.length == 1) {
            handle = args[0];
        }

        // Locate a Data Service
        DataService service = GenericServiceFetcher.getInstance().getDataService(handle, id);
        System.out.println("Ready to connect to data service at " + service.getURL());

        // Prepare a query with parameters
        ActivityRequest request =  new ActivityRequest();

        // Add parameter values to the query
        for (int i=100; i<10000; i+=1000) {
            SQLQuery query  =  new SQLQuery("select * from littleblackbook where id>? and id<?");
            query.setParameter(1, String.valueOf(i));
            query.setParameter(2, String.valueOf(i + 20));
            request.add( query );
            // Create a WebRowSet activity.
            WebRowSet rowset = new WebRowSet( query.getOutput() );
            request.add(query);
        }
        // Perform the request
        Response response = service.perform( request );
        System.out.println("Response:\n" + response.getAsString());

    }
}
