//(c) International Business Machines Corporation, 2005.
//(c) University of Edinburgh, 2005.
//See OGSA-DAI-Licence.txt for licencing information.

package uk.org.ogsadai.examples.clienttoolkit;

import uk.org.ogsadai.client.toolkit.GenericServiceFetcher;
import uk.org.ogsadai.client.toolkit.Response;
import uk.org.ogsadai.client.toolkit.activity.ActivityRequest;
import uk.org.ogsadai.client.toolkit.activity.sql.SQLQuery;
import uk.org.ogsadai.client.toolkit.activity.sql.WebRowSet;
import uk.org.ogsadai.client.toolkit.service.DataService;

/**
 * A simple example of using the client toolkit to run an SQL
 * query and return the results in the response to the client
 * as WebRowSet.
 *
 * @author The OGSA-DAI team.
 */
public class SimpleExample {

    // Copyright statement
    private static final String COPYRIGHT_NOTICE =
        "(c) International Business Machines Corporation, 2005. (c) University of Edinburgh 2002 - 2005.";

    public static void main(String[] args) throws Exception {
                String handle = "http://localhost:8080/wsrf/services/ogsadai/DataService";
                String id = "MySQLResource";
                DataService service = GenericServiceFetcher.getInstance().getDataService(handle, id);
                SQLQuery query =
                          new SQLQuery("select * from littleblackbook where id='3475'");
        WebRowSet rowset = new WebRowSet( query.getOutput() );
        ActivityRequest request = new ActivityRequest();
        request.add( query );
        request.add( rowset );
                Response response = service.perform( request );
                System.out.println(response.getAsString());
    }
}
