//(c) University of Edinburgh, 2002 - 2006.
//See OGSA-DAI-Licence.txt for licencing information.

package uk.org.ogsadai.examples.demoTransientFactory;

import uk.org.ogsadai.service.resource.config.ActivitiesConfig;
import uk.org.ogsadai.sessions.SessionComponentFactory;

/**
 * Interface provding access to various components required to create
 * a transient child data service resource.
 *
 * @author OGSA-DAI team
 */
public interface ChildDataServiceResourceComponentProvider
{
    /**
     * Gets the activity configuration associated with the child data
     * service resource.
     * 
     * @return configuration details of which activities can be executed
     *         on the child data service resource.
     */
    ActivitiesConfig getChildActivitiesConfig();
    
    /**
     * Gets the session component factory that can create the neccessary
     * session components for use with the child data service resource.
     * 
     * @return session component factory for use with child data service
     *         resource.
     */
    SessionComponentFactory getChildSessionComponentFactory();
}
