#!/bin/sh

# Add the jars from the tomcat common dir
DIRLIBS=${CATALINA_HOME}/common/lib/*.jar
for i in ${DIRLIBS}
do
    # if the directory is empty, then it will return the input string
    # this is stupid, so case for it
    if [ "$i" != "${DIRLIBS}" ] ; then
        CLASSPATH="$i":$CLASSPATH
    fi
done

# Add the jars from the WSRF webapp
DIRLIBS=${CATALINA_HOME}/webapps/wsrf/WEB-INF/lib/*.jar
for i in ${DIRLIBS}
do
    # if the directory is empty, then it will return the input string
    # this is stupid, so case for it
    if [ "$i" != "${DIRLIBS}" ] ; then
        CLASSPATH="$i":$CLASSPATH
    fi
done

# Add the jars from the OGSA-DAI lib dir
OGSA_DAI_HOME=`pwd`
export OGSA_DAI_HOME
DIRLIBS=${OGSA_DAI_HOME}/lib/*.jar
for i in ${DIRLIBS}
do
    # if the directory is empty, then it will return the input string
    # this is stupid, so case for it
    if [ "$i" != "${DIRLIBS}" ] ; then
      if [ -z "$CLASSPATH" ] ; then
        CLASSPATH=$i
      else
        CLASSPATH="$i":$CLASSPATH
      fi
    fi
done

# Add the jars from the OGSA-DAI drivers dir
DIRLIBS=${OGSA_DAI_HOME}/drivers/*.jar
for i in ${DIRLIBS}
do
    # if the directory is empty, then it will return the input string
    # this is stupid, so case for it
    if [ "$i" != "${DIRLIBS}" ] ; then
      if [ -z "$CLASSPATH" ] ; then
        CLASSPATH=$i
      else
        CLASSPATH="$i":$CLASSPATH
      fi
    fi
done

# Add the jars from the OGSA-DAI thirdparty dir
DIRLIBS=${OGSA_DAI_HOME}/thirdparty/*.jar
for i in ${DIRLIBS}
do
    # if the directory is empty, then it will return the input string
    # this is stupid, so case for it
    if [ "$i" != "${DIRLIBS}" ] ; then
      if [ -z "$CLASSPATH" ] ; then
        CLASSPATH=$i
      else
        CLASSPATH="$i":$CLASSPATH
      fi
    fi
done

CLASSPATH=.:${OGSA_DAI_HOME}/build:$CLASSPATH

export CLASSPATH
