###########################################################################
# Keith R. Jackson, LBNL
#Copyright (c) 2003, The Regents of the University of California,
#through Lawrence Berkeley National Laboratory 
#(subject to receipt of any required approvals from the U.S. Dept. of Energy). 
#All rights reserved. 
###########################################################################
from pyGlobus.ftpClient import FtpClient
from pyGlobus.ftpClient import OperationAttr
from pyGlobus.ftpClient import HandleAttr
from pyGlobus.ftpClient import RestartMarker
from pyGlobus.ftpControl import Parallelism
from pyGlobus.ftpControl import TcpBuffer
from pyGlobus.ftpControl import PARALLELISM_FIXED
from pyGlobus.ftpControl import PARALLELISM_NONE
from pyGlobus.ftpControl import MODE_EXTENDED_BLOCK
from pyGlobus.util import GlobusException
from threading import *
from exceptions import Exception
import sys, getopt

g_cond = 0
g_file = None
g_oldCbHandle = None
g_newCbHandle = None
g_ftpClient = None
g_buffer = None

def done_func(cv, handle, error):
    global g_cond
    if not error == "NONE":
        print "The following error occured: %s" % error
    cv.acquire()
    g_cond = 1
    cv.notify()
    cv.release()
    return

def data_func(cv, handle, buffer, bufHandle, bufLen, offset, eof, error):
    global g_file, g_ftpClient, g_oldCbHandle, g_newCbHandle, g_buffer
    print "data_func callback"
    if not eof:
        try:
	    
            g_buffer = g_file.read(bufSize)
             
            cb = g_ftpClient.register_write(g_buffer, len(g_buffer), 
		offset + bufLen,g_buffer == "", data_func, 0)
            if not g_oldCbHandle == None:
                g_ftpClient.free_callback(g_oldCbHandle)
            g_oldCbHandle = g_newCbHandle
            g_newCbHandle = cb
        except Exception, e:
            print "sys.exc_type is %s" % sys.exc_type
            print "sys.exc_value is %s" % sys.exc_value
            print "sys.exc_traceback is %s" % sys.exc_traceback
            sys.exit(-1)
    return

def test(src, url,para, buf):
    global g_cond, g_file, g_ftpClient, g_newCbHandle, bufSize
    print "para ", para
    print "buf ", buf 
    g_file = open(src, "r")
    condV = Condition(Lock())
    try:
        handleAttr = HandleAttr()
        opAttr = OperationAttr()
	pattr = Parallelism()
        if para > 0:
            pattr.set_mode(PARALLELISM_FIXED)
            pattr.set_size(int(para))
	else:
            pattr.set_mode(PARALLELISM_NONE)
        opAttr.set_parallelism(pattr)
	battr = TcpBuffer()
	battr.set_fixed(int(buf)*1024)
	opAttr.set_tcp_buffer(battr)
	opAttr.set_mode(MODE_EXTENDED_BLOCK)    
        g_ftpClient = FtpClient(handleAttr)
        print url
        g_ftpClient.put(url, done_func, condV, opAttr)
        bufSize = int(buf)*1024
        oset = 0
        buf = g_file.read(bufSize)
        cb = g_ftpClient.register_write(buf, len(buf), oset, buf == "",
                                        data_func, 0)
        g_newCbHandle = cb
    except GlobusException, ex:
        print ex
        sys.exit(-1)
    condV.acquire()
    while g_cond == 0:
        print "waiting on callbacks"
        condV.wait()
        condV.release()
    g_file.close()
    

def usage():
    useStr = """Usage: parallel_put [-h] -s <source file>
                            -d <destination url>
                            -p <parallelism>
                            -b <TCP buffer in KB> """
    print useStr
    return

def getArgs():
    if len(sys.argv) == 1:
        usage()
        sys.exit(-1)
    try:
        opts, args = getopt.getopt(sys.argv[1:], "hs:d:p:b:")
    except getopt.GetoptError:
        usage()
        sys.exit(-1)
    para = '1'
    buf = '64'
    for o, a in opts:
        if o == "-h":
            usage()
            sys.exit(-1)
        elif o == "-s":
            src = a
        elif o == "-d":
            url = a
        elif o == "-p":
            para = a
        elif o == "-b":
            buf = a
    return src, url, para, buf

src, url, para, buf = getArgs()
test(src, url,para, buf)

