############################################################################
# Matt Rodriguez, LBNL
#Copyright (c) 2003, The Regents of the University of California,
#through Lawrence Berkeley National Laboratory 
#(subject to receipt of any required approvals from the U.S. Dept. of Energy). 
#All rights reserved. 
###########################################################################


from pyGlobus.ftpClient import EasyFtpClient
from pyGlobus.ftpClient import OperationAttr
from pyGlobus.ftpClient import HandleAttr
from pyGlobus.ftpClient import RestartMarker
from pyGlobus.util import GlobusException
from threading import *
from exceptions import Exception
import sys, getopt, os, stat


def recursive_get(ftpC, dest, url):
    """
    Get a directory tree from the server.

    **Arguments:**
            
            - *ftpC* an instance of the EasyFtpClient class, that does the get methode calls.
            
            - *dest* is the where the directory tree will be placed
            
            - *url* is where the directory tree is located

           

         **Returns**
              Nothing is returned  

          **Raises:**

              A FtpClientException is thrown if unable to initiate a get or verbose_list

        """       
    
    dirStr = ftpC.verbose_list(url)
    dirList = readlines(dirStr)

    if len(dirList) == 1:
        fileStr = dirList[0]
        s = fileStr.split()
        if len(s) == 2:
            """Empty directory case"""
            pass
        else:
            ftpC.get(dest, url)

    dirList = dirList[1:]
    for file in dirList:
        tmpList = file.split()
        fileName = tmpList.pop()
        perms = tmpList[0]
        if perms[0] == 'd':
            dirName = dest + '/' + fileName
            os.mkdir(dirName)
            new_url = url + '/' + fileName
            recursive_get(ftpC, dirName, new_url)
        else:
            new_dest = dest + '/' + fileName
            new_url = url + '/' + fileName
            recursive_get(ftpC,new_dest, new_url)
            
def readline(str):
    i = str.find('\n')
    if i > 0:
        rest = str[i +1:]
        line = str[:i]
    else:
        rest = ""
        line = rest
    return line, rest

def readlines(str):
    list = []
    while 1:
        line,str = readline(str)
        if line == "":
            break
        list.append(line)
        continue
    return list
def usage():
    useStr = """Usage: recursive_get [-h] -s <source url> -d <destination directory tree>                    
			    **recursive_get.py does not handle links.**"""
    print useStr
    return

def getArgs():
    if len(sys.argv) == 1:
        usage()
        sys.exit(-1)
    try:
        opts, args = getopt.getopt(sys.argv[1:], "hs:d:")
	src = os.getcwd()
    except getopt.GetoptError:
        usage()
        sys.exit(-1)
    for o, a in opts:
        if o == "-h":
            usage()
            sys.exit(-1)
        elif o == "-s":
            url = a
        elif o == "-d":
            dest = a
    print "url: ", url
    return dest, url

ftpC = EasyFtpClient()
dest, url = getArgs()
recursive_get(ftpC, dest, url)
