############################################################################
# Matt Rodriguez, LBNL
#Copyright (c) 2003, The Regents of the University of California,
#through Lawrence Berkeley National Laboratory 
#(subject to receipt of any required approvals from the U.S. Dept. of Energy). 
#All rights reserved. 
###########################################################################



from pyGlobus.ftpClient import EasyFtpClient
from pyGlobus.ftpClient import OperationAttr
from pyGlobus.ftpClient import HandleAttr
from pyGlobus.ftpClient import RestartMarker
from pyGlobus.util import GlobusException
from threading import *
from exceptions import Exception
import sys, getopt, os, stat


def recursive_put(ftpC, src_file,url):
        """
        Store a directory tree on the server.

        **Arguments:**
	
	- *ftpC* an instance of the EasyFtpClient class, that does the put and mkdir  method calls.
        
            - *src_file* is the directory that will be put
            
            - *url* The url to store the data to.

           

         **Returns**
              Nothing is returned  

         **Raises:**

              A FtpClientException is thrown if unable to initiate a mkdir or put
            """

        """Fix for the mutable objects which are the last 2 default args"""
        
	
        fileInfo = os.lstat(src_file)
        mode = fileInfo[stat.ST_MODE]
        if stat.S_ISDIR(mode):
	    	
	    index = src_file.rfind('/')
	    dirName = src_file[index:]
	    server_url = url + dirName
	    ftpC.mkdir(server_url)
	    
	    listDir = os.listdir(src_file)
	    directory = src_file[:index]
	    for f in listDir:
	       file = src_file + '/' + f
	       recursive_put(ftpC, file,server_url)

	if stat.S_ISREG(mode):
	    index = src_file.rfind('/')
	    if index == -1:
	        fileName = '/' + src_file
	    else:
	        fileName = src_file[index:]
	    server_url = url + fileName
	    ftpC.put(src_file,server_url)

	if stat.S_ISLNK(mode):
	    print "Recursive_put does not handle links: ",src_file	
	

def usage():
    useStr = """Usage: recursive_put [-h] -s <source file> -d <destination url>
                            If no source file is specified the
			    current working directory is used.
			    **recursive_put.py does not handle links.**"""
    print useStr
    return

def getArgs():
    if len(sys.argv) == 1:
        usage()
        sys.exit(-1)
    try:
        opts, args = getopt.getopt(sys.argv[1:], "hs:d:")
	src = os.getcwd()
    except getopt.GetoptError:
        usage()
        sys.exit(-1)
    for o, a in opts:
        if o == "-h":
            usage()
            sys.exit(-1)
        elif o == "-s":
            src = a
        elif o == "-d":
            url = a
    print "src: ", src
    print "url: ", url
    return src, url

ftpC = EasyFtpClient()
src, url = getArgs()
recursive_put(ftpC, src, url)
