############################################################################
# Keith R. Jackson, LBNL
#Copyright (c) 2003, The Regents of the University of California,
#through Lawrence Berkeley National Laboratory 
#(subject to receipt of any required approvals from the U.S. Dept. of Energy). 
#All rights reserved. 
###########################################################################
from pyGlobus.ftpClient import FtpClient
from pyGlobus.ftpClient import OperationAttr
from pyGlobus.ftpClient import HandleAttr
from pyGlobus.ftpClient import RestartMarker
from pyGlobus.util import Buffer
from pyGlobus.util import GlobusException
from threading import *
from exceptions import Exception
import sys, getopt

g_cond = 0
g_dest = None
g_ftpClient = None
g_buffer = None
g_oldCbHandle = None
g_newCbHandle = None

def done_func(cv, handle, error):
    print "done_func called"
    global g_cond
    if not error == "NONE":
        print "The following error occured: %s" % error
    cv.acquire()
    g_cond = 1
    cv.notify()
    cv.release()
    return
    
def data_func(cv, handle, buffer, bufHandle, bufLen, offset, eof, error):
    global g_dest, g_ftpClient, g_buffer, g_oldCbHandle, g_newCbHandle
    g_dest.write(buffer)
    if not eof:
        try:
            handle = g_ftpClient.register_read(g_buffer, data_func, 0)
            if not g_oldCbHandle == None:
                g_ftpClient.free_callback(g_oldCbHandle)
            g_oldCbHandle = g_newCbHandle
            g_newCbHandle = handle
        except Exception, e:
            print "sys.exc_type is %s" % sys.exc_type
            print "sys.exc_value is %s" % sys.exc_value
            print "sys.exc_traceback is %s" % sys.exc_traceback
            sys.exit(-1)
    return

def test(url, dest):
    global g_cond, g_dest, g_ftpClient, g_buffer, g_newCbHandle
    g_dest = open(dest, "w")
    condV = Condition(Lock())
    try:
        handleAttr = HandleAttr()
        g_ftpClient = FtpClient(handleAttr)
        g_ftpClient.get(url, done_func, condV)
        g_buffer = Buffer(64*1024)
        handle = g_ftpClient.register_read(g_buffer, data_func, 0)
        g_newCbHandle = handle
    except GlobusException, ex:
        print ex.args
        sys.exit(-1)
    condV.acquire()
    while g_cond == 0:
        print "waiting on callbacks"
        condV.wait()
        condV.release()
    g_dest.close()
    del g_buffer
    del g_ftpClient

def usage():
    useStr = """Usage: simple_get [-h] -s <source url> -d <destination file>"""
    print useStr

def getArgs():
    if len(sys.argv) == 1:
        usage()
        sys.exit(-1)
    try:
        opts, args = getopt.getopt(sys.argv[1:], "hs:d:")
    except getopt.GetoptError:
        usage()
        sys.exit(-1)
    for o, a in opts:
        if o == "-h":
            usage()
            sys.exit(-1)
        elif o == "-s":
            url = a
        elif o == "-d":
            dest = a
    return url, dest

url, dest = getArgs()
test(url, dest)

