############################################################################
# Keith R. Jackson, LBNL
#Copyright (c) 2003, The Regents of the University of California,
#through Lawrence Berkeley National Laboratory 
#(subject to receipt of any required approvals from the U.S. Dept. of Energy). 
#All rights reserved. 
###########################################################################
from pyGlobus.ftpClient import FtpClient
from pyGlobus.ftpClient import OperationAttr
from pyGlobus.ftpClient import HandleAttr
from pyGlobus.ftpClient import RestartMarker
from pyGlobus.util import GlobusException
from threading import *
from exceptions import Exception
import sys, getopt,time

g_cond = 0
g_file = None
g_oldCbHandle = None
g_newCbHandle = None
g_ftpClient = None

def done_func(cv, handle, error):
    global g_cond
    #print "in done_func"
    if not error == "NONE":
        print "The following error occured: %s" % error
    cv.acquire()
    #print "df :setting g_cond"
    g_cond = 1
    cv.notify()
    #print "df :notified called"
    cv.release()
    #print "df: leaving done_func"
    return

def data_func(cv, handle, buffer, bufHandle, bufLen, offset, eof, error):
    global g_file, g_ftpClient, g_oldCbHandle, g_newCbHandle
    if not eof:
        try:
            buffer = g_file.read(bufLen)
            cb = g_ftpClient.register_write(buffer, len(buffer), offset,
                                            buffer == "", data_func, 0)
            if not g_oldCbHandle == None:                g_ftpClient.free_callback(g_oldCbHandle)
            g_oldCbHandle = g_newCbHandle
            g_newCbHandle = cb
        except Exception, e:
            print "sys.exc_type is %s" % sys.exc_type
            print "sys.exc_value is %s" % sys.exc_value
            print "sys.exc_traceback is %s" % sys.exc_traceback
            sys.exit(-1)
    return

def test(src, url):
    global g_cond, g_file, g_ftpClient, g_newCbHandle
    g_file = open(src, "r")
    condV = Condition(Lock())
    try:
        handleAttr = HandleAttr()
        g_ftpClient = FtpClient(handleAttr)
        g_ftpClient.put(url, done_func, condV)
        size = 64*1024
        oset = 0
        buf = g_file.read(size)
        cb = g_ftpClient.register_write(buf, len(buf), oset, buf == "",
                                        data_func, 0)
        g_newCbHandle = cb
    except GlobusException, ex:
        print ex.args
        sys.exit(-1)
    condV.acquire()
    while g_cond == 0:
        print "waiting on callbacks"
        condV.wait()
        condV.release()
        print "past condV statements"
    
    g_file.close()
    print "HERE"
    #time.sleep(1)
    del g_ftpClient

def usage():
    useStr = """Usage: simple_put [-h] -s <source file> -d <destination url>"""
    print useStr
    return

def getArgs():
    if len(sys.argv) == 1:
        usage()
        sys.exit(-1)
    try:
        opts, args = getopt.getopt(sys.argv[1:], "hs:d:")
    except getopt.GetoptError:
        usage()
        sys.exit(-1)
    for o, a in opts:
        if o == "-h":
            usage()
            sys.exit(-1)
        elif o == "-s":
            src = a
        elif o == "-d":
            url = a
    return src, url

src, url = getArgs()
test(src, url)

