############################################################################
# Matt Rodriguez, LBNL
#Copyright (c) 2003, The Regents of the University of California,
#through Lawrence Berkeley National Laboratory 
#(subject to receipt of any required approvals from the U.S. Dept. of Energy). 
#All rights reserved. 
###########################################################################
#!/usr/bin/env python
"""
Asynchronous Grid-Security-Infrastructure interface.
"""


import GSIasyncore

SECURE_PORT = 14831
class asynGSI(GSIasyncore.dispatcher):
    def __init__(self, port=SECURE_PORT):
        GSIasyncore.dispatcher.__init__(self)
        self.create_socket(SECURE_PORT)
        self.socket.listen(5)
        self._client = None
      
    def handle_accept(self):
        self._client, addr = self.socket.accept()
        ctx = self._client.get_security_context()
        tuple = ctx.inquire()
        pass #print "finished inquire_context"
        name = tuple[0].display()
        pass #print "Source name is: %s" % name
##      self.cred = self.client.get_delegated_credential()
##      pass #print "Got the delegated credential"
        return asynGSIhandler(self._client)

class asynGSIhandler(GSIasyncore.dispatcher):
    def __init__(self, sock=None):
        GSIasyncore.dispatcher.__init__(self, sock)

    def handle_read(self):
        data = self.recv(46)
        #print data
        return

    def handle_close(self):
##      del self.cred
        del self._client
        self.close()

    def writable(self):
        return None
