############################################################################
# Matt Rodriguez, LBNL
#Copyright (c) 2003, The Regents of the University of California,
#through Lawrence Berkeley National Laboratory 
#(subject to receipt of any required approvals from the U.S. Dept. of Energy). 
#All rights reserved. 
###########################################################################

from pyGlobus.security import GSSCred
from pyGlobus.security import GSSContext
from pyGlobus.security import GSSName, GSSMechs, GSSUsage, GSSBuffer
from pyGlobus.security import GSSContextException
from pyGlobus import gssc
import socket, sys,getopt, base64, time


def readAll(sock):
    print "in readAll"
    recvString =""
    bytesRead = 0
    header = sock.recv(5)
    print "header:", header
    t = header.split('X')
    numBytes = header.split('X')[0]
    
    totalBytes = int(numBytes)
    while bytesRead < int(numBytes):
        recvString += sock.recv(totalBytes)
        bytesRead += len(recvString)
        
    return recvString

def sendAll(sock, sendString, debug=0):
    print "in sendAll"
    stringLength = len(sendString)
    if stringLength == 0:
        return

    if stringLength > 99999:
        raise RuntimeError("sendAll can't send strings longer than 99,999 characters")
    xLength = 5 - len(str(stringLength))
    xString = ""
    for i in range(xLength):
        xString +='X'

    header = str(stringLength) + xString
    print "header is: ", header
    newSendString = header + sendString
    if debug:
        print newSendString
    sock.sendall(newSendString)
    
def acceptContext(host,port):
    name = GSSName()
    mechs = GSSMechs()
    usage = GSSUsage()
    usage.set_usage_accept()
    cred = GSSCred()
    cred.acquire_cred(name, mechs, usage)
    lifetime, cred_name = cred.inquire_cred()
    print "Cred info:  lifetime: " + str(lifetime) + "\nName: ", cred_name.display()
    s = socket.socket(socket.AF_INET, socket.SOCK_STREAM, 0)
    s.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
    s.bind((host, port))
    s.listen(5)
    conn, addr = s.accept()

    ctx = GSSContext()
    context_established = 0
    looped = 1
    tokensSent = 0
    tokensRecv = 0
    while not context_established:
        ctx_blob_recv = readAll(conn)
        print "len(ctx_blob_recv): ", len(ctx_blob_recv)
        tokensRecv += len(ctx_blob_recv)                                 
        input_token = ctx_blob_recv
        major, minor, tokens = ctx.accept_context(cred, input_token)
    
        if tokens == None: 
            print "Nothing to send"
        else:
            print "len(context_blob_send", len(tokens)
            ctx_blob_send =  tokens
            sendAll(conn, ctx_blob_send)
            tokensSent += len(ctx_blob_send)
            
        if major != gssc.GSS_S_CONTINUE_NEEDED:
            context_established = 1

        print "Going around the loop: ", looped
        looped = looped + 1
    print "tokensSent: ", tokensSent
    print "tokensRecv: ", tokensRecv
    print "Context created"
    t = ctx.inquire()
    print t
    credTuple = ctx._delegated_cred.inquire_cred() 
    print credTuple 
    wrappedMsg = readAll(conn)
    print "received wrapped msg"
    origMsg = ctx.unwrap(wrappedMsg)
    print "unwrapped Msg", origMsg
    print origMsg
    micString = ctx.get_mic(origMsg)
    print "generated mic: ", micString
    sendAll(conn, micString, 1)
    print "sent micString"


def usage():
    useStr = """Usage: testAcceptSecContext[-u] -h <host> -p <port>"""
    print useStr


def getArgs():
    
    if len(sys.argv) == 1:
        usage()
        sys.exit(-1)
    try:
        opts, args = getopt.getopt(sys.argv[1:], "h:p:")
    except getopt.GetoptError:
        usage()
        sys.exit(-1)
    for o, a in opts:
        if o == "-u":
            usage()
            sys.exit(-1)
        elif o == "-p":
            port = a
            print port
        elif o == "-h":
            host = a
            print host
        else:
            usage()
            sys.exit(-1)

            
    return host, int(port) 

host, port = getArgs()
acceptContext(host,port)
