############################################################################
# Matt Rodriguez, LBNL
#Copyright (c) 2003, The Regents of the University of California,
#through Lawrence Berkeley National Laboratory 
#(subject to receipt of any required approvals from the U.S. Dept. of Energy). 
#All rights reserved. 
###########################################################################

from pyGlobus.myProxy import MyProxy
from pyGlobus.security import grid_proxy_destroy, grid_proxy_init,grid_proxy_info
import unittest,ConfigParser
config_file = 'config.txt'
config = None

class MyProxyTestCaseParent(unittest.TestCase):
    def setUp(self):
	global config
        if config == None:
            config = ConfigParser.ConfigParser()
            config.read(config_file)
	self._proxy = MyProxy()
	self._hostname = config.get("myProxy", "host")

class MyProxyTestCaseCreate(MyProxyTestCaseParent):
   
    def checkCreateProxy(self):
        print "Testing createProxy"
        proxyFile = "/tmp/MyProxy.tmp"
        grid_proxy_init(outFile=proxyFile,verify=0)
        print "Created proxy"
        self._proxy.create_proxy(proxyFile, self._hostname)
        print "Stored proxy in the repository"
    
    def checkCreateProxyUserName(self):
	print "Testing createProxy"
	proxyFile = "/tmp/MyProxy.tmp"
	grid_proxy_init(outFile=proxyFile,verify=0)
	print "Created proxy"
	self._proxy.create_proxy(proxyFile, self._hostname)
        print "Stored proxy in the repository"


class MyProxyTestCase(MyProxyTestCaseParent):
    """
       This can't really be put into the unittesting framework because it requires the user to
       enter their passphrase several times
       
       The checkGetDelegationNonInteractive will fail unless you've
       stored a proxy on the host with the passphrase 1234pass.
       """  
	
    def checkGetDelegation(self):   
        print "Testing get_delegation"
        delegatedProxy="/tmp/DelegatedProxy"
        self._proxy.get_delegation(self._hostname, outFile=delegatedProxy)
        ps, pd = grid_proxy_info(proxyFile=delegatedProxy)
        print ps
        print pd

    def checkGetDelegationNonInteractive(self):   
        print "Testing get_delegation"
        delegatedProxy="/tmp/DelegatedProxy"
        self._proxy.set_passphrase("1234pass")
	self._proxy.get_delegation(self._hostname, outFile=delegatedProxy,
                interactive=False)
        ps, pd = grid_proxy_info(proxyFile=delegatedProxy)
        print ps
        print pd

        grid_proxy_destroy(proxyFile=delegatedProxy)
                          
    def checkProxyInfo(self):
	print "Testing proxy_info"
	ps = self._proxy.get_info(self._hostname)
	print ps
	
    

class MyProxyTestCaseDestroy(MyProxyTestCaseParent):	
    def checkProxyDestroy(self):
	print "testing proxy_destroy"
        proxyFile = "/tmp/MyProxy.tmp"
	self._proxy.destroy_proxy(self._hostname)
        grid_proxy_destroy(proxyFile)
        
class MyProxyTestCaseTestAll(MyProxyTestCaseParent):
    def checkCreateProxy(self):
	print "Testing createProxy"
	proxyFile = "/tmp/MyProxy.tmp"
	grid_proxy_init(outFile=proxyFile, verify=0)
	print "Created proxy"
	self._proxy.create_proxy(proxyFile, self._hostname)
	print "Stored proxy in repository"
	self._proxy.get_info(self._hostname)
	print "Retrived info about proxy"
	self._proxy.destroy_proxy(self._hostname)
	print "destroyed proxy in repository"
	grid_proxy_destroy(proxyFile)

def makeTestSuite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(MyProxyTestCaseCreate, "check"))
    suite.addTest(unittest.makeSuite(MyProxyTestCase, "check"))
    suite.addTest(unittest.makeSuite(MyProxyTestCaseDestroy, "check"))
    suite.addTest(unittest.makeSuite(MyProxyTestCaseTestAll, "check"))
    return suite

def main():
    unittest.main(defaultTest="makeTestSuite")


if __name__ == "__main__" : main()
