############################################################################
# Matt Rodriguez, LBNL
#Copyright (c) 2003, The Regents of the University of California,
#through Lawrence Berkeley National Laboratory 
#(subject to receipt of any required approvals from the U.S. Dept. of Energy). 
#All rights reserved. 
###########################################################################

from pyGlobus.ftpClientAttr import OperationAttr
import unittest, os
from pyGlobus.security import GSSCred
from pyGlobus.security import grid_proxy_info

class FtpClientOpAttrTestCase(unittest.TestCase):

    def checkSetAndGetAuth(self):
        print "checking getting and setting authorization on an operation attribute"
        opAttr = OperationAttr()
        cred = GSSCred()
        cred.acquire_cred()
        lifetime, name = cred.inquire_cred()
        username = os.getenv("LOGNAME")
        subject = name.display()
        opAttr.set_authorization(cred, username,"","", subject)
        auth = opAttr.get_authorization()
        s,d = grid_proxy_info() 
        if d['issuer'] == auth[4]:
            print "TEST PASSED"
        else:
            print "TEST FAILED"
        

def makeTestSuite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(FtpClientOpAttrTestCase, "check"))
    return suite

def main():
    unittest.main(defaultTest="makeTestSuite")


if __name__ == "__main__" : main()
   
