############################################################################
# Keith R. Jackson, LBNL
#Copyright (c) 2003, The Regents of the University of California,
#through Lawrence Berkeley National Laboratory 
#(subject to receipt of any required approvals from the U.S. Dept. of Energy). 
#All rights reserved. 
###########################################################################

from pyGlobus import gassCopy
from pyGlobus import ftpClient
from pyGlobus.util import GlobusException
import ConfigParser, unittest
import time

#The config file is ../../test/config.txt
config = None # ConfigParser object

SECTION = "gassCopy"
GSI_FTP_SRC = "gsiftpSrcUrl"
GSI_FTP_DEST = "gsiftpDestUrl"

#############################################################################
#  Unit test for the gassCopy Module.
##############################################################################
class GassCopyTestCase(unittest.TestCase):
    "Test case for the GassCopy module"

    def setUp(self):
        global config
        if config == None:
            config = ConfigParser.ConfigParser()
            config.read("config.txt") 
        return

    def checkGassCopyGSIFTPURLToGSIFTPURLBlocking(self):
        print "Testing using gass copy to copy a file"
        try:
            handleAttr = gassCopy.HandleAttr()
            ftpHandleAttr = ftpClient.HandleAttr()
            handleAttr.set_ftp(ftpHandleAttr)
            gCopy = gassCopy.GassCopy(handleAttr)
            srcAttr = gassCopy.Attr()
            destAttr = gassCopy.Attr()
            srcFtpAttr = ftpClient.OperationAttr()
            destFtpAttr = ftpClient.OperationAttr()
            srcAttr.set_ftp(srcFtpAttr)
            destAttr.set_ftp(destFtpAttr)
            srcUrl = config.get(SECTION, GSI_FTP_SRC)
            destUrl = config.get(SECTION, GSI_FTP_DEST) + str(time.time())
	    print "Transfering a file from %s to %s\n" % (srcUrl, destUrl) 
	    gCopy.copy_url_to_url(srcUrl, srcAttr, destUrl, destAttr)
        except GlobusException, ex:
            print "Exception occured during testing."
            print ex
            print "TEST FAILED" 

def makeTestSuite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(GassCopyTestCase, "check"))
    return suite

def main():
    unittest.main(defaultTest="makeTestSuite")


if __name__ == "__main__" : main()
    



