############################################################################
# Matt Rodriguez, Dan Gunter, LBNL
#Copyright (c) 2003, The Regents of the University of California,
#through Lawrence Berkeley National Laboratory 
#(subject to receipt of any required approvals from the U.S. Dept. of Energy). 
#All rights reserved. 
###########################################################################

import unittest, os
from cStringIO import StringIO
#This statement must be before importing inst
os.environ.update({"GLOBUS_XIO_DEBUG":"384"}) 
from pyGlobus import inst
try:
    from gov.lbl.dsd.netlogger import nllite
except ImportError:
    print "Unable to import nllite, which is part of netlogger"
    print "You have to install nllite or have it your PYTHONPATH"
    raise 

config = None

class InstrumentMe:
    def doit(self):
        pass

class InstTestCase(unittest.TestCase):
    def setUp(self):
        self.strm = StringIO()
        inst.setLogDest(self.strm)
        inst.setLogLevel(nllite.Level.DEBUG)
        
    def tearDown(self):
        pass
    
    def checkInstrument(self):
        inst.instrument(InstrumentMe,'ime')
        ime = InstrumentMe()
        inst.setMeta('ime.InstrumentMe.doit',pi=3.14)
        ime.doit()
        s = self.strm.getvalue()
        npi = 0
        for line in s.split('\n'):
            if line.startswith('d pi: 3.14'):
                npi += 1
        self.failUnlessEqual(npi,2,
                             "Log output is wrong, expected two repetitions "
                             "of 'pi' field in\n==\n%s\n==" % s)
def makeTestSuite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(InstTestCase, "check"))
    return suite

def main():
    unittest.main(defaultTest="makeTestSuite")


if __name__ == "__main__" : main()
   
