############################################################################
# Matt Rodriguez, LBNL
#Copyright (c) 2003, The Regents of the University of California,
#through Lawrence Berkeley National Laboratory 
#(subject to receipt of any required approvals from the U.S. Dept. of Energy). 
#All rights reserved. 
###########################################################################

import unittest
from pyGlobus.xio import XioAttr
from pyGlobus.xio import XioStack
from pyGlobus.xio import XioDriver
from pyGlobus.xio import XioTcpDriver 
from pyGlobus.xio import XioDriverException


config = None

class XioAttrTestCase(unittest.TestCase):
    def tearDown(self):
        pass
    
    def checkCreateAndDel(self):
        try:
            attr = XioAttr()
            del attr
        except XioAttrException, ex:
            print "Create and Del failed for XioAttr test case"
            print str(ex)
            print "TEST FAILED"
        else:
            print "TEST PASSED"


class XioStackTestCase(unittest.TestCase):
    def tearDown(self):
        pass
    
    def checkCreateAndDel(self):
        try:
            attr = XioAttr()
            stack = XioStack(attr)
            del stack
            del attr
        except XioException, ex:
            print "Create and Del failed for XioStack test case"
            print str(ex)
            print "TEST FAILED"
        else:
            print "TEST PASSED"
            


class XioDriverTestCase(unittest.TestCase):
    def tearDown(self):
        pass
    
    def checkLoadUnload(self):
        try:
           driver = XioDriver()
           driver.load("tcp")
           driver.unload() 
           del driver
        except XioDriverException, ex:
           print "error testing load and unload"
           print str(ex)
           print "TEST FAILED"
        else:
           print "TEST PASSED"

    def checkGetOpts(self):
        try:
            driver = XioTcpDriver()
            opts = driver.getopts()
        except XioDriverException, ex:
            print "error testing load and unload"
            print str(ex)
            print "TEST FAILED"
        else:
            print "TEST PASSED"
         

def makeTestSuite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(XioAttrTestCase, "check"))
    suite.addTest(unittest.makeSuite(XioStackTestCase, "check"))
    suite.addTest(unittest.makeSuite(XioDriverTestCase, "check"))
    return suite

def main():
    unittest.main(defaultTest="makeTestSuite")


if __name__ == "__main__" : main()
   
