############################################################################
# Matt Rodriguez, LBNL
#Copyright (c) 2003, The Regents of the University of California,
#through Lawrence Berkeley National Laboratory 
#(subject to receipt of any required approvals from the U.S. Dept. of Energy). 
#All rights reserved. 
###########################################################################

from pyGlobus.test import test_FtpClient
from pyGlobus.test import test_FtpClientAttr
from pyGlobus.test import test_EasyFtpClient
from pyGlobus.test import test_FtpClientPlugin
import ConfigParser, unittest

"""
Unittest for the ftpClient package.
"""

#The config file is ../../test/config.txt
config = None # ConfigParser object

def makeTestSuite():
    global config
    if config == None:
        config = ConfigParser.ConfigParser()
        config.read("config.txt")
    test_FtpClient.config = config
    suite = unittest.TestSuite()
    suite.addTest(test_FtpClient.makeTestSuite())
    suite.addTest(test_FtpClientAttr.makeTestSuite())
    suite.addTest(test_EasyFtpClient.makeTestSuite())
    suite.addTest(test_FtpClientPlugin.makeTestSuite())
    return suite

def main():
    global config
    if config == None:
        config = ConfigParser.ConfigParser()
        config.read("config.txt")
    test_FtpClient.config = config
    test_EasyFtpClient.config = config
    test_FtpClientPlugin.config = config
    test_FtpClientAttr.config = config
    unittest.main(defaultTest="makeTestSuite")


if __name__ == "__main__" : main()
    
