############################################################################
# Keith R. Jackson, LBNL
#Copyright (c) 2003, The Regents of the University of California,
#through Lawrence Berkeley National Laboratory 
#(subject to receipt of any required approvals from the U.S. Dept. of Energy). 
#All rights reserved. 
###########################################################################
import unittest, ConfigParser
from pyGlobus.test import test_gramClientAll
from pyGlobus.test import test_gassServerEZAll
from pyGlobus.test import test_utilAll
from pyGlobus.test import test_securityAll
from pyGlobus.test import test_ftpClientAll
from pyGlobus.test import test_ftpControlAll
from pyGlobus.test import test_gassCopyAll
from pyGlobus.test import test_gassCacheAll
from pyGlobus.test import test_gassTransferAll
from pyGlobus.test import test_ioAll 

TESTRLS = 1
try:	
    from pyGlobus.test import test_rlsClientAll
except ImportError:
    TESTRLS = 0

TESTNLINST = 1 
try: 
    from pyGlobus.test import test_instAll 
except ImportError: 
    TESTNLINST = 0

TESTXIO = 1 
try:
    from pyGlobus.test import test_xioAll
except ImportError:
    TESTXIO = 0

def makeTestSuite():
    suite = unittest.TestSuite()
    suite.addTest(test_utilAll.makeTestSuite())
    suite.addTest(test_ftpControlAll.makeTestSuite())
    suite.addTest(test_gramClientAll.makeTestSuite())
    suite.addTest(test_gassServerEZAll.makeTestSuite())
    suite.addTest(test_securityAll.makeTestSuite())
    suite.addTest(test_ftpClientAll.makeTestSuite())
    suite.addTest(test_gassCopyAll.makeTestSuite())
    suite.addTest(test_gassCacheAll.makeTestSuite())
    suite.addTest(test_gassTransferAll.makeTestSuite())
    suite.addTest(test_ioAll.makeTestSuite()) 
    if TESTRLS:
        suite.addTest(test_rlsClientAll.makeTestSuite())  
    if TESTXIO:
        suite.addTest(test_xioAll.makeTestSuite())
    if TESTNLINST:
        suite.addTest(test_nlinstAll.makeTestSuite()) 
    return suite

def main():
    cp = ConfigParser.ConfigParser()
    cp.read("config.txt")
    test_gramClientAll.config = cp
    test_ftpControlAll.config = cp
    test_gassServerEZAll.config = cp
    test_securityAll.config = cp
    test_ftpClientAll.config = cp
    test_gassCopyAll.config = cp
    test_gassCacheAll.config = cp
    test_gassTransferAll.config = cp
    test_ioAll.config = cp 
    if TESTXIO:
        test_xioAll.config = cp
    if TESTRLS:
        test_rlsClientAll.config = cp
    if TESTNLINST:
        test_nlinstAll.config = cp 
    unittest.main(defaultTest="makeTestSuite")


if __name__ == "__main__" : main()
    

