############################################################################
# Matt Rodriguez, LBNL
#Copyright (c) 2003, The Regents of the University of California,
#through Lawrence Berkeley National Laboratory 
#(subject to receipt of any required approvals from the U.S. Dept. of Energy). 
#All rights reserved. 
###########################################################################

import ConfigParser, unittest
from pyGlobus.test import test_GSSContext
from pyGlobus.test import test_GSSCred
from pyGlobus.test import test_GSSSimpleClasses
from pyGlobus.test import test_SecurityFunctions
from pyGlobus.test import test_GSICredential 

"""
Unittest for the security package.
"""

config = None # ConfigParser object

def makeTestSuite():
    global config
    if config == None:
        config = ConfigParser.ConfigParser()
        config.read("config.txt")
    test_GSSContext.config = config
    test_GSSCred.config = config
    test_GSSSimpleClasses.config = config
    suite = unittest.TestSuite()
    suite.addTest(test_GSSContext.makeTestSuite())
    suite.addTest(test_GSSCred.makeTestSuite())
    suite.addTest(test_GSSSimpleClasses.makeTestSuite()) 
    suite.addTest(test_SecurityFunctions.makeTestSuite()) 
    suite.addTest(test_GSICredential.makeTestSuite()) 
    return suite

def main():
    global config
    if config == None:
        config = ConfigParser.ConfigParser()
        config.read("config.txt")
    
    unittest.main(defaultTest="makeTestSuite")


if __name__ == "__main__" : main()
    
                  

