<?xml version="1.0"?>
<xsl:stylesheet version="1.0" 
          xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!-- ****** LINKS USED IN TEXT OF XML DOCUMENT ********* -->
<xsl:template match="NHOME">
<xsl:apply-templates select="ancestor::PROJECT/LINKS/PYRFT_HOME_PAGE"/>
</xsl:template>
<xsl:template match="NCVS">
<xsl:apply-templates select="ancestor::PROJECT/LINKS/PYRFT_CVS_PAGE"/>
</xsl:template>
<xsl:template match="NEXPORT">
<xsl:apply-templates select="ancestor::PROJECT/LINKS/PYRFT_EXPORT_PAGE"/>
</xsl:template>
<xsl:template match="NDOWNLOAD">
<xsl:apply-templates select="ancestor::PROJECT/LINKS/PYRFT_DOWNLOAD_PAGE"/>
</xsl:template>
<xsl:template match="NBUILD">
<xsl:apply-templates select="ancestor::PROJECT/LINKS/PYRFT_BUILD_PAGE"/>
</xsl:template>
<xsl:template match="NCONFIG">
<xsl:apply-templates select="ancestor::PROJECT/LINKS/PYRFT_CONFIGURE_PAGE"/>
</xsl:template>
<xsl:template match="NSECURITY">
<xsl:apply-templates select="ancestor::PROJECT/LINKS/PYRFT_SECURITY_PAGE"/>
</xsl:template>
<xsl:template match="NPROBLEMS">
<xsl:apply-templates select="ancestor::PROJECT/LINKS/PYRFT_PROBLEMS_PAGE"/>
</xsl:template>
<xsl:template match="OPENSSL">
  <xsl:apply-templates select="ancestor::PROJECT/LINKS/OPENSSL_PAGE"/>
</xsl:template>
<xsl:template match="PYTHON">
  <xsl:apply-templates select="ancestor::PROJECT/LINKS/PYTHON_PAGE"/>
</xsl:template>
<xsl:template match="GLOBUS">
  <xsl:apply-templates select="ancestor::PROJECT/LINKS/GLOBUS_PAGE"/>
</xsl:template>
<xsl:template match="PYGLOBUS">
  <xsl:apply-templates select="ancestor::PROJECT/LINKS/PYGLOBUS_PAGE"/>
</xsl:template>
<xsl:template match="GADFLY">
  <xsl:apply-templates select="ancestor::PROJECT/LINKS/GADFLY_PAGE"/>
</xsl:template>
<xsl:template match="NETLOGGER">
  <xsl:apply-templates select="ancestor::PROJECT/LINKS/NETLOGGER_PAGE"/>
</xsl:template>
<xsl:template match="JOSH">
  <xsl:apply-templates select="ancestor::PROJECT/LINKS/JOSH_PAGE"/>
</xsl:template>
<xsl:template match="KEITH">
  <xsl:apply-templates select="ancestor::PROJECT/LINKS/KEITH_PAGE"/>
</xsl:template>
<xsl:template match="LBNL">
  <xsl:apply-templates select="ancestor::PROJECT/LINKS/LBNL_PAGE"/>
</xsl:template>
<xsl:template match="DOESG">
  <xsl:apply-templates select="ancestor::PROJECT/LINKS/DOE_SG_PAGE"/>
</xsl:template>
<xsl:template match="CSDIV">
  <xsl:apply-templates select="ancestor::PROJECT/LINKS/CSDIV_PAGE"/>
</xsl:template>
<xsl:template match="DSD">
  <xsl:apply-templates select="ancestor::PROJECT/LINKS/DSD_PAGE"/>
</xsl:template>
<xsl:template match="NERSC">
  <xsl:apply-templates select="ancestor::PROJECT/LINKS/NERSC_PAGE"/>
</xsl:template>
<xsl:template match="NETSCAPE_EXPORT">
  <xsl:apply-templates select="ancestor::PROJECT/LINKS/NETSCAPE_CERTS_PAGE"/>
</xsl:template>

<xsl:template match="DOWNLOADLINK">
  <xsl:apply-templates select="ancestor::PROJECT/LINKS/PYRFT_DOWNLOAD_LINK"/>
</xsl:template>



<!-- ************ FORMATING OPTIONS EXPRESSED IN XML DOCUMENT *********** -->
<xsl:template match="LIST">
  <ul><xsl:apply-templates/></ul>
</xsl:template>
<xsl:template match ="LIST/I">
  <li><xsl:apply-templates/></li>
</xsl:template>
<xsl:template match ="BR">
  <br></br>
</xsl:template>


<!-- ************** DOCUMENT CREATION ****************** -->
<!-- ****** TOP LEVEL ******* -->
<xsl:template match="PROJECT">
    <html>
      <head>
        <title><xsl:value-of select="@ID"></xsl:value-of></title>
      </head>
      <body  bgcolor="#ffffff" text="#000000">
        <!-- BANNER Table -->
        <xsl:apply-templates select="child::BANNER"/>
        <hr></hr>
        <!-- Link/Content Tables -->
        <xsl:apply-templates select="child::HOMEPAGE"/>
        <hr></hr>
        <xsl:apply-templates select="child::FOOTER"/>
      </body>
    </html>
</xsl:template>

<!-- ****** 2nd LEVEL ******* -->
  <xsl:template match="PROJECT/BANNER">
    <center>
      <table cellspacing="2" cellpadding="2" width="97%">
        <tbody>
          <tr>
            <td align="Center" valign="CENTER" colspan="3" bgcolor="#66ffff">
              <center>
                <font face="Helvetica, Arial, sans-serif"><b><font size="+2">
                <xsl:value-of select="GROUP_NAME"/>(<xsl:value-of select="GROUP_ABBR"/>)
                 <xsl:text> </xsl:text></font></b><br></br>
                 <b><a href="http://www.lbl.gov/"><font size="+1">Lawrence
                Berkeley National Laboratory</font></a></b></font>
              </center>
            </td>
          </tr>

          <tr>
            <td bgcolor="#33ccff">
              <center>
                <font face="Helvetica, Arial, sans-serif"><b><a href="http://www.itg.lbl.gov/">
                <font size="-1">Distributed Computing Department</font></a></b></font>
              </center>
            </td>

            <td bgcolor="#33ccff">
              <center>
                <font face="Helvetica, Arial, sans-serif"><b><a href=
                "http://www.nersc.gov/">National Energy Research Scientific
                Computing Center</a></b></font>
              </center>
            </td>

            <td bgcolor="#33ccff">
              <center>
                <font face="Helvetica, Arial, sans-serif"><b><a href=
                "http://www.lbl.gov/CS">Computing Sciences
                Division</a></b></font>
              </center>
            </td>
          </tr>
        </tbody>
      </table>
    </center>
  </xsl:template>

  <xsl:template match="PROJECT/HOMEPAGE">
        <!-- Left Link Table -->
        <table align="left" valign="top" bgcolor="#66ffff" width="25%" height="100%" border="0">
          <tr><td valign="top">
              <br></br>
              <!-- xalan for-each will not do tables embedded tr/td -->
              <xsl:for-each select= "child::LINKS">
                <xsl:apply-templates/>
              </xsl:for-each>
            </td></tr>
        </table>

        <!-- Content Table -->
        <table valign="top" border="0" width="75%" height="100%" cellspacing="5" cellpadding="5">
          <tr><td valign="top">
            <!-- xalan for-each will not do tables embedded tr/td -->
            <xsl:for-each select="child::BLOCK">
              <xsl:apply-templates/>
            </xsl:for-each>
          </td></tr>
        </table>
  </xsl:template>
  
<!-- ****** 3rd LEVEL ******* -->
  <xsl:template match="PROJECT/LINKS/*">
     <a href="{PAGE}"><xsl:value-of select="NAME"/></a>
  </xsl:template>

  <xsl:template match="PROJECT/HOMEPAGE/BLOCK">
	<xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="PROJECT/HOMEPAGE/LINKS">
	<xsl:apply-templates/>
  </xsl:template>


<!-- ****** 4th LEVEL ******* -->
  <xsl:template match="PROJECT/HOMEPAGE/BLOCK/TITLE">
        <b><xsl:apply-templates/></b>
  </xsl:template>

  <xsl:template match="PROJECT/HOMEPAGE/BLOCK/TEXT">
        <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="PROJECT/HOMEPAGE/BLOCK/TEXT/P">
        <br></br>
	<blockquote>
		<xsl:apply-templates/>
	</blockquote>
  </xsl:template>

  <xsl:template match="PROJECT/HOMEPAGE/LINKS/TITLE">
        <b><xsl:apply-templates/></b>
  </xsl:template>

  <xsl:template match="PROJECT/HOMEPAGE/LINKS/TEXT">
        <xsl:apply-templates/>
  </xsl:template>


</xsl:stylesheet>
