#!/usr/local/bin/python
############################################################################
# Keith R. Jackson, LBNL
#Copyright (c) 2003, The Regents of the University of California,
#through Lawrence Berkeley National Laboratory 
#(subject to receipt of any required approvals from the U.S. Dept. of Energy). 
#All rights reserved. 
###########################################################################

import getopt, sys
from threading import *
from pyGlobus.gramClient import GramClient, GramClientException
from pyGlobus import gramClient
cond = 0
JOB_FINISHED = 0
PRINT_DEBUG  = 0 

def print_debug(printStr):
    if PRINT_DEBUG:
	print printStr
   	


def func(cv, contact, state, error):
    global cond, JOB_FINISHED
    if state == 1:
        print_debug("Job is pending")
    elif state == 2:
        print_debug("Job is active")
    elif state == 4:
        print_debug("Job failed")
        cv.acquire()
        cond = 1
        cv.notify()
        cv.release()
    elif state == 8:
        print_debug("Job is done")
	JOB_FINISHED = 1
        cv.acquire()
        cond = 1
        cv.notify()
        cv.release()

def test(rm, rsl):
    global cond
    condV = Condition(Lock())
    try:
        gC = GramClient()
        callbackContact = gC.set_callback(func, condV)
        jobContact = gC.submit_request(rm, rsl, gramClient.JOB_STATE_ALL,
                                               callbackContact)
    except GramClientException, ex:
        print ex.args
        sys.exit(-1)
    print_debug("sumbitted the job, waiting for callbacks")
    while cond == 0:
        condV.acquire()
        condV.wait()
        print_debug("made it out of the wait")
        condV.release()
    try:
        print_debug("trying to remove the callback")
        gC.remove_callback(callbackContact)
        print_debug("removed callback")
    except GramClientException, ex:
        print ex.args
        sys.exit(-1)

def usage():
    useStr = """Usage: testGramClient [-hd]  -c <resource manager contact> -r <rsl>"""
    print useStr
    
def getArgs():
    global PRINT_DEBUG 
    contact = rsl = None
    if len(sys.argv) == 1:
        usage()
        sys.exit(-1)
    try:
        opts, args = getopt.getopt(sys.argv[1:], "hdc:r:")
    except getopt.GetoptError:
        usage()
        sys.exit(-1)
    for o, a in opts:
        if o == "-h":
            usage()
            sys.exit(-1)
        elif o == "-d":
	    PRINT_DEBUG = 1 
        elif o == "-c":
            contact = a
        elif o == "-r":
            rsl = a
    return contact, rsl

rm, rsl = getArgs()


test(rm, rsl)
print JOB_FINISHED
