/*############################################################################
# Keith R. Jackson, LBNL
#Copyright (c) 2003, The Regents of the University of California,
#through Lawrence Berkeley National Laboratory 
#(subject to receipt of any required approvals from the U.S. Dept. of Energy). 
#All rights reserved. 
###########################################################################*/
%module gassServerEZc
%{
#undef SIZEOF_OFF_T
#undef HAVE_LIMITS_H
#undef socklen_t
#include "globus_gass_server_ez.h"
%}

%include ./src/pyGlobus-typemaps.i
%types(globus_gass_transfer_listenerattr_t*);
%types(globus_gass_transfer_requestattr_t*);

%inline %{
globus_module_descriptor_t* get_module(void) {
    return GLOBUS_GASS_SERVER_EZ_MODULE;
}

PyObject*
pyserver_init(unsigned long options, PyObject *pyLAttr, PyObject *pyReqAttr)
{
    globus_gass_transfer_listener_t* listener = GLOBUS_NULL;
    globus_gass_transfer_listenerattr_t* attr = GLOBUS_NULL;
    globus_gass_transfer_requestattr_t* reqattr = GLOBUS_NULL;
    char* scheme = GLOBUS_NULL;
    int err = GLOBUS_SUCCESS;
    PyObject *tuple, *ptr;
    char* url = GLOBUS_NULL;
    if (!(tuple=PyTuple_New(3)))
    {
        PyErr_SetString(PyExc_RuntimeError, "pyserver_init: PyTuple_New()");
        return NULL;
    }
    listener = (globus_gass_transfer_listener_t*)globus_malloc(
                                             sizeof(globus_gass_transfer_listener_t));
    if (pyLAttr != Py_None) {
	SWIG_ConvertPtr(pyLAttr, (void**)&attr, SWIGTYPE_p_globus_gass_transfer_listenerattr_t, 0);
    }
    if (pyReqAttr != Py_None) {
	SWIG_ConvertPtr(pyReqAttr, (void**)&reqattr, SWIGTYPE_p_globus_gass_transfer_requestattr_t, 0);
    }
    Py_BEGIN_ALLOW_THREADS
    err = globus_gass_server_ez_init(listener, attr, scheme, reqattr, options, NULL);
    Py_END_ALLOW_THREADS
    if (err != GLOBUS_SUCCESS)
    {
        PyTuple_SET_ITEM(tuple, 0, Py_BuildValue("i", err));
        Py_INCREF(Py_None);
        Py_INCREF(Py_None);
        PyTuple_SET_ITEM(tuple, 1, Py_None);
        PyTuple_SET_ITEM(tuple, 2, Py_None); 
        globus_free(listener);
    }
    else
    {
        PyTuple_SET_ITEM(tuple, 0, Py_BuildValue("i", err));
        ptr = SWIG_NewPointerObj((void*)listener, 
				 SWIGTYPE_p_globus_gass_transfer_listener_t, 0);
        PyTuple_SET_ITEM(tuple, 1, ptr);
        url = globus_gass_transfer_listener_get_base_url(*listener);
        PyTuple_SET_ITEM(tuple, 2, Py_BuildValue("s", url));
    }
    return tuple;
}

int
pyserver_shutdown(globus_gass_transfer_listener_t* listener)
{
    int err;
    Py_BEGIN_ALLOW_THREADS
    err = globus_gass_server_ez_shutdown(*listener);
    Py_END_ALLOW_THREADS
    globus_free(listener);
    return err;
}
%}
