/*############################################################################
# Matt Rodriguez, LBNL
#Copyright (c) 2003, The Regents of the University of California,
#through Lawrence Berkeley National Laboratory 
#(subject to receipt of any required approvals from the U.S. Dept. of Energy). 
#All rights reserved. 
###########################################################################*/
#include <Python.h>
#include "globus_common.h"

#ifdef WIN32
#define pyGlobus_dprintf printf
#else
#define pyGlobus_dprintf(format, ...) fprintf (stderr, format, ## __VA_ARGS__)
#endif

typedef struct {
    PyObject* callback;
    PyObject* arg;
} callbackStruct;

typedef struct {
     PyObject* callback;
     PyObject* arg;
     PyObject* buffer;
}  callbackStruct4;

void init_globus_thread_state_key(globus_thread_key_t *python_thread_state_key);

/* DEK: added static to io.i patch from Access Grid node when integrating into more source files */
static PyThreadState *pyGlobus_createThreadState(PyInterpreterState *python_interp);

/*
 * Retrieve the per-thread Python thread state.
 * If it doesn't exist yet, create one and put it in thread-specific  storage.
 */
PyThreadState *get_python_thread_state(globus_thread_key_t python_thread_state_key,PyInterpreterState *python_interp);

/* DEK: added static to io.i patch from Access Grid node when integrating into more source files */
void pyGlobus_destroyThreadState(PyThreadState *state, int haveLock);

void python_thread_state_destroy_cb(void *val);
