/*############################################################################
# Matt Rodriguez, LBNL
#Copyright (c) 2003, The Regents of the University of California,
#through Lawrence Berkeley National Laboratory 
#(subject to receipt of any required approvals from the U.S. Dept. of Energy). 
#All rights reserved. 
###########################################################################*/
%module sslc
%{
#undef SIZEOF_OFF_T
#undef HAVE_LIMITS_H
#undef socklen_t
#include "globus_common.h"
#include "globus_gsi_credential.h"
#include "globus_openssl.h" 
%}

%include ./src/pyGlobus-typemaps.i

%inline %{

globus_module_descriptor_t* get_module_openssl(void){
    return GLOBUS_OPENSSL_MODULE;
}


PyObject *
get_der_encoding_x509(X509 * x509){
    PyObject * ptr;
    unsigned char * outbuf = NULL;
    unsigned char * startbuf = NULL;
    int len;
    len = i2d_X509(x509, NULL);
    outbuf = (unsigned char *)globus_malloc(sizeof(unsigned char) * len);
    startbuf = outbuf;
    len = i2d_X509(x509, &outbuf);
    
    ptr = PyString_FromStringAndSize(startbuf,len);
    /*openssl allocated this memory for me, so I have to 
      free it, MKR
    */
    globus_free(startbuf); 
    return ptr;
}

%}
