#!/usr/bin/env python
############################################################################
# Joshua R. Boverhof, LBNL
# See LBNLCopyright for copyright notice!
###########################################################################
import sys, time, urlparse, optparse
from ConfigParser import ConfigParser
from pyGridWare.generated.stubs.widgetservice import *

CONFIG_FILE = 'config.txt'
SEC_PATHS = 'Paths'
TEST = 'WidgetService'




def Scenario_1(portAddress, **kw):
    loc = WidgetServiceLocator()
    port = loc.getWidgetServicePortType(portAddress=portAddress, **kw)
    request = createRequest()
    port.create(request)

def Scenario_2(portAddress, **kw):
    loc = WidgetServiceLocator()
    port = loc.getWidgetServicePortType(portAddress=portAddress, **kw)
    request = createRequest()
    response = port.create(request)

    kw['endPointReference'] = response._EndpointReference
    port = loc.getWidgetServicePortType(portAddress=portAddress, **kw)
    request = destroyRequest()
    response = port.destroy(request)


def Scenario_3(portAddress, **kw):
    loc = WidgetServiceLocator()
    port = loc.getWidgetServicePortType(portAddress=portAddress, **kw)
    request = createRequest()
    response = port.create(request)

    kw['endPointReference'] = response._EndpointReference
    port = loc.getWidgetServicePortType(portAddress=portAddress, **kw)
    request = setTermTimeRequest()
    request._RequestedTerminationTime = time.gmtime(time.time()+5.0)
    response = port.setTermTime(request)

def Scenario_4(portAddress, **kw):
    print "PORT: ", portAddress, kw
    loc = WidgetServiceLocator()
    port = loc.getWidgetServicePortType(portAddress=portAddress, **kw)
    request = createRequest()
    response = port.create(request)

    kw['endPointReference'] = response._EndpointReference
    port = loc.getWidgetServicePortType(portAddress=portAddress, **kw)
    request = setTermTimeRequest()
    request._RequestedTerminationTime = time.gmtime(time.time()+30.0)
    response = port.setTermTime(request)

    request = resPropRequest(\
        ("http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd",\
         "TerminationTime"))
    response = port.getResourceProperty(request)


def main():
    cp = ConfigParser()
    cp.read(CONFIG_FILE)

    op = optparse.OptionParser()
    op.add_option("-s", "--host",
        action="store", dest="host", default=cp.get('Location', 'host'),
        help="location of service container")
    op.add_option("-p", "--port", type="int",
        action="store", dest="port", default=cp.getint('Location', 'port'),
        help="port of service container")
    (opts, args) = op.parse_args()

    path = cp.get(SEC_PATHS, TEST)
    netloc = '%s:%d'%(opts.host,opts.port)
    urlTuple = ('http',netloc,path,'','','')
    url = urlparse.urlunparse(urlTuple)
    scheme,netloc,path,params,query,fragment = urlparse.urlparse(url)
    kw = {'tracefile':sys.stdout, 'url':path}
    Scenario_4(url, **kw)


if __name__ == '__main__':
    main()

