###########################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
###########################################################################


class EndPointReference:
    def setAddress(self, value):
        self._Address = value

    def setReferenceProperties(self, value):
        self._ReferenceProperties = value


class ReferenceProperties:
    def setResourceID(self, value):
        self._any = [value,]


class AddressingUtils:
    def createEndpointReference(ctx):
        epr = EndPointReference()
        epr.setAddress(ctx.getAddress())

        resourceID = ctx.getResourceID()
        if resourceID:
            refProp = ReferenceProperties()
            epr.setReferenceProperties(refProp)
            refProp.setResourceID(resourceID)
        return epr
    createEndpointReference = staticmethod(createEndpointReference)

    def getResourceID(ps, typecode):
        '''
        typecode -- representing the ResourceID expecting in WS-Address
           Header.
        '''
        d = ps.ParseHeaderElements((typecode,))
        return d[(typecode.nspname,typecode.pname)]
    getResourceID = staticmethod(getResourceID)

