############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
###########################################################################
__all__=['NotificationConsumer','NotificationProducer','SubscriptionManager']

from ZSI import TC as _TC
from ZSI.wstools.Namespaces import WSRF_V1_2 as _WSRF
import pyGridWare.generated.types.basenotification as _bn
import pyGridWare.generated.types.notificationconsumerservice as _ncs



class SubscribeUtility:
    '''Utility for setting up SubscriptionRequest Message.
    '''

    def SimpleTopicExpression(request, consumer, namespace, name):
        '''Method to set up a SubscribeRequest for Simple dialect.  
        Expecting Subscribe GED.
        '''
        if request.typecode.nspname not in _WSRF.BASENOTIFICATION.XSD_LIST and\
           request.typecode.pname != 'Subscribe':
            raise TypeError,\
                'Expecting WS-BaseNotification Subscribe GED not (%s,%s)'\
                %(request.typecode.nspname, request.typecode.pname)

        request._ConsumerReference = consumer.getEndPointReference()
        request._TopicExpression = SimpleTopicExpression(namespace, name)
        request._UseNotify = True

    SimpleTopicExpression = staticmethod(SimpleTopicExpression)


class DIALECT:
    '''WS-Topics dialects
    '''
    SIMPLE = 'http://docs.oasis-open.org/wsn/2004/06/TopicExpression/Simple'


class SimpleTopicExpression:
    '''TopicExpression to use with WSRF implementations of WS-Topics 
    Simple dialect.
    '''
    class QName(tuple):
        typecode = _TC.QName()

    def __init__(self, namespace, name):
        '''namespace -- of the RP element 
           name -- of the RP element 
        '''
        self._attrs = {'Dialect':DIALECT.SIMPLE}
        self._text = SimpleTopicExpression.QName((namespace,name))
