###########################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
###########################################################################
import time
from zope.interface import implements
from twisted.internet import reactor
from pyGridWare.resource.ResourceSweeper import ResourceSweeper
from pyGridWare.wsrf.faults.PropertiesFaults import ResourceUnknownFault
from pyGridWare.resource import IResourceHome, IPersistent


class ResourceHomeManager:
    '''
    Instance variables:
        context -- IResourceHome implementation.
    '''
    
    def __init__(self, context):
        self.context = context
        self.sweeper = ResourceSweeper(context, 5.0)
        
        if IPersistent.providedBy(context):
            context.load()
            
    def __getattr__(self, attr):
        # Quick and Dirty adapter
        return getattr(self.context,attr)
        
