############################################################################
# Matt Rodriguez, LBNL
# See Copyright for copyright notice!
#########################################################################
from zope.interface import implements
from pyGridWare.security.interfaces import IWSSecurity
from pyGridWare.security.gss.GssSignatureHandler import GssSignatureHandler


class GssSecureResourceMixIn:
    implements(IWSSecurity)
    
    def __init__(self):
        self._sigHandler = GssSignatureHandler()
        
    def verify(self, ps):
        self._sigHandler.verify(ps)

    def sign(self, sw):
        self._sigHandler.sign(sw)
