############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
# Generated by setup.py
###########################################################################

from pyGridWare.generated.services.delegationservice.DelegationFactoryService \
    import DelegationFactoryServiceWSRF
from pyGridWare.utility.http import GetURLFromRequest
from M2Crypto import X509
import base64

class DelegationFactoryService(DelegationFactoryServiceWSRF):
    """Delegate to Singleton resource
    """
    def __init__(self, **kw):
        """
        We need to pass in the location of the cert file
        """ 
        stack = X509.X509_Stack() 
        cert = X509.load_cert(self.server.CERTFILE)
        stack.push(cert)
        der_encoding = stack.as_der() 
        self._certChain = base64.encodestring(der_encoding) 

    def wsa_GetResourceProperty(self, ps, address, **kw):
        print "in RequestSecurityTokenResponse"
        self._ctx = DelegationFactoryServiceWSRF.NewResourceContextDelegationFactoryPortTypePort(GetURLFromRequest(kw['request']))
        self._ctx.CertChain = self._certChain
        request,response = DelegationFactoryServiceWSRF.wsa_GetResourceProperty(self, ps, address)
        
    def wsa_RequestSecurityToken(self, ps, address, **kw):
        #http://schemas.xmlsoap.org/ws/2004/04/trust RequestSecurityTokenMsg
        print "in RequestSecurityToken"
        request,response = DelegationFactoryServiceWSRF.wsa_RequestSecurityToken(self, ps, address)

        # http://dsd.lbl.gov/gtg/projects/pyGridWare/doc/API/pyGridWare/generated/stubs/delegationservice/RequestSecurityToken_Dec_Holder.html
        ctxattr = request.get_attribute_Context()
        anyattr = arequest.get_attribute_anyAttribute()

        for any in request.Any:
            print any

        ctx = DelegationFactoryServiceWSRF.NewResourceContextDelegationFactoryPortTypePort()
        ctx.CertificateChain = None

        response.Any = None
        response.set_Attribute_Context('whatever')
        response.set_Attribute_anyAttribute('whatever')

        return request,response

    def wsa_RequestSecurityToken2(self, ps, address, **kw):
        #http://schemas.xmlsoap.org/ws/2004/04/trust RequestSecurityTokenMsg
        print "in RequestSecurityToken2"
        request,response = DelegationFactoryServiceWSRF.wsa_RequestSecurityToken2(self, ps, address)
        ctx = DelegationFactoryServiceWSRF.GetResourceContext(ps, address)
        chain = ctx.CertificateChain
        return request,response
    
    
    


