############################################################################
# Joshua R. Boverhof, LBNL
# See LBNLCopyright for copyright notice!
###########################################################################
from pyGridWare.utility.http import GetURLFromRequest
from pyGridWare.addressing.AddressingUtils import AddressingUtils
from pyGridWare.generated.services.performancecounter.CounterService import\
    CounterServiceWSRF as WSRFService


class Counter(WSRFService):

    def wsa_add(self, ps, address, **kw):
        # Get request and response
        request,response = WSRFService.wsa_add(self, ps, address, **kw)

        # Get Resource Context
        ctx = WSRFService.GetResourceContext(ps, address)

        # Access resource properties, and evaluate new value.
        counter = ctx.properties
        result = counter.Value
        result += request
        counter.Value = result

        # response is immutable instance, create new one with result.
        response = response.__class__(result)
        return request,response

    def wsa_createCounter(self, ps, address, **kw):
        # Get request and response
        request,response = WSRFService.wsa_createCounter(self, ps, address, **kw)

        # Create Resource Context
        ctx = self.NewResourceContextCounterPortTypePort(\
            GetURLFromRequest(kw['request'])
        )

        # Initialize Value to 0
        counter = ctx.properties
        counter.Value = 0

        # Create EndPointReference and set in response
        epr = AddressingUtils.createEndpointReference(ctx)
        response._EndpointReference = epr
        return request,response


