############################################################################
# Joshua R. Boverhof, LBNL
# See LBNLCopyright for copyright notice!
###########################################################################
import pyGridWare.generated.types.basenotification
from pyGridWare.generated.services.submanagerservice.SubscriptionManagerService\
    import SubscriptionManagerServiceWSRF
from pyGridWare.wsrf.notification.SubscriptionManager import SubscriptionManager as SM


class SubscriptionManager(SubscriptionManagerServiceWSRF):
    '''Delegates to SubscriptionManager implementation
    '''
    def wsa_PauseSubscription(self, ps, address, request=None):
        ctx = self.GetResourceContext(ps, address)
        SM.getInstance().pause(ctx)
        req,response = SubscriptionManagerServiceWSRF.wsa_PauseSubscription(\
            self, ps, address, request=request
        )
        return req,response

    def wsa_ResumeSubscription(self, ps, address, request=None):
        ctx = self.GetResourceContext(ps, address)
        SM.getInstance().resume(ctx)
        req,response = SubscriptionManagerServiceWSRF.wsa_ResumeSubscription(\
            self, ps, address, request=request
        )
        return req,response


