###########################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
###########################################################################
import time

"""
  <wsdl:portType name="ImmediateResourceTermination">
    <wsdl:operation name="Destroy">
      <wsdl:input message="wsrl:DestroyRequest" />
      <wsdl:output message="wsrl:DestroyResponse" />
      <wsdl:fault name="ResourceUnknownFault" 
                  message="wsrl:ResourceUnknownFault" />
      <wsdl:fault name="ResourceNotDestroyedFault" 
                  message="wsrl:ResourceNotDestroyedFault" />
    </wsdl:operation>
  </wsdl:portType>

  <wsdl:portType name="ScheduledResourceTermination"
     wsrp:ResourceProperties ="wsrl:ScheduledResourceTerminationRP">
    <wsdl:operation name="SetTerminationTime">
      <wsdl:input message="wsrl:SetTerminationTimeRequest" />
      <wsdl:output message="wsrl:SetTerminationTimeResponse" />
      <wsdl:fault name="ResourceUnknownFault" 
                  message="wsrl:ResourceUnknownFault" />
      <wsdl:fault name="UnableToSetTerminationTimeFault" 
                  message="wsrl:UnableToSetTerminationTimeFault" />
      <wsdl:fault name="TerminationTimeChangeRejectedFault" 
                  message="wsrl:TerminationTimeChangeRejectedFault" />
    </wsdl:operation>
  </wsdl:portType>
"""
class ImmediateResourceTermination:

    def Destroy(resource):
        home = resource.getResourceHome()
        home.delete(resource.getResourceID())
    Destroy = staticmethod(Destroy)


class ScheduledResourceTermination:

    def SetTerminationTime(resource,terminationTime):
        home = resource.getResourceHome()
        home.setTerminationTime(resource.getResourceID(), terminationTime=time.mktime(terminationTime)-time.timezone)
    SetTerminationTime = staticmethod(SetTerminationTime)

