############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
# Generated by setup.py
###########################################################################

import ZSI.TC

from ZSI.TC import _get_global_element_declaration as GED
import generated.counter_service.types.counter_service

from pyGridWare.wsrf.properties.ResourceProperties import ResourceProperties
from pyGridWare.wsrf.properties.ResourceProperties import ScheduledResourceTerminationRP as _ScheduledResourceTerminationRP
from pyGridWare.wsrf.properties.ResourceProperties import NotificationProducerRP as _NotificationProducerRP
class CounterPortType(_ScheduledResourceTerminationRP,_NotificationProducerRP,ResourceProperties):
    declaration = GED("http://counter.com","CounterRP")

    def __init__(self):
        ResourceProperties.__init__(self)
        _ScheduledResourceTerminationRP.__init__(self)
        _NotificationProducerRP.__init__(self)

    def getValue(self):
        return self.getResourceProperty("http://counter.com","Value")
    def setValue(self, pyobj):
        return self.setResourceProperty("http://counter.com","Value", pyobj)
    Value = property(getValue, setValue, None, "RP element Value")

    def getCurrentTime(self):
        return self.getResourceProperty("http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd","CurrentTime")
    def setCurrentTime(self, pyobj):
        return self.setResourceProperty("http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd","CurrentTime", pyobj)
    CurrentTime = property(getCurrentTime, setCurrentTime, None, "RP element CurrentTime")

    def getTerminationTime(self):
        return self.getResourceProperty("http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd","TerminationTime")
    def setTerminationTime(self, pyobj):
        return self.setResourceProperty("http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd","TerminationTime", pyobj)
    TerminationTime = property(getTerminationTime, setTerminationTime, None, "RP element TerminationTime")

    def getTopic(self):
        return self.getResourceProperty("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","Topic")
    def setTopic(self, pyobj):
        return self.setResourceProperty("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","Topic", pyobj)
    Topic = property(getTopic, setTopic, None, "RP element Topic")

    def getFixedTopicSet(self):
        return self.getResourceProperty("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","FixedTopicSet")
    def setFixedTopicSet(self, pyobj):
        return self.setResourceProperty("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","FixedTopicSet", pyobj)
    FixedTopicSet = property(getFixedTopicSet, setFixedTopicSet, None, "RP element FixedTopicSet")

    def getTopicExpressionDialects(self):
        return self.getResourceProperty("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","TopicExpressionDialects")
    def setTopicExpressionDialects(self, pyobj):
        return self.setResourceProperty("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","TopicExpressionDialects", pyobj)
    TopicExpressionDialects = property(getTopicExpressionDialects, setTopicExpressionDialects, None, "RP element TopicExpressionDialects")
