################################################## 
# Counter_services.py 
# generated by ZSI.generate.wsdl2python
##################################################


from generated.counter_service.types.counter_service import *
import urlparse, types
import ZSI
from ZSI.TC import _get_global_element_declaration as GED
from ZSI.TCcompound import Struct
from pyGridWare.utility.web import client
from pyGridWare.utility.dom import DomletteReader, DomletteElementProxy

# Locator
class CounterServiceLocator:
    CounterPortType_address = "http://localhost:8080/wsrf/services/"
    def getCounterPortTypeAddress(self):
        return CounterServiceLocator.CounterPortType_address
    def getCounterPortType(self, url=None, **kw):
        return CounterPortTypeSOAPBindingSOAP(url or CounterServiceLocator.CounterPortType_address, **kw)

# Methods
class CounterPortTypeSOAPBindingSOAP:
    defer = False
    def __init__(self, url, endPointReference=None, **kw):
        kw.setdefault("readerclass", DomletteReader)
        kw.setdefault("writerclass", DomletteElementProxy)
        kw.setdefault("wsAddressingURL", "http://schemas.xmlsoap.org/ws/2004/03/addressing")
        kw.setdefault("ResourceProperties", ("http://counter.com","CounterRP"))
        self.binding = client.Binding(url=url, **kw)
        self.endPointReference = endPointReference

    def createCounter(self, request):
        """input parameters for operation createCounter
               request -- CreateCounterRequest
           return -- CreateCounterResponse
        """
        if isinstance(request, CreateCounterRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://counter.com/CounterPortType/createCounterRequest"
        d = self.binding.Send(None, None, request, soapaction="http://counter.com/CounterPortType/createCounterRequest", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://counter.com/CounterPortType/createCounterResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=CreateCounterResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(CreateCounterResponse.typecode, wsaction=wsaction)
        if isinstance(response, CreateCounterResponse.typecode.pyclass) is False:
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    def add(self, request):
        """input parameters for operation add
               request -- AddInputMessage
           return -- AddOutputMessage
        """
        if isinstance(request, AddInputMessage) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://counter.com/CounterPortType/addRequest"
        d = self.binding.Send(None, None, request, soapaction="http://counter.com/CounterPortType/addRequest", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://counter.com/CounterPortType/addResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=AddOutputMessage.typecode, address=d.address,
                wsaction=wsaction)
            d.addCallback(lambda response: AddOutputMessage(response))
            return d
        response = self.binding.Receive(AddOutputMessage.typecode, wsaction=wsaction)
        return AddOutputMessage(response)

    def GetResourceProperty(self, request):
        """input parameters for operation GetResourceProperty
               request -- GetResourcePropertyRequest
           return -- GetResourcePropertyResponse
        """
        if isinstance(request, GetResourcePropertyRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourceProperty"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourceProperty", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourcePropertyResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=GetResourcePropertyResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(GetResourcePropertyResponse.typecode, wsaction=wsaction)
        if isinstance(response, GetResourcePropertyResponse.typecode.pyclass) is False:
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    def Subscribe(self, request):
        """input parameters for operation Subscribe
               request -- SubscribeRequest
           return -- SubscribeResponse
        """
        if isinstance(request, SubscribeRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/Subscribe"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/Subscribe", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/SubscribeResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=SubscribeResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(SubscribeResponse.typecode, wsaction=wsaction)
        if isinstance(response, SubscribeResponse.typecode.pyclass) is False:
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    def GetCurrentMessage(self, request):
        """input parameters for operation GetCurrentMessage
               request -- GetCurrentMessageRequest
           return -- GetCurrentMessageResponse
        """
        if isinstance(request, GetCurrentMessageRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/GetCurrentMessage"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/GetCurrentMessage", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/GetCurrentMessageResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=GetCurrentMessageResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(GetCurrentMessageResponse.typecode, wsaction=wsaction)
        if isinstance(response, GetCurrentMessageResponse.typecode.pyclass) is False:
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    def Destroy(self, request):
        """input parameters for operation Destroy
               request -- DestroyRequest
           return -- DestroyResponse
        """
        if isinstance(request, DestroyRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/Destroy"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/Destroy", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/DestroyResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=DestroyResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(DestroyResponse.typecode, wsaction=wsaction)
        if isinstance(response, DestroyResponse.typecode.pyclass) is False:
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    def SetTerminationTime(self, request):
        """input parameters for operation SetTerminationTime
               request -- SetTerminationTimeRequest
           return -- SetTerminationTimeResponse
        """
        if isinstance(request, SetTerminationTimeRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/SetTerminationTime"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/SetTerminationTime", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/SetTerminationTimeResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=SetTerminationTimeResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(SetTerminationTimeResponse.typecode, wsaction=wsaction)
        if isinstance(response, SetTerminationTimeResponse.typecode.pyclass) is False:
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    def QueryResourceProperties(self, request):
        """input parameters for operation QueryResourceProperties
               request -- QueryResourcePropertiesRequest
           return -- QueryResourcePropertiesResponse
        """
        if isinstance(request, QueryResourcePropertiesRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/QueryResourceProperties"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/QueryResourceProperties", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/QueryResourcePropertiesResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=QueryResourcePropertiesResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(QueryResourcePropertiesResponse.typecode, wsaction=wsaction)
        if isinstance(response, QueryResourcePropertiesResponse.typecode.pyclass) is False:
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response

    def GetMultipleResourceProperties(self, request):
        """input parameters for operation GetMultipleResourceProperties
               request -- GetMultipleResourcePropertiesRequest
           return -- GetMultipleResourcePropertiesResponse
        """
        if isinstance(request, GetMultipleResourcePropertiesRequest) is False:
            raise TypeError, "%s incorrect request type" % (request.__class__)
        kw = {}
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetMultipleResourceProperties"
        d = self.binding.Send(None, None, request, soapaction="http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetMultipleResourceProperties", wsaction=wsaction, endPointReference=self.endPointReference, **kw)
        wsaction = "http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetMultipleResourcePropertiesResponse"
        if self.defer is True:
            d.addCallback(self.binding.getResponseSOAPMessage,
                replytype=GetMultipleResourcePropertiesResponse.typecode, address=d.address,
                wsaction=wsaction)
            return d
        response = self.binding.Receive(GetMultipleResourcePropertiesResponse.typecode, wsaction=wsaction)
        if isinstance(response, GetMultipleResourcePropertiesResponse.typecode.pyclass) is False:
            raise TypeError, "%s incorrect response type" % (response.__class__)
        return response
CreateCounterRequest = GED("http://counter.com","createCounter").pyclass

CreateCounterResponse = GED("http://counter.com","createCounterResponse").pyclass

AddInputMessage = GED("http://counter.com","add").pyclass

AddOutputMessage = GED("http://counter.com","addResponse").pyclass

GetResourcePropertyRequest = GED("http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd","GetResourceProperty").pyclass

GetResourcePropertyResponse = GED("http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd","GetResourcePropertyResponse").pyclass

SubscribeRequest = GED("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","Subscribe").pyclass

SubscribeResponse = GED("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","SubscribeResponse").pyclass

GetCurrentMessageRequest = GED("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","GetCurrentMessage").pyclass

GetCurrentMessageResponse = GED("http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd","GetCurrentMessageResponse").pyclass

DestroyRequest = GED("http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd","Destroy").pyclass

DestroyResponse = GED("http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd","DestroyResponse").pyclass

SetTerminationTimeRequest = GED("http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd","SetTerminationTime").pyclass

SetTerminationTimeResponse = GED("http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd","SetTerminationTimeResponse").pyclass

QueryResourcePropertiesRequest = GED("http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd","QueryResourceProperties").pyclass

QueryResourcePropertiesResponse = GED("http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd","QueryResourcePropertiesResponse").pyclass

GetMultipleResourcePropertiesRequest = GED("http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd","GetMultipleResourceProperties").pyclass

GetMultipleResourcePropertiesResponse = GED("http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties-1.2-draft-01.xsd","GetMultipleResourcePropertiesResponse").pyclass

