-- Driver 'org.apache.derby.jdbc.ClientDriver';
-- Protocol 'jdbc:derby:';
-- connect 'workspaceDb';

CREATE SCHEMA "GLOBUS";

CREATE TABLE "GLOBUS"."WORKSPACE_ID_TABLE" ( 
    "ID" INTEGER NOT NULL);
-- There can be multiple rows with same DN + Attr but different counter
-- A query for max(counter) for a DN would be sufficient for next available counter
CREATE TABLE "GLOBUS"."WORKSPACE_TABLE" (
    "ID" INTEGER NOT NULL PRIMARY KEY, 
    "LOCAL_NAME" VARCHAR(128) NOT NULL,
    "CREATION_MECHANISM" VARCHAR(250) NOT NULL, 
    "CALLER_DN" VARCHAR(250) NOT NULL,
    "PRIMARY_ATTR" VARCHAR(250),
    "CREATION_TIME" BIGINT NOT NULL,
    "TERMINATION_TIME" BIGINT NOT NULL,
    "POLICY_PRESENT" CHAR(1) DEFAULT 'F',
    "ROLES_PRESENT" CHAR(1) DEFAULT 'F',
    "VO" VARCHAR(250));

-- This should be ACCESS_POLICY 
CREATE TABLE "GLOBUS"."ACCESS_POLICY_DN_TABLE" (
    "ID" INTEGER NOT NULL,
    "DN_POLICY" VARCHAR(500) );

CREATE TABLE "GLOBUS"."CREATOR_ATTRIBUTE_TABLE" (
    "ID" INTEGER NOT NULL,
    "CREATOR_ATTRIBUTES" VARCHAR(500));

--CREATE TABLE ACCESS_POLICY_ATTR_TABLE (
--    "ID" INTEGER NOT NULL,
 --   "ATTR_POLICY" VARCHAR(500) );

CREATE TABLE "GLOBUS"."VOMS_DN_TABLE" (
    "ID" INTEGER NOT NULL,
    "DN" VARCHAR(250) );

CREATE TABLE "GLOBUS"."VOMS_ATTRIBUTES_TABLE" (
    "ID" INTEGER NOT NULL,
    "ATTRIBUTE" VARCHAR(250));

CREATE TABLE "GLOBUS"."LCMAPS_TABLE" (
    "ID" INTEGER NOT NULL,
    -- EXECUTABLE should not be per resource
    "POOL_INDEX" VARCHAR(250) NOT NULL,
    -- Conf file is Not per resource
    "COUNTER" INTEGER );

CREATE TABLE "GLOBUS"."LEASED_ACCOUNTS_TABLE" (
    "LOCAL_NAME" VARCHAR(250) NOT NULL,
    "POOL_NAME" VARCHAR(250) NOT NULL,
    "STATUS" VARCHAR(250) NOT NULL DEFAULT 'FREE');
