/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.workspace;

/**
 *  Used to carry back the return code of a forked process, and
 *  also the stdin/stdout/stderr if needed. 
 */
public class ReturnException extends Exception {
    public int retval;
    public String stdout;
    public String stderr;

    ReturnException() {
        super();
    }

    public ReturnException(int ret) {
        super();
        this.retval = ret;
    }

    public ReturnException(int ret, String stderr) {
        super();
        this.retval = ret;
        this.stdout = stderr;
    }

    public ReturnException(int ret, String stderr, String stdout) {
        super();
        this.retval = ret;
        this.stdout = stdout;
        this.stderr = stderr;
    }
}
