/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.workspace;

import org.globus.wsrf.Constants;

public class WorkspaceConstants {

    public static final String SERVICE_PATH = "WorkspaceService";

    public static final String FACTORY_PATH = "WorkspaceFactoryService";

    public static final String NS = "http://www.globus.org/03/2005/workspace";

    public static final String IND_ACCOUNT = "IndependentAccount";

    public static final String DB_ADAPTER_RESOURCE = "/PersistenceAdapter";

    // TODO: Database constants - in a different file
    public static final String PERSISTENCE_ADAPTER =
        Constants.JNDI_SERVICES_BASE_NAME
            + "WorkspaceService" + DB_ADAPTER_RESOURCE;

    public static final String GET_NEXT_ID_QUERY = 
        "SELECT ID FROM WORKSPACE_ID_TABLE";
    
    public static final String STORE_QUERY = 
        "INSERT INTO WORKSPACE_TABLE VALUES(?,?,?,?,?,?,?,?,?,?)";

    public static final String STORE_ACCESS_POLICY_DN_QUERY = 
        "INSERT INTO ACCESS_POLICY_DN_TABLE VALUES(?,?)";

    public static final String STORE_CREATOR_ATTR_QUERY = 
        "INSERT INTO CREATOR_ATTRIBUTE_TABLE VALUES(?,?)";

    public static final String STORE_VOMS_DN_QUERY = 
        "INSERT INTO VOMS_DN_TABLE VALUES(?,?)";

    public static final String STORE_VOMS_ATTRIBUTES_QUERY = 
        "INSERT INTO  VOMS_ATTRIBUTES_TABLE VALUES(?,?)";

    public static final String STORE_LCMAPS_QUERY = 
        "INSERT INTO LCMAPS_TABLE VALUES(?,?,?)";

    public static final String GET_ACTIVE_WORKSPACE_ID =
        "SELECT LOCAL_NAME FROM WORKSPACE_TABLE ";

    public static final String LOAD_RESOURCE_QUERY = 
        "SELECT * FROM WORKSPACE_TABLE WHERE LOCAL_NAME=?";

    public static final String GET_ACCESS_POLICY_DN_QUERY = 
        "SELECT DN_POLICY FROM ACCESS_POLICY_DN_TABLE WHERE ID=?";

    public static final String GET_CREATOR_ATTRIBUTE_QUERY = 
        "SELECT CREATOR_ATTRIBUTES FROM CREATOR_ATTRIBUTE_TABLE WHERE ID=?";

    public static final String LOAD_LCMAPS_QUERY = "SELECT * FROM " +
            "LCMAPS_TABLE WHERE ID = ? ";

    public static final String GET_VOMS_ATTRS_QUERY = "SELECT ATTRIBUTE FROM" +
            " VOMS_ATTRIBUTES_TABLE WHERE ID= ?" ;
    
    public static final String GET_VOMS_DN_QUERY = "SELECT DN FROM " +
            " VOMS_DN_TABLE WHERE ID= ?";

    public static final String CHECK_FOR_DUPLICATE_QUERY = "SELECT *" +
            " FROM WORKSPACE_TABLE WHERE LOCAL_NAME=?";

    public static final String ID_TO_LOCAL_NAME_QUERY = "SELECT ID FROM " +
            "WORKSPACE_TABLE WHERE LOCAL_NAME=?";

    public static final String DELETE_WORKSPACE_ROWS = "DELETE FROM WORKSPACE_TABLE" +
            " WHERE ID=?";
    
    public static final String DELETE_CREATOR_ATTRIBUTES = "DELETE FROM " +
            " CREATOR_ATTRIBUTE_TABLE WHERE ID=?";
    
    public static final String DELETE_ACCESS_POLICY_ROWS = "DELETE FROM " +
            " ACCESS_POLICY_DN_TABLE WHERE ID=?";
    
    public static final String DELETE_VOMS_ATTR_ROWS = "DELETE FROM " +
            "VOMS_ATTRIBUTES_TABLE  WHERE ID=?";
    
    public static final String DELETE_VOMS_DN_ROWS = "DELETE FROM " +
            "VOMS_DN_TABLE WHERE ID=?";
    
    public static final String DELETE_LCMAPS_ROWS = "DELETE FROM LCMAPS_TABLE " +
            " WHERE ID=?";

    public static final String ADD_AUTHZ_DN_QUERY = "INSERT INTO VOMS_DN_TABLE(ID," +
            "DN) VALUES(?,?) ";
    
    public static final String ADD_ACCESS_POLICY_DN_QUERY = "INSERT" +
            " INTO ACCESS_POLICY_DN_TABLE VALUES(?,?)";

    public static final String REMOVE_ACCESS_POLICY_QUERY = "DELETE FROM " +
            " ACCESS_POLICY_DN_TABLE WHERE ID=? AND DN_POLICY=?";

    public static final String REMOVE_AUTHZ_DN_QUERY = "DELETE FROM VOMS_DN_TABLE" +
            " WHERE ID=? AND DN=?";
    
    public static final String UPDATE_TERM_TIME_QUERY = "UPDATE WORKSPACE_TABLE SET" +
            " TERMINATION_TIME=? WHERE LOCAL_NAME=?";
    
    public static final String GET_ACCESS_POLICY_QUERY = " SELECT LOCAL_NAME " +
            " FROM WORKSPACE_TABLE WHERE ID IN(";
    
    public static final String GET_ID_FOR_ACCESS_DN_QUERY = "SELECT ID " +
            " FROM ACCESS_POLICY_DN_TABLE WHERE DN_POLICY=?";

    public static final String GET_ID_FOR_CREATOR_ATTRIBUTE_QUERY = "SELECT ID "
            + " FROM CREATOR_ATTRIBUTE_TABLE WHERE CREATOR_ATTRIBUTES=?";
    
    public static final String REMOVE_ACCESS_POLICY_HOME_QUERY = "DELETE FROM "
            + " ACCESS_POLICY_DN_TABLE WHERE DN_POLICY=?";
    
    public static final String GET_COUNT_QUERY = "SELECT COUNT(*) FROM "
            + " WORKSPACE_TABLE WHERE CALLER_DN=?";

    public static final String GET_COUNT_QUERY2 = "SELECT COUNT(*) FROM "
            + " WORKSPACE_TABLE WHERE CALLER_DN=? AND PRIMARY_ATTR=?";
    
    public static final String GET_LEASED_NAMES_QUERY = "SELECT LOCAL_NAME FROM "
            + "LEASED_ACCOUNTS_TABLE WHERE POOL_NAME=? AND STATUS=?";
    
    public static final String STORE_LEASED_ACCOUNTS_QUERY = "INSERT INTO " 
            + " LEASED_ACCOUNTS_TABLE VALUES(?,?,?)";
    
    public static final String DELETE_LEASED_ACCOUNT_MAPPING_QUERY = "DELETE FROM "
            + " LEASED_ACCOUNTS_TABLE WHERE POOL_NAME=? AND LOCAL_NAME=?";
    public static final String GET_LEASED_ACCOUNT_NAME_QUERY = "SELECT POOL_NAME "
            + " FROM LEASED_ACCOUNTS_TABLE WHERE LOCAL_NAME=?";

    public static final String GET_QUARANTINED_ACCOUNTS_QUERY = "SELECT " +
            "POOL_NAME,LOCAL_NAME FROM LEASED_ACCOUNTS_TABLE WHERE " +
            "STATUS='Quarantined'";

    public static final String LEASED_ACCOUNT_STATUS_ACTIVE = "Active";
    public static final String LEASED_ACCOUNT_STATUS_FREE = "Free";
    public static final String LEASED_ACCOUNT_STATUS_QUARANTINED = "Quarantined";

}
