/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.workspace.factory;

import org.globus.wsrf.impl.SimpleResourceKey;

import org.globus.wsrf.Resource;
import org.globus.wsrf.ResourceProperties;
import org.globus.wsrf.ResourceException;
import org.globus.wsrf.ResourceKey;
import org.globus.wsrf.NoSuchResourceException;
import org.globus.wsrf.InvalidResourceKeyException;

import org.globus.workspace.WorkspaceException;
import org.globus.workspace.WorkspaceConstants;
import org.globus.workspace.LimitException;

import org.globus.workspace.generated.types.AccountInformation;
import org.globus.workspace.generated.types.AccountReference;

import javax.xml.namespace.QName;

public interface WorkspaceFactoryResource
    extends ResourceProperties, Resource {

    public static final QName RP_SET =
        new QName(WorkspaceConstants.NS, "FactoryRPSet");

    public void initialize(SimpleResourceKey key, Integer ttl, Integer maxttl,
                           Integer maxWorkspaces)
        throws Exception;
    
    public AccountReference createAccount(AccountInformation accountInfo,
                                          String userName)
        throws WorkspaceException, LimitException;

    public void store() throws ResourceException;

    public void load(ResourceKey key) throws ResourceException,
            NoSuchResourceException,
            InvalidResourceKeyException;
}
