/*
 * Portions of this file Copyright 1999-2005 University of Chicago
 * Portions of this file Copyright 1999-2005 The University of Southern California.
 *
 * This file or a portion of this file is licensed under the
 * terms of the Globus Toolkit Public License, found at
 * http://www.globus.org/toolkit/download/license.html.
 * If you redistribute this file, with or without
 * modifications, you must include this notice in the file.
 */
package org.globus.workspace.impl.service;

import org.apache.axis.message.addressing.EndpointReferenceType;
import org.apache.axis.types.Duration;
import org.globus.workspace.LimitException;
import org.globus.workspace.TestConstants;
import org.globus.workspace.WorkspaceException;
import org.globus.workspace.generated.types.AccountInformation;
import org.globus.workspace.generated.types.AccountReference;
import org.globus.wsrf.ResourceKey;
import org.globus.wsrf.container.ServiceHost;
import org.globus.wsrf.utils.AddressingUtils;

public class TestWorkspaceHome extends WorkspaceHome {

    int cnt = 0;

    public synchronized AccountReference create(AccountInformation accountInfo,
                                                String creationMechanism,
                                                String callerDN,
                                                String callerUsername,
                                                Duration factoryTTL,
                                                Duration maxTTL)
            throws WorkspaceException, LimitException {

        cnt++;        
        return super.create(accountInfo, creationMechanism, callerDN, 
                            callerUsername, factoryTTL, maxTTL);
    }

    public int getCount() {
        return cnt;
    }

    protected EndpointReferenceType getEPR(ResourceKey key)
            throws WorkspaceException {

        EndpointReferenceType epr = null;
        try {
            String addr = ServiceHost.getBaseURL()
                + TestConstants.TEST_SERVICE_NAME;
            epr = AddressingUtils.createEndpointReference(addr, key);
        } catch (Exception exp) {
            String err = "Error creating endpoint reference";
            throw new WorkspaceException(err, exp);
        }
        return epr;
    }
}
